#!/bin/sh
#
# An example script of how to run the ratmac-to-fortran preprocessor
# The preprocessor opens a ratmac source file called RFPRAT and produces a
# Fortran source file called RFPFTN
# Files *COMN may be extruded during the preprocessing phase
#
RFPP=      # Enter the pathname of the preprocessor here
#
rm -f *COMN RFP* $1.o
cp $1.r RFPRAT
$RFPP
mv RFPFTN $1.f
f77 -c $1
rm -f *COMN RFP* $1.f
