systemheader:(PA    )#                                                  PA     1
######################################################################  PA     2
#                                                                    #  PA     3
#                       **** PREABS ****                             #  PA     4
#                                                                    #  PA     5
#  PREABS MARK II:  The intent was to take a series of scanning 
#  electron microscope slides, of known rotation about some 
#  pseudo known axis, and then refine two angles describing the
#  misorientation of the axis with respect to the camera/photographic
#  axes, and then optimise a model of the crystal shape, specified
#  in terms of crystal vertices. They were then used to determine 
#  face planes abcd and hkl miller indices.
#  This actually worked quite well.
#  The refinement maths was being rewritten using matrices, the way
#  it should have been done originally! Sadly it wasnt finished.
#  Potentially it could be integrated with PREABS MARK II the 
#  Xtal GUI shape visualization program. potentially ...
#                        D. du boulay 1993 
#                                                                       PA     6
#                                                                       PA     7
#                                                                       PA     8
######################################################################  PA     9
#                                                                       PA    10
include:(XMACRO)#                                                       PA    11
macro:(postm:,CALL PA04($1,$2,$3))#                                     PA    12
macro:(mmult:,CALL PA05($1,$2,$3))#                                     PA    13
macro:(triple:,CALL PA06($1,$2,$3))#                                    PA    14
macro:(transp:,CALL PA07($1,$2))$#                                      PA    15
macro:(invert:,CALL PA08($1,$2))#                                       PA    16
macro:(sg:,ifelse:(mxbtwd:,32,SNGL($1),$1))#                            PA    17
#                                                                       PA    18
#                                                                       PA    19
extrude:(PACOMN)#                                                       PA    20
INTEGER PPKT#                          Projection packet size           PA    21
INTEGER VPKT#                          Vertex packet size               PA    22
INTEGER FPKT#                          Reduced face  packet size        PA    23
INTEGER VMAX#                          Number of crystal vertices       PA    24
INTEGER PNUM#                          Number of projections            PA    25
INTEGER FACES#                         Number of crystal faces          PA    26
INTEGER RFACES#                        Reduced num of crystl faces      PA    27
INTEGER SEM#                           Scanning microscope type         PA    28
INTEGER METHOD#                        Photos=2 digi image=1            PA    29
INTEGER STEREO#                        Stereo plot                      PA    30
INTEGER OLDSUB#                                                         PA    31
INTEGER IPCH#                                                           PA    32
INTEGER ICOS#                                                           PA    33
INTEGER RELTV#                                                          PA    34
INTEGER NPAIR#                         Num of pairs of photos           PA    35
INTEGER PROJDT#                        Qx space for projectn data       PA    36
INTEGER RELCON#                                                         PA    37
INTEGER XYZ#                         
INTEGER XYZ2#                                                           PA    39
INTEGER XYZA#                       
INTEGER XYZB#                      
INTEGER XYZ1A#                                                          PA    42
INTEGER XYZ1B#                                                          PA    43
INTEGER XYZAA#                    
INTEGER XYZBB#                   
INTEGER XYZAB#                  
INTEGER LSDRAB#                        Qx least square derivs alf bet   PA    47
INTEGER LSABDT#                        Qx least square alf bet data     PA    48
INTEGER DTPK#                          Alf bet data packet size         PA    49
INTEGER DRAB#                          Num of derivs of alfa beta       PA    50
INTEGER RELCOM#                        Qx relative coordinate matrice   PA    51
INTEGER WRKSPC#                        Qx workspace pointer             PA    52
INTEGER VC1D#                                                           PA    53
INTEGER MX2D#                                                           PA    54
INTEGER VCX#                                                            PA    55
INTEGER VCSG#                                                           PA    56
INTEGER FACE#                                                           PA    57
INTEGER RFACE#                         Reduced set of faces             PA    58
INTEGER EDGES#                                                          PA    59
INTEGER REDGES#                        Reduced set of edges             PA    60
INTEGER VERTC#                                                          PA    61
INTEGER DVERT#                                                          PA    62
INTEGER ATEST#                                                          PA    63
INTEGER DTEST#                                                          PA    64
INTEGER NTEST#                                                          PA    65
INTEGER PHROT#                                                          PA    66
INTEGER LENG#                                                           PA    67
INTEGER VARS(10)#                      Number of variables in lsq       PA    68
INTEGER PARAM(14)#                     Number of variables in lsq       PA    69
#                                                                       PA    70
REAL OMIN,OMAX#                                                         PA    71
REAL DSCAL#                                                             PA    72
REAL XSCAL#                                                             PA    73
REAL YSCAL#                                                             PA    74
REAL CVOL#                                                              PA    75
REAL ROT(5)#                                                            PA    76
REAL TC(3,3)#                                                           PA    77
REAL PHI90#                                                             PA    78
REAL UB(3,3)#                                                           PA    79
REAL UINV(3,3)#                                                         PA    80
REAL TRANS(3,3)#                                                        PA    81
REAL UB1(3,3)#                         Inverse of ub                    PA    82
REAL MT(9)#                                                             PA    83
REAL PI#                                                                PA    84
REAL FUDG#                             Least square fudge factor        PA    85
REAL ALF#                              Rotation angle alpha             PA    86
REAL BET#                              Rotation angle beta              PA    87
REAL ADELT#                                                             PA    88
REAL DDELT#                                                             PA    89
REAL NDELT#                                                             PA    90
REAL PHMIN#                                                             PA    91
REAL PHMAX#                                                             PA    92
REAL PHSTP#                                                             PA    93
REAL PHISH#                                                             PA    94
#                                                                       PA    95
#                                                                       PA    96
COMMON/COMFPA/OMIN,OMAX,DSCAL,XSCAL,YSCAL,CVOL,UB1,TRANS,$#             PA    97
ROT,TC,PHI90,UB,UINV,MT,PI,FUDG,ALF,BET,ADELT,DDELT,NDELT,$#            PA    98
PHMIN,PHMAX,PHSTP,PHISH#                                                PA    99
#                                                                       PA   100
#                                                                       PA   101
COMMON/COMIPA/PPKT,VPKT,PNUM,ATEST,DTEST,NTEST,$# Integer common stor   PA   102
SEM,METHOD,STEREO,OLDSUB,IPCH,ICOS,RELTV,VMAX,RFACES,FPKT,$#            PA   103
VC1D,MX2D,VCX,VCSG,FACE,EDGES,VERTC,FACES,RFACE,REDGE,$#                PA   104
NPAIR,PROJDT,LSDRAB,LSABDT,DRAB,RELCOM,WRKSPC,DTPK,$#                   PA   105
DVERT,PHROT,LENG,RELCON,XYZ,XYZ2,XYZA,XYZB,XYZAA,XYZBB,$#               PA   106
XYZAB,XYZ1A,XYZ1B,VARS,PARAM#                                           PA   107
#                                                                       PA   108
#                                                                       PA   109
endext:#                                                                PA   110
#                                                                       PA   111
systemheader:(PA00)#                                                    PA00   1
#################################################################       PA00   2
#                                                               #       PA00   3
#                             PA00                              #       PA00   4
#                                                               #       PA00   5
#################################################################       PA00   6
SUBROUTINE PA00#                                                        PA00   7
include:(AACOMN)#                                                       PA00   8
include:(PACOMN)#                                                       PA00   9
#                                                                       PA00  10
FILEXT(IOUNIT(5))='ABS'#               Output plot file of xtal shape   PA00  11
#                                                                       PA00  12
CALL PA10#                                                              PA00  13
IF(METHOD==2)#                         If not spherical                 PA00  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA00  15
CALL PA51#                             Load in vertices                 PA00  16
CALL PA53#                             Refine angles alpha beta         PA00  17
#CALL PA54#                            DETERMN RELATVE COORD MATRIX     PA00  18
#CALL PA55#                            REFINE ABSOLUTE COORDS           PA00  19
#CALL PA56#                            DETERMINE TRIANGULAR FACES       PA00  20
#CALL PA61#                            REDUCE FACE SET                  PA00  21
#CALL PA63#                            MILLER INDICES                   PA00  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA00  23
IF(METHOD==1)#                         Digitized pictures??             PA00  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA00  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA00  26
#                                                                       PA00  27
RETURN#                                                                 PA00  28
END#                                                                    PA00  29
#                                                                       PA00  30
systemheader:(PA01)#                                                    PA01   1
###################################################################     PA01   2
#                                                                 #     PA01   3
#                             PA01                                #     PA01   4
#                                                                 #     PA01   5
###################################################################     PA01   6
SUBROUTINE PA01(H1,H2,T)#                                               PA01   7
#                                                                       PA01   8
## COMPUTE NORMALIZED CROSS PRODUCT                                     PA01   9
## XRAY PROGRAM BY H.L. AMMON, SEPTEMBER 1971                           PA01  10
## XTAL PROGRAM BY J.M. STEWART, NOVEMBER 1980                          PA01  11
#                                                                       PA01  12
REAL H1(3)#                            First vector                     PA01  13
REAL H2(3)#                            Second vector                    PA01  14
REAL S#                                Normalization factor             PA01  15
REAL T(3)#                             Cross product                    PA01  16
INTEGER N#                                                              PA01  17
#                                                                       PA01  18
T(1)=H1(2)*H2(3)-H1(3)*H2(2)#          First element                    PA01  19
T(2)=H1(3)*H2(1)-H1(1)*H2(3)#          Second element                   PA01  20
T(3)=H1(1)*H2(2)-H1(2)*H2(1)#          Third element                    PA01  21
S=1.0/SQRT(T(1)**2+T(2)**2+T(3)**2)#   Normalization factor             PA01  22
T(1)=T(1)*S ; T(2)=T(2)*S ; T(3)=T(3)*S# Normalize                      PA01  23
#                                                                       PA01  24
RETURN#                                                                 PA01  25
END#                                                                    PA01  26
systemheader:(PA04)#                                                    PA04   1
####################################################################    PA04   2
#                                                                  #    PA04   3
#                              PA04                                #    PA04   4
#                                                                  #    PA04   5
####################################################################    PA04   6
SUBROUTINE PA04(A,B,C)#                                                 PA04   7
#                                                                       PA04   8
REAL A(3,3)#                           Matrix                           PA04   9
REAL B(3)#                             Vector                           PA04  10
REAL C(3)#                             New vector c=a*b                 PA04  11
#                                                                       PA04  12
C(1)=A(1,1)*B(1)+A(1,2)*B(2)+A(1,3)*B(3)# First element                 PA04  13
C(2)=A(2,1)*B(1)+A(2,2)*B(2)+A(2,3)*B(3)# Second element                PA04  14
C(3)=A(3,1)*B(1)+A(3,2)*B(2)+A(3,3)*B(3)# Third element                 PA04  15
RETURN#                                                                 PA04  16
END#                                                                    PA04  17
systemheader:(PA05)#                                                    PA05   1
#################################################################       PA05   2
#                                                               #       PA05   3
#                            PA05                               #       PA05   4
#                                                               #       PA05   5
#################################################################       PA05   6
SUBROUTINE PA05(A,B,C)#                                                 PA05   7
#                                                                       PA05   8
## 3X3 MATRIX MULTIPLY                                                  PA05   9
## H.L. AMMON, 1971                                                     PA05  10
## FORSYTH, 1973                                                        PA05  11
## J.M. STEWART, 1980                                                   PA05  12
#                                                                       PA05  13
REAL A(3,3)#                           First matrix                     PA05  14
REAL B(3,3)#                           Second matrix                    PA05  15
REAL C(3,3)#                           Product matrix                   PA05  16
INTEGER I#                             Loop index                       PA05  17
INTEGER J#                             Loop index                       PA05  18
INTEGER K#                             Loop index                       PA05  19
#                                                                       PA05  20
DO I=1,3#                              Loop over 3 elements             PA05  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA05  22
DO J=1,3#                              Loop over 3 elements             PA05  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA05  24
C(I,J)=0.0#                            Initialize output element        PA05  25
DO K=1,3#                              Sum of element products          PA05  26
C(I,J)=C(I,J)+A(I,K)*B(K,J)#           Product element                  PA05  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA05  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA05  29
#                                                                       PA05  30
RETURN#                                                                 PA05  31
END#                                                                    PA05  32
systemheader:(PA06)#                                                    PA06   1
##################################################################      PA06   2
#                                                                #      PA06   3
#                            PA06                                #      PA06   4
#                                                                #      PA06   5
##################################################################      PA06   6
SUBROUTINE PA06(H1,H2,T)#                                               PA06   7
#                                                                       PA06   8
## FORM A RIGHT-HANDED UNIT VECTOR TRIPLE                               PA06   9
## H.L. AMMON, SEPTEMBER 1971                                           PA06  10
## J.M. STEWART, NOVEMBER 1980                                          PA06  11
#                                                                       PA06  12
REAL H1(3)#                            First input vector               PA06  13
REAL H2(3)#                            Second input vector              PA06  14
REAL S#                                Normalization factor             PA06  15
REAL T(3,3)#                           Vector triple (columns)          PA06  16
REAL TEMP(3)#                          Temporary storage                PA06  17
REAL TEMP1(3)#                         Temporary storage                PA06  18
#                                                                       PA06  19
S=1.0/SQRT(H1(1)**2+H1(2)**2+H1(3)**2)# Normalization factor            PA06  20
T(1,1)=H1(1)*S#                        First element vector 1           PA06  21
T(2,1)=H1(2)*S#                        Second                           PA06  22
T(3,1)=H1(3)*S#                        Third                            PA06  23
#                                                                       PA06  24
CALL PA01(H1,H2,TEMP)#                 Vector 3                         PA06  25
T(1,3)=TEMP(1)#                        First element                    PA06  26
T(2,3)=TEMP(2)#                        Second                           PA06  27
T(3,3)=TEMP(3)#                        Third                            PA06  28
#                                                                       PA06  29
CALL PA01(TEMP,H1,TEMP1)#              Vector 2                         PA06  30
T(1,2)=TEMP1(1)#                       First element                    PA06  31
T(2,2)=TEMP1(2)#                       Second                           PA06  32
T(3,2)=TEMP1(3)#                       Third                            PA06  33
#                                                                       PA06  34
RETURN#                                                                 PA06  35
END#                                                                    PA06  36
#                                                                       PA06  37
systemheader:(PA07)#                                                    PA07   1
####################################################################    PA07   2
#                                                                  #    PA07   3
#  MATRIX TRANSPOSE                                                     PA07   4
#                                                                  #    PA07   5
####################################################################    PA07   6
SUBROUTINE PA07(A,B)#                                                   PA07   7
#                                                                       PA07   8
REAL A(3,3)#                                                            PA07   9
REAL B(3,3)#                                                            PA07  10
#                                                                       PA07  11
DO I=1,3 ; DO J=1,3 ; B(I,J)=A(J,I)#                                    PA07  12
#                                                                       PA07  13
RETURN#                                                                 PA07  14
END#                                                                    PA07  15
systemheader:(PA08)#                                                    PA08   1
####################################################################    PA08   2
#                                                                  #    PA08   3
#  MATRIX INVERSION                                                     PA08   4
#                                                                  #    PA08   5
####################################################################    PA08   6
SUBROUTINE PA08(A,B)#                                                   PA08   7
#                                                                       PA08   8
REAL A(3,3)#                                                            PA08   9
REAL B(3,3)#                                                            PA08  10
REAL DETERM#                                                            PA08  11
#                                                                       PA08  12
DETERM=A(1,1)*A(2,2)*A(3,3)-A(1,1)*A(2,3)*A(3,2)+$#                     PA08  13
A(1,3)*A(2,1)*A(3,2)-A(1,3)*A(2,2)*A(3,1)+$#                            PA08  14
A(1,2)*A(2,3)*A(3,1)-A(1,2)*A(2,1)*A(3,3)#                              PA08  15
#                                                                       PA08  16
B(1,1)=(A(2,2)*A(3,3)-A(3,2)*A(2,3))/DETERM#                            PA08  17
B(1,2)=-(A(1,2)*A(3,3)-A(3,2)*A(1,3))/DETERM#                           PA08  18
B(1,3)=(A(1,2)*A(2,3)-A(2,2)*A(1,3))/DETERM#                            PA08  19
B(2,1)=-(A(2,1)*A(3,3)-A(3,1)*A(2,3))/DETERM#                           PA08  20
B(2,2)=(A(1,1)*A(3,3)-A(3,1)*A(1,3))/DETERM#                            PA08  21
B(2,3)=-(A(1,1)*A(2,3)-A(2,1)*A(1,3))/DETERM#                           PA08  22
B(3,1)=(A(2,1)*A(3,2)-A(3,1)*A(2,2))/DETERM#                            PA08  23
B(3,2)=-(A(1,1)*A(3,2)-A(3,1)*A(1,2))/DETERM#                           PA08  24
B(3,3)=(A(1,1)*A(2,2)-A(2,1)*A(1,2))/DETERM#                            PA08  25
#                                                                       PA08  26
RETURN#                                                                 PA08  27
END#                                                                    PA08  28
#                                                                       PA08  29
systemheader:(PA10)#                                                    PA10   1
################################################################        PA10   2
#                                                              #        PA10   3
#                            PA10                              #        PA10   4
#                                                              #        PA10   5
################################################################        PA10   6
SUBROUTINE PA10#                                                        PA10   7
include:(AACOMN)#                                                       PA10   8
include:(PACOMN)#                                                       PA10   9
#                                                                       PA10  10
## J.M. STEWART, NOVEMBER 1980                                          PA10  11
## G. DAVENPORT, JANUARY 1982                                           PA10  12
## T. MASLEN, JANUARY 1984                                              PA10  13
## N. SPADACCINI, MARCH 1989 - PSI SCANS INCLUDED                       PA10  14
#                                                                       PA10  15
INTEGER I#                             Loop index                       PA10  16
INTEGER IP#                            Packet pointer                   PA10  17
INTEGER IPP#                           Pointer                          PA10  18
INTEGER IREL(4)#                       Relative pointers                PA10  19
INTEGER IWANT(3)#                      Want list for indexpkt           PA10  20
INTEGER J#                             Loop index                       PA10  21
INTEGER JP#                            Pointer                          PA10  22
INTEGER KEY(4)#                        Keys for indexpkt                PA10  23
INTEGER M#                             Start of string                  PA10  24
INTEGER N#                             End of string                    PA10  25
INTEGER PSIZE#                         Packet size                      PA10  26
INTEGER IWAV#                          Wave length index                PA10  27
INTEGER INDX#                          Table index for mua-ta           PA10  28
INTEGER IDXMU#                         Key for emu-source               PA10  29
INTEGER NSF#                           (number of atom types)           PA10  30
INTEGER KEY1#                                                           PA10  31
#                                                                       PA10  32
REAL CHI#                              Chi                              PA10  33
REAL PHI#                              Phi                              PA10  34
REAL TCTRAN(3,3)#                      Tc transpose                     PA10  35
REAL TRAN(3,3)#                                                         PA10  36
REAL TPHI(3,3)#                        Vector triple                    PA10  37
REAL U(3,3)#                           Rotation matrix                  PA10  38
REAL VEC(10)#                          Orref vectors                    PA10  39
REAL B(3,3)#                                                            PA10  40
REAL BINV(3,3)#                        Inverse of b                     PA10  41
REAL PHISHF(3,3)#                                                       PA10  42
#                                                                       PA10  43
string:(ACH,108)#                      Char store for atom types        PA10  44
#                                                                       PA10  45
chardata:(PA101,DIGI PHOT SCAL MAGN PHI  $#                             PA10  46
STER PROJ DCOS PCH  )#                                                  PA10  47
chardata:(PA102,DIFF   ORIENT ROTATE REFPAR FIXPAR PROJ   END     )#    PA10  48
chardata:(PA103,AC  DIGI IMAGE PHOTOGRAPH  YES NO     SPHERICAL)#       PA10  49
chardata:(PA104, DETERMINATION FROM      PHOTOGRAPHS)#                  PA10  50
chardata:(PA105,A0 B0 A1 B1 D1 L1 AI BI DI LI AC BC DC LC  )#           PA10  51
chardata:(PA10B, PHOTO HORIZONTAL SCALE FACTOR      )#                  PA10  52
chardata:(PA10C, PHOTO VERTICAL   SCALE FACTOR      )#                  PA10  53
chardata:(PA10D, CALCULATE DIRECTION COSINES  YES)#                     PA10  54
chardata:(PA10E, PUNCH REFLECTION CARDS WITH  FREL  TBAR  DIR.COSINES)# PA10  55
chardata:(PA10F,(INPUT)     (CALCULATED)(DEFAULT)   )#                  PA10  56
chardata:(PA10H, PLOT CRYSTAL VIEWS IN PROJECTION )#                    PA10  57
chardata:(PA10I,STEREO    PROJECTION)#                                  PA10  58
chardata:(PA10J, ROTATION SENSES  THETA/CHI/PHI             C C C    )# PA10  59
chardata:(PA10K,/OMEGA/PSI  )#                                          PA10  60
realdata:(FM,[210303.,350403.,521042.])#                                PA10  61
realdata:(WV,[1.54179,0.7106])#                                         PA10  62
datastuff:#                                                             PA10  63
#                                                                       PA10  64
# SET UP INPUT AND OUTPUT FILE BUFFERS                                  PA10  65
# ------------------------------------                                  PA10  66
#                                                                       PA10  67
IOMARK(1)=QXSTR#                       Start of input buffer            PA10  68
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of output buffer           PA10  69
IOMARK(3)=IOMARK(2)+bdfbuf:#           Start plot buffer                PA10  70
incrqx:(WRKSPC,IOMARK(3)+bdfbuf:,PA1001)# Start of face array           PA10  71
OMIN=-.837758 ; OMAX=1.01229#          Default omega limits - syntex    PA10  72
#                                                                       PA10  73
# DEFAULTS                                                              PA10  74
# --------                                                              PA10  75
#                                                                       PA10  76
METHOD=1#                              Default gaussian                 PA10  77
ICOS=0#                                No direction cosines             PA10  78
IPNCH=0#                               No punch                         PA10  79
STEREO=no:#                            Assume projection plots          PA10  80
OLDSUB=-1#                             But if stereo set color          PA10  81
SCALE=1.0#                                                              PA10  82
XSCAL=1.0#                                                              PA10  83
YSCAL=1.0#                                                              PA10  84
SEM=505#                                                                PA10  85
PI=3.1415927#                                                           PA10  86
PHISH=0.0#                                                              PA10  87
PHIROT=no:#                                                             PA10  88
RELTV=2#                               Relative coords                  PA10  89
VARS(1)=10#                                                             PA10  90
DO I=2,10 ;VARS(I)=1#                                                   PA10  91
#                                                                       PA10  92
# INTERPRET THE ABSORB LINE                                             PA10  93
# -------------------------                                             PA10  94
#                                                                       PA10  95
DO I=1,mxfdim:#                        Loop over rest of fields         PA10  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA10  97
IF(BUFIN(I)>=voidflg:) NEXT#           Next on void                     PA10  98
stringlim:(I,M,N)#                     Get string limits                PA10  99
compchar:(CHRIN,M,PA101,1,4,5,NPA101,KEY1)# Identify string             PA10 100
IF     (KEY1==0) NEXT#                 Unidentified code                PA10 101
ELSE IF(KEY1<3)  METHOD=KEY1#          Calculation method               PA10 102
ELSE IF(KEY1==3)#                                                       PA10 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA10 104
IF ((BUFIN(I+1)>0)&(BUFIN(I+2)>0))#                                     PA10 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA10 106
XSCAL=BUFIN(I+1);YSCAL=BUFIN(I+2);I=I+2#                                PA10 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA10 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA10 109
ELSE IF(KEY1==4)#                                                       PA10 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA10 111
MAGN=BUFIN(I+1) ; I=I+1#                                                PA10 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA10 113
ELSE IF (KEY1==5)#                                                      PA10 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA10 115
PHISH=BUFIN(I+1)*PI/180.; I=I+1#                                        PA10 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA10 117
ELSE IF(KEY1==6) STEREO=yes:#          Vset for stereo views            PA10 118
ELSE IF(KEY1==8) ICOS=6#               Output dir. cosines              PA10 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA10 120
#COPYFILE:(1,2,1,DECR:(LRCELL:))#      COPY UP TO LRCELL                PA10 121
copyfile:(1,1,1,decr:(lrcell:))#       Copy up to lrcell                PA10 122
#                                                                       PA10 123
# OUTPUT FOR USER                                                       PA10 124
# ---------------                                                       PA10 125
#                                                                       PA10 126
IF(METHOD==1) movechar:(PA103, 5,PA104,26,10,0)# Print digi image       PA10 127
IF(METHOD==2) movechar:(PA103,16,PA104,26,10,0)# Print photograph       PA10 128
writeline:(1,PA104,NPA104,3,3)#                                         PA10 129
movechar:(PA10I,11,PA10H,24,10,0)#     Default projection views         PA10 130
IF(STEREO==yes:) movechar:(PA10I,1,PA10H,24,10,0)# Stereo views         PA10 131
writeline:(0,PA10H,NPA10H,3,3)#                                         PA10 132
IF (ICOS>0) writeline:(0,PA10D,NPA10D,3,3)#                             PA10 133
ncodefld:(XSCAL,1,PA10B,360622.,1)#                                     PA10 134
writeline:(0,PA10B,NPA10B,3,3)#                                         PA10 135
ncodefld:(YSCAL,1,PA10C,360622.,1)#                                     PA10 136
writeline:(0,PA10C,NPA10C,3,3)#                                         PA10 137
#                                                                       PA10 138
# GET THE B MATRIX FROM LRCELL:                                         PA10 139
# -----------------------------                                         PA10 140
#                                                                       PA10 141
DO K=1,10#                             Loop over lrcell packets         PA10 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA10 143
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Point to next lrcell pkt         PA10 144
IF(IP<=0) BREAK#                       Exit after last packet           PA10 145
writepkt:(2,lrcell:,PSIZE,IPP)#                                         PA10 146
movereal:(QX,IP+1,QX,IPP+1,PSIZE,1)#                                    PA10 147
IF(K==5)#                              Skip unless trans matrix         PA10 148
DO I=1,3;  DO J=1,3#                   Loop over columns & rows         PA10 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA10 150
JP=IP+3*I-3+J#                         Point into qx                    PA10 151
B(J,I)=QX(JP)#                         Store element                    PA10 152
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA10 153
IF(K==6) CVOL=QX(IP+1)#                Get cell volume                  PA10 154
IF(K==8)#                              Test if inv metric tensor        PA10 155
DO I=1,9; MT(I)=QX(IP+I)#              Store metric tensor              PA10 156
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA10 157
#                                                                       PA10 158
#                                                                       PA10 159
#COPYFILE:(1,2,INCR:(LREXPL:),DECR:(LRREFL:))# COPY UP TO LRREFL:       PA10 160
copyfile:(1,1,incr:(lrexpl:),decr:(lrrefl:))# Copy up to lrrefl:        PA10 161
#                                                                       PA10 162
# READ DIFF AND ORIENT LINES                                            PA10 163
# -------------------------                                             PA10 164
#                                                                       PA10 165
IF(METHOD!=3)#                         For gaussian and analytical      PA10 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA10 167
PHI90=0.0#                             Default 0.0                      PA10 168
DO J=1,5; ROT(J)=1.0#                  Default clockwise                PA10 169
REPEAT#                                                                 PA10 170
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA10 171
readline:(PA102,-NPA102)#              Read control line                PA10 172
#                                                                       PA10 173
# DIFF LINE                                                             PA10 174
# ---------                                                             PA10 175
#                                                                       PA10 176
IF(LINID==1)#                          Diff line                        PA10 177
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA10 178
DO J=1,3#                              Loop over compulsory fields 1-   PA10 179
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA10 180
ifnm:(BUFIN(J)) iquit:(PA1002)#        Character field                  PA10 181
stringlim:(J,M,N)#                     Get string limits                PA10 182
compchar:(CHRIN,M,PA103,1,1,1,2,N)#    Identify string                  PA10 183
IF(N==0) iquit:(PA1002)#               Default clockwise                PA10 184
IF(N==1)#                              Anticlockwise                    PA10 185
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PA10 186
ROT(J)=-1.0#                           Store rotation element           PA10 187
movechar:(PA103,1,PA10J,45+(J-1)*2,1,0)# Rotation sense output          PA10 188
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PA10 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PA10 190
DO J=4,5#                                                               PA10 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PA10 192
ifvo:(BUFIN(J)) NEXT#                  If not there - next              PA10 193
movechar:(PA10K,1+(J-4)*6,PA10J,32+(J-4)*6,6,0)# Title                  PA10 194
stringlim:(J,M,N)#                     Get string limits                PA10 195
compchar:(CHRIN,M,PA103,1,1,1,2,N)#    Identify string                  PA10 196
IF(N==0) iquit:(PA1002)#               Default clockwise                PA10 197
IF(N==1)#                                                               PA10 198
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PA10 199
ROT(J)=-1#                                                              PA10 200
movechar:(PA103,1,PA10J,45+(J-1)*2,1,0)#                                PA10 201
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PA10 202
ELSE movechar:(PA103,2,PA10J,45+(J-1)*2,1,0)#                           PA10 203
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PA10 204
writeline:(0,PA10J,NPA10J,3,3)#                                         PA10 205
ifnm:(BUFIN(6)) PHI90=BUFIN(6)*.017453# Phi at chi=90                   PA10 206
ELSE     PHI90=0.0#                    Default 0.0                      PA10 207
ifnm:(BUFIN(7)) OMIN=BUFIN(7)/57.29578# Omega min in radians            PA10 208
ifnm:(BUFIN(8)) OMAX=BUFIN(8)/57.29578# Omega max in radians            PA10 209
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA10 210
#                                                                       PA10 211
# ORIENT LINE                                                           PA10 212
# -----------                                                           PA10 213
#                                                                       PA10 214
ELSE IF(LINID==2)#                     Orient line                      PA10 215
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PA10 216
DO I=1,10#                             Loop over fields                 PA10 217
IF(BUFIN(I)<=voidflg:) iquit:(PA1003)# Non-numeric, so quit             PA10 218
postm:(B,BUFIN,VEC)#                   B x hkl                          PA10 219
postm:(B,BUFIN(6),VEC(4))#             B x hkl                          PA10 220
triple:(VEC,VEC(4),TC)#                Form vector triple               PA10 221
#                                                                       PA10 222
CHI=0.01745329*BUFIN(4)#               Chi                              PA10 223
PHI=0.01745329*BUFIN(5)#               Phi                              PA10 224
VEC(1)=ROT(1)*COS(CHI)*COS(PHI)#       Element 1                        PA10 225
VEC(2)=ROT(1)*ROT(3)*COS(CHI)*SIN(PHI)# Element 2                       PA10 226
VEC(3)=ROT(1)*ROT(2)*SIN(CHI)#         Element 3                        PA10 227
#                                                                       PA10 228
CHI=0.01745329*BUFIN(9)#               Chi                              PA10 229
PHI=0.01745329*BUFIN(10)#              Phi                              PA10 230
VEC(4)=ROT(1)*COS(CHI)*COS(PHI)#       Element 1                        PA10 231
VEC(5)=ROT(1)*ROT(3)*COS(CHI)*SIN(PHI)# Element 2                       PA10 232
VEC(6)=ROT(1)*ROT(2)*SIN(CHI)#         Element 3                        PA10 233
#                                                                       PA10 234
triple:(VEC,VEC(4),TPHI)#              Form vector triple               PA10 235
#                                                                       PA10 236
DO I=1,3#                                                               PA10 237
DO J=1,3#                                                               PA10 238
TCTRAN(I,J)=TC(J,I)#                                                    PA10 239
mmult:(TPHI,TCTRAN,U)#                 Matrix multiply                  PA10 240
#                                                                       PA10 241
DO I=1,3#                                                               PA10 242
DO J=1,3#                                                               PA10 243
UINV(I,J)=U(J,I)#                                                       PA10 244
#                                                                       PA10 245
BINV(1,1)=1/B(1,1)#                                                     PA10 246
BINV(2,1)=0.0#                                                          PA10 247
BINV(3,1)=0.0#                                                          PA10 248
BINV(1,2)=-B(1,2)/B(1,1)/B(2,2)#                                        PA10 249
BINV(2,2)=1/B(2,2)#                                                     PA10 250
BINV(3,2)=0.0#                                                          PA10 251
BINV(1,3)=(B(1,2)*B(2,3)-B(1,3)*B(2,2))/(B(1,1)*B(2,2)*B(3,3))#         PA10 252
BINV(2,3)=-B(2,3)/B(2,2)/B(3,3)#                                        PA10 253
BINV(3,3)=1/B(3,3)#                                                     PA10 254
#                                                                       PA10 255
#                                                                       PA10 256
mmult:(U,B,UB)#                        Matrix multiply                  PA10 257
mmult:(BINV,UINV,UB1)#                 Matrix multiply                  PA10 258
#                                                                       PA10 259
DO IROW=1,3#                                                            PA10 260
DO JCOL=1,3 ;TRAN(IROW,JCOL)=0.0#                                       PA10 261
TRAN(2,2)=1.0 ;TRAN(1,3)=1.0 ; TRAN(3,1)=-1.0#                          PA10 262
PHISHF(1,1)=COS(PHISH) ; PHISHF(1,2)=SIN(PHISH); PHISHF(1,3)=0.0#       PA10 263
PHISHF(2,1)=-SIN(PHISH); PHISHF(2,2)=COS(PHISH); PHISHF(2,3)=0.0#       PA10 264
PHISHF(3,1)=0.0        ; PHISHF(3,2)=0.0       ; PHISHF(3,3)=1.0#       PA10 265
mmult:(PHISHF,TRAN,TRANS)#                                              PA10 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PA10 267
#                                                                       PA10 268
#                                                                       PA10 269
#                                                                       PA10 270
#                                                                       PA10 271
ELSE IF(LINID==3)#                     Multiple rotations about phi     PA10 272
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PA10 273
PHROT=yes:#                                                             PA10 274
ifnm:(BUFIN(1)) PHMIN=BUFIN(1)*.017453-PHISH#                           PA10 275
ELSE     PHMIN=0.0-PHISH#              Default 0.0                      PA10 276
ifnm:(BUFIN(2)) PHMAX=BUFIN(2)*.017453-PHISH#                           PA10 277
ELSE     PHMAX=360.0-PHISH#            Default 0.0                      PA10 278
ifnm:(BUFIN(3)) PHSTP=BUFIN(3)*.017453#                                 PA10 279
ELSE     PHSTP=360.0#                  Default 0.0                      PA10 280
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PA10 281
ELSE IF(LINID==4)#                                                      PA10 282
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PA10 283
STP=WRKSPC#                                                             PA10 284
DO J=1,NPA105 ; PARAM(J)=0#                                             PA10 285
DO J=1,mxfdim:#                        Loop over rest of fields         PA10 286
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PA10 287
ifnm:(BUFIN(J)) iquit:(PA1002)#        Character field                  PA10 288
stringlim:(J,M,N)#                     Get string limits                PA10 289
compchar:(CHRIN,M,PA105,1,2,3,NPA105,N)# Identify string                PA10 290
IF(N==0)  NEXT#                                                         PA10 291
DO L=1,NPA105  ; IF(N==L)#                                              PA10 292
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PA10 293
incrqx:(STP,STP+1,PA1001)#                                              PA10 294
MARK(N)=STP#                                                            PA10 295
IF (N>2)#                              Test for repeated variables      PA10 296
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PA10 297
SUM=0#                                                                  PA10 298
DO II=1,3 ; SUM=SUM+PARAM(2+II*MOD(N-2,4))#                             PA10 299
IF (SUM==0& N>6)#                      Variable not repeated            PA10 300
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 PA10 301
REPEAT#                                Check for numerical fields       PA10 302
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 PA10 303
ifch:(BUFIN(J+1)) BREAK#               Non-numeric so break             PA10 304
PARAM(N)=PARAM(N)+1#                   Numeric so count it              PA10 305
incrqx:(STP,STP+1,PA1001)#             Find mem to store it             PA10 306
QX(STP)=BUFIN(J+1)#                    Store it                         PA10 307
J=J+1#                                 Point to next field              PA10 308
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 PA10 309
IF (PARAM(N)==0) PARAM(N)=-1#          If no subsequent numbers         PA10 310
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 PA10 311
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PA10 312
ELSE PARAM(N)=1#                                                        PA10 313
STOP(N)=STP#                                                            PA10 314
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PA10 315
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PA10 316
WRKSPC=STP#                            End of input refinement params   PA10 317
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PA10 318
ELSE  BREAK#                           Pa10 277                         PA10 319
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA10 320
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA10 321
#                                                                       PA10 322
#                                                                       PA10 323
#COPYFILE:(1,2,INCR:(LRREFL:),ENDRECORD:)#                              PA10 324
copyfile:(1,1,incr:(lrrefl:),endrecord:)#                               PA10 325
#BDFCLOSE:(1)                                                           PA10 326
#                                                                       PA10 327
RETURN#                                                                 PA10 328
END#                                                                    PA10 329
#                                                                       PA10 330
systemheader:(PA51)#                                                    PA51   1
####################################################################    PA51   2
#                                                                  #    PA51   3
#                    LOAD IN THE VERTICES                          #    PA51   4
#                                                                  #    PA51   5
####################################################################    PA51   6
SUBROUTINE PA51#                                                        PA51   7
include:(AACOMN)#                                                       PA51   8
include:(PACOMN)#                                                       PA51   9
#                                                                       PA51  10
# QX FORMAT       PROJPKT;VERTXPKT;VETXPKT;VERTXPKT...PROJPKT           PA51  11
#   PROJPKT                                                             PA51  12
#          PROJECTION   ROTATN TILT   ABSOLUTE  NUMBER OF   XAVE  YAVE  PA51  13
#           NUMBER      ANGLE  ANGLE   ANGLE    VERTICES                PA51  14
#VERTEXPKT                                                              PA51  15
#          VERTEX ID    X    Y   Z1,Z2,Z3...                            PA51  16
#                                                                       PA51  17
#                                                                       PA51  18
## READ IN LINES DEFINING THE CRYSTAL  vertices                         PA51  19
#                                                                       PA51  20
INTEGER MARKA,MARKB#                                                    PA51  21
INTEGER STOPA,STOPB#                                                    PA51  22
INTEGER LINID1#                                                         PA51  23
INTEGER VNUM#                                                           PA51  24
INTEGER N#                                                              PA51  25
INTEGER PROJ#                                                           PA51  26
INTEGER SWAP#                                                           PA51  27
REAL ABSANG#                                                            PA51  28
REAL TEMP(50,2)#                                                        PA51  29
REAL TMP(2)#                                                            PA51  30
#                                                                       PA51  31
chardata:(PA511,PROJ VERT END  )#                                       PA51  32
datastuff:#                                                             PA51  33
#                                                                       PA51  34
PROJDT=WRKSPC#                                                          PA51  35
PPKT= 12#                              Size of projection packet        PA51  36
VPKT= 10#                              Size of vertex packe             PA51  37
STOPA=PROJDT#                          Beginning of input data          PA51  38
readline:(PA511,NPA511)#               Get first projct line            PA51  39
LINID1=LINID#                          Memorize the option used         PA51  40
PNUM=0#                                                                 PA51  41
VMAX=0#                                                                 PA51  42
#                                                                       PA51  43
REPEAT#                                Loop over remaining input line   PA51  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA51  45
IF(LINID!=1) BREAK#                    End line                         PA51  46
PNUM=PNUM+1#                                                            PA51  47
MARKA=STOPA#                                                            PA51  48
incrqx:(STOPA,MARKA+PPKT,PA5101)#      Get memory  for projection dir   PA51  49
ifnm:(BUFIN(1)) QX(MARKA+6)=BUFIN(1)#  Photonumber                      PA51  50
ifnm:(BUFIN(2)) QX(MARKA+2)=BUFIN(2)#  Sem phi angle a - manual rotn    PA51  51
ifnm:(BUFIN(3)) QX(MARKA+3)=BUFIN(3)#  Sem phi angle b - tilt angle     PA51  52
ifnm:(BUFIN(4)) QX(MARKA+9)=BUFIN(4)#  Alpha angle input                PA51  53
ifnm:(BUFIN(5)) QX(MARKA+10)=BUFIN(5)# Beta angle input                 PA51  54
ifnm:(BUFIN(6)) QX(MARKA+11)=BUFIN(6)# Average photo depth              PA51  55
ifnm:(BUFIN(7)) QX(MARKA+12)=BUFIN(7)# Photo veiwing distance           PA51  56
QX(MARKA+1)=FLOAT(PNUM)#               Order number of photo            PA51  57
#                                                                       PA51  58
IF (SEM== 505)#                        If philips505 in default mode    PA51  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA51  60
ABSANG= (BUFIN(2)-BUFIN(3))*PI/180.#   Absolute phi coordinate          PA51  61
IF (ABSANG<0) ABSANG=ABSANG+2.*PI#     Phi in radians                   PA51  62
QX(MARKA+4)=ABSANG#                                                     PA51  63
WRITE(6,*)"ang",ABSANG*180/PI,"photo numb ",BUFIN(1)#                   PA51  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA51  65
#                                                                       PA51  66
#      GET VERTICES COMMON TO PHOTO                                     PA51  67
#      ----------------------------                                     PA51  68
#                                                                       PA51  69
VNUM=0#                                Initialize vertex number         PA51  70
REPEAT#                                                                 PA51  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA51  72
readline:(PA511,NPA511)#                                                PA51  73
IF(LINID!=2) BREAK#                    Vertex line                      PA51  74
VNUM=VNUM+1#                           Increment vertex counter         PA51  75
incrqx:(STOPA,STOPA+VPKT,PA5101)#      Get memory for vertex file       PA51  76
ifnm:(BUFIN(1))QX(STOPA+1-VPKT)=BUFIN(1)# Vertex identity               PA51  77
VMAX=MAX(VMAX,NINT(BUFIN(1)))#                                          PA51  78
ifnm:(BUFIN(2))QX(STOPA+2-VPKT)=BUFIN(2)*XSCAL# X position of vertex    PA51  79
ifnm:(BUFIN(3))QX(STOPA+3-VPKT)=-BUFIN(3)*YSCAL# Y position of vertex   PA51  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA51  81
QX(MARKA + 5)=FLOAT(VNUM)#             No of vertices counted           PA51  82
TEMP(PNUM,1)=FLOAT(PNUM)#                                               PA51  83
TEMP(PNUM,2)=ABSANG#                                                    PA51  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA51  85
incrqx:(WRKSPC,STOPA+2*(PPKT+VMAX*VPKT),PA5104)#                        PA51  86
#                                                                       PA51  87
#   ORDER THE POINTERS                                                  PA51  88
#   ------------------                                                  PA51  89
#                                                                       PA51  90
REPEAT#                                                                 PA51  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA51  92
SWAP=no:#                                                               PA51  93
DO PROJ=1,PNUM-1#                                                       PA51  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA51  95
IF (TEMP(PROJ,2)>TEMP(PROJ+1,2))#                                       PA51  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA51  97
TMP(1)=TEMP(PROJ,1); TMP(2)=TEMP(PROJ,2)#                               PA51  98
TEMP(PROJ,1)=TEMP(PROJ+1,1);TEMP(PROJ,2)=TEMP(PROJ+1,2)#                PA51  99
TEMP(PROJ+1,1)=TMP(1);TEMP(PROJ+1,2)=TMP(2)#                            PA51 100
SWAP=yes:#                                                              PA51 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA51 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA51 103
IF (SWAP==no:)BREAK#                                                    PA51 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA51 105
DO J=1,2#                              Copy first two projns to end     PA51 106
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA51 107
DO I=1,2 ;TEMP(PNUM+J,I)=TEMP(J,I)#                                     PA51 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA51 109
PNUM=PNUM+2#                                                            PA51 110
#                                                                       PA51 111
#   ORDER THE PROJECTIONS                                               PA51 112
#   ---------------------                                               PA51 113
#                                                                       PA51 114
MARKA=PROJDT#                          P                                PA51 115
MARKB=WRKSPC#                                                           PA51 116
DO PROJ=1,PNUM#                                                         PA51 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA51 118
REPEAT#                                                                 PA51 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA51 120
N=NINT(QX(MARKA+5))#                   Number of vertices in pic        PA51 121
ifeq:(QX(MARKA+1),TEMP(PROJ,1))#                                        PA51 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA51 123
incrqx:(STOPB,MARKB+PPKT,PA5101)#      Get memory  for projection dir   PA51 124
movereal:(QX,MARKA+1,QX,MARKB+1,PPKT,1)# Directory packet               PA51 125
incrqx:(STOPB,STOPB+N*VPKT,PA5101)#    Get memory  for vertex files     PA51 126
movereal:(QX,MARKA+PPKT+1,QX,MARKB+PPKT+1,VPKT*N,1)# All files          PA51 127
MARKA= PROJDT#                                                          PA51 128
BREAK#                                                                  PA51 129
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA51 130
ELSE MARKA= MARKA+PPKT +N*VPKT#                                         PA51 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA51 132
CALL PA52(MARKB)#                      Get average                      PA51 133
MARKB=STOPB#                           Update pntr for next proj        PA51 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA51 135
movereal:(QX,WRKSPC+1,QX,PROJDT+1,STOPB-WRKSPC,1)# Copy projdt back     PA51 136
WRKSPC=PROJDT+STOPB-WRKSPC#                                             PA51 137
#                                                                       PA51 138
#                                                                       PA51 140
RETURN#                                                                 PA51 141
END#                                                                    PA51 142
systemheader:(PA52)#                                                    PA52   1
####################################################################    PA52   2
#                                                                  #    PA52   3
#                    FIND AVERAGE FOR EACH PROJECTION                   PA52   4
#                                                                  #    PA52   5
####################################################################    PA52   6
SUBROUTINE PA52(CMARK)#                                                 PA52   7
include:(AACOMN)#                                                       PA52   8
include:(PACOMN)#                                                       PA52   9
#                                                                       PA52  10
#  FIND THE BOUNDARY POINTS OF THE DEFINED SHAPE                        PA52  11
# FROM THE VERTICES AND THEN FIND AVERAGE X AND Y                       PA52  12
#                                                                       PA52  13
INTEGER CMARK#                         Point to vertex drectry          PA52  14
INTEGER I,J,K#                                                          PA52  15
INTEGER NV#                                                             PA52  16
INTEGER MARKC#                                                          PA52  17
INTEGER VLOG(50)#                                                       PA52  18
INTEGER NEWPT#                                                          PA52  19
REAL X1,X2,Y1,Y2#                                                       PA52  20
REAL DELX,DELY#                                                         PA52  21
REAL NEWX,NEWY#                                                         PA52  22
REAL XAVE,YAVE#                                                         PA52  23
REAL A,B#                              Quadrant pointers                PA52  24
REAL MNGRAD#                                                            PA52  25
#                                                                       PA52  26
datastuff:#                                                             PA52  27
#                                                                       PA52  28
NV=NINT(QX(CMARK+5))#                  Number of vertices in pic        PA52  29
MARKC=CMARK+PPKT#                      First vertex                     PA52  30
IF(NV==0)RETURN#                                                        PA52  31
#                                                                       PA52  32
#   START FROM MINIMUM Y                                                PA52  33
#   --------------------                                                PA52  34
#                                                                       PA52  35
Y1=9.9E+20#                                                             PA52  36
DO I=1,NV#                                                              PA52  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA52  38
Y1=MIN(Y1,QX(MARKC+(I-1)*VPKT+3))#     Find min y point                 PA52  39
ifeq:(Y1,QX(MARKC+(I-1)*VPKT+3))#                                       PA52  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA52  41
X1=QX(MARKC+(I-1)*VPKT+2)#             Store x for future               PA52  42
VLOG(1)=I#                             Log first vertex                 PA52  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA52  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA52  45
XAVE=0.0;YAVE=0.0;J=1#                 Initialize variables             PA52  46
#                                                                       PA52  47
#   FIND BOUNDARY CURVE OF CRYSTAL                                      PA52  48
#   FROM VERTICES BY FINDING MINIMUM GRADIENT                           PA52  49
#                                                                       PA52  50
DO K=1,4#                              Loop over four quadrants         PA52  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA52  52
IF (K>2)A=-1.0#                                                         PA52  53
ELSE A=1.0#                                                             PA52  54
IF ((K<2)\(K>3))B=1.0#                                                  PA52  55
ELSE B=-1.0#                                                            PA52  56
REPEAT#                                Until no points in quad          PA52  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA52  58
NEWPT=no:#                                                              PA52  59
MNGRAD=9.9E+20#                                                         PA52  60
DO I=1,NV#                             Cycle thru all vertices          PA52  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA52  62
IF(I==VLOG(J)) NEXT#                                                    PA52  63
X2=QX(MARKC+(I-1)*VPKT+2)#             Second x                         PA52  64
Y2=QX(MARKC+(I-1)*VPKT+3)#             Second y                         PA52  65
DELX=X1-X2#                            Delta x                          PA52  66
DELY=Y1-Y2#                            Delta y                          PA52  67
IF ((A*DELY>0.0)\(B*DELX>0.0))NEXT#    Wrong quadrant                   PA52  68
ifeq:(DELX,0.0)#                       Infinite gradiant                PA52  69
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA52  70
IF (NEWPT==yes:) NEXT#                 Test for a previous value        PA52  71
DELX=-1.0E-15#                         Make gradiant very large         PA52  72
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA52  73
MNGRAD=MIN(DELY/DELX,MNGRAD)#                                           PA52  74
ifeq:(MNGRAD,DELY/DELX)#               If the minimum gradiant          PA52  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA52  76
VLOG(J+1)=I#                           Log the vertex                   PA52  77
NEWX=X2;NEWY=Y2#                       Save the coords                  PA52  78
NEWPT=yes:#                            A value has been found           PA52  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA52  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA52  81
IF(NEWPT==no:)BREAK#                                                    PA52  82
J=J+1#                                 Increment vertex counter         PA52  83
X1=NEWX;Y1=NEWY#                       Set new initial points           PA52  84
XAVE=XAVE+X1;YAVE=YAVE+Y1#             Accumulate average               PA52  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA52  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA52  87
QX(CMARK+7)=XAVE/FLOAT(J-1)#           Store average x coord            PA52  88
QX(CMARK+8)=YAVE/FLOAT(J-1)#           Store average y coord            PA52  89
#                                                                       PA52  90
RETURN#                                                                 PA52  91
END#                                                                    PA52  92
#                                                                       PA52  93
systemheader:(PA53)#                                                    PA53   1
####################################################################    PA53   2
#                                                                  #    PA53   3
# LOOP OVER ALL PHOTO PAIRS TO DETERMINE ALPHA AND BETA            #    PA53   4
#                                                                  #    PA53   5
####################################################################    PA53   6
SUBROUTINE PA53#                                                        PA53   7
include:(AACOMN)#                                                       PA53   8
include:(PACOMN)#                                                       PA53   9
#                                                                       PA53  10
INTEGER II,I,J,K,L,M,N#                                                 PA53  11
INTEGER MARKC,MARKD,MARKE,STOPE#                                        PA53  12
INTEGER FMARK,FMARK1#                                                   PA53  13
INTEGER NV1,NV2,NPED#                                                   PA53  14
INTEGER NCV#                                                            PA53  15
INTEGER COMON#                                                          PA53  16
REAL XI,XJ,AIJ,SI#                                                      PA53  17
REAL SUM#                                                               PA53  18
REAL VERT1A,VERT1B#                                                     PA53  19
REAL RIJ(3)#                                                            PA53  20
REAL DIFF Z1A,Z2A#                                                      PA53  21
REAL DALF,DBET#                        Alpha beta and shifts            PA53  22
REAL NUM1,NUM2,DEN#                    Least square numerator denom     PA53  23
REAL R,RA,RB,RAA,RAB,RBB#              Least square sums                PA53  24
REAL SXKA,SXKB,SYKA,SYKB,SZKA,SZKB#                                     PA53  25
REAL KA,KB,DKA,DKB,RKA,RKB,R2KA,R2KB#                                   PA53  26
REAL XKA,XKB,YKA,YKB#                                                   PA53  27
REAL VARA, VARB,TST#                                                    PA53  28
datastuff:#                                                             PA53  29
#                                                                       PA53  30
#
#   MAJOR STORAGE REQUEST
#   ---------------------
#
CORMAT=REFVAR*(REFVAR+1)/2#            Linear length of corr matrix
LENG=VMAX*(VMAX-1)/2#                  Linear length of relco matrix
RELCON=WRKSPC#                         Number of (xi-xj) etc
incrqx:(XYZ,RELCON+LENG,PA5302)#       Storage of numb of rel coords
incrqx:(SHIFT ,XYZ+3*LENG,PA5302)#     Storage of relative coords
incrqx:(CORMAX ,SHIFT+REFVAR,PA5302)#  Least squares shift vector
incrqx:(GENSUM ,CORMAX+CORMAT,PA5302)# Correlation matrix   
incrqx:(WRKSPC ,GENSUM+2*CORMAT*LENG,PA5302)# General sums  (many)
#                                                                       PA53  41
ALF =0.0 ; BET = 0.0#                                                   PA53  42
#                                                                       PA53  43
DO LOOP= 1,10#                         Least squares iteration loop     PA53  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA53  45
movereal:(0.0,1,QX,RELCON+1,LENG*17,2)#                                 PA53  46
R=0.0 ; RA=0.0 ; RB=0.0 ; RAA=0.0 ; RBB=0.0 ; RAB=0.0#                  PA53  47
MARKE=WRKSPC#                                                           PA53  48
NCV=QX(MARKE+1)#                       Number of entries in packet      PA53  49
DO I=1,NPAIR#                          Loop over data packets           PA53  50
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA53  51
CALL PA67(NCV,MARKE)#                  Accumulate sums                  PA53  52
MARKE=MARKE+(NCV+1)*DTPK#              Point to next data packet        PA53  53
NCV=QX(MARKE+1)#                       Number of entries in packet      PA53  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA53  55
#                                                                       PA53  56
DO POS=1,LENG#                                                          PA53  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA53  58
NCP=QX(RELCON+POS)#                                                     PA53  59
ifne:(NCP,0.0)#                                                         PA53  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA53  61
R=R+QX(XYZ2+POS)/NCP#                                                   PA53  62
RA=RA+QX(XYZ1A+POS)/NCP#                                                PA53  63
RB=RB+QX(XYZ1B+POS)/NCP#                                                PA53  64
RAA=RAA+QX(XYZAA+POS)/NCP#                                              PA53  65
RBB=RBB+QX(XYZBB+POS)/NCP#                                              PA53  66
RAB=RAB+QX(XYZAB+POS)/NCP#                                              PA53  67
DO I=0,2#                                                               PA53  68
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA53  69
QX(XYZ+POS+I*LENG)  =QX(XYZ+POS+I*LENG)/NCP#                            PA53  70
QX(XYZA+POS+I*LENG) =QX(XYZA+POS+I*LENG)/NCP#                           PA53  71
QX(XYZB+POS+I*LENG) =QX(XYZB+POS+I*LENG)/NCP#                           PA53  72
R =R -QX(XYZ+POS+I*LENG)*QX(XYZ+POS+I*LENG)#                            PA53  73
RA=RA-QX(XYZ+POS+I*LENG)*QX(XYZA+POS+I*LENG)# Pa53                      PA53  74
RB=RB-QX(XYZ+POS+I*LENG)*QX(XYZB+POS+I*LENG)# Pa53                      PA53  75
RAA=RAA-QX(XYZA+POS+I*LENG)*QX(XYZA+POS+I*LENG)# Pa53                   PA53  76
RBB=RBB-QX(XYZB+POS+I*LENG)*QX(XYZB+POS+I*LENG)# Pa53                   PA53  77
RAB=RAB-QX(XYZA+POS+I*LENG)*QX(XYZB+POS+I*LENG)# Pa53                   PA53  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA53  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA53  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA53  81
#                                                                       PA53  82
DEN=RAA*RBB-RAB*RAB#                                                    PA53  83
DALF=(RAB*RB-RBB*RA)/DEN#              Shift in alpha                   PA53  84
DBET=(RAB*RA-RAA*RB)/DEN#              Shift in beta                    PA53  85
VARA=RBB/DEN ; VARB=RAA/DEN#                                            PA53  86
ALF=ALF+FUDG*DALF#                                                      PA53  87
BET=BET+FUDG*DBET#                                                      PA53  88
TST=(ABS(DALF)+ABS(DBET))/SQRT(VARA+VARB)# P                            PA53  89
WRITE(6,*)" minimization criteria",R#                                   PA53  90
WRITE(6,*)" alph shft beta shft  ",DALF,DBET#                           PA53  91
WRITE(6,*)" alpha and beta       ",ALF,BET#                             PA53  92
WRITE(6,*)" shifts / esd         ",TST#                                 PA53  93
IF (TST<0.0001) BREAK#                 P                                PA53  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA53  95
WRITE(6,*)" "#                                                          PA53  96
WRITE(6,*)"Final alpha and beta angles"#                                PA53  97
WRITE(6,*)"alpha  ",ALF*180./PI," beta  ",BET*180./PI#                  PA53  98
WRITE(6,*)"sig(a) ",SQRT(VARA)*180./PI," sig(b) ",SQRT(VARB)*180./PI#   PA53  99
WRITE(6,*)" "#                                                          PA53 100
#                                                                       PA53 101
RETURN#                                                                 PA53 102
END#                                                                    PA53 103
#                                                                       PA53 104
systemheader:(PA54)#                                                    PA54   1
####################################################################    PA54   2
#                                                                  #    PA54   3
#  PROCESS REFINEMENT CONTROL PARAMS                                    PA54   4
#                                                                  #    PA54   5
####################################################################    PA54   6
SUBROUTINE PA54#                                                        PA54   7
include:(AACOMN)#                                                       PA54   8
include:(PACOMN)#                                                       PA54   9
#                                                                       PA54  10
# CONSTRUCT LISTS OF POSSIBLE PROJECTION VARIABLES                      PA54  11
# ------------------------------------------------                      PA54  12
#                                                                       PA54  13
STLST1=WRKSPC#                         Empty work area                  PA54  14
incrqx:(PTLST1,STLST1+5*PNUM,PA5302)#  Points to ith alfa for jth pnu   PA54  15
MARKC=PROJDT#                          First projection packet          PA54  16
DO I=1,PNUM#                           Cycle over all projections       PA54  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA54  18
NV1=NINT(QX(MARKC+5))#                 Num vertices proj 1              PA54  19
QX(STLST1+I)=QX(MARKC+2)#              Store manual rotation angle      PA54  20
DO J=1,4 ;QX(STLST1+J*PNUM+I)=QX(MARKC+8+J)# Store alfa beta dpth dis   PA54  21
MARKC=MARKC+PPKT+NV1*VPKT#             Next projection                  PA54  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA54  23
#                                                                       PA54  24
# ANALYSE LISTS OF  PARAMETERS                                          PA54  25
# ----------------------------                                          PA54  26
#                                                                       PA54  27
incrqx:(TEMP1,PTLST1+5*PNUM,PA5302)#   Points to ith alfa for jth pnu   PA54  28
incrqx:(STLST2,TEMP1+5,PA5302)#        Points 2 num of common variabl   PA54  29
WRKSPC=STLST2#                         Empty work area                  PA54  30
#                                                                       PA54  31
DO II=0,4#                             Loop over 5 param lists          PA54  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA54  33
QX(TEMP1+II+1)=FLOAT(WRKSPC)#          Point to adres of common var c   PA54  34
MARK1=WRKSPC#                          Beginnning of non =  list        PA54  35
incrqx:(WRKSPC,MARK1+2,PA5302)#        Get mem for first param          PA54  36
QX(MARK1+1)=1.0#                       Count first param                PA54  37
QX(MARK1+2)=QX(STLST1+II*PNUM+1)#      Copy first param                 PA54  38
QX(PTLST1+II*PNUM+1)=1.0#              Pointr list points to first en   PA54  39
DO I=2,PNUM#                           Loop remainder and test if =     PA54  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA54  41
FLG=0#                                 Assume not in list               PA54  42
DO J=MARK1+2,WRKSPC; ifeq:(QX(STLST1+II*PNUM+I),QX(J)) FLG=J-MARK1-1#   PA54  43
IF (FLG==0)#                           Not in list so add               PA54  44
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA54  45
incrqx:(WRKSPC,WRKSPC+1,PA5302)#       Find mem                         PA54  46
QX(WRKSPC)=QX(STLST1+II*PNUM+I)#       And store                        PA54  47
QX(MARK1+1)= QX(MARK1+1)+1.0#          Increase num of non similar it   PA54  48
QX(PTLST1+II*PNUM+I)= FLOAT(WRKSPC-MARK1+1)# Point location in param    PA54  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA54  50
ELSE QX(PTLST1+II*PNUM+I)=FLOAT(FLG)#  Point location in param lst      PA54  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA54  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA54  53
#                                                                       PA54  54
TEMP2=WRKSPC#                                                           PA54  55
incrqx:(WRKSPC,TEMP2+5,PA5302)#        Points 2 num of common variabl   PA54  56
NCS=QX(NINT(QX(TEMP1+1)))#             Number of common settings        PA54  57
DO I=1,4#                              Loop over alf bet depth dist     PA54  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA54  59
NCI=QX(NINT(QX(TEMP1+I+1)))#           Min num of non = params          PA54  60
IF (NCI==NCS & NCS==1) QX(TEMP2+I+1)= 0.0# A type 1 variable eg a1      PA54  61
ELSE IF (NCI==NCS &NCS <PNUM)#         A type  c variable eg ac         PA54  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA54  63
TST=no:#                                                                PA54  64
DO J=1,PNUM ; ifne:(QX(PTLST1+I*PNUM+J),QX(PTLST1+J)) TST=yes:#         PA54  65
IF (TST==no:) QX(TEMP2+I+1)=1.0#       A type  c variable eg ac         PA54  66
ELSE          QX(TEMP2+I+1)=2.0#       A type  i variable eg ai         PA54  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA54  68
ELSE          QX(TEMP2+I+1)=2.0#       A type  i variable eg ai         PA54  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA54  70
#                                                                       PA54  71
# CREATE COMPLETE LIST OF *REFINMENT* VARIABLES                         PA54  72
# -------------------------------------------                           PA54  73
#                                                                       PA54  74
MARK1=WRKSPC#                                                           PA54  75
DO I=1,14#                                                              PA54  76
IF (PARAM(I)!=0)#                                                       PA54  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA54  78
IF (I<7)#                                                               PA54  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA54  80
incrqx:(MARK2,MARK1+1,PA5302)#                                          PA54  81
movereal:(QX,MARK(I),QX,MARK1+1,1,1)#                                   PA54  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA54  83
ELSEIF ( I<=10)#                       All photos different             PA54  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA54  85
incrqx:(MARK2,MARK1+PNUM,PA5302)#                                       PA54  86
IF (PARAM(I)==-1)  
$(
DO K=1,PNUM ; QX(MARK1+K)=K#      
PARAM(I)=PNUM
$)
ELSE#                                                                   PA54  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA54  89
DO J=1,STOP(I)-MARK(I)#                                                 PA54  90
DO K=1,PNUM ; ifeq:(QX(MARK(I)+J-1),K) QX(MARK1+K)=J#                   PA54  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA54  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA54  93
ELSE IF (I<=14)#                       Common manual rotation setting   PA54  94
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA54  95
incrqx:(MARK2,MARK1+NCS,PA5302)#                                        PA54  96
IF (PARAM(I)==-1) 
$(
DO K=1,NCS ; QX(MARK1+K)=K#        
PARAM(I)=ncs
$)
ELSE#                                                                   PA54  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PA54  99
DO J=1,STOP(I)-MARK(I)#                                                 PA54 100
DO K=1,NCS ; ifeq:(QX(MARK(I)+J-1),QX(SETLST2+1+K)) QX(MARK1+K)=J#      PA54 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PA54 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PA54 103
MARK(I)=MARK1+1-WRKSPC ; STOP(I)=MARK2-WRKSPC#                          PA54 104
MARK1=MARK2#                                                            PA54 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA54 106
MARK1=WRKSPC#                                                           PA54 107
WRKSPC=MARK2#                                                           PA54 108
#                                                                       PA54 109
#  ADDAPT PARAMS TO POINT TO DERIVATIVE VECTOR AND FIND INITIAL VALUES  PA54 110
#  ----------------------------------------------------                 PA54 111
#                                                                       PA54 112
MARK3=WRKSPC#                                                           PA54 113
REFVAR=0  ; TMP=1#                     Initialz numb of refined vars
DO I=1,14#                                                              PA54 115
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PA54 116
IF (PARAM(I)==0)NEXT#                                                   PA54 117
REFVAR=REFVAR+TMP#                                                      PA54 120
TMP=PARAM(I)#                                                           PA54 118
PARAM(I)=REFVAR#                                                        PA54 119
incrqx:(MARK3, MARK3+STOP(I)-MARK(I), PA5401)#                          PA54 121
IF     (I==1)  QX(MARK2+PARAM(I))=QX(MARK1+MARK(1))#                    PA54 122
ELSEIF (I==2)  QX(MARK2+PARAM(I))=QX(MARK1+MARK(2))#                    PA54 123
ELSEIF (I<7)#                                                           PA54 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PA54 125
ifne:(QX(TEMP2+I-2+1),0.0) iquit:(PA5400)# Invalid refinement type      PA54 126
QX(MARK2+PARAM(I))=QX(NINT(QX(TEMP1+I-1))+1)#                           PA54 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PA54 128
ELSEIF (I<11) movereal:(QX,SETLST+(I-6)+1,QX,MARK2+MARK(I),PNUM,1)#     PA54 129
ELSEIF (I<15)#                                                          PA54 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PA54 131
IF (NINT(QX(TEMP2+I-10)!=1)) iquit:(PA5400)# Invalid refinement type    PA54 132
movereal:(QX,NINT(QX(TEMP1+I-9))+1,QX,MARK2+MARK(I),NCS,1)#             PA54 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PA54 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PA54 135
REFVAR=REFVAR+TMP-1# 
WRKSPC=MARK3#                                                           PA54 136
#                                                                       PA54 137
MARKE=WRKSPC#                                                           PA54 138
COMON=yes:#                                                             PA54 139
DTPK=5#                                                                 PA54 140
MARKC=PROJDT#                          Loop over all pairs of projns    PA54 141
#                                                                       PA54 142
NPAIR=0#                                                                PA54 143
DO II=1,PNUM-2#                                                         PA54 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PA54 145
NV1=NINT(QX(MARKC+5))#                 Num vertices proj 1              PA54 146
MARKD=MARKC#                                                            PA54 147
DO JJ=II+1,PNUM-1#                                                      PA54 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PA54 149
MARKD=MARKD+PPKT+NV1*VPKT#             Next projection                  PA54 150
NV2=NINT(QX(MARKD+5))#                 Num vertices proj 2              PA54 151
IF (COMON==yes:) ifne:(QX(MARKC+2),QX(MARKD+2)) NEXT#                   PA54 152
#                                                                       PA54 153
NPAIR=NPAIR+1#                                                          PA54 154
WRITE(6,*)"photo pair, photo numbers ",II,QX(MARKC+6),QX(MARKD+6)#      PA54 155
#                                                                       PA54 156
incrqx:(STOPE,MARKE+DTPK,PA5302)#                                       PA54 157
#ALF=QX(MARKC+9);BET=QX(MARKC+10)#     GET ALPHA AND BETA IF KNOWN      PA54 158
QX(MARKE+2)=II#                                                         PA54 159
QX(MARKE+3)=JJ#                                                         PA54 160
QX(MARKE+4)=QX(MARKC+3)#                                                PA54 161
QX(MARKE+5)=QX(MARKD+3)#                                                PA54 162
NCV=0#                                 Number of common points          PA54 163
DO I=1,NV1#                            Get all vertex numbers           PA54 164
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PA54 165
VERT1A=QX(MARKC+PPKT+(I-1)*VPKT+1)#    Vertex id                        PA54 166
DO J=1,NV2#                            Get all vertex numbers           PA54 167
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PA54 168
VERT1B=QX(MARKD+PPKT+(J-1)*VPKT+1)#    Vertex id                        PA54 169
ifeq:(VERT1A,VERT1B)#                  Common point                     PA54 170
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 PA54 171
NCV=NCV+1#                             Count common points              PA54 172
incrqx:(STOPE,STOPE+DTPK,PA5302)#                                       PA54 173
QX(STOPE-DTPK+1)=VERT1A#               Store common point id            PA54 174
QX(STOPE-DTPK+2)=QX(MARKC+PPKT+(I-1)*VPKT+2)# X coordinate point fram   PA54 175
QX(STOPE-DTPK+3)=QX(MARKC+PPKT+(I-1)*VPKT+3)# Y coordinate point fram   PA54 176
QX(STOPE-DTPK+4)=QX(MARKD+PPKT+(J-1)*VPKT+2)# X coordinate point fram   PA54 177
QX(STOPE-DTPK+5)=QX(MARKD+PPKT+(J-1)*VPKT+3)# Y coordinate point fram   PA54 178
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 PA54 179
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PA54 180
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PA54 181
QX(MARKE+1)=FLOAT(NCV)#                                                 PA54 182
MARKE=STOPE#                                                            PA54 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PA54 184
MARKC=MARKC+PPKT+NV1*VPKT#             Next projection                  PA54 185
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PA54 186
RELCON=STOPE#                                                           PA54 187
#                                                                       PA54 188
RETURN#                                                                 PA54 189
END#                                                                    PA54 190
#                                                                       PA54 191
systemheader:(PA59)#                                                    PA59   1
####################################################################    PA59   2
#                                                                  #    PA59   3
# PRINT RELATIVE POSITION MATRICES                                 #    PA59   4
#                                                                  #    PA59   5
####################################################################    PA59   6
SUBROUTINE PA59(EMARK,DIM,NUM,TYPE)#                                    PA59   7
include:(AACOMN)#                                                       PA59   8
include:(PACOMN)#                                                       PA59   9
INTEGER I,J,K,POS,V2#                                                   PA59  10
INTEGER EMARK,DIM,NUM,TYPE#                                             PA59  11
realdata:(FM2,[70622.,140622.,210622.,280622.,350622.,420622.,$#        PA59  12
490622.,560622.,630622.,700622.,7700622.,840622.,910622.])#             PA59  13
chardata:(XT502,"  (i-2)  (i-3)  (i-4)  (i-5)  (i-6)  (i-7)  $#         PA59  14
(i-8)  (i-9)  (i-10) (i-11) (i-12)")#                                   PA59  15
datastuff:#                                                             PA59  16
#                                                                       PA59  17
WRITE(6,*)" "#                                                          PA59  18
WRITE(6,*)" "#                                                          PA59  19
IF (TYPE==1)#                                                           PA59  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA59  21
V2=DIM*(DIM+1)/2#                      Pa                               PA59  22
DO K=0,NUM-1#                                                           PA59  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA59  24
WRITE(6,*)"matrix number (1=x,2=y,3=z) : ",K+1#                         PA59  25
writeline:(0,XT502,NXT502,3,3)#        Write to outfile                 PA59  26
POS=1#                                                                  PA59  27
DO I=1,DIM#                            Pa5                              PA59  28
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA59  29
DO J=0,I-1 ;BUFOT(J)=0.0#                                               PA59  30
DO J=I,DIM#                            Pa5                              PA59  31
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA59  32
BUFOT(J)=QX(EMARK+POS+K*V2)#                                            PA59  33
POS=POS+1#                                                              PA59  34
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA59  35
ncodefld:(BUFOT,1,CHROT,FM2,DIM)#      Pa5                              PA59  36
writeline:(0,XT502,NXT502,1,3)#        Write to outfile                 PA59  37
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA59  38
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA59  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA59  40
ELSEIF (TYPE==2)#                                                       PA59  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA59  42
DO I=1,DIM#                            Pa5                              PA59  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA59  44
DO J=1,DIM#                            Pa5                              PA59  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA59  46
BUFOT(J)=QX(EMARK+(I-1)*DIM+J)#                                         PA59  47
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA59  48
ncodefld:(BUFOT,1,CHROT,FM2,DIM)#      Pa5                              PA59  49
writeline:(0,XT502,NXT502,1,3)#        Write to outfile                 PA59  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA59  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA59  52
#                                                                       PA59  53
RETURN#                                                                 PA59  54
END#                                                                    PA59  55
#                                                                       PA59  56
systemheader:(PA67)#                                                    PA67   1
####################################################################    PA67   2
#                                                                  #    PA67   3
#                                                                       PA67   4
#                                                                  #    PA67   5
####################################################################    PA67   6
SUBROUTINE PA67(NCV,MARKE)#                                             PA67   7
include:(AACOMN)#                                                       PA67   8
include:(PACOMN)#                                                       PA67   9
#                                                                       PA67  10
INTEGER ROW,COL,ROWI,COLJ#                                              PA67  11
INTEGER I,J#                                                            PA67  12
INTEGER NCV,MARKE#                                                      PA67  13
INTEGER POS#                                                            PA67  14
REAL MA1(3,3),MB1(3,3)#                                                 PA67  15
REAL MA2(3,3),MB2(3,3)#                                                 PA67  16
REAL MA3(3,3),MB3(3,3)#                                                 PA67  17
REAL MG1(3,3),MG2(3,3)#                                                 PA67  18
REAL RA12(3,3),RB12(3,3)#                                               PA67  19
REAL RA21(3,3),RB21(3,3)#                                               PA67  20
REAL A2222(3,3),B2222(3,3)#                                               PA67  21
REAL RA23(3,3),RB23(3,3)#                                               PA67  22
REAL RA32(3,3),RB32(3,3)#                                               PA67  23
REAL VA(3),VB(3)#                                                       PA67  24
REAL VC1(3),VC2(3)#                                                     PA67  25
REAL VC1A(3),VC2A(3)#                                                   PA67  26
REAL VC1B(3),VC2B(3)#                                                   PA67  27
REAL VA12(3),VB12(3)#                                                   PA67  28
REAL VA21(3),VB21(3)#                                                   PA67  29
REAL VA22(3),VB22(3)#                                                   PA67  30
REAL VA23(3),VB23(3)#                                                   PA67  31
REAL VA32(3),VB32(3)#                                                   PA67  32
REAL TMP(3,3)#                                                          PA67  33
REAL TEMP(8)#                                                           PA67  34
REAL TEMP1, TEMP2#                                                      PA67  35
REAL X1A,X1B,X2A,X2B#                                                   PA67  36
REAL Y1A,Y1B,Y2A,Y2B#                                                   PA67  37
REAL GA,GB,SGA,SGB,CGA,CGB#                                             PA67  38
REAL SA,CA,SB,CB#                                                       PA67  39
#                                                                       PA67  40
#                                                                       PA67  41
PROJA=NINT(QX(MARKE+2))#                                                PA67  42
PROJB=NINT(QX(MARKE+3))#                                                PA67  43
GMA0=QX(MARKE+4)#                                                       PA67  44
GMB0=QX(MARKE+5)#                                                       PA67  45
GMA1=QX(SETLST+PROJA)#                                                  PA67  46
GMB1=QX(SETLST+PROJB)#                                                  PA67  47
PTA=NINT(QX(PTLST1+PROJA))#                                             PA67  48
PTB=NINT(QX(PTLST1+PROJB))#                                             PA67  49
#                                                                       PA67  50
IF (PARAM(1)!=0) AL0=QX(MARK2+PARAM(1))#                                PA67  51
ELSE AL0=ALF#                                                           PA67  52
IF (PARAM(2)!=0) BE0=QX(MARK2+PARAM(2))#                                PA67  53
ELSE BE0=BET#                                                           PA67  54
DO J=1,4#                                                               PA67  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PA67  56
IF (PARAM(J+2)!=0)#                                                     PA67  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PA67  58
LIST1(J)=QX(MARK2+MARK(J+2))#       
LIST2(j)=PARAM(J+2)
LIST1(4+J)=QX(MARK2+MARK(J+2))#      
LIST2(4+j)=PARAM(J+2)
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PA67  61
ELSEIF (PARAM(J+6)!=0)#                                                 PA67  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PA67  63
LIST1(J)  =QX(MARK2+MARK(J+6)+PROJA)#                                   PA67  64
LIST1(4+J)=QX(MARK2+MARK(J+6)+PROJB)#                                   PA67  65
ifeq:(QX(MARK1+MARK(J+6)+PROJA),0.0) LIST2(J)=0#                        PA67  66
ELSE LIST2(J)=PARAM(J+6)+nint(QX(MARK1+MARK(J+6)+PROJA))
ifeq:(QX(MARK1+MARK(J+6)+PROJB),0.0) LIST2(J+4)=0#                      PA67  68
ELSE LIST2(J+4)=PARAM(J+6)+nint(QX(MARK1+MARK(J+6)+PROJB))
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PA67  70
ELSEIF (PARAM(J+10)!=0)#                                                PA67  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PA67  72
LIST1(J)  =QX(MARK2+MARK(J+10)+PTA)#                                    PA67  73
LIST1(4+J)=QX(MARK2+MARK(J+10)+PTB)#                                    PA67  74
ifeq:(QX(MARK1+MARK(J+10)+PTA),0.0) LIST2(J)=0#                         PA67  75
ELSE LIST2(J)=PARAM(J+10)+nint(QX(MARK1+MARK(J+10)+PTA))
ifeq:(QX(MARK1+MARK(J+10)+PTB),0.0) LIST2(J+4)=0#                       PA67  77
ELSE LIST2(J+4)=PARAM(J+10)+nint(QX(MARK1+MARK(J+10)+PTA))
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PA67  79
ELSE#                                                                   PA67  80
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PA67  81
LIST1(J)  =QX(SETLST1+J*PNUM+PROJA)#                                    PA67  82
LIST2(J)=0#                                                             PA67  83
LIST1(4+J)=QX(SETLST1+J*PNUM+PROJB)#                                    PA67  84
LIST2(J+4)=0#                                                           PA67  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PA67  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PA67  87
AL1=LIST1(1) ; AL2=LIST1(5)#                                            PA67  88
BE1=LIST1(2) ; BE2=LIST1(6)#                                            PA67  89
DP1=LIST1(3) ; DP2=LIST1(7)#                                            PA67  90
VD1=LIST1(4) ; VD2=LIST1(8)#                                            PA67  91
#                                                                       PA67  92
#  CONSTRUCT ZERO POINT MATRICES                                        PA67  93
#  --------------------                                                 PA67  94
#                                                                       PA67  95
DO I=1,3 ; DO J=1,3#                   Initialise                       PA67  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PA67  97
MPA2(I,J)=0.0   ; MPB2(I,J)=0.0#                                        PA67  98
MQA2(I,J)=0.0   ; MQB2(I,J)=0.0#                                        PA67  99
MRA2(I,J)=0.0   ; MRB2(I,J)=0.0#                                        PA67 100
MSA2(I,J)=0.0   ; MSB2(I,J)=0.0#                                        PA67 101
MT2(I,J)=0.0    ;  MU2(I,J)=0.0#                                        PA67 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PA67 103
CA0=COS(A0)     ; SA0=SIN(A0)#                                          PA67 104
CB0=COS(B0)     ; SB0=SIN(B0)#                                          PA67 105
CG0A=COS(GA0)   ; SG0A=SIN(GA0)#                                        PA67 106
CG0B=COS(GB0)   ; SG0B=SIN(GB0)#                                        PA67 107
CA1=COS(A1)     ; SA1=SIN(A1)#                                          PA67 108
CA2=COS(A2)     ; SA2=SIN(A2)#                                          PA67 109
CB1=COS(B1)     ; SB1=SIN(B1)#                                          PA67 110
CB2=COS(B2)     ; SB2=SIN(B2)#                                          PA67 111
CG1A=COS(GA1)   ; SG1A=SIN(GA1)#                                        PA67 112
CG1B=COS(GB1)   ; SG1B=SIN(GB1)#                                        PA67 113
MU2(1,1)=CB0    ; MU2(1,3)=SB0#                                         PA67 114
MU2(3,1)=-SB0   ; MU2(3,3)=CB0   ; MU2(2,2)=1.0#                        PA67 115
MT2(1,1)=CA0    ; MT2(1,2)=SA0#                                         PA67 116
MT2(2,1)=-SA0   ; MT2(2,2)=CA0   ; MT2(3,3)=1.0#                        PA67 117
MSA2(2,2)=CG0A  ; MSA2(2,3)=SG0A#                                       PA67 118
MSA2(3,2)=-SG0A ; MSA2(3,3)=CG0A ; MSA2(1,1)=1.0#                       PA67 119
MSB2(2,2)=CG0B  ; MSB2(2,3)=SG0B#                                       PA67 120
MSB2(3,2)=-SG0B ; MSB2(3,3)=CG0B ; MSB2(1,1)=1.0#                       PA67 121
MRA2(1,1)=CB1   ; MRA2(1,3)=SB1#                                        PA67 122
MRA2(3,1)=-SB1  ; MRA2(3,3)=CB1  ; MRA2(2,2)=1.0#                       PA67 123
MRB2(1,1)=CB2   ; MRB2(1,3)=SB2#                                        PA67 124
MRB2(3,1)=-SB2  ; MRB2(3,3)=CB2  ; MRB2(2,2)=1.0#                       PA67 125
MQA2(1,1)=CA1   ; MQA2(1,3)=SA1#                                        PA67 126
MQA2(2,1)=-SA1  ; MQA2(2,2)=CA1  ; MQA2(3,3)=1.0#                       PA67 127
MQB2(1,1)=CA1   ; MQB2(1,2)=SA1#                                        PA67 128
MQB2(2,1)=-SA1  ; MQB2(2,2)=CA1  ; MQB2(3,3)=1.0#                       PA67 129
MPA2(2,2)=CG1A  ; MPA2(2,3)=SG1A#                                       PA67 130
MPA2(3,2)=-SG1A ; MPA2(3,3)=CG1A ; MPA2(1,1)=1.0#                       PA67 131
MPB2(2,2)=CG1B  ; MPB2(2,3)=SG1B#                                       PA67 132
MPB2(3,2)=-SG1B ; MPB2(3,3)=CG1B ; MPB2(1,1)=1.0#                       PA67 133
#                                                                       PA67 134
# CONSTRUCT FURTHER TWO MATRICES FOR EACH DERIVATIVE                    PA67 135
# --------------------------------------------------                    PA67 136
#                                                                       PA67 137
mmult:(MPA2,MQA2,AF)#                                                   PA67 138
mmult:(AF,MRA2,AF)#                                                     PA67 139
mmult:(AF,MSA2,AF)#                                                     PA67 140
mmult:(AF,MT2,AF)#                                                      PA67 141
mmult:(MPB2,MQB2,BF)#                                                   PA67 142
mmult:(BF,MRB2,BF)#                                                     PA67 143
mmult:(BF,MSB2,BF)#                                                     PA67 144
mmult:(BF,MT2,BF)#                                                      PA67 145
MMULT(AF,MU2,A2222)#                                                    PA67 146
MMULT(BF,MU2,B2222)#                                                    PA67 147
DELTA =0.01#                                                            PA67 148
IF (PARAM(2)!=0)#                                                       PA67 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA67 150
CB0=COS(B0-DELTA) ; SB0=SIN(B0-DELTA)#                                  PA67 151
MU1(1,1)=CB0      ; MU1(1,3)=SB0#                                       PA67 152
MU1(3,1)=-SB0     ; MU1(3,3)=CB0   ; MU1(2,2)=1.0#                      PA67 153
CB0=COS(B0+DELTA) ; SB0=SIN(B0+DELTA)#                                  PA67 154
MU1(1,3)=CB0      ; MU3(1,3)=SB0#                                       PA67 155
MU1(3,3)=-SB0     ; MU3(3,3)=CB0   ; MU3(2,2)=1.0#                      PA67 156
MMULT(AF,MU1,A2221)#                                                    PA67 157
MMULT(AF,MU3,A2223)#                                                    PA67 158
MMULT(BF,MU1,B2221)#                                                    PA67 159
MMULT(BF,MU3,B2223)#                                                    PA67 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PA67 161
transp:(MT2,MT2I)#                                                      PA67 162
mmult:(AF,MT2I,AF)#                                                     PA67 163
mmult:(BF,MT2I,BF)#                                                     PA67 164
IF (PARAM(1)!=0)#                                                       PA67 165
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PA67 166
CA0=COS(A0-DELTA) ; SA0=SIN(A0-DELTA)#                                  PA67 167
MT1(1,1)=CA0      ; MT1(1,2)=SA0#                                       PA67 168
MT1(2,1)=-SA0     ; MT1(2,2)=CA0   ; MT1(3,3)=1.0#                      PA67 169
CA0=COS(A0+DELTA) ; SA0=SIN(A0+DELTA)#                                  PA67 170
MT3(1,1)=CA0      ; MT3(1,2)=SA0#                                       PA67 171
MT3(2,1)=-SA0     ; MT3(2,2)=CA0   ; MT3(3,3)=1.0#                      PA67 172
mmult:(AF,MT1,TMPA)#                                                    PA67 173
mmult:(TMPA,MU2,A2212)#                                                 PA67 174
mmult:(AF,MT3,TMPA)#                                                    PA67 175
mmult:(TMPA,MU2,A2232)#                                                 PA67 176
mmult:(BF,MT1,TMPB)#                                                    PA67 177
mmult:(TMPB,MU2,B2212)#                                                 PA67 178
mmult:(BF,MT3,TMPB)#                                                    PA67 179
mmult:(TMPB,MU2,B2232)#                                                 PA67 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PA67 181
transp:(MSA2,MSA2I)#                                                    PA67 182
transp:(MSB2,MSB2I)#                                                    PA67 183
mmult:(AF,MSA2I,AF)#                                                    PA67 184
mmult:(BF,MSB2I,BF)#                                                    PA67 185
mmult:(MT2,MU2,AR)#                                                     PA67 186
mmult:(MT2,MU2,BR)#                                                     PA67 187
transp:(MRA2,MRA2I)#                                                    PA67 188
transp:(MRB2,MRB2I)#                                                    PA67 189
mmult:(AF,MRA2I,AF)#                                                    PA67 190
mmult:(BF,MRB2I,BF)#                                                    PA67 191
mmult:(MSA2,AR,AR)#                                                     PA67 192
mmult:(MSB2,BR,BR)#                                                     PA67 193
IF (LIST2(2)!=0)#                                                       PA67 194
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PA67 195
CB1=COS(B1-DELTA)     ; SB1=SIN(B1-DELTA)#                              PA67 196
MRA1(1,1)=CB1   ; MRA1(1,3)=SB1#                                        PA67 197
MRA1(3,1)=-SB1  ; MRA1(3,3)=CB1  ; MRA1(2,2)=1.0#                       PA67 198
CB1=COS(B1+DELTA)     ; SB1=SIN(B1+DELTA)#                              PA67 199
MRA3(1,1)=CB1   ; MRA3(1,3)=SB1#                                        PA67 200
MRA3(3,1)=-SB1  ; MRA3(3,3)=CB1  ; MRA3(2,2)=1.0#                       PA67 201
mmult:(AF,MRA1,TMPA)#                                                   PA67 202
mmult:(TMPA,AR,A2122)#                                                  PA67 203
mmult:(AF,MRA3,TMPA)#                                                   PA67 204
mmult:(TMPA,AR,A2322)#                                                  PA67 205
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PA67 206
IF (LIST2(6)!=0)#                                                       PA67 207
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PA67 208
CB2=COS(B2-DELTA)     ; SB2=SIN(B2-DELTA)#                              PA67 209
MRB1(1,1)=CB2   ; MRB1(1,3)=SB2#                                        PA67 210
MRB1(3,1)=-SB2  ; MRB1(3,3)=CB2  ; MRB1(2,2)=1.0#                       PA67 211
CB2=COS(B2+DELTA)     ; SB2=SIN(B2+DELTA)#                              PA67 212
MRB3(1,1)=CB2   ; MRB3(1,3)=SB2#                                        PA67 213
MRB3(3,1)=-SB2  ; MRB3(3,3)=CB2  ; MRB3(2,2)=1.0#                       PA67 214
mmult:(BF,MRB1,TMPB)#                                                   PA67 215
mmult:(TMPB,BR,B2122)#                                                  PA67 216
mmult:(BF,MRB3,TMPB)#                                                   PA67 217
mmult:(TMPB,BR,B2322)#                                                  PA67 218
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PA67 219
transp:(MQA2,MQA2I)#                                                    PA67 220
transp:(MQB2,MQB2I)#                                                    PA67 221
mmult:(AF,MQA2I,AF)#                                                    PA67 222
mmult:(BF,MQB2I,BF)#                                                    PA67 223
mmult:(MRA2,AR,AR)#                                                     PA67 224
mmult:(MRB2,BR,BR)#                                                     PA67 225
IF (LIST2(1)!=0)#                                                       PA67 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA67 227
CA1=COS(A1-DELTA)     ; SA1=SIN(A1-DELTA)#                              PA67 228
MQA1(1,1)=CA1   ; MQA1(1,3)=SA1#                                        PA67 229
MQA1(2,1)=-SA1  ; MQA1(2,2)=CA1  ; MQA1(3,3)=1.0#                       PA67 230
CA1=COS(A1+DELTA)     ; SA1=SIN(A1+DELTA)#                              PA67 231
MQA3(1,1)=CA1   ; MQA3(1,3)=SA1#                                        PA67 232
MQA3(2,1)=-SA1  ; MQA3(2,2)=CA1  ; MQA3(3,3)=1.0#                       PA67 233
mmult:(AF,MQA1,TMPA)#                                                   PA67 234
mmult:(TMPA,AR,A1222)#                                                  PA67 235
mmult:(AF,MQA3,TMPA)#                                                   PA67 236
mmult:(TMPA,AR,A3222)#                                                  PA67 237
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PA67 238
IF (LIST2(5)!=0)#                                                       PA67 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PA67 240
CA2=COS(A2-DELTA)     ; SA2=SIN(A2-DELTA)#                              PA67 241
MQB1(1,1)=CA2   ; MQB1(1,2)=SA2#                                        PA67 242
MQB1(2,1)=-SA2  ; MQB1(2,2)=CA2  ; MQB1(3,3)=1.0#                       PA67 243
CA2=COS(A2+DELTA)     ; SA2=SIN(A2+DELTA)#                              PA67 244
MQB3(1,1)=CA2   ; MQB3(1,2)=SA2#                                        PA67 245
MQB3(2,1)=-SA2  ; MQB3(2,2)=CA2  ; MQB3(3,3)=1.0#                       PA67 246
mmult:(BF,MQB1,TMPB)#                                                   PA67 247
mmult:(TMPB,BR,B1222)#                                                  PA67 248
mmult:(BF,MQB3,TMPB)#                                                   PA67 249
mmult:(TMPB,BR,B1222)#                                                  PA67 250
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PA67 251
#                                                                       PA67 252
#                                                                       PA67 253
#                                                                       PA67 254
IF (1==1)#                                                              PA67 255
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PA67 256
DO COL = 1,NCV-1#                      Loop over first common points    PA67 257
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PA67 258
DO ROW = COL+1,NCV#                    Loop over second common point    PA67 259
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PA67 260
#                                                                       PA67 261
#   GET TWO POINTS IN TWO PHOTOS                                        PA67 262
#   ----------------                                                    PA67 263
#                                                                       PA67 264
ROWI=NINT(QX(MARKE+COL*DTPK+1));COLJ=NINT(QX(MARKE+ROW*DTPK+1))#        PA67 265
POS=(ROWI-1)*VMAX+COLJ-ROWI*(ROWI+1)/2# Positn in upper diag matrix     PA67 266
X1A=QX(MARKE+COL*DTPK+2) ; X1B=QX(MARKE+COL*DTPK+4)#                    PA67 267
Y1A=QX(MARKE+COL*DTPK+3) ; Y1B=QX(MARKE+COL*DTPK+5)#                    PA67 268
X2A=QX(MARKE+ROW*DTPK+2) ; X2B=QX(MARKE+ROW*DTPK+4)#                    PA67 269
Y2A=QX(MARKE+ROW*DTPK+3) ; Y2B=QX(MARKE+ROW*DTPK+5)#                    PA67 270
VA(1)=X1A-X2A ; VA(2)=Y1A-Y2A#                                          PA67 271
VB(1)=X1B-X2B ; VB(2)=Y1B-Y2B#                                          PA67 272
#                                                                       PA67 273
#                                                                       PA67 274
TEMP1=A2222(2,1)*VA(1)+A2222(2,2)*VA(2)-$\
B2222(2,1)*VB(1)-B2222(2,2)*VB(2)#  
TEMP2=A2222(3,1)*VA(1)+A2222(3,2)*VA(2)-$\
B2222(3,1)*VB(1)-B2222(3,2)*VB(2)# 
VA(3)=(B2222(3,3)*TEMP1-B2222(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2222(3,3)*B2222(2,3)-A2222(2,3)*B2222(3,3))#     
postm:(A2222,VA,VA2222)#                                          
VB(3)=(VA2222(2)-(B2222(2,1)*VB(1)+B2222(2,2)*VB(2)))/B2222(2,3)#  
postm:(B2222,VB,VB2222)#                                            
DO I=1,3 ;VC1(I)=VA2222(I) 
DO I=1,3 ;VC2(I)=VB2222(I)#
#
IF (PARAM(2)!=0)#                                                       PA67 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA67 150
TEMP1=A2221(2,1)*VA(1)+A2221(2,2)*VA(2)-$\
B2221(2,1)*VB(1)-B2221(2,2)*VB(2)#  
TEMP2=A2221(3,1)*VA(1)+A2221(3,2)*VA(2)-$\
B2221(3,1)*VB(1)-B2221(3,2)*VB(2)# 
VA(3)=(B2221(3,3)*TEMP1-B2221(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2221(3,3)*B2221(2,3)-A2221(2,3)*B2221(3,3))#     
postm:(A2221,VA,VA2221)#                                          
VB(3)=(VA2221(2)-(B2221(2,1)*VB(1)+B2221(2,2)*VB(2)))/B2221(2,3)#  
postm:(B2221,VB,VB2221)#                                            
#
TEMP1=A2223(2,1)*VA(1)+A2223(2,2)*VA(2)-$\
B2223(2,1)*VB(1)-B2223(2,2)*VB(2)#  
TEMP2=A2223(3,1)*VA(1)+A2223(3,2)*VA(2)-$\
B2223(3,1)*VB(1)-B2223(3,2)*VB(2)# 
VA(3)=(B2223(3,3)*TEMP1-B2223(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2223(3,3)*B2223(2,3)-A2223(2,3)*B2223(3,3))#     
postm:(A2223,VA,VA2223)#                                          
VB(3)=(VA2223(2)-(B2223(2,1)*VB(1)+B2223(2,2)*VB(2)))/B2223(2,3)#  
postm:(B2223,VB,VB2223)#                                            
DO I=1,3
$(
VCAB0(I)=(VA2223(I)-VA2221(I))/(2.*DELTA)#
VCBB0(I)=(VB2223(I)-VB2221(I))/(2.*DELTA)#
LIST3(PARAM(2))=VCAB0(I)-VCBB0(I)
$)
$)
#
IF (PARAM(2)!=0)#                                                       PA67 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PA67 150
TEMP1=A2212(2,1)*VA(1)+A2212(2,2)*VA(2)-$\
B2212(2,1)*VB(1)-B2212(2,2)*VB(2)#  
TEMP2=A2212(3,1)*VA(1)+A2212(3,2)*VA(2)-$\
B2212(3,1)*VB(1)-B2212(3,2)*VB(2)# 
VA(3)=(B2212(3,3)*TEMP1-B2212(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2212(3,3)*B2212(2,3)-A2212(2,3)*B2212(3,3))#     
postm:(A2212,VA,VA2212)#                                          
VB(3)=(VA2212(2)-(B2212(2,1)*VB(1)+B2212(2,2)*VB(2)))/B2212(2,3)#  
postm:(B2212,VB,VB2212)#                                            
#
TEMP1=A2232(2,1)*VA(1)+A2232(2,2)*VA(2)-$\
B2232(2,1)*VB(1)-B2232(2,2)*VB(2)#  
TEMP2=A2232(3,1)*VA(1)+A2232(3,2)*VA(2)-$\
B2232(3,1)*VB(1)-B2232(3,2)*VB(2)# 
VA(3)=(B2232(3,3)*TEMP1-B2232(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2232(3,3)*B2232(2,3)-A2232(2,3)*B2232(3,3))#     
postm:(A2232,VA,VA2232)#                                          
VB(3)=(VA2232(2)-(B2232(2,1)*VB(1)+B2232(2,2)*VB(2)))/B2232(2,3)#  
postm:(B2232,VB,VB2232)#                                            
DO I=1,3 ;VCAA0(I)=(VA2232(I)-VA2212(I))/(2.*DELTA)#
DO I=1,3 ;VCBA0(I)=(VB2232(I)-VB2212(I))/(2.*DELTA)#
$)
IF (LIST2(2)!=0)#                                                       PA67 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA67 227
TEMP1=A2122(2,1)*VA(1)+A2122(2,2)*VA(2)-$\
B2222(2,1)*VB(1)-B2222(2,2)*VB(2)#  
TEMP2=A2122(3,1)*VA(1)+A2122(3,2)*VA(2)-$\
B2222(3,1)*VB(1)-B2222(3,2)*VB(2)# 
VA(3)=(B2222(3,3)*TEMP1-B2222(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2122(3,3)*B2222(2,3)-A2122(2,3)*B2222(3,3))#     
postm:(A2122,VA,VA2122)#                                          
VB(3)=(VA2122(2)-(B2222(2,1)*VB(1)+B2222(2,2)*VB(2)))/B2222(2,3)#  
postm:(B2222,VB,VB2122)#                                            
#
TEMP1=A2322(2,1)*VA(1)+A2322(2,2)*VA(2)-$\
B2222(2,1)*VB(1)-B2222(2,2)*VB(2)#  
TEMP2=A2322(3,1)*VA(1)+A2322(3,2)*VA(2)-$\
B2222(3,1)*VB(1)-B2222(3,2)*VB(2)# 
VA(3)=(B2222(3,3)*TEMP1-B2222(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2322(3,3)*B2222(2,3)-A2322(2,3)*B2222(3,3))#     
postm:(A2322,VA,VA2322)#                                          
VB(3)=(VA2122(2)-(B2222(2,1)*VB(1)+B2222(2,2)*VB(2)))/B2222(2,3)#  
postm:(B2222,VB,VB2322)#                                            
DO I=1,3 ;VCAB1(I)=(VA2322(I)-VA2122(I))/(2.*DELTA)#
DO I=1,3 ;VCBB1(I)=(VB2322(I)-VB2122(I))/(2.*DELTA)#
$)
IF (LIST2(6)!=0)#                                                       PA67 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA67 227
TEMP1=A2222(2,1)*VA(1)+A2222(2,2)*VA(2)-$\
B2122(2,1)*VB(1)-B2122(2,2)*VB(2)#  
TEMP2=A2222(3,1)*VA(1)+A2222(3,2)*VA(2)-$\
B2122(3,1)*VB(1)-B2122(3,2)*VB(2)# 
VA(3)=(B2122(3,3)*TEMP1-B2122(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2222(3,3)*B2122(2,3)-A2222(2,3)*B2122(3,3))#     
postm:(A2222,VA,VA2122)#                                          
VB(3)=(VA2222(2)-(B2122(2,1)*VB(1)+B2122(2,2)*VB(2)))/B2122(2,3)#  
postm:(B2122,VB,VB2122)#                                            
#
TEMP1=A2222(2,1)*VA(1)+A2222(2,2)*VA(2)-$\
B2322(2,1)*VB(1)-B2322(2,2)*VB(2)#  
TEMP2=A2222(3,1)*VA(1)+A2222(3,2)*VA(2)-$\
B2322(3,1)*VB(1)-B2322(3,2)*VB(2)# 
VA(3)=(B2322(3,3)*TEMP1-B2322(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2222(3,3)*B2322(2,3)-A2222(2,3)*B2322(3,3))#     
postm:(A2222,VA,VA2322)#                                          
VB(3)=(VA2222(2)-(B2322(2,1)*VB(1)+B2322(2,2)*VB(2)))/B2322(2,3)#  
postm:(B2322,VB,VB2322)#                                            
DO I=1,3 ;VCAB2(I)=(VA2322(I)-VA2122(I))/(2.*DELTA)#
DO I=1,3 ;VCBB2(I)=(VB2322(I)-VB2122(I))/(2.*DELTA)#
$)
IF (LIST2(1)!=0)#                                                       PA67 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA67 227
TEMP1=A1222(2,1)*VA(1)+A1222(2,2)*VA(2)-$\
B2222(2,1)*VB(1)-B2222(2,2)*VB(2)#  
TEMP2=A1222(3,1)*VA(1)+A1222(3,2)*VA(2)-$\
B2222(3,1)*VB(1)-B2222(3,2)*VB(2)# 
VA(3)=(B2222(3,3)*TEMP1-B2222(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A1222(3,3)*B2222(2,3)-A1222(2,3)*B2222(3,3))#     
postm:(A1222,VA,VA1222)#                                          
VB(3)=(VA1222(2)-(B2222(2,1)*VB(1)+B2222(2,2)*VB(2)))/B2222(2,3)#  
postm:(B2222,VB,VB1222)#                                            
#
TEMP1=A3222(2,1)*VA(1)+A3222(2,2)*VA(2)-$\
B2222(2,1)*VB(1)-B2222(2,2)*VB(2)#  
TEMP2=A3222(3,1)*VA(1)+A3222(3,2)*VA(2)-$\
B2222(3,1)*VB(1)-B2222(3,2)*VB(2)# 
VA(3)=(B2222(3,3)*TEMP1-B2222(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A3222(3,3)*B2222(2,3)-A3222(2,3)*B2222(3,3))#     
postm:(A3222,VA,VA3222)#                                          
VB(3)=(VA3222(2)-(B2222(2,1)*VB(1)+B2222(2,2)*VB(2)))/B2222(2,3)#  
postm:(B2222,VB,VB3222)#                                            
DO I=1,3 ;VCAA1(I)=(VA3222(I)-VA1222(I))/(2.*DELTA)#
DO I=1,3 ;VCBA1(I)=(VB3222(I)-VB1222(I))/(2.*DELTA)#
$)
IF (LIST2(5)!=0)#                                                       PA67 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PA67 227
TEMP1=A2222(2,1)*VA(1)+A2222(2,2)*VA(2)-$\
B1222(2,1)*VB(1)-B1222(2,2)*VB(2)#  
TEMP2=A2222(3,1)*VA(1)+A2222(3,2)*VA(2)-$\
B1222(3,1)*VB(1)-B1222(3,2)*VB(2)# 
VA(3)=(B1222(3,3)*TEMP1-B1222(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2222(3,3)*B1222(2,3)-A2222(2,3)*B1222(3,3))#     
postm:(A2222,VA,VA1222)#                                          
VB(3)=(VA2222(2)-(B1222(2,1)*VB(1)+B1222(2,2)*VB(2)))/B1222(2,3)#  
postm:(B1222,VB,VB1222)#                                            
#
TEMP1=A2222(2,1)*VA(1)+A2222(2,2)*VA(2)-$\
B3222(2,1)*VB(1)-B3222(2,2)*VB(2)#  
TEMP2=A2222(3,1)*VA(1)+A2222(3,2)*VA(2)-$\
B3222(3,1)*VB(1)-B3222(3,2)*VB(2)# 
VA(3)=(B3222(3,3)*TEMP1-B3222(2,3)*TEMP2)#                    
VA(3)=VA(3)/(A2222(3,3)*B3222(2,3)-A2222(2,3)*B3222(3,3))#     
postm:(A2222,VA,VA3222)#                                          
VB(3)=(VA2222(2)-(B3222(2,1)*VB(1)+B3222(2,2)*VB(2)))/B3222(2,3)#  
postm:(B3222,VB,VB3222)#                                            
DO I=1,3 ;VCAA2(I)=(VA3222(I)-VA1222(I))/(2.*DELTA)#
DO I=1,3 ;VCBA2(I)=(VB3222(I)-VB1222(I))/(2.*DELTA)#
$)
#                                                                       PA67 314
#                                                                       PA67 315
QX(RELCON+POS)=QX(RELCON+POS)+2.#                                       PA67 316
DO I=1,3#                                                               PA67 317
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PA67 318
#                                     CONSTRUCT DERIVATIVES             PA67 319
VC1(I)=VA22(I) ; VC2(I)=VB22(I)#                                        PA67 320
VC1A(I)=(VA32(I)-VA12(I))/(2.*DELTA)#                                   PA67 321
VC2A(I)=(VB32(I)-VB12(I))/(2.*DELTA)#                                   PA67 322
VC1B(I)=(VA23(I)-VA21(I))/(2.*DELTA)#                                   PA67 323
VC2B(I)=(VB23(I)-VB21(I))/(2.*DELTA)#                                   PA67 324
#                                       Accumulate sums                 PA67 325
QX(XYZ+POS+(I-1)*LENG)  =QX(XYZ+POS+(I-1)*LENG)  +VC1(I)+VC2(I)#        PA67 326
QX(XYZA+POS+(I-1)*LENG) =QX(XYZA+POS+(I-1)*LENG) +VC1A(I)+VC2A(I)#      PA67 327
QX(XYZB+POS+(I-1)*LENG) =QX(XYZB+POS+(I-1)*LENG) +VC1B(I)+VC2B(I)#      PA67 328
QX(XYZ2+POS)  =QX(XYZ2+POS)  +VC1(I)*VC1(I)  +VC2(I)*VC2(I)#            PA67 329
QX(XYZ1A+POS) =QX(XYZ1A+POS) +VC1(I)*VC1A(I) +VC2(I)*VC2A(I)#           PA67 330
QX(XYZ1B+POS) =QX(XYZ1B+POS) +VC1(I)*VC1B(I) +VC2(I)*VC2B(I)#           PA67 331
QX(XYZAA+POS) =QX(XYZAA+POS) +VC1A(I)*VC1A(I)+VC2A(I)*VC2A(I)#          PA67 332
QX(XYZBB+POS) =QX(XYZBB+POS) +VC1B(I)*VC1B(I)+VC2B(I)*VC2B(I)#          PA67 333
QX(XYZAB+POS) =QX(XYZAB+POS) +VC1A(I)*VC1B(I)+VC2A(I)*VC2B(I)#          PA67 334
#IF (POS==1)                                                            PA67 335
#$(                                                                     PA67 336
#WRITE(6,*)"VC1,VC2",VC1(I),VC2(I)                                      PA67 337
#WRITE(6,*)"VC1^2,VC2^2",VC1(I)*VC1(I),VC2(I)                           PA67 338
#$)                                                                     PA67 339
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PA67 340
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PA67 341
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PA67 342
#                                                                       PA67 343
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PA67 344
RETURN#                                                                 PA67 345
END#                                                                    PA67 346
pmacro:([no:])#                                                         PA67 347
