systemheader:(MD    )#                                                  MD     1
##   version: Aug93                                                             
##   version: Jan93                                                             
####################################################################### MD     2
#                                                                     # MD     3
#                           *** MERGDS ***                            # MD     4
#                                                                     # MD     5
#    THE PROGRAM MERGDS SELECTS DATA FOR AN ISOMORPH FROM ONE BDF     # MD     6
#     AND EITHER ADDS IT TO, OR REPLACES DATA FOR THE SAME ISOMORPH   # MD     7
#     ON, A SECOND BDF.                                               # MD     8
#                                                                     # MD     9
####################################################################### MD    10
#                                             J.m stewart oct 1989    @ MD    11
include:(XMACRO)#                                                       MD    12
#                                                                       MD    13
macro:(nwffnm:,arith:(incr:(arith:(5,/,mxchwd:)),*,mxchwd:))#           MD    14
macro:(nw12chr:,incr:(arith:(11,/,mxchwd:)))#                           MD    15
macro:(cp12:,arith:(nw12chr:,*,mxchwd:))#                               MD    16
#                                                                       MD    17
extrude:(MDCOMN)#                                                       MD    18
string:(IDNEW,12)#                     Data set name being acted up     MD    19
string:(UIDNEW,12)#                    Data set name in u.c.            Jan93001
INTEGER IDPTR1# ## Pointer to the requested data set on the primary b   MD    20
INTEGER IDPTR3# ## Pointer to the requested data set on the secondary   MD    21
INTEGER J1,J2,J3## Pointers to slow/med/fast chnging h,k,l              MD    22
INTEGER MARK1#  ## Pointer to the beginning of the qx working area.     MD    23
INTEGER NSETS1# ## Number of data sets on the primary bdf.              MD    24
INTEGER NSETS3# ## Number of data sets on the secondary bdf.            MD    25
INTEGER SUPER#  ## Signal that forces renaming of dataset in fileb      MD    26
INTEGER SUPDAT# ## Number of data set in file c to be passed to file    MD    27
COMMON/COMCMD/ IDNEW,UIDNEW#                                            Jan93002
COMMON/COMIMD/IDPTR1,IDPTR3,MARK1 ,NSETS1,NSETS3,SUPER ,SUPDAT,$#       MD    29
J1,J2,J3#                                                               MD    30
endext:#                                                                MD    31
#                                                                       MD    32
systemheader:(MD00)#                                                    MD00   1
# ################################################################## #  MD00   2
#                                                                    #  MD00   3
#                               MD00                                 #  MD00   4
#                                                                    #  MD00   5
# ################################################################## #  MD00   6
SUBROUTINE MD00#                       Add/replace new data on bdf      MD00   7
#                                      Jun 1980  r.a. alden             MD00   8
include:(AACOMN)#                                                       MD00   9
include:(MDCOMN)#                                                       MD00  10
#                                                                       MD00  11
FILEXT(IOUNIT(3))='MER'#               Ext of second merge bdf          MD00  12
#                                                                       MD00  13
CALL MD11#                             Process log rec 1 - lrsequ:      MD00  14
CALL MD21#                             Process log rec lrrefl:          MD00  15
CALL MD31#                             Merge logical records lrrefl     MD00  16
#                                                                       MD00  17
RETURN#                                                                 MD00  18
END#                                                                    MD00  19
systemheader:(MD11)#                                                    MD11   1
# ################################################################## #  MD11   2
#                                                                    #  MD11   3
#                               MD11                                 #  MD11   4
#                                                                    #  MD11   5
# ################################################################## #  MD11   6
SUBROUTINE MD11#                       Process logical records          MD11   7
#                                         Up to lrddef:.                MD11   8
#                                        Jun 1980  r.a. alden           MD11   9
#                                        Jun 1985  j.m. stewart         MD11  10
#                                        Jun 1986  k.d.watenpaugh       MD11  11
include:(AACOMN)#                                                       MD11  12
include:(MDCOMN)#                                                       MD11  13
#                                                                       MD11  14
INTEGER BEGIN#                         Start of character field         MD11  15
INTEGER CHCNT#                         Length of scat fact table        MD11  16
INTEGER ENDD#                          End of character field           MD11  17
INTEGER I#                             Loop index                       MD11  18
INTEGER INDEX8(251)#                   Id nums of lrscat:               MD11  19
INTEGER IPR#                           Sum of pointer and offset        MD11  20
INTEGER IPTR1#                         Pointer to a particular valu     MD11  21
#                                         On the primary bdf.           MD11  22
INTEGER IPTR3#                         Pointer to a particular valu     MD11  23
#                                         On the secondary bdf.         MD11  24
INTEGER IPT1#                          Primary input packet pointer     MD11  25
INTEGER IPT3#                          Secondary input packet point     MD11  26
INTEGER J#                             Loop index                       MD11  27
INTEGER JPT#                           Output packet pointer            MD11  28
INTEGER MK#                            Start of qx working area         MD11  29
INTEGER NCHAR#                         Number of characters in an       MD11  30
#                                         Input field.                  MD11  31
INTEGER NSTEP1#                        Word step in scat fac table      MD11  32
INTEGER PSIZ1#                         Primary input packet size        MD11  33
INTEGER PSIZ3#                         Secondary input packet size      MD11  34
INTEGER PT1(251)#                      Offsets to values in lrscat:     MD11  35
#                                         Of the primary bdf.           MD11  36
INTEGER PT11#                          Offset to scattering factor      MD11  37
#                                         Factor name in lrscat: of     MD11  38
#                                         Secondary bdf.                MD11  39
INTEGER PT3(251)#                      Offsets to values in lrscat:     MD11  40
#                                         Of the secondary bdf.         MD11  41
string:(SCMPID,6)#                     Compound id expected on the      MD11  42
#                                         Secondary bdf.                MD11  43
string:(PCMPID,6)#                     Compound id expected on the      MD11  44
#                                         Primary bdf.                @ MD11  45
string:(UCMPID,6)#                     Compound id from bdf rolled      Jan93003
#                                         into upper case.              Jan93004
string:(USCMPI,6)#                     Compound id from bdf rolled      Jan93005
#                                         into upper case.              Jan93006
string:(UPCMPI,6)#                     Compound id from bdf rolled      Jan93007
#                                         into upper case.              Jan93008
string:(CH1,8)#                        Scattering factor name from      MD11  46
#                                         The primary bdf.              MD11  47
string:(CH3,8)#                        Scattering factor name from      MD11  48
#                                         The secondary bdf.            MD11  49
chardata:(MD012, LABEL  END    )#                                       MD11  50
chardata:(MD013,SUPER)#                                                 MD11  51
chardata:(MD014, *WARNING* ITEM    OF PACKET    OF LRSYMM FROM $#       MD11  52
FILE A = XXX.XXX FROM FILE MER XXX.XXX )#                               MD11  53
chardata:(MD015, SCATTERING FACTORS     FILE A   FILE MER)#             MD11  54
realdata:(FMTSY,[180313.,310313.,630732.,840732.])#                     MD11  55
intdata:(KEY,[1,1,1,0,100])#           Signal array for indexpkt:       MD11  56
datastuff:#                                                             MD11  57
#                                                                       MD11  58
SUPER=no: ; SUPDAT=1#                  Set for no superseding           MD11  59
IOMARK(1) = QXSTR + arith:(7,*,nwffnm:)# Prime inp bdf buffr            MD11  60
IOMARK(2) = IOMARK(1) + bdfbuf:#       Output bdf buffer                MD11  61
IOMARK(3) = IOMARK(2) + bdfbuf:#       Secondary input bdf buffer       MD11  62
MARK1     = IOMARK(3) + bdfbuf:#                                        MD11  63
incrqx:(K,MARK1+600,MD1101)#           Request some memory              MD11  64
#                                                                       MD11  65
INDEX8(1)=11#                          Scat factor symbol               MD11  66
NSTEP1 = incr:(7,/,mxchwd:)#           Length words scat fact symbol    MD11  67
MK = QXSTR#                                                             MD11  68
QX(MK+1) = FLOAT(IOMARK(3)+bdfbuf:)#   Place to hold list of            MD11  69
QX(MK+2) = FLOAT(NSTEP1)#              Scattering factor names whic     MD11  70
QX(MK+3) = QX(MK+1) + 16.*QX(MK+2)#    Will be on the output bdf.       MD11  71
QX(MK+4) = QX(MK+3) + 1.#                                               MD11  72
#                                                                       MD11  73
# MERGDS PROGRAM INITIATION CARD FORMAT                                 MD11  74
#  FIELD        CONTENTS                                                MD11  75
#   <1>         COMPOUND ID OF BOTH THE PRIMARY BDF AND THE OUTPUT BDF. MD11  76
#   <2>         COMPOUND ID OF THE SECONDARY BDF WITH EXTENSION 'MER'.  MD11  77
#   <3>         DATA SET NAME FOR DATA BEING REPLACED OR APPENDED TO    MD11  78
#                  PRIMARY BDF. THE DATA SET NAME  MUST BE IDENTICAL TO MD11  79
#                  ONE NAME FOUND IN LOGICAL RECORD 10 OF THE SECONDARY MD11  80
#                  BDF.  IF THE DATA SET NAME IS ALSO IDENTICAL TO ONE  MD11  81
#                  NAME IN LOGICAL RECORD 10 OF THE PRIMARY BDF, THAT   MD11  82
#                  DATA SET WILL BE REPLACED BY THE CORRESPONDING ONE O MD11  83
#                  THE SECONDARY BDF.  OTHERWISE THE REQUESTED DATA SET MD11  84
#                  WILL BE APPENDED TO THE PRIMARY BDF.                 MD11  85
#   <4>         THE SIGNAL 'SUPER' GIVEN IN FIELD FOUR WILL CAUSE THE   MD11  86
#                  DATA SET NAME GIVEN IN FIELD THREE TO BE USED AND    MD11  87
#                  PLACED IN THE OUTPUT FILE, NFILEB. THE ACTUAL DATA   MD11  88
#                  SET USED FROM FILE C WILL BE SPECIFIED BY THE        MD11  89
#                  INTEGER GIVEN IN FIELD 5.  THE SAME RULES WILL       MD11  90
#                  APPLY TO REPLACEMENT OR ADDITION OF DATA SETS FROM   MD11  91
#                  FILE A.                                              MD11  92
#    <5>          NUMBER OF THE DATA SET TO BE USED FROM FILE C WHEN    MD11  93
#                  'SUPER' SPECIFIED IN FIELD 4.  VOID=1.               MD11  94
#                                                                       MD11  95
upcase:(COMPID,UCMPID,6)#              Upper case version of COMPID     Jan93009
movechar:(BLANK,1,PCMPID,1,6,1)#       Blank the primary comp id        MD11  96
movechar:(BLANK,1,UPCMPI,1,6,1)#       Blank the primary also u.c.      Jan93010
stringlim:(1,BEGIN,ENDD)#              Load compound id of primary      MD11  97
NCHAR = MIN0((ENDD-BEGIN),6)#          Bdf.                             MD11  98
movechar:(CHRIP,BEGIN,PCMPID,1,NCHAR,0)#                                Jan93011
movechar:(CHRIN,BEGIN,UPCMPI,1,NCHAR,0)#                                Jan93012
IF(UPCMPI!=UCMPID) iquit:(MD1105)#     Must match existing compid       Jan93013
#                                                                       MD11 101
movechar:(BLANK,1,SCMPID,1,6,1)#       Blank the secondary id           MD11 102
movechar:(BLANK,1,USCMPI,1,6,1)#       Blank the secn'ry comp id u.c.   Jan93014
stringlim:(2,BEGIN,ENDD)#              Load compound id of secondary    MD11 103
NCHAR = MIN0((ENDD-BEGIN),6)#          Bdf.                             MD11 104
movechar:(CHRIP,BEGIN,SCMPID,1,NCHAR,0)#                                Jan93015
movechar:(CHRIN,BEGIN,USCMPI,1,NCHAR,0)#                                Jan93016
#                                                                       MD11 106
movechar:(BLANK,1,IDNEW,1,12,1)#       Blank out the data set name      MD11 107
movechar:(BLANK,1,UIDNEW,1,12,1)#      Blank out the u. c. name too     Jan93017
stringlim:(3,BEGIN,ENDD)#              Pick up the request              MD11 108
NCHAR = MIN0(ENDD-BEGIN,12)#                                            MD11 109
movechar:(CHRIP,BEGIN,IDNEW,1,NCHAR,0)# And save it.                    Jan93018
movechar:(CHRIN,BEGIN,UIDNEW,1,NCHAR,0)# And save it.                   Jan93019
IF(BUFIN(4)<voidflg:)#                 Check for superseding            MD11 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MD11 112
stringlim:(4,BEGIN,ENDD)#                                               MD11 113
compchar:(MD013,1,CHRIN,BEGIN,NMD013,NMD013,NMD013,J)#                  MD11 114
IF(J==1) SUPER=yes:#                   Mark for new data set name       MD11 115
IF(BUFIN(5)>0.5) SUPDAT=NINT(BUFIN(5))#                                 MD11 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MD11 117
#                                                                       MD11 118
copyfile:(1,2,1,lrlabl:)#              Copy the labels from the         MD11 119
COMPID=SCMPID#                         Install new compid for open      MD11 120
REPEAT#                                Primary and secondary bdf's.     MD11 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MD11 122
readwpkt:(3,lrlabl:,PSIZ3,IPT3,0)#                                      MD11 123
IF(IPT3 <= 0)  BREAK#                                                   MD11 124
writepkt:(2,lrlabl:,PSIZ3,JPT)#                                         MD11 125
movereal:(QX,IPT3+1,QX,JPT+1,PSIZ3,1)#                                  MD11 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MD11 127
COMPID=PCMPID#                         Reset compid to std value        MD11 128
#                                                                       MD11 129
readline:(MD012,NMD012)#               Process any new label images     MD11 130
WHILE(LINID == 1)#                     So long as label line            MD11 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MD11 132
writepkt:(2,lrlabl:,PSIZ3,JPT)#                                         MD11 133
movector:(BLANK,1,QX(JPT+1),1,mxchim:,1)#                               MD11 134
movector:(CHRIP,1,QX(JPT+1),1,CHRMAX,0)##                               Jan93020
readline:(MD012,NMD012)#                                                MD11 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MD11 137
#                                                                       MD11 138
# COPY LOGICAL RECORDS LRSTAT: AND LRCELL: FROM THE PRIMARY BDF         MD11 139
#                                                                       MD11 140
copyfile:(1,2,incr:(lrlabl:),decr:(lrsymm:))#                           MD11 141
readwpkt:(1,lrsymm:,PSIZ1,IPT1,0)#     Read in and check to be sure     MD11 142
readwpkt:(3,lrsymm:,PSIZ3,IPT3,0)#     That the symmetry informatio     MD11 143
J=1#                                   Recorded in log. rec. lrsymm:    MD11 144
WHILE(IPT1 != 0)#                      Is identical for both of the     MD11 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MD11 146
IF(PSIZ1 != PSIZ3)  iquit:(MD1102)#    Input bdf's.                     MD11 147
FOR(I=1; I <= PSIZ1; I=I+1)#                                            MD11 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MD11 149
IPTR1 = IPT1 + I#                                                       MD11 150
IPTR3 = IPT3 + I#                                                       MD11 151
ifne:(QX(IPTR1),QX(IPTR3))#            Complain about mismatches        MD11 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MD11 153
BUFOT(1)=FLOAT(I) ; BUFOT(2)=FLOAT(J)# Item & packet count              MD11 154
BUFOT(3)=QX(IPTR1) ; BUFOT(4)=QX(IPTR3)# Items themselves               MD11 155
ncodefld:(BUFOT,1,MD014,FMTSY,4) ; writeline:(0,MD014,NM014,3,1)#       MD11 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MD11 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MD11 158
writepkt:(2,lrsymm:,PSIZ1,JPT)#                                         MD11 159
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)#                                  MD11 160
readwpkt:(1,lrsymm:,PSIZ1,IPT1,0)#                                      MD11 161
readwpkt:(3,lrsymm:,PSIZ3,IPT3,0) ; J=J+1# Read & count packets         MD11 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MD11 163
copyfile:(1,2,incr:(lrsymm:),decr:(lrscat:))#                           MD11 164
#                                                                       MD11 165
# COPY LOGICAL RECORDS LRSYMM: UP TO LRSCAT:                            MD11 166
#                                                                       MD11 167
KEY(4) = 0#                                                             MD11 168
indexpkt:(3,lrscat:,PSIZ3,IPT3,0,KEY,INDEX8,PT3)#                       MD11 169
IF(KEY(4)<=0) iquit:(MD1104)#          Scattering facts must be         MD11 170
PT11 = PT3(1)#                         Retain pointer to scattering     MD11 171
#                                         Factor name.                  MD11 172
KEY(4) = 0#                            No update just checking          MD11 173
indexpkt:(1,lrscat:,PSIZ1,IPT1,0,KEY,INDEX8,PT1)#                       MD11 174
IF(KEY(4)<= 0)  iquit:(MD1104)#                                         MD11 175
#                                                                       MD11 176
DO I=1,PSIZ1#                          Create a list of id's requir     MD11 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MD11 178
IPTR1 = IPT1 + I#                      To be on the secondary bdf.      MD11 179
INDEX8(I) = NINT(QX(IPTR1))#                                            MD11 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MD11 181
#                                                                       MD11 182
rewindbdf:(3)#                         Go back to front of file c       MD11 183
KEY(1) = KEY(4)#                       Set the signals.  everything     MD11 184
KEY(2) = KEY(4)#                       Found on the primary is          MD11 185
KEY(3) = KEY(4)#                       Required to be on the            MD11 186
KEY(4) = 0#                            Secondary.                       MD11 187
indexpkt:(3,lrscat:,PSIZ3,IPT3,0,KEY,INDEX8,PT3)#                       MD11 188
IF(KEY(4)<= 0)  iquit:(MD1103)#                                         MD11 189
#                                                                       MD11 190
writepkt:(2,lrscat:,PSIZ1,JPT)#        Write the output directory       MD11 191
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)# Transfer the directory to op     MD11 192
#                                                                       MD11 193
FOR(J=MARK1+1;J>0;J=J+NSTEP1)#         Do scattering factor types       MD11 194
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MD11 195
readwpkt:(1,lrscat:,PSIZ1,IPT1,0)#                                      MD11 196
IF(IPT1 <= 0)  BREAK#                                                   MD11 197
writepkt:(2,lrscat:,PSIZ1,JPT)#                                         MD11 198
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)# Copy to output                   MD11 199
IPR = IPT1 + PT1(1)#                   Pointer to sf name               MD11 200
movereal:(QX,IPR,QX,J,NSTEP1,1)#       Move sf name into mark1          MD11 201
movertoc:(QX(IPR),1,CHROT,25,8,0)#     Get name for printing sf list    MD11 202
writeline:(0,MD015,NMD015,1,3)#        And print it                     MD11 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MD11 204
CHCNT = J#                             Mark end of sf names             MD11 205
#                                                                       MD11 206
REPEAT#                                Loop over secondary scat facto   MD11 207
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MD11 208
readwpkt:(3,lrscat:,PSIZ3,IPT3,0)#                                      MD11 209
IF(IPT3 == 0)  BREAK#                                                   MD11 210
IPTR3 = IPT3 + PT11#                   Pointer for sf name              MD11 211
movertoc:(QX(IPTR3),1,CH3,1,8,0)#      Move name to character array     MD11 212
FOR(J=MARK1+1;J<CHCNT;J=J+NSTEP1)#     Loop over name list for fi       MD11 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MD11 214
movertoc:(QX(J),1,CH1,1,8,0)#          Get name from sf list            MD11 215
IF(CH3==CH1) BREAK#                    Exit if names match              MD11 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MD11 217
IF(J < CHCNT)  NEXT#                   This is not a new type           MD11 218
writepkt:(2,lrscat:,PSIZ1,JPT)#        Write new type to file           MD11 219
movereal:(QX,IPT3+1,QX,JPT+1,PSIZ1,1)# Transfer packet                  MD11 220
#                                                                       MD11 221
movechar:(CH3,1,CHROT,35,8,0)#         Place it in print buffer         MD11 222
writeline:(0,MD015,NMD015,1,3)#        And print it                     MD11 223
movector:(BLANK,1,QX(CHCNT),1,nwffnm:,1)# Blank fill ff name            MD11 224
movector:(CH3,1,QX(CHCNT),1,8,0)#      Add new ff name to list          MD11 225
CHCNT = CHCNT + NSTEP1#                Advance end of list pointer      MD11 226
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MD11 227
copyfile:(1,2,incr:(lrscat:),decr:(lrddef:))#                           MD11 228
#                                                                       MD11 229
RETURN#                                                                 MD11 230
END#                                                                    MD11 231
systemheader:(MD21)#                                                    MD21   1
# ################################################################## #  MD21   2
#                                                                    #  MD21   3
#                               MD21                                 #  MD21   4
#                                                                    #  MD21   5
# ################################################################## #  MD21   6
SUBROUTINE MD21#                       Process logical records          MD21   7
#                                         Lrddef: up to lrrefl:.        MD21   8
#                                        Jun 1980  r.a. alden           MD21   9
#                                        Jun 1985  j.m. stewart         MD21  10
include:(AACOMN)#                                                       MD21  11
include:(MDCOMN)#                                                       MD21  12
#                                                                       MD21  13
INTEGER CHCNT#                         Number of characters in all      MD21  14
INTEGER COL#                           Column pointer                   MD21  15
INTEGER IPT1#                          Primary input packet pointer     MD21  16
INTEGER IPT3#                          Secondary input packet point     MD21  17
INTEGER J#                             Qx array pointer                 MD21  18
INTEGER JPT#                           Output packet pointer            MD21  19
INTEGER MATCH#                         Flag denoting whether 2          MD21  20
#                                       #  Character fields agree.      MD21  21
INTEGER NSTEP1#                        Number of characters in the      MD21  22
#                                         Word(s) required to hold 12   MD21  23
#                                         Characters in a data set name MD21  24
INTEGER PSIZ1#                         Primary input bdf packet siz     MD21  25
INTEGER PSIZ3#                         Secondary input bdf packet       MD21  26
#                                                                       MD21  27
string:(CH,12)#                        Data set name on bdf 2           MD21  28
string:(UCH,12)#                       Data set name on bdf 2 in UC     Jan93021
chardata:(MD021,DATA FOR              WILL REPLACE THAT ALREADY $#      MD21  29
FOUND ON THE PRIMARY INPUT BDF.)#                                       MD21  30
chardata:(MD022,DATA FOR              WILL BE ADDED TO THE PRIMARY $#   MD21  31
INPUT BDF.)#                                                            MD21  32
chardata:(MD023, THE OUTPUT BDF NOW CONTAINS DATA FOR)#                 MD21  33
chardata:(MD024, DATA SET XX FROM FILE MER IS BE CALLED XXXXXXXXXXXX $# MD21  34
AND BE PLACED IN OUTPUT FILE B AS A DERIVATIVE.)#                       MD21  35
intdata:(WANT11,[1,2,12,100,101,11])#                                   Aug93001
intdata:(WANT12,[1,11,12,13,14,15,30,31,32,33])#                        MD21  37
intdata:(SGNL11,[6,6,6,0])#                                             Aug93002
intdata:(SGNL12,[10,10,10,0])#                                          MD21  39
datastuff:#                                                             MD21  40
#                                                                       MD21  41
J = QXSTR#                                                              MD21  42
QX(J+2) = FLOAT(nw12chr:)#             Re-use the mark1 array for       MD21  43
QX(J+3) = QX(J+1) + 16.*QX(J+2)#       The names of the data sets.      MD21  44
QX(J+4) = QX(J+3) + 1.#                                                 MD21  45
incrqx:(I,NINT(QX(J+4)),MD2101)#       Request memory                   MD21  46
#                                                                       MD21  47
NSTEP1 = NINT(QX(J+2))#                                                 MD21  48
IDPTR3 = 0#                            Pointer to position of data      MD21  49
NSETS3=0#                              Loop over the secondary bdf      MD21  50
REPEAT#                                                                 MD21  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MD21  52
NSETS3=NSETS3+1#                                                        MD21  53
readwpkt:(3,lrddef:,PSIZ3,IPT3,0)#     Data set names.                  MD21  54
IF(IPT3 == 0)  BREAK#                                                   MD21  55
movertoc:(QX(IPT3+1),1,CH,1,12,0)#     Convert to characters            MD21  56
upcase:(CH,UCH,12)#                    Kill case problems               Jan93022
compchar:(UCH,1,UIDNEW,1,12,12,12,MATCH)## Compare against requested    Jan93023
IF(MATCH == 0) NEXT#                   Set name.  if found, make        MD21  58
IF(IDPTR3 != 0)  iquit:(MD2102)#       Sure it's unique, then set       MD21  59
IDPTR3 = NSETS3#                       Pointer to it.                   MD21  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MD21  61
NSETS3 = NSETS3 - 1#                   Number of data sets on           MD21  62
#                                         The secondary bdf.            MD21  63
#                                                                       MD21  64
IF(IDPTR3==0&SUPER==no:) iquit:(MD2103)# Bad news if no match           MD21  65
ELSE IF(SUPER==yes:)#                  Are we superseding data set      MD21  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MD21  67
IF(SUPDAT>NSETS3) iquit:(MD2105)#      It has to be in file c           MD21  68
IDPTR3 = SUPDAT#                       Use the specified data set       MD21  69
ncodefld:(REAL(IDPTR3),1,MD024,120213.,1)#                              MD21  70
movechar:(IDNEW,1,MD024,41,12,0)#                                       MD21  71
writeline:(1,MD024,NMD024,3,3)#        Tell user its going to be        MD21  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MD21  73
#                                                                       MD21  74
CHCNT = 1#                             Initialize character count,      MD21  75
NSETS1 = 0#                            Number of data sets on the       MD21  76
#                                         Primary bdf, and              MD21  77
IDPTR1 = 0#                            The pointer to the requested     MD21  78
#                                         Data set on the primary bdf   MD21  79
J = MARK1 + 1#                         Start of name array              MD21  80
readwpkt:(1,lrddef:,PSIZ1,IPT1,0)#                                      MD21  81
#                                                                       MD21  82
WHILE(IPT1 != 0)#                      Loop over primary names          MD21  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MD21  84
NSETS1 = NSETS1 + 1#                   Count data sets                  MD21  85
movertoc:(QX(IPT1+1),1,CH,1,12,0)#     See if the requested name is     MD21  86
upcase:(CH,UCH,12)#                    Kill case problems               Jan93024
compchar:(UCH,1,UIDNEW,1,12,12,12,MATCH)## Also present here.           Jan93025
IF(MATCH != 0)#                        It had better not be here        MD21  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MD21  89
IF(IDPTR1 != 0)  iquit:(MD2104)#       More than once.                  MD21  90
IDPTR1 = NSETS1#                       Point to its position            MD21  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MD21  92
movereal:(QX,IPT1+1,QX,J,PSIZ1,1)#     Save the name in the mark1       MD21  93
#                                         Array.                        MD21  94
J = J + NSTEP1#                        Update mark1 pointer             MD21  95
writepkt:(2,lrddef:,PSIZ1,JPT)#        Write output bdf                 MD21  96
movereal:(QX,IPT1+1,QX,JPT+1,PSIZ1,1)#                                  MD21  97
CHCNT = CHCNT + cp12:#                 Update total character count     MD21  98
readwpkt:(1,lrddef:,PSIZ1,IPT1,0)#     Read next packet                 MD21  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MD21 100
#                                                                       MD21 101
IF(IDPTR1 != 0)#                       Make comments to user about      MD21 102
movechar:(MD021,1,CHROT,2,NMD021,0)#   Addition or replacement          MD21 103
#                                         Taking place.                 MD21 104
ELSE#                                                                   MD21 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MD21 106
movechar:(MD022,1,CHROT,2,NMD022,0)#                                    MD21 107
writepkt:(2,lrddef:,PSIZ1,JPT)#        Write new name on output bdf     MD21 108
movector:(IDNEW,1,QX(JPT+1),1,cp12:,0)## And put it in the mark1        MD21 109
movector:(IDNEW,1,QX(J),1,cp12:,0)#    Array.                           MD21 110
J = J + NSTEP1#                                                         MD21 111
CHCNT = CHCNT + cp12:#                 Increment character count        MD21 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MD21 113
#                                                                       MD21 114
movechar:(IDNEW,1,CHROT,11,12,0)#      Tell the user about all of       MD21 115
writeline:(1,0,0,1,3)#                 Data set names now found on      MD21 116
writeline:(1,MD023,NMD023,3,3)#        The output bdf.                  MD21 117
#                                                                       MD21 118
COL = 2#                                                                MD21 119
FOR(J=1; J < CHCNT; J=J+cp12:)#                                         MD21 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MD21 121
IF((COL+cp12:) > prtcmax:)#                                             MD21 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MD21 123
writeline:(0,0,0,1,3)#                                                  MD21 124
COL = 2#                                                                MD21 125
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MD21 126
movertoc:(QX(MARK1+1),J,CHROT,COL,12,0)#                                MD21 127
COL = COL + cp12:#                                                      MD21 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MD21 129
writeline:(0,0,0,1,3)#                                                  MD21 130
#                                                                       MD21 131
CALL MD22(lrexpl:,SGNL11,WANT11)#      Merge and write out logical      MD21 132
#                                         Record lrexpl:.               MD21 133
CALL MD22(lrdset:,SGNL12,WANT12)#      Likewise for lrdset:             MD21 134
#                                                                       MD21 135
copyfile:(1,2,incr:(lrdset:),decr:(lrrefl:))#                           MD21 136
#                                                                       MD21 137
RETURN#                                                                 MD21 138
END#                                                                    MD21 139
systemheader:(MD22)#                                                    MD22   1
# ################################################################## #  MD22   2
#                                                                    #  MD22   3
#                               MD22                                 #  MD22   4
#                                                                    #  MD22   5
# ################################################################## #  MD22   6
SUBROUTINE MD22(LREC,SIGNAL,WANT)#     Merge together 2 logical         MD22   7
#                                         Records which may each        MD22   8
#                                         Contain different size        MD22   9
#                                         Directories.                  MD22  10
#                                        Oct 1980  r.a. alden           MD22  11
#                                        Jun 1985  j.m. stewart         MD22  12
include:(AACOMN)#                                                       MD22  13
include:(MDCOMN)#                                                       MD22  14
#                                                                       MD22  15
INTEGER DSET#                          Current data set number          MD22  16
INTEGER I,II#                          Loop index                       MD22  17
INTEGER IDPTR#                         Current data set number          MD22  18
INTEGER IHIT#                          Signial for matches in pkt       MD22  19
INTEGER IPTR#                                                           MD22  20
INTEGER IPT1#                          Primary input packet pointer     MD22  21
INTEGER IPT3#                          Secondary input packet point     MD22  22
INTEGER J,JJ#                          Loop index                       MD22  23
INTEGER JPT#                           Output packet pointer            MD22  24
INTEGER JPTR#                                                           MD22  25
INTEGER LREC#                          Logical record number merged     MD22  26
INTEGER OFF1(150)#                     Offsets for primary bdf          MD22  27
INTEGER OFF3(150)#                     Offsets for secondary bdf        MD22  28
INTEGER PSIZ1#                         Primary packet size              MD22  29
INTEGER PSIZ2#                         Output packet size               MD22  30
INTEGER PSIZ3#                         Secondary packet size            MD22  31
INTEGER SIGNAL(4)#                     Signals to indexpkt:             MD22  32
REAL SOR1,SOR3#                        Packed sort order from lrexpl:   MD22  33
REAL SORMT1,SORMT3#                    Sort method from lrexpl:         Aug93003
INTEGER SOR1OF,SOR3OF#                 Offsets to sort order word       MD22  34
REAL SMT1OF,SMT3OF#                    Offsets to sort method lrexpl:   Aug93004
INTEGER WANT(*)#                       Desired catalogue numbers        MD22  35
REAL VOID(1)#                          Holds voidflg: for stuffing      MD22  36
#                                                                       MD22  37
#                                                                       MD22  38
VOID(1) = voidflg:#                                                     MD22  39
SIGNAL(4) = 0#                                                          MD22  40
indexpkt:(1,LREC,PSIZ1,IPT1,0,SIGNAL,WANT,OFF1)#                        MD22  41
IF(SIGNAL(4)<=0) iquit:(MD2201)#       Check mandatory list             MD22  42
IPTR = OFF1(1)#                        Keep track of data set no.       MD22  43
#                                                                       MD22  44
# FIND ALL REQUIRED AND OPTIONAL ID NUMBERS PLUS ANY PRESENT BUT        MD22  45
#  NOT REQUESTED, THIS TIME ON THE SECONDARY BDF.                       MD22  46
#                                                                       MD22  47
SIGNAL(4) = 0#                         Set for read update mode         MD22  48
indexpkt:(3,LREC,PSIZ3,IPT3,0,SIGNAL,WANT,OFF3)#                        MD22  49
IF(SIGNAL(4)<=0) iquit:(MD2203)#       Check mandatory list             MD22  50
IF(LREC==lrexpl:)#                     Get out pointer to sort order    MD22  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MD22  52
SOR1OF=OFF1(3) ; SOR3OF=OFF3(3)#       Save offsets for below           MD22  53
SMT1OF=OFF1(6) ; SMT3OF=OFF3(6)#       Save sort method offsets         Aug93005
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MD22  54
PSIZ2 = 0#                             Size of output lr must be        MD22  55
#                                         A combination of the sizes    MD22  56
#                                         Of both input bdf's.          MD22  57
#                                                                       MD22  58
#  IT IS NECESSARY TO CHECK OUT WHETHER OR NOT THERE ARE QUANTITIES     MD22  59
#  IN THE SECONDARY FILE PACKET WHICH ARE NOT IN THE PRIMARY FILE       MD22  60
#  AND VISA VERSA.  THE OUTPUT FILE MUST CONTAIN A NON-REDUNDANT SET.   MD22  61
#                                                                       MD22  62
DO I=1,PSIZ3#                          Loop over the secondary pkt      MD22  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MD22  64
II = IPT3 + I#                         Point to secondaries in turn     MD22  65
OFF1(I) = 0 ; IHIT = no:#              Assume it wont be in primary     MD22  66
DO J=1,PSIZ1#                          Look at all in primary pkt       MD22  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MD22  68
JJ = IPT1 + J#                         Point to primaries               MD22  69
ifne:(QX(JJ),QX(II)) NEXT#             Keep looking                     MD22  70
IHIT = yes: ; OFF1(I) = J#             Remember hits                    MD22  71
BREAK#                                 And terminate search             MD22  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MD22  73
IF(IHIT==no:)#                         Test if the secondary has        MD22  74
#                                        An item not in the primary     MD22  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MD22  76
PSIZ2 = PSIZ2 + 1#                     Count the new items              MD22  77
OFF3(PSIZ2) = I#                       And remember where they live     MD22  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MD22  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MD22  80
#                                                                       MD22  81
#  SET UP THE NEW OUTPUT PACKET SIZE BASED ON THE SURVEY                MD22  82
#                                                                       MD22  83
JPTR = PSIZ2#                          Save number of new items         MD22  84
PSIZ2 = PSIZ2 + PSIZ1#                 And get the total for o/p        MD22  85
#                                                                       MD22  86
writepkt:(2,LREC,PSIZ2,JPT)#           Write out the new directory      MD22  87
#                                                                       MD22  88
#  BUILD THE COMBINED HEADER PACKET TACKING ANY NEW ITEMS ON THE        MD22  89
#  BACK SIDE OF THE PRIMARY FILE HEADER PACKET                          MD22  90
#                                                                       MD22  91
J = JPT ; II = IPT1#                   Set buffer pointers              MD22  92
DO I=1,PSIZ1#                          Loop over primaries              MD22  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MD22  94
II = II + 1 ; J = J + 1#               Advance buffer pointers          MD22  95
QX(J) = QX(II)#                        Move the primary idnums          MD22  96
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MD22  97
FOR(I=1 ; I<= JPTR ; I=I+1)#           Loop over new secondaries        MD22  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MD22  99
J = J + 1#                             Up output pointer                MD22 100
II = IPT3 + OFF3(I)#                   Get indirect address of new      MD22 101
QX(J) = QX(II)#                        Move the new idnum to o/p        MD22 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MD22 103
#                                                                       MD22 104
#  NOW POSITION THE SECONDARY FILE SO THAT THE DATA SET TO BE MERGED    MD22 105
#  IS STANDING IN THE BUFFER READY TO BE COPIED TO O/P                  MD22 106
#                                                                       MD22 107
FOR(J=1; J <= NSETS3; J=J+1)#          Point to the proper packet o     MD22 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MD22 109
readwpkt:(3,LREC,PSIZ3,IPT3,0)#        The secondary bdf.               MD22 110
IF(IDPTR3 != J)  NEXT#                 Found it                         MD22 111
IF(LREC==lrexpl:)#                     Get sort information             Aug93006
$(#                                                                     Aug93007
SOR3=QX(IPT3+SOR3OF)#                  Save sort order word             Aug93008
SORMT3=QX(IPT3+SMT3OF) ; BREAK#        Save sort method signal          Aug93009
$)#                                                                     Aug93010
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MD22 113
#                                                                       MD22 114
FOR(I=1; I <= NSETS1; I=I+1)#          Loop over the packet(s)          MD22 115
#                                         On the input (primary) bdf,   MD22 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MD22 117
readwpkt:(1,LREC,PSIZ1,IPT1,0)#        Copying out the old ones         MD22 118
writepkt:(2,LREC,PSIZ2,JPT)#           And voiding the one that is      MD22 119
IDPTR = IPT1 + OFF1(1)#                Get the current data set         MD22 120
DSET = QX(IDPTR)#                      Number.                          MD22 121
IF(LREC==lrexpl:)#                     Save sort order information      Aug93011
$(#                                                                     Aug93012
SOR1=QX(IPT1+SOR1OF)#                  Save sort order word             Aug93013
SORMT1=QX(IPT1+SMT1OF)#                Save sort order method           Aug93014
$)#                                                                     Aug93015
#                                                                       MD22 123
FOR(J=1; J <= PSIZ2; J=J+1)#           Being replaced (if any).         MD22 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MD22 125
IF(IDPTR1 == DSET)#                    A replacement is                 MD22 126
#                                         Being effected here.          MD22 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MD22 128
JJ = JPT + J#                          Point to output buffer           MD22 129
IF(J==IPTR) QX(JJ) = FLOAT(IDPTR1)#    Get proper data set number       MD22 130
ELSE IF(J<=PSIZ1)#                     Within old primaries...          MD22 131
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MD22 132
IF(OFF1(J)==0) QX(JJ) = VOID(1)#       Nothing to bring from scndry     MD22 133
ELSE#                                  There is something               MD22 134
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MD22 135
II = IPT3 +OFF1(J)#                    Point to item in secondary       MD22 136
movepakwd:(QX(II),QX(JJ))#             Transfer item to output          MD22 137
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MD22 138
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MD22 139
ELSE#                                  It is a new item not in prim     MD22 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MD22 141
IS = J - PSIZ1#                        Reduce pointer to new list       MD22 142
II = IPT3 + OFF3(IS)#                  Point to secondary source        MD22 143
movepakwd:(QX(II),QX(JJ))#             Place new item in o/p            MD22 144
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MD22 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MD22 146
ELSE#                                  Here is a straight copy          MD22 147
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MD22 148
JJ = JPT + J#                          Point to output buffer           MD22 149
IF(J<=PSIZ1)#                          For items in primary file        MD22 150
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MD22 151
II = IPT1 + J#                         Find pointer to input            MD22 152
movepakwd:(QX(II),QX(JJ))#             Move the item to o/p             MD22 153
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MD22 154
ELSE QX(JJ) = VOID(1)#                 And blunk out any new ones       MD22 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MD22 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MD22 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MD22 158
#                                                                       MD22 159
IF(IDPTR1 == 0)#                       Add on the packet for a          MD22 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MD22 161
writepkt:(2,LREC,PSIZ2,JPT)#           New data set.                    MD22 162
FOR(J=1; J <= PSIZ2; J=J+1)#                                            MD22 163
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MD22 164
JJ = JPT + J#                          Point to output buffer           MD22 165
IF(J==IPTR) QX(JJ) = FLOAT(IDPTR1)#    Get proper data set number       MD22 166
ELSE IF(J<=PSIZ1)#                     Within old primaries...          MD22 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MD22 168
IF(OFF1(J)==0) QX(JJ) = VOID(1)#       Nothing to bring from scndry     MD22 169
ELSE#                                  There is something               MD22 170
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MD22 171
II = IPT3 +OFF1(J)#                    Point to item in secondary       MD22 172
movepakwd:(QX(II),QX(JJ))#             Transfer item to output          MD22 173
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MD22 174
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MD22 175
ELSE#                                  It is a new item not in prim     MD22 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MD22 177
IS = J - PSIZ1#                        Reduce pointer to new list       MD22 178
II = IPT3 + OFF3(IS)#                  Point to secondary source        MD22 179
movepakwd:(QX(II),QX(JJ))#             Place new item in o/p            MD22 180
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MD22 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MD22 182
II = JPT + IPTR#                       Get pointer to data set no.      MD22 183
QX(II) = FLOAT(NSETS1+1)#              Make sure that the new set       MD22 184
#                                         Is properly numbered.         MD22 185
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MD22 186
#                                                                     @ MD22 187
IF(LREC==lrexpl:)#                     Get sort order info              MD22 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MD22 189
## Unless the sort option chosen in SORTRF was "SORT 3" the merge       Aug93016
## will fail. So check on the sort method passed from SORTRF            Aug93017
## In addition, of course, the sort order must be the same!             Aug93018
ifne:(SORMT1,SORMT3) iquit:(MD2206)#   Must be the same sort method     Aug93019
ifne:(SORMT1,3.0) iquit:(MD2206)#      And the method must be no. 3     Aug93020
ifne:(SOR1,SOR3) iquit:(MD2205)#       Die if sort order of parent      MD22 190
J1=NINT(SOR1*0.01)#                    Not equal to derivative          MD22 191
J2=MOD(NINT(SOR1*0.1),10) ; J3=MOD(NINT(SOR1),10)# And sve for md31     MD22 192
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MD22 193
#                                                                       MD22 194
RETURN#                                                                 MD22 195
END#                                                                    MD22 196
systemheader:(MD31)#                                                    MD31   1
# ################################################################## #  MD31   2
#                                                                    #  MD31   3
#                               MD31                                 #  MD31   4
#                                                                    #  MD31   5
# ################################################################## #  MD31   6
SUBROUTINE MD31#                       Merge logical records lrrefl     MD31   7
#                                        Oct 1980  r.a. alden           MD31   8
#                                        Jun 85 & 86  j.m. stewart      MD31   9
include:(AACOMN)#                                                       MD31  10
include:(MDCOMN)#                                                       MD31  11
#                                                                       MD31  12
INTEGER ADDREF#                        Flag denoting whether addref     MD31  13
#                                         Needs to be run.              MD31  14
INTEGER DONE1#                         Flag set to yes: when            MD31  15
#                                         Completed reading primary bdf MD31  16
INTEGER DONE3#                         Flag set to yes: when com-       MD31  17
#                                         Pleted reading secondary bdf. MD31  18
INTEGER H1,H2,H3#                      Permuted values of h,k,l         MD31  19
INTEGER H1NEXT#                        The next packed hkl from the     MD31  20
#                                         Primary bdf.                  MD31  21
INTEGER H1NOW#                         The current packed hkl from      MD31  22
#                                         The primary bdf.              MD31  23
REAL    H1NOWD(3)#                     In unpacked form                 MD31  24
INTEGER H3NEXT#                        The next packed hkl from the     MD31  25
#                                         Secondary bdf.                MD31  26
INTEGER H3NOW#                         The current packed hkl from      MD31  27
#                                         The secondary bdf.            MD31  28
REAL    H3NOWD(3)#                     In unpacked form                 MD31  29
INTEGER I,II#                          Loop index                       MD31  30
INTEGER INID11,INID21,INID31#          Pointer/signals for id nums      MD31  31
#                                        1,2&3 in file1                 MD31  32
INTEGER INID13,INID23,INID33#          Ditto for file 3                 MD31  33
INTEGER IPTR1#                         Pointer to a particular valu     MD31  34
#                                         In the i/o buffer of the      MD31  35
#                                         Primary bdf.                  MD31  36
INTEGER IPTR3#                         Pointer to a particular valu     MD31  37
#                                         In the i/o buffer of the      MD31  38
#                                         Secondary bdf.                MD31  39
INTEGER IPT1#                          Primary input packet pointer     MD31  40
INTEGER IPT3#                          Secondary input packet point     MD31  41
INTEGER JPT#                           Output packet pointer            MD31  42
INTEGER JPTR#                          Pointer to a particular valu     MD31  43
#                                         In the output i/o buffer.     MD31  44
INTEGER LARGE#                         An impossibly large packed h     MD31  45
INTEGER MAXDO#                         Maximum packet size in files     MD31  46
#                                        1, 2 & 3 for lrrefl:           MD31  47
INTEGER NSETS2#                        Number of data sets that wil     MD31  48
#                                         Be on the output bdf.         MD31  49
INTEGER OFF1(300)#                     Offsets for lrrefl: of prima     MD31  50
#                                         Bdf.                          MD31  51
INTEGER OFF3(300)#                     Offsets for lrrefl: of           MD31  52
#                                         Secondary bdf.                MD31  53
INTEGER PSIZ1#                         Primary input packet size        MD31  54
INTEGER PSIZ2#                         Output packet size               MD31  55
INTEGER PSIZ2P#                        Output packet size as far as     MD31  56
#                                        File 1 data; file 3 data next  MD31  57
INTEGER PSIZ3#                         Secondary input packet size      MD31  58
REAL BOTH#                             Count of reflections which       MD31  59
#                                         Came from both primary and    MD31  60
#                                         Secondary bdf's.              MD31  61
REAL BONCOR#                           Correction of data set no.       MD31  62
REAL BOUNDC#                           Low id num file 3                MD31  63
REAL BOUNDD#                           High id num file 3               MD31  64
REAL BOUNDH#                           High id num file 2               MD31  65
REAL BOUNDL#                           Low id num file 2                MD31  66
REAL BOUNDR#                           Low bound on file 2 discards     MD31  67
REAL HEAD2(300)#                       Header packet for o/p file 2     MD31  68
REAL ONLY(2)#                          Count of reflections which       MD31  69
#                                         Came from primary or          MD31  70
#                                         Secondary bdf only.           MD31  71
REAL REFL(3)#                          Counts of reflections of         MD31  72
#                                         Primary, secondary, and       MD31  73
#                                         Output bdf's.                 MD31  74
#                                                                       MD31  75
chardata:(MD031,INPUT PRIMARY  SECONDARY   OUTPUT)#                     MD31  76
chardata:(MD033, ----- ADDREF SHOULD BE EXECUTED FOLLOWING THIS RUN.)#  MD31  77
chardata:(MD034,REFLECTIONS ON)#                                        MD31  78
chardata:(MD035,REFLECTIONS UNIQUE TO)#                                 MD31  79
chardata:(MD036,REFLECTIONS COMMON TO BOTH INPUT BDFS)#                 MD31  80
chardata:(MD31A,COPIED)#                                                MD31  81
chardata:(MD31B,DELETED)#                                               MD31  82
chardata:(MD31C,WRITTEN FROM FILE A )#                                  MD31  83
chardata:(MD31D, INPUT FILE A        INPUT FILE MER      $#             MD31  84
OUTPUT FILE B        )#                                                 MD31  85
chardata:(MD31E, RESULTS OF MERGDS OPERATION IN TERMS OF $#             MD31  86
PACKET HEADER ID NUMBERS)#                                              MD31  87
chardata:(MD31F,OR C)#                                                  MD31  88
intdata:(START1,[0])#                  First theoretical catalogue      MD31  89
realdata:(FMT031,[280513.,380513.,500513.])#                            MD31  90
realdata:(FMT032,[440513.])#                                            MD31  91
realdata:(FMIO,[170313.,370313.,580313.])#                              MD31  92
datastuff:#                                                             MD31  93
#                                                                       MD31  94
REFL(3) = 0.#                          Initialize reflection            MD31  95
ONLY(1) = 0.#                          Counters.                        MD31  96
ONLY(2) = 0.#                                                           MD31  97
BOTH    = 0.#                                                           MD31  98
#                                                                       MD31  99
#  READ THE HEADER PACKETS ON THE TWO INPUT FILES TO BE MERGED          MD31 100
#                                                                       MD31 101
readwpkt:(1,lrrefl:,PSIZ1,IPT1,0)#                                      MD31 102
readwpkt:(3,lrrefl:,PSIZ3,IPT3,0)#                                      MD31 103
#                                                                       MD31 104
NSETS2 = NSETS1 + 1#                   Default for no. of output        MD31 105
#                                         Data sets is 1 more than on   MD31 106
#                                         Primary input (i.e., new data MD31 107
#                                         Set being added).             MD31 108
#                                                                       MD31 109
# SET UPPER AND LOWER BOUNDS FOR ALLOWED PACKET ID NUMBERS              MD31 110
#                                                                       MD31 111
BOUNDL=1000.0#                         Set lower bound on file 1        MD31 112
BOUNDH=FLOAT(NSETS1*1000)+999.0#       Set upper bound on file 1        MD31 113
BOUNDC=FLOAT(IDPTR3*1000)#             Set lower bound on file 3        MD31 114
BOUNDD=BOUNDC+999.0#                   Set upper bound on file 3        MD31 115
BONCOR=FLOAT((NSETS1+1)*1000)#         Set new data set no. on 2        MD31 116
BOUNDR=BOUNDH+1.0#                     Set no replacement on f 1        MD31 117
ADDREF = yes:#                         Flag addref has been run.        MD31 118
#                                                                       MD31 119
IF(IDPTR1 > 0)#                        If this is a replacement run     MD31 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MD31 121
NSETS2 = NSETS1#                       No. of output data sets          MD31 122
BONCOR=FLOAT(IDPTR1*1000)#             Set new data set no. on 2        MD31 123
BOUNDR=BONCOR#                         Set low bound on eliminees       MD31 124
BOUNDS=BOUNDR+999.0#                   Set up bound on eliminees        MD31 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MD31 126
#                                                                       MD31 127
# SCAN THE INPUT FILE PACKETS TO SEE WHATS THERE AND TO SET UP THE      MD31 128
# OUTPUT HEADER PACKET FOR FILE 2.  ID'S 1, 2, AND 3 ARE SPECIAL        MD31 129
#                                                                       MD31 130
INID11=0 ; INID21=0 ; INID31=0#        So check for them                MD31 131
PSIZ2=0#                               Zero the o/p packet size         MD31 132
DO I=1,PSIZ1#                          Loop over file 1 packet          MD31 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MD31 134
J=IPT1+I#                              Point to packet item             MD31 135
OFF1(I)=0#                             Clear signal to 'no move'        MD31 136
ifeq:(QX(J),1.0)#                      Test for packed hkl word         MD31 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MD31 138
PSIZ2=PSIZ2+1 ; HEAD2(PSIZ2)=1.0 ; OFF1(I)=I ; INID11=I#                MD31 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MD31 140
ifeq:(QX(J),2.0)#                      Test stol                        MD31 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MD31 142
PSIZ2=PSIZ2+1 ; HEAD2(PSIZ2)=2.0 ; OFF1(I)=I ; INID21=I#                MD31 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MD31 144
ifeq:(QX(J),3.0)#                      Test refln multiplicity          MD31 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MD31 146
PSIZ2=PSIZ2+1 ; HEAD2(PSIZ2)=3.0 ; OFF1(I)=I ; INID31=I#                MD31 147
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MD31 148
IF((QX(J)<BOUNDL)\(QX(J)>BOUNDH)) NEXT# Reject out of bounds            MD31 149
IF((QX(J)>BOUNDR)&(QX(J)<BOUNDS)) NEXT# Reject to be deleteds           MD31 150
PSIZ2=PSIZ2+1 ; HEAD2(PSIZ2)=QX(J) ; OFF1(I)=I# Take all others         MD31 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MD31 152
PSIZ2P=PSIZ2#                          Remember where file 1 ends       MD31 153
INID13=0 ; INID23=0 ; INID33=0#        So check for them                MD31 154
DO I=1,PSIZ3#                          Loop over merge file 3           MD31 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MD31 156
J=IPT3+I#                              Point to input packet            MD31 157
OFF3(I)=0#                             Assume no interest               MD31 158
ifeq:(QX(J),1.0) INID13=I#             Ids 1 ,2, and 3 special          MD31 159
ifeq:(QX(J),2.0) INID23=I#                                              MD31 160
ifeq:(QX(J),3.0) INID33=I#                                              MD31 161
IF((QX(J)<BOUNDC)\(QX(J)>BOUNDD)) NEXT## Skip deletes                   MD31 162
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MD31 163
PSIZ2=PSIZ2+1 ; HEAD2(PSIZ2)=AMOD(QX(J),1000.0)+BONCOR#                 MD31 164
OFF3(I)=I#                             Remember the ones to move        MD31 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MD31 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MD31 167
#                                                                       MD31 168
# WRITE A SUMMARY OF THE PROPOSED MERGING PROCEEDURE                    MD31 169
#                                                                       MD31 170
BUFOT(1)=FLOAT(IOUNIT(1));BUFOT(2)=FLOAT(IOUNIT(3))#                    MD31 171
BUFOT(3)=FLOAT(IOUNIT(2))#             Float unit numbers               MD31 172
ncodefld:(BUFOT,1,MD31D,FMIO,3)#       Encode them                      MD31 173
writeline:(2,MD31E,NMD31E,3,3)#        Write heading                    MD31 174
LINRM=4 ; MAXDO=MAX0(PSIZ1,PSIZ2,PSIZ3)# Pick longest packet            MD31 175
II=MAX0(INID13,INID23,INID33);III=II#  Pick out special itms            MD31 176
DO I=1,MAXDO#                          Loop over all items              MD31 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MD31 178
IF(I<=PSIZ1)#                          Anything in file 1?              MD31 179
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MD31 180
J=IPT1+I#                                                               MD31 181
ncodefld:(QX,J,CHROT,60513.,1)#        Encode id num                    MD31 182
IF(OFF1(I)>0) movechar:(MD31A,1,CHROT,10,NMD31A,0)# Copied              MD31 183
ELSE movechar:(MD31B,1,CHROT,10,NMD31B,0)# Deleted                      MD31 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MD31 185
IF(I>PSIZ2P)#                          Into stuff from file3?           MD31 186
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MD31 187
II=II+1#                               Move thru file 3 pkt             MD31 188
IF(II<=PSIZ3)#                         Anything in file 3?              MD31 189
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MD31 190
J=IPT3+II#                                                              MD31 191
ncodefld:(QX,J,CHROT,260513.,1)#       Encode id num                    MD31 192
IF(OFF3(II)>0) movechar:(MD31A,1,CHROT,30,NMD31A,0)# Copied             MD31 193
ELSE movechar:(MD31B,1,CHROT,30,NMD31B,0)# Deleted                      MD31 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MD31 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MD31 196
IF(I<=PSIZ2)#                          Anything in file 2?              MD31 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MD31 198
ncodefld:(HEAD2,I,CHROT,460513.,1)#    Encode id num                    MD31 199
movechar:(MD31C,1,CHROT,50,NMD31C,0)#  Written from file a              MD31 200
IF(I>PSIZ2P) movechar:(MD31A,1,CHROT,68,1,1)# Or file c                 MD31 201
IF(I<=III) movechar:(MD31F,1,CHROT,70,NMD31F,0)# Or both                MD31 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MD31 203
writeline:(0,MD31D,NMD31D,1,3)#                                         MD31 204
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MD31 205
#                                                                       MD31 206
IF((INID21==0)\(INID31==0)\(INID23==0)\(INID33==0))  ADDREF = no:#      MD31 207
#                                                                       MD31 208
# IF NO PREVIOUS ADDREF RUN, THEN DON'T USE INFO EVEN IF PRESENT ON ONE MD31 209
#  OF THE INPUT BDF'S.                                                  MD31 210
#                                                                       MD31 211
IF(ADDREF == no:)#                                                      MD31 212
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MD31 213
J=0#                                   Squeeze out ids 2 & 3            MD31 214
DO I=1,PSIZ2#                          Loop over formed packet          MD31 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MD31 216
J=J+1#                                 Advance squeezing pointer        MD31 217
HEAD2(J)=HEAD2(I)#                     Pack up the stack                MD31 218
ifeq:(HEAD2(I),2.0) J=J-1#             Drop 2.0                         MD31 219
ifeq:(HEAD2(I),3.0) J=J-1#             Drop 3.0                         MD31 220
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MD31 221
J=PSIZ2-J ; PSIZ2=PSIZ2-J ; PSIZ2P=PSIZ2-J# Readjust pointers           MD31 222
DO I=1,PSIZ1#                          Loop over input packet           MD31 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MD31 224
J=IPT1+I#                                                               MD31 225
ifeq:(QX(J),2.0) OFF1(I) = 0#          Shut off input of 2 & 3          MD31 226
ifeq:(QX(J),3.0) OFF3(I) = 0#                                           MD31 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MD31 228
writeline:(1,MD033,NMD033,3,3)#                                         MD31 229
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MD31 230
#                                                                       MD31 231
writepkt:(2,lrrefl:,PSIZ2,JPT)#        Write the output directory       MD31 232
DO I=1,PSIZ2#                                                           MD31 233
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MD31 234
QX(JPT+I)=HEAD2(I)#                    Id num by id num                 MD31 235
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MD31 236
LARGE = 2**30#                         An impossibly large packed h     MD31 237
#                                                                       MD31 238
readwpkt:(1,lrrefl:,PSIZ1,IPT1,0)#     Read in first hkl's              MD31 239
readwpkt:(3,lrrefl:,PSIZ3,IPT3,0)#                                      MD31 240
#                                                                       MD31 241
# PICK UP PRIMARY AND SECONDARY PACKED HKL                              MD31 242
#                                                                       MD31 243
IPTR1 = IPT1 + INID11#                                                  MD31 244
gethkl:(IPTR1,H1NOWD)#                 Pull out reflection hkl          MD31 245
H1=NINT(H1NOWD(J1))#                   Get slowest-varying index        MD31 246
H2=NINT(H1NOWD(J2))#                   Get medium -varying index        MD31 247
H3=NINT(H1NOWD(J3))#                   Get fastest-varying index        MD31 248
#                                                                     @ MD31 249
IF((H1<0)$#                            H1 must be positive              MD31 250
\ ((H2<0)&(H1==0))$#                   H1=0 h2 negative                 MD31 251
\ ((H3<0)&(H1==0)&(H2==0)))#           H1=0 h2=0 h3 negative            MD31 252
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MD31 253
H1=-H1; H2=-H2; H3=-H3; IB=1#          Reverse hkl set bijvoet          MD31 254
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MD31 255
ELSE IB=0#                             Bijvoet sign not set             MD31 256
intpak:(0,H1NEXT,0,mxbtwd:)#           Clear out previous reflectio     MD31 257
intpak:(IABS(H1),H1NEXT,21,bitlen:(21))# Pack slow index                MD31 258
intpak:(IB,H1NEXT,0,1)#                Bijvoet sign code                MD31 259
intpak:(IABS(H3),H1NEXT, 3, 9)#        Pack fast index                  MD31 260
intpak:(IABS(H2),H1NEXT,12, 9)#        Pack med  index                  MD31 261
IF(H3<0) intpak:(1,H1NEXT, 1,1)#       Sign code for fas index          MD31 262
IF(H2<0) intpak:(1,H1NEXT, 2,1)#       Sign code for med index          MD31 263
#                                                                     @ MD31 264
IPTR3 = IPT3 + INID13#                                                  MD31 265
gethkl:(IPTR3,H3NOWD)#                 Pull out reflection hkl          MD31 266
H1=NINT(H3NOWD(J1))#                   Get slowest-varying index        MD31 267
H2=NINT(H3NOWD(J2))#                   Get medium -varying index        MD31 268
H3=NINT(H3NOWD(J3))#                   Get fastest-varying index        MD31 269
#                                                                     @ MD31 270
IF((H1<0)$#                            H1 must be positive              MD31 271
\ ((H2<0)&(H1==0))$#                   H1=0 h2 negative                 MD31 272
\ ((H3<0)&(H1==0)&(H2==0)))#           H1=0 h2=0 h3 negative            MD31 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MD31 274
H1=-H1; H2=-H2; H3=-H3; IB=1#          Reverse hkl set bijvoet          MD31 275
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MD31 276
ELSE IB=0#                             Bijvoet sign not set             MD31 277
intpak:(0,H3NEXT,0,mxbtwd:)#           Clear out previous reflectio     MD31 278
intpak:(IABS(H1),H3NEXT,21,bitlen:(21))# Pack slow index                MD31 279
intpak:(IB,H3NEXT,0,1)#                Bijvoet sign code                MD31 280
intpak:(IABS(H3),H3NEXT, 3, 9)#        Pack fast index                  MD31 281
intpak:(IABS(H2),H3NEXT,12, 9)#        Pack med  index                  MD31 282
IF(H3<0) intpak:(1,H3NEXT, 1,1)#       Sign code for fas index          MD31 283
IF(H2<0) intpak:(1,H3NEXT, 2,1)#       Sign code for med index          MD31 284
#                                                                     @ MD31 285
#                                                                       MD31 286
REFL(1) = 1.#                          Initialize counts                MD31 287
REFL(2) = 1.#                                                           MD31 288
#                                                                       MD31 289
DONE1 = no:#                           Initialize completion flags      MD31 290
DONE3 = no:#                                                            MD31 291
#                                                                       MD31 292
REPEAT#                                Loop over all reflections        MD31 293
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MD31 294
H1NOW = H1NEXT#                        Find current hkl's being         MD31 295
H3NOW = H3NEXT#                        Processed.                       MD31 296
REFL(3) = REFL(3) + 1.#                Count reflection output          MD31 297
writepkt:(2,lrrefl:,PSIZ2,JPT)#        Write the output reflection      MD31 298
#                                                                       MD31 299
JPTR=JPT#                              Pointer to output buffer         MD31 300
FOR(I=1; I <= PSIZ2; I=I+1)#           Set all data  to voids           MD31 301
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MD31 302
JPTR = JPTR + 1#                                                        MD31 303
QX(JPTR) = voidflg:#                                                    MD31 304
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MD31 305
#                                                                       MD31 306
IF(H1NOW <= H3NOW)#                    Primary reflection will be       MD31 307
#                                         Output.                       MD31 308
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MD31 309
JPTR=JPT#                              Pointer to output buffer         MD31 310
FOR(I=1; I <= PSIZ1; I=I+1)#           Fill up the buffer (includin     MD31 311
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MD31 312
IF(OFF1(I)>0)#                         Move those marked to be moved    MD31 313
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 MD31 314
IPTR1 = IPT1 + OFF1(I)#                Crystal specific info).          MD31 315
JPTR = JPTR + 1#                                                        MD31 316
movepakwd:(QX(IPTR1),QX(JPTR))#                                         MD31 317
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 MD31 318
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MD31 319
#                                                                       MD31 320
IF(H1NOW == H3NOW)  BOTH = BOTH + 1.#  Both input bdf's contribute      MD31 321
ELSE  ONLY(1) = ONLY(1) + 1.#          Only primary was present         MD31 322
readwpkt:(1,lrrefl:,PSIZ1,IPT1,0)#     Get next primary reflection      MD31 323
IF(IPT1 == 0)#                         If reading finished....          MD31 324
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 MD31 325
IF(DONE3 == yes:)  BREAK#              If secondary already done,       MD31 326
#                                         Leave.                        MD31 327
ELSE#                                  Otherwise set flag and next      MD31 328
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 MD31 329
DONE1 = yes:#                          Primary hkl to a huge value.     MD31 330
H1NEXT = LARGE#                                                         MD31 331
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 MD31 332
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 MD31 333
ELSE#                                                                   MD31 334
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 MD31 335
REFL(1) = REFL(1) + 1.#                Count primary input reflecti     MD31 336
IPTR1 = IPT1 + INID11#                                                  MD31 337
gethkl:(IPTR1,H1NOWD)#                 Pull out reflection hkl          MD31 338
H1=NINT(H1NOWD(J1))#                   Get slowest-varying index        MD31 339
H2=NINT(H1NOWD(J2))#                   Get medium -varying index        MD31 340
H3=NINT(H1NOWD(J3))#                   Get fastest-varying index        MD31 341
#                                                                     @ MD31 342
IF((H1<0)$#                            H1 must be positive              MD31 343
\ ((H2<0)&(H1==0))$#                   H1=0 h2 negative                 MD31 344
\ ((H3<0)&(H1==0)&(H2==0)))#           H1=0 h2=0 h3 negative            MD31 345
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 MD31 346
H1=-H1; H2=-H2; H3=-H3; IB=1#          Reverse hkl set bijvoet          MD31 347
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 MD31 348
ELSE IB=0#                             Bijvoet sign not set             MD31 349
intpak:(0,H1NEXT,0,mxbtwd:)#           Clear out previous reflectio     MD31 350
intpak:(IABS(H1),H1NEXT,21,bitlen:(21))# Pack slow index                MD31 351
intpak:(IB,H1NEXT,0,1)#                Bijvoet sign code                MD31 352
intpak:(IABS(H3),H1NEXT, 3, 9)#        Pack fast index                  MD31 353
intpak:(IABS(H2),H1NEXT,12, 9)#        Pack med  index                  MD31 354
IF(H3<0) intpak:(1,H1NEXT, 1,1)#       Sign code for fas index          MD31 355
IF(H2<0) intpak:(1,H1NEXT, 2,1)#       Sign code for med index          MD31 356
#                                                                     @ MD31 357
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 MD31 358
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MD31 359
IF(H1NOW >= H3NOW)#                    Secondary also must go out       MD31 360
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 MD31 361
#                                                                       MD31 362
# IF SECONDARY IS UNIQUE, THEN  CRYSTAL SPECIFIC INFO MUST              MD31 363
# ALSO BE PUT OUT.                                                      MD31 364
#                                                                       MD31 365
IF(H1NOW > H3NOW)#                                                      MD31 366
#                                                                       MD31 367
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 MD31 368
DO I=1,PSIZ2#                          Loop over special ids 1,2&3      MD31 369
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 MD31 370
ifeq:(HEAD2(I),1.0) movepakwd:(QX(IPT3+INID13),QX(JPT+I))#              MD31 371
ifeq:(HEAD2(I),2.0) movepakwd:(QX(IPT3+INID23),QX(JPT+I))#              MD31 372
ifeq:(HEAD2(I),3.0) movepakwd:(QX(IPT3+INID33),QX(JPT+I))#              MD31 373
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 MD31 374
JPTR=PSIZ2P+JPT#                       Set up to move file 3 to o/p     MD31 375
FOR(I=1; I < PSIZ3; I=I+1)#                                             MD31 376
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 MD31 377
IF(OFF3(I)>0)#                         Only move marked ones            MD31 378
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 MD31 379
IPTR3 = IPT3 + OFF3(I)#                                                 MD31 380
JPTR = JPTR + 1#                                                        MD31 381
movepakwd:(QX(IPTR3),QX(JPTR))#                                         MD31 382
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 MD31 383
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 MD31 384
ONLY(2) = ONLY(2) + 1.#                Only secondary present           MD31 385
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 MD31 386
JPTR=PSIZ2P+JPT#                       Point to place in o/p            MD31 387
FOR(I=1; I <= PSIZ3; I=I+1)#           Transfer data set info           MD31 388
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 MD31 389
IF(OFF3(I)>0)#                                                          MD31 390
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 MD31 391
JPTR = JPTR + 1#                                                        MD31 392
IPTR3 = IPT3 + OFF3(I)#                                                 MD31 393
movepakwd:(QX(IPTR3),QX(JPTR))#                                         MD31 394
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 MD31 395
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 MD31 396
readwpkt:(3,lrrefl:,PSIZ3,IPT3,0)#     Get next secondary reflectio     MD31 397
IF(IPT3 == 0)#                         If reading finished....          MD31 398
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 MD31 399
IF(DONE1 == yes:)  BREAK#              If primary already done, lea     MD31 400
ELSE#                                  Otherwise set flag and next      MD31 401
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 MD31 402
DONE3 = yes:#                          Secondary hkl to huge value.     MD31 403
H3NEXT = LARGE#                                                         MD31 404
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 MD31 405
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 MD31 406
ELSE#                                                                   MD31 407
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 MD31 408
REFL(2) = REFL(2) + 1.#                Count secondary reflection       MD31 409
IPTR3 = IPT3 + INID13#                                                  MD31 410
gethkl:(IPTR3,H3NOWD)#                 Pull out reflection hkl          MD31 411
H1=NINT(H3NOWD(J1))#                   Get slowest-varying index        MD31 412
H2=NINT(H3NOWD(J2))#                   Get medium -varying index        MD31 413
H3=NINT(H3NOWD(J3))#                   Get fastest-varying index        MD31 414
#                                                                     @ MD31 415
IF((H1<0)$#                            H1 must be positive              MD31 416
\ ((H2<0)&(H1==0))$#                   H1=0 h2 negative                 MD31 417
\ ((H3<0)&(H1==0)&(H2==0)))#           H1=0 h2=0 h3 negative            MD31 418
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 MD31 419
H1=-H1; H2=-H2; H3=-H3; IB=1#          Reverse hkl set bijvoet          MD31 420
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 MD31 421
ELSE IB=0#                             Bijvoet sign not set             MD31 422
intpak:(0,H3NEXT,0,mxbtwd:)#           Clear out previous reflectio     MD31 423
intpak:(IABS(H1),H3NEXT,21,bitlen:(21))# Pack slow index                MD31 424
intpak:(IB,H3NEXT,0,1)#                Bijvoet sign code                MD31 425
intpak:(IABS(H3),H3NEXT, 3, 9)#        Pack fast index                  MD31 426
intpak:(IABS(H2),H3NEXT,12, 9)#        Pack med  index                  MD31 427
IF(H3<0) intpak:(1,H3NEXT, 1,1)#       Sign code for fas index          MD31 428
IF(H2<0) intpak:(1,H3NEXT, 2,1)#       Sign code for med index          MD31 429
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 MD31 430
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 MD31 431
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MD31 432
#                                                                       MD31 433
LINRM = 7#                             Alllow space for 7 lines         MD31 434
movechar:(MD031,1,CHROT,30,5,0)#                                        MD31 435
writeline:(1,0,0,1,3)#                                                  MD31 436
movechar:(MD031,7,CHROT,23,27,0)#                                       MD31 437
writeline:(0,0,0,1,3)#                                                  MD31 438
movechar:(MD034,1,CHROT,2,NMD034,0)#                                    MD31 439
ncodefld:(REFL,1,CHROT,FMT031(1),3)#                                    MD31 440
writeline:(0,0,0,1,3)#                                                  MD31 441
movechar:(MD035,1,CHROT,2,NMD035,0)#                                    MD31 442
ncodefld:(ONLY,1,CHROT,FMT031(1),2)#                                    MD31 443
writeline:(0,0,0,1,3)#                                                  MD31 444
movechar:(MD036,1,CHROT,2,NMD036,0)#                                    MD31 445
BUFOT(1) = BOTH#                                                        MD31 446
ncodefld:(BUFOT,1,CHROT,FMT032,1)##                                     MD31 447
writeline:(1,0,0,1,3)#                                                  MD31 448
#                                                                       MD31 449
readwpkt:(3,endrecord:,PSIZ3,IPT3,0)#  Finish off secondary bdf         MD31 450
copyfile:(1,2,incr:(lrrefl:),endrecord:)#                               MD31 451
#                                                                       MD31 452
RETURN#                                                                 MD31 453
END#                                                                    MD31 454
pmacro:([no:])#                        Purge xtal system macros         MD31 455
