systemheader:(VF    )#                                                  VF     1
######################################################################  VF     2
#                                                                    #  VF     3
#                         *** VUFILE ***                             #  VF     4
#                                                                    #  VF     5
#   VUFILE LISTS THE CONTENTS OF ANY LINE FILE SUCH AS .PCH          #  VF     6
#                                                                    #  VF     7
######################################################################  VF     8
#                                                                       VF     9
include:(XMACRO)#                                                       VF    10
#                                                                       VF    11
systemheader:(VF00)#                   List the specified line file     VF00   1
######################################################################  VF00   2
#                                                                    #  VF00   3
#                             VF00                                   #  VF00   4
#                                                                    #  VF00   5
######################################################################  VF00   6
SUBROUTINE VF00#                       S.r. hall 1990                   VF00   7
include:(AACOMN)#                                                       VF00   8
#                                                                       VF00   9
INTEGER I,J,K#                                                          VF00  10
INTEGER WIDTH,TITL#                                                     VF00  11
#                                                                       VF00  12
chardata:(VF1,FIL WID NTI )#                                            VF00  13
chardata:(HEAD,' Listing of the file            -')#                    VF00  14
datastuff:#                                                             VF00  15
#                                                                       VF00  16
FILEXT(iofm1:)='PCH'#                  Default listed file is pch       VF00  17
WIDTH=80#                              Default page width               VF00  18
TITL=yes:#                             Switch on the title mode         VF00  19
#                                                                       VF00  20
#   PROCESS THE VUFILE LINE                                             VF00  21
#   -----------------------                                             VF00  22
#                                                                       VF00  23
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over input fields           VF00  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  VF00  25
stringlim:(I,J,K)#                     Get string limits                VF00  26
compchar:(CHRIN,J,VF1,1,3,4,NVF1,K)#   Identify strings                 VF00  27
IF(K==0) iquit:(VF0001)#               Unknown symbol                   VF00  28
IF(K==1)#                              File extension specified         VF00  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  VF00  30
I=I+1; stringlim:(I,J,K)#              Get position of extension        VF00  31
FILEXT(iofm1:)=CHRIN(J^J+2)#           Install file extension           VF00  32
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  VF00  33
IF(K==2)#                              Page width is specified          VF00  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  VF00  35
I=I+1;   WIDTH=NINT(BUFIN(I))#         Install page width               VF00  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  VF00  37
IF(K==3) TITL=no:#                     Switch page title                VF00  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  VF00  39
readline:(' END ',5)#                  Pull in the end line             VF00  40
#                                                                       VF00  41
#    OPEN UP REQUESTED FILE                                             VF00  42
#    -----------------------                                            VF00  43
#                                                                       VF00  44
IF(FILEXT(iofm1:)=='PCH'\$#            Test for punch file              VF00  45
   FILEXT(iofm1:)=='pch') closepch:#   Close punch file                 VF00  46
openfmt:(iofm1:,' ')#                  Open the requested file          VF00  47
movechar:(HEAD,NHEAD,CHROT,2,NHEAD-2,1)# Insert underline               VF00  48
movechar:(FILENM(iofm1:),1,HEAD,23,10,0)# Put name in header            VF00  49
writeline:(2,HEAD,NHEAD-1,2,3)#        Print header                     VF00  50
writeline:(1,0,0,1,3)#                 Insert spacer                    VF00  51
LINRM=8#                               Ensure a good place to start     VF00  52
IF(TITL==no:) LINCT=99999#             Switch page title                VF00  53
#                                                                       VF00  54
REPEAT#                                Loop over lines of file          VF00  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  VF00  56
readfmt:(iofm1:,'(A)',100,CHROT(2^WIDTH+1))# Read a line                VF00  57
writeline:(0,0,0,1,3)#                 Write a line                     VF00  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  VF00  59
100 closefmt:(iofm1:)#                 Close input file                 VF00  60
IF(TITL==no:) LINCT=0#                 Reset line counter               VF00  61
#                                                                       VF00  62
RETURN#                                                                 VF00  63
END#                                                                    VF00  64
pmacro:([no:])#                                                         VF00  65
