
:    #################################################################
:    #                                                               #
:    #  This is a variety of different Xtal test decks that are      #
:    #  useful as examples. They also include some non-standard      #
:    #  applications and difficult symmetries. Also included are     #
:    #  some applications of PLOTX and PIG.                          #
:    #                                                               #
:    #################################################################


compid exampl
master  no


title   Tests for sorting and listing Friedel related reflections


STARTX
cell   8.38090   8.38090   6.66120  
sgname p -4
ADDREF  
hklin hkl frel sigf rcod
HKL      0    2    0    74.120      .370         1
HKL      0    3    0    46.570      .240         1
HKL      0    7    5     3.570      .570         1
HKL      7    0    5     4.670      .610         1
HKL      7    0    6     4.330      .750         1
HKL      0    7    5     4.220      .530         1
HKL      7    0    5     4.460      .640         1
VUBDF lrec 20
SORTRF  pakfdl print              : pack Friedel pairs in same packet
VUBDF lrec 20
LISTFC ind 3 width 40  pun vbl    : print void items as blank
output hkl frel sigf 1314 1315    : list Friedel pairs side by side
format i5 f7.2 f5.2 f7.2 f5.2
SORTRF  sepfdl ave print          : put Friedel pairs in separate packets
VUBDF lrec 20
LISTFC ind 3 width 20             : list as column data
output hkl frel sigf 
format i5 f7.2 f5.2 
SORTRF  print                     : average and merge Friedel data
VUBDF lrec 20
LISTFC width 30                   : list merged data in archive format
output hkl frel sigf
pscale 1. 10. 10. 
 

TITLE   Test NEWMAN and PLOTX output to screen with salasylic acid

STARTX 
cell          11.52   11.21   4.92    90.0    90.8331      90.0 
latice  c  p
symtry   x,y,z
symtry   1/2+x,1/2-y,z
celcon  o  12 
celcon  c 28 
ADDATM  
atom     o1    .5484   .6379   .1533   0.03
atom     o2    .3977   .5132   .2308   0.03
atom     o3    .2541   .5710   .6016   0.03
atom     c1    .4152   .6943   .4956   0.03
atom     c2    .3185   .6696   .6318   0.03
atom     c3    .2766   .7508   .8437   0.03
atom     c4    .3440   .8547   .8796   0.03
atom     c5    .4447   .8799   .7429   0.03
atom     c6    .4757   .7921   .5370   0.03
atom     c7    .4530   .6124   .2792   0.03
NEWMAN  plot 4
:PLOTX postl nwm                     :<<<< postscript output file .ps
PLOTX $1 nwm                        :<<<< default plot device 



TITLE  (Z)-7,7'-dimethylbiindanylidene Fdd2 240k
STARTX
cell 12.6944 30.2047 7.686
sgname F_2_-2d
celcon C
celcon H
ADDATM
graf    -.8701   .4924  -.0229   .0229   .0868   .9960   .4924   .8660  -.0868  
atom C1         .46143  .51598 -.09086 .057 1.00 .00039 .00021 .00179 .003 .000 
uij  C1         .03946  .09928  .03097 -.02451 -.00534  .02098                  
suij C1         .00282  .00475  .00245  .00252  .00227  .00294                  
atom C2         .42880  .54111 -.25452 .116 1.00 .00065 .00053 .00191 .008 .000 
uij  C2         .05776  .24154  .04860 -.04034 -.01581  .06734                  
suij C2         .00456  .01370  .00438  .00642  .00386  .00678                  
atom C3         .39339  .58562 -.18983 .137 1.00 .00071 .00040 .00233 .009 .000 
uij  C3         .07331  .16130  .17692 -.03166 -.05402  .11785                  
suij C3         .00518  .00944  .01220  .00603  .00673  .00973                  
atom C4         .28440  .59957  .09260 .114 1.00 .00063 .00025 .00266 .008 .000 
uij  C4         .05894  .04392  .24048  .00606 -.06097 -.00757                  
suij C4         .00452  .00422  .01519  .00330  .00696  .00623                  
atom C5         .25131  .58145  .24648 .107 1.00 .00062 .00031 .00233 .007 .000 
uij  C5         .06856  .07157  .18123  .01882 -.02966 -.06397                  
suij C5         .00471  .00558  .01107  .00431  .00678  .00689                  
atom C6         .28815  .54196  .30047 .077 1.00 .00046 .00026 .00187 .005 .000 
uij  C6         .05102  .09994  .07912 -.00487 -.00607 -.04627                  
suij C6         .00326  .00543  .00540  .00338  .00373  .00445                  
atom C7         .35908  .51654  .20112 .041 1.00 .00036 .00017 .00169 .003 .000 
uij  C7         .02801  .05424  .04206 -.00406 -.00208 -.00994                  
suij C7         .00223  .00265  .00285  .00199  .00222  .00236                  
atom C8         .39615  .53468  .04578 .045 1.00 .00038 .00016 .00169 .003 .000 
uij  C8         .03545  .04652  .05380 -.00980 -.01662  .00930                  
suij C8         .00227  .00273  .00310  .00217  .00255  .00261                  
atom C9         .35509  .57613 -.00795 .084 1.00 .00047 .00021 .00191 .005 .000 
uij  C9         .05231  .06404  .13640 -.01767 -.03822  .04153                  
suij C9         .00326  .00393  .00766  .00324  .00493  .00469                  
atom C10        .38309  .47038  .25664 .052 1.00 .00041 .00018 .00158 .003 .000 
uij  C10        .03957  .06651  .05024 -.00721  .00135  .01881                  
suij C10        .00285  .00349  .00364  .00238  .00257  .00288                  
atom H21        .47491  .53297 -.33420 .054 1.00 .00461 .00185 .00908 .017 .000 
atom H22        .35419  .52618 -.30936 .131 1.00 .00606 .00224 .00794 .032 .000 
atom H31        .46158  .61079 -.20172 .166 1.00 .00563 .00206 .01537 .036 .000 
atom H32        .32717  .59781 -.27311 .160 1.00 .00689 .00199 .01023 .036 .000 
atom H4         .26383  .62997  .04038 .089 1.00 .00496 .00229 .01086 .021 .000 
atom H5         .18079  .59565  .31548 .167 1.00 .00722 .00252 .00893 .037 .000 
atom H6         .24313  .52176  .40983 .150 1.00 .00488 .00184 .01168 .039 .000 
atom H101       .44462  .46420  .30510 .047 1.00 .00392 .00069 .00834 .014 .000 
atom H102       .32352  .45136  .32923 .113 1.00 .00439 .00158 .01255 .025 .000 
atom H103       .39118  .44343  .14381 .074 1.00 .00407 .00100 .03298 .018 .000 
NEWMAN plot 4
bondin C1 C1 (2_665) C2 C8
bondin C1 (2_665) C1 C2 (2_665) C8 (2_665)
bondin C6 C5 C7 H6
bondin C7 C6 C8 C10
bondin C8 C1 C7 C9
bondin C10 C7 H101 H102 H103
projax C7 C6
projax C7 C8
projax C7 C10
projax C1 (2_665) C1
PLOTX $1    nwm
:PLOTX postl nwm



TITLE 1,1,8,8-tetramethyl-1,8-digermacyclotetradecane
STARTX
cell .7279600+01  .1039400+02  .1315900+02  90 100.12 90
sgname  -P_2ybc
celcon C
celcon H
celcon Ge
ADDATM
atom Ge        -.39613  .52717  .28889 .043 1.00 .00009 .00007 .00005 .000 .000 
uij  Ge         .03817  .05014  .04038  .00210  .00362 -.00185                  
suij Ge         .00033  .00038  .00033  .00031  .00027  .00031                  
atom C01       -.42063  .57009  .14270 .062 1.00 .00100 .00074 .00050 .004 .000 
uij  C01        .06711  .07428  .04352  .01236  .00328  .00437                  
suij C01        .00449  .00499  .00362  .00392  .00326  .00352                  
atom C02       -.64135  .48654  .32225 .062 1.00 .00088 .00076 .00055 .004 .000 
uij  C02        .04208  .07542  .06896 -.00667  .01414 -.00992                  
suij C02        .00362  .00500  .00449  .00350  .00322  .00394                  
atom C1        -.22819  .37982  .31555 .044 1.00 .00082 .00058 .00043 .003 .000 
uij  C1         .04852  .04403  .03675  .00729  .00207 -.00600                  
suij C1         .00346  .00353  .00311  .00288  .00263  .00274                  
atom C2        -.18085  .34185  .43135 .044 1.00 .00081 .00058 .00044 .003 .000 
uij  C2         .04377  .04257  .04208  .00514  .00030 -.00151                  
suij C2         .00331  .00353  .00330  .00279  .00268  .00274                  
atom C3        -.04031  .23065  .45108 .050 1.00 .00089 .00058 .00048 .003 .000 
uij  C3         .05625  .03323  .05332  .00210 -.00766 -.00798                  
suij C3         .00384  .00319  .00366  .00291  .00301  .00289                  
atom C4         .00042  .18863  .56308 .058 1.00 .00095 .00062 .00053 .004 .000 
uij  C4         .06146  .03752  .06591 -.00524 -.01141  .00983                  
suij C4         .00421  .00355  .00432  .00320  .00344  .00324                  
atom C5         .09381  .29090  .63930 .047 1.00 .00083 .00061 .00046 .003 .000 
uij  C5         .04303  .05049  .04625 -.00668  .00271  .00556                  
suij C5         .00338  .00381  .00345  .00294  .00277  .00296                  
atom C6        -.29102  .67034  .37681 .045 1.00 .00081 .00058 .00047 .003 .000 
uij  C6         .04202  .04030  .05262  .00252  .00478 -.00237                  
suij C6         .00333  .00339  .00364  .00275  .00281  .00291                  
atom H011      -.29720  .57670  .12348 .095 1.00 .00000 .00000 .00000 .000 .000 
atom H012      -.44695  .49484  .09840 .111 1.00 .00000 .00000 .00000 .000 .000 
atom H013      -.46662  .64705  .12951 .109 1.00 .00000 .00000 .00000 .000 .000 
atom H021      -.69711  .40581  .28540 .087 1.00 .00000 .00000 .00000 .000 .000 
atom H022      -.63049  .45850  .40174 .106 1.00 .00000 .00000 .00000 .000 .000 
atom H023      -.72771  .56762  .31258 .108 1.00 .00000 .00000 .00000 .000 .000 
atom H11       -.09970  .40023  .27393 .058 1.00 .00000 .00000 .00000 .000 .000 
atom H12       -.27564  .30607  .26633 .044 1.00 .00000 .00000 .00000 .000 .000 
atom H21       -.31468  .32198  .46736 .053 1.00 .00000 .00000 .00000 .000 .000 
atom H22       -.12807  .42694  .47737 .050 1.00 .00000 .00000 .00000 .000 .000 
atom H31        .09475  .25769  .42288 .083 1.00 .00000 .00000 .00000 .000 .000 
atom H32       -.07945  .16675  .41325 .049 1.00 .00000 .00000 .00000 .000 .000 
atom H41        .06661  .12392  .56775 .045 1.00 .00000 .00000 .00000 .000 .000 
atom H42       -.13145  .15318  .58595 .081 1.00 .00000 .00000 .00000 .000 .000 
atom H51       -.00306  .36813  .64778 .081 1.00 .00000 .00000 .00000 .000 .000 
atom H52        .10441  .25159  .72492 .058 1.00 .00000 .00000 .00000 .000 .000 
atom H61       -.37920  .74888  .36056 .042 1.00 .00000 .00000 .00000 .000 .000 
atom H62       -.28291  .64156  .45384 .040 1.00 .00000 .00000 .00000 .000 .000 
NEWMAN PLOT 4
atomty new Ge
bonlen Ge 1.7 2.0 1.7 1.7 1.7 1.7 1.7 1.7
bondin Ge C1 C6 C01 C02
bondin C1 Ge C2 H11 H12
bondin C2 C1 C3 H21 H22
bondin C3 C2 C4 H31 H32
bondin C4 C3 C5 H41 H42
bondin C5 C4 C6 (3_566) H51 H52
bondin C6 C5 (3_566) Ge H61 H62
bondin C6 (3_566) C5 Ge (3_566) H61 (3_566) H62 (3_566)
projax Ge C6
projax C1 C2
projax C2 C3
projax C3 C4
projax C4 C5
projax C5 C6 (3_566)
PLOTX $1 nwm
:PLOTX postl nwm



TITLE Test of least squares lines and planes in Fddd                    

STARTX
CELL   22.2340  23.6150  26.4230  90.0000  90.0000  90.0000
CELLSD    0.0020   0.0020   0.0030   0.0000   0.0000   0.0000
SGNAME -F 2UV 2VW
CELCON C   432. 
CELCON N    96. 
CELCON S    32. 
CELCON NI   16. 
addatm
ATOM NI         .87500   .11306   .37500 $1 1.00 .00000  .00008 .00000 
ATOM N1         .88193   .11358   .29766 $1 1.00 .00040  .00035 .00025
ATOM C1         .88670   .12443   .25580 $1 1.00 .00043  .00043 .00032
ATOM S1         .89364   .13852   .19591 $1 1.00 .00012  .00014 .00009
ATOM N11        .94316   .17719   .37864 $1 1.00 .00033  .00030 .00035
ATOM C12        .98468   .17683   .41620 $1 1.00 .00050  .00043 .00038
ATOM C13       1.02952   .21678   .42009 $1 1.00 .00051  .00051 .00043
ATOM C14       1.03099   .25964   .38513 $1 1.00 .00050  .00048 .00048
ATOM C15        .98925   .26055   .34657 $1 1.00 .00055  .00044 .00044
ATOM C16        .94584   .21889   .34447 $1 1.00 .00046  .00049 .00040
LSQPL  
PLANE
DEFINE N11 C12 C13 C14 C15 C16
PLANE
DEFINE NI N1 C1 S1
LINE
DEFINE NI N1 C1 S1

 
Title   Test Generation of Symmetry Constraints in Ia-3d


STARTX
CELL   4.0 4.0 4.0  90.0 90.0 90.0
SGNAME -I 4BD 2AB 3
CELCON C 6
ADDATM
ATOM C48G    0.125 0.234 0.016
ATOM C48F    0.728 0.000 0.25
ATOM C32E    0.289 0.289 0.289
ATOM C24D    0.375 0.0   0.25
ATOM C24C    0.125 0.0   0.25
ATOM C16B    0.125 0.125 0.125 
ATOM C16A    0.0   0.0   0.0
VUBDF LREC 16 17 NPAK 1 500


Title   Test Generation of Symmetry Constraints in P-4n2


STARTX
CELL   4.0 4.0 6.0  90.0 90.0 90.0
LATICE N P
SYMTRY X,Y,Z
SYMTRY -X,-Y,Z
SYMTRY Y,-X,-Z
SYMTRY -Y,X,-Z
SYMTRY 1/2+X,1/2-Y,1/2+Z
SYMTRY 1/2-X,1/2+Y,1/2+Z
SYMTRY 1/2+Y,1/2+X,1/2-Z
SYMTRY 1/2-Y,1/2-X,1/2-Z
CELCON C 6
ADDATM
ATOM C8I    0.162 0.456 0.328
ATOM C4H    0.000 0.5   0.342
ATOM C4G    0.133 0.633 0.25
ATOM C4F    0.857 0.643 0.25
ATOM C4E    0.0   0.0   0.491
ATOM C2D    0.0   0.5   0.75
ATOM C2C    0.0   0.5   0.25
ATOM C2B    0.0   0.0   0.5
ATOM C2A    0.0   0.0   0.0
VUBDF LREC 17 17 NPAK 1 500


Title   Test Generation of Symmetry Constraints in Fddd Centre at 0 0 0


STARTX
CELL   4.0 5.0 6.0  90.0 90.0 90.0
sgname -F 2UV 2VW
CELCON C 6
ADDATM
ATOM C32H    0.162 0.456 0.328
ATOM C16G    0.125 0.125 0.381
ATOM C16F    0.125 0.519 0.125
ATOM C16E    0.206 0.125 0.125
ATOM C16D    0.500 0.500 0.500
ATOM C16C    0.000 0.000 0.000
ATOM C8B     0.125 0.125 0.625
ATOM C8A     0.125 0.125 0.125
VUBDF  LREC 17 17 NPAK 1 500
  


Title  Test all aspects of CIFIO write/read .arc read/write .cif

STARTX  
cell      8.53    8.53    20.37    90  90   120 
cellsd   .01 .01 .01 .01 .01 .01
sgname   p 61 2   (0 0 -1)                 : p6122 at intab origin
celmol   24
celcon   s   6  
celcon   o   6  
celcon   c  12 
exper    1   1.5418
ADDREF
hklin  skip hkl rcod frel eval sigf
hkl    p6122   0  0  6     1   39.40   0.41         3.51000
hkl    p6122   0  0 12     1   48.44   0.90         2.38000
hkl    p6122   0  1  0     1   43.20   0.62         5.27000
hkl    p6122   0  1  1     1   57.36   1.18         5.27000
hkl    p6122   0  1  2     1   76.96   1.62         4.83000
hkl    p6122   0  1  3     1   53.04   1.16         4.30000
hkl    p6122   1  1  2     2    6.40   0.15         0.00000
hkl    p6122   1  1  3     1   17.60   0.43         3.53000
hkl    p6122   1  1  4     1   81.44   2.11         3.37000
hkl    p6122   1  1  6     2    6.52   0.19         0.00000
hkl    p6122   1  1  7     2    7.36   0.23         0.00000
hkl    p6122   1  1  8     1   42.20   1.47         2.70000
hkl    p6122   1  1  9     2    8.44   0.32         0.00000
hkl    p6122   1  1 10     1   28.28   1.17         2.11000
hkl    p6122   1  1 11     1   11.92   0.54         2.02000
hkl    p6122   1  2  0     1   27.84   0.79         3.15000
hkl    p6122   1  2  1     1   29.28   0.84         2.88000
hkl    p6122   1  2  2     1   39.36   1.15         3.04000
hkl    p6122   1  2  3     1   19.48   0.59         2.75000
hkl    p6122   1  2  4     1   24.32   0.76         2.55000
hkl    p6122   2  2  2     2    7.68   0.28         0.00000
hkl    p6122   2  2  3     1   12.64   0.47         2.36000
hkl    p6122   2  2  4     1    7.72   0.30         2.32000
hkl    p6122   2  2  5     1   47.48   1.91         2.36000
hkl    p6122   2  2  6     1   10.40   0.44         2.51000
hkl    p6122   2  2  7     1   15.60   0.70         2.14000
hkl    p6122   2  2  8     1   16.64   0.79         1.69000
hkl    p6122   2  3  0     1   27.08   1.23         2.12000
hkl    p6122   2  3  1     2    8.08   0.37         0.00000
hkl    p6122   2  3  2     1   22.92   1.06         2.31000
hkl    p6122   2  3  3     1   40.36   1.91         2.19000
hkl    p6122   2  3  4     1   16.92   0.82         1.91000
ADDATM 
scale   0.95
atom   s    .202     .798    .91667   0.0252
uij    s    .0253    .0253   .0253    0.0127     0.0   0.0
atom   o    .498     .498    .66667   0.0252
atom   c1   .488     .096    .038     0.0317
FC     list 10.  disp
FOURR fobs
CONTRS  flay 1 llay 2
levels direct 0 1 2 3 4 5 6 7 8 9 
PLOTX postl con :<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
PLOTX $1 con
:***** This is a test if the CIFIO archiving facility.
:***** Note that the VUBDF op should be the same 
:***** before and after the bdf->arc, arc->bdf runs.
:VUBDF               :<<<< apply if details of bdf needed
CIFIO arco
VUFILE file arc
CIFIO arci
:VUBDF               :<<<< apply if details of bdf needed
FC     list 10.  disp
:***** This is a test of the CIFIO CIF generation.
:***** Note that this process automatically spawns
:***** a STARTX, ADDATM, ADDREF and SORTRF run. The
:***** FC is to prove that we have the same data.  
:***** The created input stream is on .new
CIFIO cifo sfac nscal ncorr
VUFILE file cif
CIFIO cifi
VUFILE file new
:VUBDF               :<<<< apply if details of bdf needed
FC     list 10.  disp




:      This example shows intensity data input to DIFDAT as DATA lines.
:      These lines are output to the PCH file after a NID or NIV run.
:      The following ABSORB run generates a plot of the crystal shape.

title bidtc2 P21/c (BiCl2(dtc)) Apply ABSORB to Nicolet data  

STARTX  
cell 9.971  14.911  7.762  90.0  94.02  90.0     
cellsd  .006  .011  .004  0 .04  0                                   
latice c  p
symtry x,y,z
symtry x,1/2-y,1/2+z
celcon  C  20   
celcon  O  0   
celcon  H  40   
celcon  Bi  4  
celcon  N  4 
celcon  Cl 8
celcon  S 8

DIFDAT  pri 50 excl inst 4 .0004 obst 3
stands 1 1 2 2 
fetch rfn h k l tth omg phi chi irl sir sig
DATA      1   11   0   0    46.18    23.09    83.79    16.54    32760  810  2
DATA      2    0  10   0    27.52    13.76    82.09   286.56    32905  708  2
DATA      3    0   0   8    42.99    21.49   169.81     0.70    61989  957  2
DATA      4    0   2   0     5.45     2.73    82.09   286.56   577574 2470  1
DATA      5    0   4   0    10.92     5.46    82.09   286.56   146488 1295  1
DATA      6    0   6   0    16.41     8.20    82.09   286.56    13354  518  1
:    <<<<<<<<<<<<<<< reflections removed from here
DATA   3476   13   7   0    59.01    29.50    83.61   356.81      204  483  1
DATA   3477   13   7   1    59.68    29.84    88.89   356.91     2302  499  1
DATA   3478   14   1  -1    59.82    29.91    78.33    13.81       75  494  1
DATA   3479   14   1   0    59.97    29.98    83.75    13.84      610  503  1
genscl 1

ABSORB  mu 15.53  analyt irel pscal 2  : <<<<< note mu is in mm!!
diff  a  a  c  a
orient  11  0  0  16.54 83.79         0  0  8  0.70  169.81      
faceml  1  0  0  .135
faceml -1  0  0  .135 :<<<<<<<<< note dist in mm too!!!!
faceml  1  1  0  .230
faceml  1 -1  0  .230
faceml -1  1  0  .230
faceml -1 -1  0  .230
faceml  0  1  1  .185
faceml  0 -1 -1  .185
faceml  0  1 -1  .185
faceml  0 -1  1  .185
faceml  0  1  0  .33
faceml  0 -1  0  .33
PLOTX  *2 abs

SORTRF aver

ADDREF 
reduce itof rlp4 
bdfin  hkl irel sigi rcod


title br272  P1bar Z2  Apply ABSORB to CAD4 data with stereo plot

:                 NOTE that CAD4 kappa's and phi's were converted
:                 for the 'orient' input using the table on page 16
:                 of the CAD4 users manual.
:                 Some of the commented DIFDAT and ADDREF lines have
:                 been retained to show how a full run would work.

STARTX      
cell 16.218  14.946 14.215 94.10 107.71 109.09   
cellsd  .006 .006 .009 .04  .04  .03                                 
latice c  p
symtry x,y,z
celcon  C  120  
celcon  O  26  
celcon  H  78   
celcon  Ru  10 
celcon P  6 
celcon  N  0 
celcon  Cl 4  
:  DIFDAT cad  pri 50 excl inst 4 .0004 obst 3
:  attenu  19.14
:  genscl 1
:  SORTRF 
ADDREF            
:  reduce itof rlp4 
:  bdfin  hkl irel sigi rcod
hklin hkl frel sigf             : dummy refln
hkl 1 2 3   77. 7.              : dummy refln

ABSORB  mu 1.335  gauss  frel pscal 2 ster
diff  c c c c 
orient  10  0  0  28.72  -6.35  0  0  7  26.95 74.12     
faceml   1  0  0  .025
faceml  -1  0  0  .025
faceml   0  1  0  .13
faceml   0 -1  0  .13
faceml   0  0  1  .115
faceml   0  0 -1  .115
PLOTX *2  abs


:      Here is another ABSORB run with a very small crystal.
:      This is intended to show how effective the stereo plot is.

title Yttrium Iron Garnet Y3 Fe5 O12,   T= 25C

startx 
cell 12.3804 12.3804 12.3804  90.00000  90.00000 90.0000 
cellsd .003   .003   .003    .03       .03      .03
sgname -I 4BD 2AB 3
celmol 8
celcon  Y  24
celcon  Fe 40
celcon  O   96  
 
ADDREF
hklin hkl irel sigi
hkl 1 2 3 77777 77

ABSORB  gauss store stere irel tbar list 20 :scale 40000
diff  a a c a 
orient   0 0 16 55.83 344.84   16 0 0  19.70  223.44
faceml  1 -1  0 .025   :yes
faceml -1  1  0 .025  :maybe
faceml  1  1  0 .025  :maybe
faceml -1  0 -1 .025  :small
faceml  1  0 -1 .025  :yes
faceml -1  0  1 .025  :yes
faceml  1  0  1 .025  :yes
faceml  0 -1 -1 .025   :yes
faceml  0 -1  1 .040  :on tip neglectable
faceml  0  1 -1 .030   :poss
faceml  0  1  1 .028  :no
faceml -2 -1 -1 .026

PLOTX *2 abs




:    This test includes PIG -- this line (and PRESET) should be removed
:    if PIG is not implemented. Note that graphics device may have to be
:    defined on this line. Note which ORTEP options need to be used
:    for this situation, and the use of the STACK line in ADDATM.
:    This is basically a test of PIG and an ORTEP mole plot. Note that the
:    ORTEP output will depend what you do in PIG. The test output supplied
:    rotated the initial display by clicking the -Y(90) panel once, and the
:    -Y(10) and -X(10) panels twice each.

TITLE HN3(OET) P21/c 2 molecules close to inversion centre

STARTX 
CELL    10.44660  17.85200  15.90160  90.00000  102.5630  90.00000
cellsd .001 .001 .001 0 .01 0
LATICE C P 
SYMTRY X,Y,Z 
SYMTRY -X,Y+1/2,-Z+1/2 
CELCON C         96
CELCON H         152
CELCON O          40
CELCON RU          8
EXPER  1     1.5418
ADDATM
SCALE             .15791   1.00000     PARENT                                   
UOV               .04217               PARENT                                   
ATOM RU1      .88059   .52785   .49281 $1 1.000 .00003 .00001 .00002            
UIJ  RU1      .05436   .04564   .04165  -.00244   .01867   .00497               
SUIJ RU1      .00020   .00019   .00020   .00011   .00014   .00010               
ATOM O111     .91748   .60279   .40485 $1 1.000 .00026 .00015 .00016            
UIJ  O111     .06610   .05090   .04344  -.00153   .01684   .00792               
SUIJ O111     .00160   .00141   .00137   .00118   .00120   .00110               
ATOM C112     .89392   .67128   .40658 $1 1.000 .00037 .00021 .00024            
UIJ  C112     .05306   .05459   .04352  -.00890  -.00256   .00692               
SUIJ C112     .00204   .00219   .00199   .00165   .00164   .00162               
ATOM C113     .82842   .70676   .46519 $1 1.000 .00039 .00021 .00027            
UIJ  C113     .06554   .04633   .06161  -.00035   .00598  -.00396               
SUIJ C113     .00244   .00195   .00245   .00172   .00200   .00179               
ATOM C114     .78183   .67457   .53027 $1 1.000 .00038 .00022 .00028            
UIJ  C114     .05088   .05654   .06551  -.00178   .00595  -.00807               
SUIJ C114     .00209   .00225   .00255   .00169   .00186   .00191               
ATOM O115     .79148   .60509   .55273 $1 1.000 .00027 .00015 .00017            
UIJ  O115     .06406   .05786   .05549   .00338   .02302  -.00071               
SUIJ O115     .00162   .00154   .00162   .00125   .00133   .00124               
ATOM C116     .93890   .71817   .34012 $1 1.000 .00045 .00024 .00028            
UIJ  C116     .07741   .06404   .06177  -.01439   .00878   .01596               
SUIJ C116     .00283   .00246   .00258   .00214   .00219   .00206               
ATOM C117     .70982   .72190   .58205 $1 1.000 .00050 .00028 .00035            
UIJ  C117     .08638   .06956   .08909   .00643   .02505  -.01659               
SUIJ C117     .00334   .00285   .00350   .00243   .00279   .00254               
ATOM O121     .83891   .45652   .58348 $1 1.000 .00026 .00015 .00017            
UIJ  O121     .06232   .05841   .05309  -.00518   .02507   .00757               
SUIJ O121     .00162   .00142   .00159   .00130   .00132   .00128               
ATOM C122     .73370   .42137   .57492 $1 1.000 .00042 .00022 .00028            
UIJ  C122     .06389   .05664   .06395  -.00288   .02945   .00627               
SUIJ C122     .00244   .00220   .00257   .00186   .00210   .00188               
ATOM C123     .63038   .42184   .50139 $1 1.000 .00044 .00026 .00032            
UIJ  C123     .06302   .07656   .07620  -.01980   .02650   .00282               
SUIJ C123     .00257   .00295   .00313   .00216   .00239   .00237               
ATOM C124     .62026   .46417   .42747 $1 1.000 .00043 .00024 .00030            
UIJ  C124     .05907   .06651   .06580   .00019   .02256  -.01104               
SUIJ C124     .00244   .00246   .00278   .00196   .00216   .00205               
ATOM O125     .70491   .51091   .41286 $1 1.000 .00028 .00016 .00019            
UIJ  O125     .05781   .06770   .05761  -.00194   .01849   .00296               
SUIJ O125     .00165   .00164   .00169   .00131   .00138   .00135               
ATOM C126     .71914   .37538   .65238 $1 1.000 .00050 .00030 .00034            
UIJ  C126     .08421   .09036   .08604  -.01208   .03960   .02667               
SUIJ C126     .00331   .00332   .00354   .00269   .00286   .00283               
ATOM C127     .50256   .45570   .35559 $1 1.000 .00050 .00033 .00035            
UIJ  C127     .06864   .10774   .06921  -.01441   .01346  -.01384               
SUIJ C127     .00297   .00365   .00319   .00275   .00252   .00289               
ATOM O131     .94511   .44025   .43244 $1 1.000 .00025 .00014 .00015            
UIJ  O131     .06373   .05043   .03949  -.00411   .01847   .00210               
SUIJ O131     .00154   .00137   .00131   .00114   .00116   .00104               
ATOM C132     .92738   .44301   .33908 $1 1.000 .00046 .00024 .00026            
UIJ  C132     .08494   .06716   .04216  -.00774   .02303   .00088               
SUIJ C132     .00293   .00252   .00213   .00216   .00208   .00184               
ATOM C133     .88980   .36916   .30230 $1 1.000 .00062 .00032 .00034            
UIJ  C133     .13174   .08922   .06365  -.02906   .02476  -.01277               
SUIJ C133     .00479   .00361   .00307   .00338   .00316   .00266               
ATOM RU2      .59665   .47932   .96312 $1 1.000 .00003 .00001 .00002            
UIJ  RU2      .04783   .04198   .03275  -.00373   .00661  -.00211               
SUIJ RU2      .00019   .00018   .00018   .00010   .00013   .00009               
ATOM O211     .46772   .43260   .86316 $1 1.000 .00024 .00014 .00015            
UIJ  O211     .05378   .05425   .03640  -.00357   .00883  -.00535               
SUIJ O211     .00139   .00142   .00126   .00109   .00108   .00105               
ATOM C212     .48634   .37064   .83144 $1 1.000 .00037 .00020 .00023            
UIJ  C212     .05755   .05353   .03804  -.01433   .01313  -.00458               
SUIJ C212     .00211   .00201   .00183   .00165   .00163   .00158               
ATOM C213     .59144   .32151   .86127 $1 1.000 .00040 .00022 .00027            
UIJ  C213     .06727   .05384   .05592  -.00149   .01164  -.01829               
SUIJ C213     .00250   .00211   .00232   .00180   .00197   .00179               
ATOM C214     .69721   .33338   .92864 $1 1.000 .00038 .00021 .00026            
UIJ  C214     .05648   .05497   .05503   .00034   .01667  -.00270               
SUIJ C214     .00219   .00212   .00227   .00170   .00184   .00176               
ATOM O215     .72116   .39277   .97457 $1 1.000 .00024 .00014 .00017            
UIJ  O215     .05242   .05231   .05184   .00380   .00797  -.00166               
SUIJ O215     .00141   .00140   .00148   .00111   .00115   .00115               
ATOM C216     .38450   .34882   .75351 $1 1.000 .00045 .00026 .00027            
UIJ  C216     .07417   .07456   .04937  -.01782   .00372  -.01522               
SUIJ C216     .00270   .00272   .00228   .00218   .00204   .00205               
ATOM C217     .79813   .27259   .95365 $1 1.000 .00052 .00029 .00038            
UIJ  C217     .08124   .07691   .10574   .02463   .00660  -.01311               
SUIJ C217     .00331   .00323   .00404   .00263   .00295   .00293               
ATOM O221     .73467   .52550  1.05937 $1 1.000 .00027 .00013 .00017            
UIJ  O221     .05433   .05559   .04256  -.00207   .00567  -.00444               
SUIJ O221     .00151   .00151   .00143   .00109   .00119   .00103               
ATOM C222     .83613   .55814  1.04551 $1 1.000 .00037 .00021 .00027            
UIJ  C222     .04969   .05276   .05585   .00243   .00649  -.01034               
SUIJ C222     .00207   .00210   .00229   .00168   .00175   .00171               
ATOM C223     .86536   .57159   .96508 $1 1.000 .00040 .00023 .00030            
UIJ  C223     .05918   .05557   .06770  -.01227   .01759  -.00304               
SUIJ C223     .00231   .00222   .00266   .00179   .00205   .00194               
ATOM C224     .79197   .55226   .88576 $1 1.000 .00041 .00021 .00027            
UIJ  C224     .06781   .04216   .05765   .00006   .02103  -.00174               
SUIJ C224     .00246   .00187   .00237   .00172   .00198   .00168               
ATOM O225     .68166   .51719   .87080 $1 1.000 .00027 .00013 .00017            
UIJ  O225     .05848   .05763   .04294  -.00819   .01593  -.00467               
SUIJ O225     .00160   .00148   .00141   .00115   .00123   .00108               
ATOM C226     .92900   .58646  1.12495 $1 1.000 .00045 .00027 .00033            
UIJ  C226     .06179   .08734   .07285  -.01356  -.00114  -.02087               
SUIJ C226     .00258   .00320   .00299   .00230   .00226   .00255               
ATOM C227     .83654   .57308   .80526 $1 1.000 .00050 .00027 .00032            
UIJ  C227     .09104   .07999   .07348  -.01407   .04292  -.00513               
SUIJ C227     .00333   .00297   .00303   .00249   .00268   .00243               
ATOM O231     .49551   .57650   .95635 $1 1.000 .00024 .00013 .00015            
UIJ  O231     .05885   .04552   .03638  -.00156   .00804   .00108               
SUIJ O231     .00144   .00125   .00124   .00104   .00108   .00097               
ATOM C232     .42072   .60384   .87447 $1 1.000 .00043 .00024 .00025            
UIJ  C232     .07624   .06118   .04267  -.00022   .00515   .00822               
SUIJ C232     .00269   .00230   .00208   .00198   .00191   .00175               
ATOM C233     .46999   .67635   .85612 $1 1.000 .00069 .00030 .00041            
UIJ  C233     .15015   .07726   .10247  -.01262  -.01024   .05073               
SUIJ C233     .00570   .00345   .00454   .00356   .00409   .00333               
stack RU
END
BONDLA dihed            
dihed O111 RU1 O131 C132 1 1 3 3 555 555 766 766
dihed O115 RU1 O131 C132 1 1 3 3 555 555 766 766
dihed O121 RU1 O131 C132 1 1 3 3 555 555 766 766
dihed O125 RU1 O131 C132 1 1 3 3 555 555 766 766
dihed O211 RU2 O231 C232 1 1 3 3 555 555 667 667
dihed O215 RU2 O231 C232 1 1 3 3 555 555 667 667
dihed O221 RU2 O231 C232 1 1 3 3 555 555 667 667
dihed O225 RU2 O231 C232 1 1 3 3 555 555 667 667
dihed O111 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O115 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O121 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O125 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O211 RU2 O231 RU2 1 1 3 3 555 555 667 667
dihed O215 RU2 O231 RU2 1 1 3 3 555 555 667 667
dihed O221 RU2 O231 RU2 1 1 3 3 555 555 667 667
dihed O225 RU2 O231 RU2 1 1 3 3 555 555 667 667
dihed O111 RU1 O131 RU1 1 1 1 3 555 555 555 766
dihed O115 RU1 O131 RU1 1 1 1 3 555 555 555 766
dihed O121 RU1 O131 RU1 1 1 1 3 555 555 555 766
dihed O125 RU1 O131 RU1 1 1 1 3 555 555 555 766
dihed O211 RU2 O231 RU2 1 1 1 3 555 555 555 667
dihed O215 RU2 O231 RU2 1 1 1 3 555 555 555 667
dihed O221 RU2 O231 RU2 1 1 1 3 555 555 555 667
dihed O225 RU2 O231 RU2 1 1 1 3 555 555 555 667
dihed O225 RU2 O231 RU2 1 1 1 3 555 555 555 667
dihed O111 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O115 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O121 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O125 RU1 O131 RU1 1 1 3 3 555 555 766 766
dihed O211 RU2 O231 RU2 1 1 3 3 555 555 667 667
dihed O215 RU2 O231 RU2 1 1 3 3 555 555 667 667
VUFILE                 : list the .pch data
PIG                    : *optional* orient the molecules for ORTEP
preset sext            : this option adds the symmetry related sites
ORTEP 
sphere RU .3 C .2 O .2 : display the atoms as spheres
vsc 1  2 1 36 1 .2 2.2 : search radius for Ru atoms
vsc 1 36 1 36 1 .2 1.8 : search radius for C & O atoms
molorg RU1             : start connection search in mol1
molorg RU2             : start connection search in mol2
PLOTX


:    This is basically a test of PIG and ORTEP mole plot. Note that the
:    ORTEP output will depend what you do in PIG. The test output supplied
:    rotated the initial display by clicking the -Y(90) panel once, and the
:    -Y(10) and -X(10) panels twice each.

title   Test involving a molecular complex. Correct clustering is important.

STARTX 
CELL 8.551 9.640 19.750 90. 97.465 90.
CELLSD 0.001 0.001 0.002 0.0 0.006 0.0
SGNAME -P 2YBC 
CELCON RU 4 
CELCON C 72
CELCON H 108
ADDATM
ATOM Ru1          .80167   .64960   .11166                                    
UIJ  Ru1          .03055   .03638   .04589   .00155  -.00353  -.00146         
ATOM C1           .99043   .49639   .14151                                    
UIJ  C1           .02816   .04363   .05447   .00215  -.00365   .00668         
ATOM C2           .84476   .42343   .12415                                    
UIJ  C2           .03633   .03500   .04483   .00106  -.00743  -.00001         
ATOM C3           .74489   .46161   .17290                                    
UIJ  C3           .03662   .04807   .05375   .00130  -.00071   .01062         
ATOM C4           .97649   .58081   .19851                                    
UIJ  C4           .04233   .04820   .04790  -.00224  -.01174  -.00060         
ATOM C5           .82367   .55852   .21833                                    
UIJ  C5           .05577   .05633   .04055   .01055   .00179  -.00339         
ATOM C6           .77374   .85973   .14454                                    
UIJ  C6           .07292   .04536   .07223   .00897  -.00684  -.01593         
ATOM C7           .55496   .68301   .07786                                    
UIJ  C7           .03366   .05471   .07461   .00308  -.00953   .00523         
ATOM C8           .63708   .69061   .02042                                    
UIJ  C8           .05087   .04700   .05310   .00445  -.01227  -.00128         
ATOM C9           .60421   .91390   .13425                                    
UIJ  C9           .09809   .06661   .14060   .03167   .01200  -.04321         
ATOM C10         1.13824   .47670   .10844                                    
UIJ  C10          .03981   .08438   .07752   .01529   .00858   .01478         
ATOM C11          .81107   .31167   .07176                                    
UIJ  C11          .07517   .04665   .06177   .00097  -.00926  -.01295         
ATOM C12          .58727   .39721   .17976                                    
UIJ  C12          .03786   .09611   .09288  -.00913  -.00168   .03546         
ATOM C13          .76844   .61533   .28132                                    
UIJ  C13          .12705   .09522   .05700   .02133   .03037  -.01097         
ATOM C14          .86839   .85927   .09094                                    
UIJ  C14          .05823   .04837   .08302  -.01348  -.00580   .00453         
ATOM C15          .66712   .82569  -.01372                                    
UIJ  C15          .07914   .06007   .06751   .00767  -.00370   .01725         
ATOM C16         1.10222   .66925   .23655                                    
UIJ  C16          .07804   .06877   .08893  -.01801  -.04198  -.00266         
ATOM C17          .48874   .80508   .11153                                    
UIJ  C17          .04791   .09826   .12002   .02297   .02450   .00450         
ATOM C18          .80789   .90472   .01979                                    
UIJ  C18          .10282   .05530   .09705  -.00942   .00619   .01874         
ATOM H101        1.16564   .37630   .11486  0.03500                           
ATOM H102        1.10619   .49591   .05882  0.03500                           
ATOM H103        1.23991   .52762   .12056  0.03500                           
ATOM H111         .79658   .22519   .09820  0.03500                           
ATOM H112         .70852   .33807   .04456  0.03500                           
ATOM H113         .88159   .28471   .03734  0.03500                           
ATOM H121         .60094   .35046   .22535  0.03500                           
ATOM H122         .51258   .47686   .18049  0.03500                           
ATOM H123         .53121   .32824   .14743  0.03500                           
ATOM H131         .84463   .57955   .32008  0.03500                           
ATOM H132         .77973   .71827   .27803  0.03500                           
ATOM H133         .66144   .59972   .29520  0.03500                           
ATOM H161        1.19023   .60372   .25214  0.03500                           
ATOM H162        1.13577   .73363   .20144  0.03500                           
ATOM H163        1.09231   .72926   .27707  0.03500                           
ATOM H8           .67678   .60285   .00172  0.03500                           
ATOM H14          .98027   .82731   .10091  0.03500                           
ATOM H6           .81885   .82366   .19042  0.03500                           
ATOM H7           .53984   .58914   .09756  0.03500                           
ATOM H171         .40391   .84728   .07824  0.03500                           
ATOM H172         .44218   .77085   .15233  0.03500                           
ATOM H91          .57891   .95264   .17852  0.03500                           
ATOM H92          .59588   .98904   .09906  0.03500                           
ATOM H151         .57175   .88566  -.01355  0.03500                           
ATOM H152         .68386   .80550  -.06192  0.03500                           
ATOM H181         .77798  1.00483   .02146  0.03500                           
ATOM H182         .89509   .89378  -.00898  0.03500                           
BONDAT 
CALCAT TETERM 1.0 C2 C1 C10 H101 H102 H103
CALCAT TETERM 1.0 C3 C2 C11 H111 H112 H113
CALCAT TETERM 1.0 C5 C3 C12 H121 H122 H123
CALCAT TETERM 1.0 C4 C5 C13 H131 H132 H133
CALCAT TETERM 1.0 C1 C4 C16 H161 H162 H163
CALCAT TRIGON 1.0 C7 C8 C15 H8
CALCAT TRIGON 1.0 C6 C14 C18 H14
CALCAT TRIGON 1.0 C9 C6 C14 H6
CALCAT TRIGON 1.0 C8 C7 C17 H7
CALCAT TETCHN 1.0 C7 C17 C9 H171 H172
CALCAT TETCHN 1.0 C6 C9 C17 H91 H92
CALCAT TETCHN 1.0 C18 C15 C8 H151 H152
CALCAT TETCHN 1.0 C14 C18 C15 H181 H182
PIG 
ORTEP  mole
sphere C .2        
molorg Ru1
molorg C1
molorg C6
plotp 12 12 0 .4
PLOTX 


:    This is basically a test of PIG and ORTEP cell plot. Note that the
:    ORTEP output will depend what you do in PIG. The test output supplied
:    rotated the initial display by clicking the -Y(90) panel once, and the
:    -Y(10) and -X(10) panels twice each.

Title   Test with molecular fragment sitting on a mirror

STARTX
CELL 19.370 24.675 5.9082 90.0 90.0 90.0
CELLSD 0.003 0.003 0.0006
SGNAME F 2 -2D
CELMOL 8
CELCON C 104
CELCON N 16
CELCON O 16
CELCON H 176
ADDATM 
ATOM N1           .45058  .02545  .20276  0.0351  1.0000  .00011  .00008  .00000
UIJ  N1           .05856  .06075  .02073  .01488  .00038  .00229                
ATOM O1           .39173  .05102  .50403  0.0359  1.0000  .00010  .00008  .00040
UIJ  O1           .07152  .08741  .02004  .01890  .00556 -.00032                
ATOM C1           .39511  .05075  .29450  0.0351  1.0000  .00013  .00010  .00049
UIJ  C1           .05200  .04991  .03013  .00186 -.00138 -.00005                
ATOM C2           .50000  .00000  .35616  0.0355  1.0000  .00000  .00000  .00063
UIJ  C2           .05780  .05345  .02305  .00827  .00000  .00000                
ATOM C3           .47184  .01440 -.02345  0.0351  1.0000  .00014  .00012  .00050
UIJ  C3           .06103  .06935  .01899  .00991 -.00341  .00160                
ATOM C4           .34072  .07846  .14823  0.0359  1.0000  .00012  .00010  .00052
UIJ  C4           .04999  .05498  .03425  .00496 -.00060  .00389                
ATOM C5           .28761  .10370  .30880  0.0354  1.0000  .00019  .00017  .00064
UIJ  C5           .06292  .07605  .05444  .01911  .00789  .00615                
ATOM C6           .30414  .03660  .00069  0.0351  1.0000  .00019  .00015  .00069
UIJ  C6           .05863  .08242  .04998 -.00205 -.00501 -.00585                
ATOM C7           .37341  .12343  .00638  0.0354  1.0000  .00019  .00014  .00069
UIJ  C7           .07378  .06361  .05148  .00718  .00128  .01673                
ATOM H2           .52585  .02737  .44724  0.0359  1.0000  .00134  .00107  .00617
ATOM H3           .44810  .02970 -.12624  0.0351  1.0000  .00122  .00105  .00522
ATOM H5A          .25165  .12182  .23673  0.0354  1.0000  .00135  .00117  .00627
ATOM H5B          .26591  .07491  .38667  0.0359  1.0000  .00190  .00164  .00775
ATOM H5C          .30929  .13409  .39925  0.0351  1.0000  .00151  .00131  .00585
ATOM H6A          .26440  .05577 -.08680  0.0358  1.0000  .00169  .00122  .00662
ATOM H6B          .28561  .00722  .07166  0.0355  1.0000  .00170  .00170  .00826
ATOM H6C          .33791  .02184 -.07998  0.0359  1.0000  .00150  .00118  .00646
ATOM H7A          .39405  .15465  .09620  0.0353  1.0000  .00173  .00127  .00712
ATOM H7B          .41193  .11312 -.08742  0.0350  1.0000  .00182  .00138  .00665
ATOM H7C          .33800  .14296 -.06433  0.0355  1.0000  .00190  .00154  .00709
END
pig 
ortep cell
plotx
finish
