systemheader:(DM    )#                                                  DM     1
####################################################################### DM     2
##      Copyright (C) 2002, The GNU Xtal System                       # DM     3
## Distributed under the GNU General Public Licence as published by   # DM     4
## the Free Software Foundation, in the hope that it will be useful   # DM     5
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # DM     6
## for more details.                                                  # DM     7
##                                                                    # DM     8
##                          *** DYNAMO ***   a.k.a. MOULDY            # DM     9
##                                                                    # DM    10
##   HOPEFULLY THIS PROGRAM CAN BE USED TO CALCULATE EFFECTIVE        # DM    11
##   STRUCTURE FACTORS FROM MOLECULAR DYNAMICS CALCULATION DATA       # DM    12
##                                                                    # DM    13
##                         ddb@R3401.msl.titech.ac.jp                 # DM    14
##                                  Tokyo Institute of Technology     # DM    15
####################################################################### DM    16
#                                      Basically kludged from fc        DM    17
#                                                                       DM    18
include:(XMACRO)#                                                       DM    19
macro:(atomlist:,[ifelse:($1,,M,$1)])# Define atom list pointer         DM    20
macro:(scat:,[QX(atomlist:($1)+1)])#                                    DM    21
macro:(xif:, [QX(atomlist:($1)+1+$2)])#                                 DM    22
macro:(pmul:,[QX(atomlist:($1)+5)])#                                    DM    23
macro:(bis:, [QX(atomlist:($1)+6)])#                                    DM    24
macro:(bij:, [QX(atomlist:($1)+5+$2)])#                                 DM    25
#                                                                       DM    26
macro:(reflnlist:,[ifelse:($1,,HKL,$1)])# Define refln list pointer     DM    27
macro:(refh:,[QX(reflnlist:($1)+1)])#                                   DM    28
macro:(refk:,[QX(reflnlist:($1)+2)])#                                   DM    29
macro:(refl:,[QX(reflnlist:($1)+3)])#                                   DM    30
macro:(stol:,[QX(reflnlist:($1)+4)])#                                   DM    31
macro:(anod:,[QX(reflnlist:($1)+5)])#  Inter step summations            DM    32
macro:(bnod:,[QX(reflnlist:($1)+6)])#  Inter step summations            DM    33
macro:(adis:,[QX(reflnlist:($1)+7)])#  Inter step summations            DM    34
macro:(bdis:,[QX(reflnlist:($1)+8)])#  Inter step summations            DM    35
macro:(anodl:,[QX(reflnlist:($1)+9)])# Intra step summation             DM    36
macro:(bnodl:,[QX(reflnlist:($1)+10)])# Intra step summation            DM    37
macro:(adisl:,[QX(reflnlist:($1)+11)])# Intra step summation            DM    38
macro:(bdisl:,[QX(reflnlist:($1)+12)])# Intra step summation            DM    39
macro:(step8:,12)#                     Basic stepsize                   DM    40
#                                                                       DM    41
macro:(isf:,  ARCH($1))#               Lrrefl: archive pointers         DM    42
macro:(irj:,  ARCH(NTYP+1))#                                            DM    43
macro:(irs:,  ARCH(NTYP+2))#                                            DM    44
macro:(irx:,  ARCH(NTYP+3))#                                            DM    45
macro:(ifcnd:,ARCH(NTYP+4))#                                            DM    46
macro:(ifa:,  ARCH(NTYP+5))#                                            DM    47
macro:(ifb:,  ARCH(NTYP+6))#                                            DM    48
macro:(ifad:, ARCH(NTYP+7))#                                            DM    49
macro:(ifbd:, ARCH(NTYP+8))#                                            DM    50
macro:(ifanx:,ARCH(NTYP+9))#                                            DM    51
macro:(ifbnx:,ARCH(NTYP+10))#                                           DM    52
macro:(irh:,  ARCH(NTYP+11))#                                           DM    53
macro:(irl:,  ARCH(NTYP+12))#                                           DM    54
macro:(iph:,  ARCH(NTYP+13))#                                           DM    55
macro:(iph2:, ARCH(NTYP+14))#                                           DM    55
#                                                                       DM    56
macro:(mxat:,16)#                      Maximum number of atom types     DM    57
macro:(mxspec:,40)#                    Max number of reference specie   DM    58
#                                                                       DM    59
extrude:(DMCOMN)#                                                       DM    60
REAL ARCH(32)#                         Archive list                     DM    61
REAL ADI(mxat:),ADR(mxat:)#            Anomalous dispersion terms       DM    62
REAL ATA(mxat:)#                       Number of atoms in unit cell     DM    63
REAL ATP(mxat:)#                       And in a partial structure       DM    64
REAL ATZ(mxat:)#                       Atomic numbers                   DM    65
INTEGER ASP(mxspec:)#                  Atomic species- pointer          DM    66
INTEGER NASP(mxspec:)#                 Count of atomic species          DM    67
REAL BOVL#                             Overall tf                       DM    68
INTEGER CENT#                          Centro flag                      DM    69
INTEGER DISP#                          Dispersion flag                  DM    70
REAL DLIS#                             List > fdiff value               DM    71
REAL DSTL#                             Delta st/l for ff table          DM    72
REAL DSNM#                             Data set number                  DM    73
REAL ELIM#                             Limit of e value                 DM    74
REAL FMUL#                             S.f. multiplicity                DM    75
INTEGER IATM#                          Atom list increment              DM    76
INTEGER IEXT#                          Extinction flag                  DM    77
INTEGER IFFF#                          Refl form factor flag            DM    78
INTEGER IP,JP#                         Working ip/op pointers           DM    79
INTEGER ISEL#                          Select flag: 1 select/2 omit     DM    80
INTEGER ISCF#                          Step in ff name list             DM    81
INTEGER ISIM#                          Sim weight flag                  DM    82
INTEGER ISIN#                          Sin/cos lookup flag              DM    83
INTEGER ITEM#                          Number of archive items          DM    84
INTEGER IREL(67)#                      Relative packet pointers         DM    85
INTEGER IFC,IFR,IFRC#                  Relative packet pointers         DM    86
INTEGER IWNT(66)#                      Want list of idnums              DM    87
INTEGER KEY(4)#                        Indexpkt control signals         DM    88
INTEGER LPAK#                          Input packet length              DM    89
INTEGER MARK1#                         Start-1 of sym matrices          DM    90
INTEGER MARK2#                         Start-1 of ff name list          DM    91
INTEGER MARK3#                         Start-1 of scatfac table         DM    92
INTEGER MARK4#                         Start-1 of scale list            DM    93
INTEGER MARK5#                         Start-1 of select list           DM    94
INTEGER MARK6#                         Start-1 of atoms list            DM    95
INTEGER MARK7#                         Start-1 of sin/cos table         DM    96
INTEGER MARK8#                         Start-1 of refln list            DM    97
INTEGER MARK9#                         End of refln list                DM    98
REAL MAXH,MAXK,MAXL#                   Maximum /h/,/k/,/l/              DM    99
INTEGER NAME#                          Qx step for select list          DM   100
INTEGER NATM#                          Count number of atoms            DM   101
INTEGER IRAD#                          Radiation type flag              DM   102
INTEGER NDEL#                          Extra items in op packet         DM   103
INTEGER NMDS#                          Data set number *1000            DM   104
INTEGER NPAK#                          Output packet length             DM   105
INTEGER NROT#                          Number of rotation matrices      DM   106
INTEGER NSCF#                          Length of ff table               DM   107
INTEGER NSCL#                          Number of scale groups           DM   108
INTEGER NSPEC#                         Number of species                DM   109
INTEGER NTYP#                          Number of atom types             DM   110
INTEGER OFF(mxat:)#                    Ff table offsets                 DM   111
INTEGER RUNAVE#                        Running average sum mode         DM   112
INTEGER STEP8#                                                          DM   113
REAL REJF#                             Reject code flag                 DM   114
REAL SMAX,SMIN#                        Max/min st/l limits              DM   115
REAL SUMC(2,6),SUMD(2,6),SUMN(2,6),SUMR(2,6)# Statistics sums           DM   116
REAL UTOB#                             8*pi**2                          DM   117
REAL UTOBET(6)#                        Convert uij to beta ij           DM   118
REAL RM(9)#                            Reciprocal metric tensor         DM   119
REAL RC(9)#                            Reciprocal cell constants        DM   120
REAL TM(9)#                            Original cell to mol dyn trans   DM   121
REAL TMI(9)#                           Inverse transformation transf    DM   122
REAL VOLFAC#                           Volume transformation factor     DM   123
INTEGER TYPE#                          Temp. factor type                DM   124
INTEGER NORMFC#                        Archive storage mode             DM   125
INTEGER MOLDFR#                        Archive storage mode             DM   126
INTEGER MOLDFC#                        Archive storage mode             DM   127
INTEGER FRAME1#                        Starting frame                   DM   128
INTEGER FRAME2#                        Finishing frame                  DM   129
string:(MDFILE,256)#                   Molecular dynamics file          DM   130
string:(MDFMT,80)#                     Molecular dynamics format stri   DM   131
#                                                                       DM   132
COMMON /COMCDM/MDFILE,MDFMT#                                            DM   133
#                                                                       DM   134
COMMON /COMIDM/$#                                                       DM   135
CENT,DISP,IATM,IEXT,IFFF,IP,JP,ITEM,ISCF,ISIN,ASP,NASP,$#               DM   136
IREL,IWNT,KEY,LPAK,MARK1,MARK2,MARK3,MARK4,ISIM,$#                      DM   137
MARK5,MARK6,MARK7,MARK8,MARK9,NAME,NATM,TYPE,$#                         DM   138
IRAD,NDEL,NMDS,NPAK,NROT,NSCF,NSCL,NTYP,OFF,ISEL,$#                     DM   139
STEP8,NSPEC,RUNAVE,NORMFC,MOLDFR,MOLDFC,FRAME1,FRAME2,IFC,IFR,IFRC#     DM   140
#                                                                       DM   141
COMMON /COMFDM/$#                                                       DM   142
ARCH,ADI,ADR,BOVL,DLIS,DSNM,DSTL,FMUL,$#                                DM   143
MAXH,MAXK,MAXL,REJF,SMIN,SMAX,ATP,ATA,ATZ,$#                            DM   144
SUMC,SUMD,SUMN,SUMR,UTOB,UTOBET,ELIM,RC,RM,TM,TMI,VOLFAC#               DM   145
endext:#                                                                DM   146
#                                                                       DM   147
systemheader:(DM00)#                   Structure factor calculation     DM00   1
# ################################################################## #  DM00   2
#                                                                    #  DM00   3
#                               DM00                                 #  DM00   4
#                                                                    #  DM00   5
# ################################################################## #  DM00   6
SUBROUTINE DM00#                                                        DM00   7
include:(AACOMN)#                                                       DM00   8
include:(DMCOMN)#                                                       DM00   9
#                                                                       DM00  10
CALL DM10#                             Read archive                     DM00  11
CALL DM20#                             Read command lines               DM00  12
CALL DM30#                             Read lratom:                     DM00  13
CALL DM40#                             Prepare refln info               DM00  14
CALL DM45#                             Calc mol. dynam struct fact      DM00  15
CALL DM50#                             Init second lrrefl: pass         DM00  16
CALL DM55#                             Calculate fcal/fdiff             DM00  17
CALL DM60#                             Stats                            DM00  18
#                                                                       DM00  19
RETURN#                                                                 DM00  20
END#                                                                    DM00  21
systemheader:(DM10)#                   Read bdf lrsymm: to lrdset:      DM10   1
# ####################################################################  DM10   2
#                                                                       DM10   3
#                                DM10                                   DM10   4
#                                                                       DM10   5
# ####################################################################  DM10   6
SUBROUTINE DM10#                                                        DM10   7
include:(AACOMN)#                                                       DM10   8
include:(DMCOMN)#                                                       DM10   9
#                                                                       DM10  10
REAL    CELL#                          Cell volume                      DM10  11
INTEGER I,J,K,L#                       Working indices                  DM10  12
INTEGER IDS#                           Compound pointer and offset      DM10  13
INTEGER IPO#                           Pointer to output buffer         DM10  14
INTEGER J2#                            Index for sf names in mark2      DM10  15
#                                                                       DM10  16
chardata:(DM11,SCT NOS OVE ISO ANI MIX POP NOP DIS NOD $#               DM10  17
EXT NOE XRA NEU DSE LIS REJ NLI NRE FRE FCA FIL )#                      DM10  18
datastuff:#                                                             DM10  19
#                                                                       DM10  20
#---------------------------------------------------------------------- DM10  21
#                                                                       DM10  22
# THE DM INPUT LINE CONTAINS CODES TO DIRECT THE SETTING OF THE FOLLOWI DM10  23
# VARIABLES.                                                            DM10  24
#                                                                       DM10  25
# VARIABLE  POSSIBLE  VALUE OF  MEANING                                 DM10  26
#   NAME     CODES    VARIABLE                                          DM10  27
#                                                                       DM10  28
#  ISIN      SCT       YES:    CALC A & B WITH SIN TABLE 0-0/1/449 DEGR DM10  29
#            NOS       NO:     CALC A & B WITH LIBRARY SUBROUTINE       DM10  30
#                                                                       DM10  31
#  TYPE      OVE        2      OVERALL TEMPERATURE FACTOR               DM10  32
#            ISO        3      INDIVIDUAL ISOTROPIC TEMP. FACTORS       DM10  33
#            ANI        4      INDIVIDUAL ANISOTROPIC TEMP. FACTORS     DM10  34
#            MIX        4      MIXED TEMPERATURE FACTORS                DM10  35
#                                                                       DM10  36
#  DISP      DIS       YES:    APPLY ANOMALOUS DISPERSION CORRECTION    DM10  37
#            NOD       NO:     DO NOT APPLY DISPERSION CORRECTION       DM10  38
#                                                                       DM10  39
#  IEXT      EXT       YES:    APPLY EXTINCTION CORRECTION              DM10  40
#            NOE       NO:     DO NOT APPLY EXTINCTION CORRECTION       DM10  41
#                                                                       DM10  42
#  DSNM      DSE       INPUT   DATASET FLAG PRECEDES NUMERIC VALUE THAT DM10  43
#                              FOLLOWS. IF NO VALUE ENTERED SET AT 1.   DM10  44
#                                                                       DM10  45
#  DLIS      LIS       YES:    LIST DM'S IF FDIFF > VALUE FOLLOWING     DM10  46
#            NLI               THIS FLAG. IF NO VALUE INPUT - LIST ALL. DM10  47
#                                                                       DM10  48
#  REJF      REJ       YES:    REJECT REFLN IF JCODE >= VALUE FOLLOWING DM10  49
#            NRE               THIS FLAG.  IF NO VALUE: REJECT > 0.     DM10  50
#                                                                       DM10  51
#  ISIM      SIM       YES:    SIM WEIGHT FOR PARTIAL STRUCTURE         DM10  52
#                      NO:     DEFAULT                                  DM10  53
#                                                                       DM10  54
#---------------------------------------------------------------------- DM10  55
#                                                                       DM10  56
#                                                                       DM10  57
#    DECODE =DM= LINE PARAMETERS                                        DM10  58
#    ---------------------------                                        DM10  59
#                                                                       DM10  60
ISIN=no:#                              Set default parameters           DM10  61
IRAD=3#                                Set default rad as xrays         DM10  62
TYPE=4#                                Set default parameters           DM10  63
ELIM=-1.#                              Set default parameters           DM10  64
DISP=no:#                              Set default parameters           DM10  65
IFFF=0#                                Set default parameters           DM10  66
IEXT=no:#                              Set default parameters           DM10  67
DSNM=1.#                               Set default parameters           DM10  68
DLIS=999999.#                          Set default parameters           DM10  69
REJF=6.#                               Set default parameters           DM10  70
ISIM=no:#                              Set default parameters           DM10  71
UTOB=78.9568#                          8*pi**2                          DM10  72
MDFILE=' '#                            Initialize blank                 DM10  73
MOLDFR=no:#                            User not forced save as frel     DM10  74
MOLDFC=no:#                            User not forced save as fcal     DM10  75
#                                                                       DM10  76
FOR(I=1;I<30;I=I+1)#                   Loop over input fields           DM10  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM10  78
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            DM10  79
stringlim:(I,J,K)#                     Find limits of the field         DM10  80
compchar:(CHRIN,J,DM11,1,3,4,NDM11,K)# Find what's there                DM10  81
IF(K==0) iquit:(DM1001,I)#             Dud flag.......fc101             DM10  82
ELSE IF(K==1)  ISIN=yes:#              Do not use lookup table          DM10  83
ELSE IF(K==3)  TYPE=2#                 Overall tf                       DM10  84
ELSE IF(K==4)  TYPE=3#                 Individual isotropic tf          DM10  85
ELSE IF(K==5)  TYPE=4#                 Anisotropic or mixed tf          DM10  86
ELSE IF(K==6)  TYPE=4#                 Anisotropic or mixed tf          DM10  87
ELSE IF(K==9)  DISP=yes:#              Don't apply disper corr.         DM10  88
ELSE IF(K==11) IEXT=yes:#              No extinction corr.              DM10  89
ELSE IF(K==15)#                        Data set number to follow        DM10  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM10  91
IF(BUFIN(I+1)>voidflg:)#               Should be numeric dsetnum        DM10  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DM10  93
DSNM=NINT(BUFIN(I+1))#                 Get dataset number               DM10  94
I=I+1#                                 Advance field counter            DM10  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DM10  96
ELSE DSNM=1.#                          Default dataset is 1             DM10  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM10  98
ELSE IF(K==16)#                        Test for list flag               DM10  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DM10 100
IF(BUFIN(I+1)>voidflg:)#               Test if diff limit follows       DM10 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DM10 102
DLIS=NINT(BUFIN(I+1))#                 Extract diff list limit          DM10 103
I=I+1#                                 Advance field counter            DM10 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DM10 105
ELSE DLIS=-1.#                         Force all to be listed           DM10 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DM10 107
ELSE IF(K==17)#                        Test for reject refln flag       DM10 108
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DM10 109
IF(BUFIN(I+1)>voidflg:)#               Is reject limit following        DM10 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DM10 111
REJF=BUFIN(I+1)-0.5#                   Set up reject limit              DM10 112
I=I+1#                                 Advance field counter            DM10 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DM10 114
ELSE REJF=1.5#                         Default reject all but 1.        DM10 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DM10 116
ELSE IF(K==20)MOLDFR=yes:#             User force save as frel          DM10 117
ELSE IF(K==21)MOLDFC=yes:#             User force save as fcal          DM10 118
ELSE IF(K==22)#                        Mol dynam filename               DM10 119
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DM10 120
ifvo:(BUFIN(I+1)) iquit:(DM1010)#      Quit if missing                  DM10 121
stringlim:(I+1,J,K)#                   Find start of string             DM10 122
DO L=K,mxchim:;IF(CHRIP(L^L)==':')BREAK# Search for comment delimiter   DM10 123
IF(L<mxchim:&(CHRIP(L+1^L+1)==' '\CHRIP(L-1^L-1)==' '))# Found it       DM10 124
MDFILE=CHRIP(J^L-1)#                   Copy partial string              DM10 125
ELSE MDFILE=CHRIP(J^)#                 Copy ehole string to storage     DM10 126
BREAK#                                 File name is last option         DM10 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DM10 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM10 129
#                                                                       DM10 130
IF(MDFILE(1^1)==" ")         iquit:(DM1011)# Need a filename            DM10 131
IF(MOLDFR==yes:&MOLDFC==yes:)iquit:(DM1020)# Alert foolish user         DM10 132
NMDS=NINT(DSNM)*1000#                  Form dataset offset              DM10 133
#                                                                       DM10 134
#   ASSIGN BDF BUFFERS 1 AND 2                                          DM10 135
#   --------------------------                                          DM10 136
#                                                                       DM10 137
IOMARK(1)=QXSTR#                       Set start of io buffer1          DM10 138
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of buffer2                 DM10 139
incrqx:(MARK1,IOMARK(2)+bdfbuf:,DM1030)# Expand mem.....fc0104          DM10 140
copyfile:(1,2,1,decr:(lrcell:))#       Copy to cell record              DM10 141
#                                                                       DM10 142
#   EXTRACT CELL INFORMATION                                            DM10 143
#   ------------------------                                            DM10 144
#                                                                       DM10 145
DO I=1,100#                            Loop over cell packets           DM10 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DM10 147
readwpkt:(1,lrcell:,LPAK,IP,0)#        Read  1st packet of lrcell       DM10 148
IF(IP<=0) BREAK#                       Exit when finished               DM10 149
writepkt:(2,lrcell:,LPAK,IPO)#         Write 1st packet of lrcell       DM10 150
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Transfer data to output          DM10 151
IF(I==8) DO J=1,9; RM(J)=QX(IP+J)#     Get recip metric tensor          DM10 152
IF(I!=3) NEXT#                         Skip all but recip constants     DM10 153
UTOBET(1)=19.739209*QX(IP+1)*QX(IP+1)# 2*pi**2*astar**2                 DM10 154
UTOBET(2)=19.739209*QX(IP+2)*QX(IP+2)# 2*pi**2*bstar**2                 DM10 155
UTOBET(3)=19.739209*QX(IP+3)*QX(IP+3)# 2*pi**2*cstar**2                 DM10 156
UTOBET(4)=19.739209*QX(IP+1)*QX(IP+2)# 2*pi**2*astar*bstar              DM10 157
UTOBET(5)=19.739209*QX(IP+1)*QX(IP+3)# 2*pi**2*astar*cstar              DM10 158
UTOBET(6)=19.739209*QX(IP+2)*QX(IP+3)# 2*pi**2*bstar*cstar              DM10 159
DO J=1,9; RC(J)=QX(IP+J)#              Get reciprocal cell const.       DM10 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DM10 161
#                                                                       DM10 162
#   EXTRACT SYMMETRY CODES & MATRICES (LRSYMM:)                         DM10 163
#   ---------------------------------------                             DM10 164
#                                                                       DM10 165
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read first packet of lr lrsy     DM10 166
writepkt:(2,lrsymm:,LPAK,IPO)#         Copy to output file              DM10 167
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#                                     DM10 168
CENT=NINT(QX(IP+2))#                   Centric=0 / acentric=1           DM10 169
NROT=NINT(QX(IP+4))#                   Get number rotation matrices     DM10 170
FMUL=QX(IP+6)#                         Get reflection multiplicity      DM10 171
incrqx:(MARK2,MARK1+NROT*LPAK,DM1031)# Expand qx......fc105             DM10 172
FOR(J=MARK1;J>0;J=J+LPAK)#             Loop over symm matrices          DM10 173
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DM10 174
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Get packet pointer               DM10 175
IF(IP<=0) BREAK#                       Exit after last packet           DM10 176
writepkt:(2,lrsymm:,LPAK,IPO)#         Get pointer to o/p buffer        DM10 177
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    And copy the packet              DM10 178
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Save the symop for later         DM10 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DM10 180
copyfile:(1,2,incr:(lrsymm:),decr:(lrscat:))# Copy to scatt. rec.       DM10 181
#                                                                       DM10 182
#   ENTER SCATT. FACTOR & ATOM SUMMARY (LR LRSCAT:)                     DM10 183
#   ---------------------------------------                             DM10 184
#                                                                       DM10 185
incrqx:(MARK3,MARK2+32,DM1032)#        Save room for 16 sf types        DM10 186
ISCF=incr:(arith:(7,/,mxchwd:))#       Allow for 8 char. per name       DM10 187
J2=MARK2#                              Set marker for first sf name     DM10 188
IWNT(1)=NINT(DSNM+20.);  IWNT(3)=100#  Set real ad & ff idnums          DM10 189
IWNT(2)=NINT(DSNM+60.);  IWNT(4)=10#   Set imag ad & neut ff            DM10 190
IWNT(5)=11 ;  IWNT(6)=7#               Set sf name idnum                DM10 191
IWNT(7)=1#                             Set atom number idnum            DM10 192
IWNT(8)=3#                             Set atom number idnum            DM10 193
KEY(1)=0;  KEY(2)=8;  KEY(3)=0#        Set search delimiters            DM10 194
KEY(4) = 0#                                                             DM10 195
indexpkt:(1,lrscat:,LPAK,IP,2,KEY,IWNT,IREL)# Get packet pointers       DM10 196
IF((IREL(1)==0)&(IREL(2)==0)) DISP=no:# No dispersion values            DM10 197
#                                                                       DM10 198
FOR(I=IP+IREL(3);I<=IP+LPAK;I=I+1)#    Loop over ff list                DM10 199
IF((QX(I)<99.5)\(QX(I)>299.5)) BREAK#  Exit after last ff               DM10 200
IF(IREL(3)>0)  NSCF=I-IP-IREL(3)+1#    Count contiguous ff      ddb     DM10 201
ELSE           NSCF=0#                 Ff table present                 DM10 202
IF(IREL(4)>0)  NSCF=1#                 Count neutron ff                 DM10 203
IF(IREL(3)>0) DSTL=(QX(I-1)-QX(I-2))*.01# Set st/l interval             DM10 204
#                                                                       DM10 205
NTYP=0#                                Zero count of atom types         DM10 206
FOR(J=MARK3;J>0;J=J+NSCF)#             Loop over each atom type         DM10 207
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DM10 208
readwpkt:(1,lrscat:,LPAK,IP,0)#        Get packet pointer               DM10 209
IF(IP<=0) BREAK#                       Exit after last packet           DM10 210
writepkt:(2,lrscat:,LPAK,IPO)#         Get output pointer               DM10 211
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy packet                      DM10 212
L=IP+IREL(5)#                          Set pointer for sf name          DM10 213
movereal:(QX,L,QX,J2+1,ISCF,1)#        Move sf name to mark2 array      DM10 214
J2=J2+ISCF#                            Advance sf name pointer          DM10 215
incrqx:(MARK4,J+NSCF,DM1033)#          Expand qx.......fc108            DM10 216
NTYP=NTYP+1#                           Count atom types                 DM10 217
ADR(NTYP)=0.;   ADI(NTYP)=0.#          Zero dispersion values           DM10 218
I=IP+IREL(1); IF(I>IP) ifnv:(QX(I)) ADR(NTYP)=QX(I)# Get real disp      DM10 219
I=IP+IREL(2); IF(I>IP) ifnv:(QX(I)) ADI(NTYP)=QX(I)# Get imag disp      DM10 220
I=IP+IREL(6); IF(I>IP) IFFF=NINT(QX(I))# Get refl ff flag               DM10 221
I=IP+IREL(7); IF(I>IP) ATA(NTYP)=QX(I)# Get total atom number           DM10 222
I=IP+IREL(8); IF(I>IP) ATZ(NTYP)=QX(I)# Get atomic number               DM10 223
I=IP+IREL(4); IF(I>IP) QX(MARK4)=QX(I)# Store neutron ff                DM10 224
ELSE IF(IREL(3)>0)#                    If xray or electron ff present   DM10 225
FOR(I=J;I<MARK4;I=I+1)#                Loop over sf data points         DM10 226
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DM10 227
K=IP+IREL(3)+I-J#                      Point to each ff value           DM10 228
QX(I+1)=QX(K)#                         Store each ff value              DM10 229
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DM10 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DM10 231
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))# Copy to experm. rec.      DM10 232
#                                                                       DM10 233
#   ENTER SCALE INFORMATION (LR LREXPL:)                                DM10 234
#   ------------------------------                                      DM10 235
#                                                                       DM10 236
IWNT(1)=1;    IWNT(2)=100#             Set data set & nscl idnums       DM10 237
IWNT(3)=94;   IWNT(4)=22#              Set rad type & cell volume       DM10 238
KEY(1)=1; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set search delimiters           DM10 239
indexpkt:(1,lrexpl:,LPAK,IP,2,KEY,IWNT,IREL)# Get packet pointers       DM10 240
incrqx:(MARK5,MARK4+64,DM1034)#        Expand qx.......fc109            DM10 241
NSCL=1;   QX(MARK4+1)=1.#              Default group & rel pointer&     DM10 242
FOR(I=IP+1;I<=IP+LPAK;I=I+1)#          Loop over directory              DM10 243
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DM10 244
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           DM10 245
J=MARK4+NINT(QX(I))-100#               Get group number of scale        DM10 246
QX(J)=FLOAT(I-IP)#                     Store relative position          DM10 247
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DM10 248
REPEAT#                                Loop over data sets              DM10 249
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DM10 250
readwpkt:(1,lrexpl:,LPAK,IP,0)#        Get packet pointer               DM10 251
IF(IP<=0) BREAK#                       Exit after last packet           DM10 252
writepkt:(2,lrexpl:,LPAK,IPO)#         Get o/p buffer pointer           DM10 253
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  DM10 254
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        DM10 255
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           DM10 256
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               DM10 257
FOR(I=MARK4;I<MARK4+NSCL;I=I+1)#       Loop over scale factors          DM10 258
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DM10 259
J=IP+NINT(QX(I+1))#                    Point to scale location          DM10 260
IF(J>IP) QX(I+1)=QX(J)#                Store scale in table             DM10 261
ELSE     QX(I+1)=1.#                   Default scale is 1.              DM10 262
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DM10 263
I=IP+IREL(3); IF(I>IP) IRAD=NINT(QX(I))# Radiation (1=n,2=e;3=x)        DM10 264
I=IP+IREL(4); IF(I>IP) CELL=QX(I)/47.878# Cell volume for elect rad     DM10 265
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DM10 266
IF(IREL(4)==0&IRAD==2) iquit:(DM1037)# Cell volume missing              DM10 267
IF(IRAD==2) FMUL=FMUL/CELL#            Scale structure factor volts     DM10 268
MARK5=MARK4+NSCL#                      Reset mark5 for true nscl        DM10 269
#                                                                       DM10 270
#   ENTER DATA SET INFORMATION (LR LRDSET:)                             DM10 271
#   ---------------------------------                                   DM10 272
#                                                                       DM10 273
IWNT(1)=2;  IWNT(7)=1#                 Request ovb, dataset number      DM10 274
DO I=2,6;   IWNT(I)=I+9#               Request maxhkl, max&min stol     DM10 275
KEY(1)=0;  KEY(2)=7; KEY(3)=0#         Set search delimiters            DM10 276
indexpkt:(1,lrdset:,LPAK,IP,2,KEY,IWNT,IREL)# Search rel pointers       DM10 277
BOVL=0.; SMIN=0.; SMAX=2.#             Set default parameters           DM10 278
MAXH=256.; MAXK=256.; MAXL=256.#       Set default parameters           DM10 279
IF (IP>0) $#                           If there was a directory         DM10 280
REPEAT#                                Loop over data sets              DM10 281
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DM10 282
readwpkt:(1,lrdset:,LPAK,IP,0)#                                         DM10 283
IF(IP<=0) BREAK#                                                        DM10 284
writepkt:(2,lrdset:,LPAK,IPO)#         Get o/p buffer pointer           DM10 285
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  DM10 286
IDS=IP+IREL(7)#                        Make pointer to dataset no.      DM10 287
ifne:(DSNM,QX(IDS)) NEXT#              Skip unwanted datasets           DM10 288
I=IP+IREL(1); IF(I>IP) BOVL=QX(I)*UTOB# Get active b overall            DM10 289
I=IP+IREL(2); IF(I>IP) MAXH=QX(I)#     Get active max /h/               DM10 290
I=IP+IREL(3); IF(I>IP) MAXK=QX(I)#     Get active max /k/               DM10 291
I=IP+IREL(4); IF(I>IP) MAXL=QX(I)#     Get active max /l/               DM10 292
I=IP+IREL(5); IF(I>IP) SMIN=QX(I)#     Get active smin                  DM10 293
I=IP+IREL(6); IF(I>IP) SMAX=QX(I)#     Get active smax                  DM10 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DM10 295
#                                                                       DM10 296
RETURN#                                                                 DM10 297
END#                                                                    DM10 298
systemheader:(DM20)#                   Read controls                    DM20   1
# ####################################################################  DM20   2
#                                                                       DM20   3
#                                DM20                                   DM20   4
#                                                                       DM20   5
# ####################################################################  DM20   6
SUBROUTINE DM20#                                                        DM20   7
include:(AACOMN)#                                                       DM20   8
include:(DMCOMN)#                                                       DM20   9
#                                                                       DM20  10
INTEGER IARC#                          Archive input flag               DM20  11
INTEGER I,J,K,M#                       Working indices                  DM20  12
string:(SFTYP,128)#                                                     DM20  13
#                                                                       DM20  14
## data example: x0,y0,z0 are ideal initial refrence coords             DM20  15
##    x1     y1     z1       x0     yo      zo      Atom #sequ          DM20  16
## 0.06601 0.06530 0.06577 0.06570 0.06570 0.06570    1                 DM20  17
chardata:(FMT,'(3F8.5,24x,I5)')#       Maybe should be free format      DM20  18
chardata:(DM21, SCALE MAXHKL SELECT OMIT TRANSF TYPINF FRAMES $#        DM20  19
FORMAT END )#                                                           DM20  20
chardata:(DM22,        )#                                               DM20  21
#                                                                       DM20  22
datastuff:#                                                             DM20  23
#                                                                       DM20  24
#   ENTER CONTROL LINES                                                 DM20  25
#   -------------------                                                 DM20  26
#                                                                       DM20  27
MARK6=MARK5#                           Set select atom marker           DM20  28
NAME=incr:(arith:(23,/,mxchwd:))#      Calc atom name length            DM20  29
movertoc:(QX(MARK2+1),1,SFTYP,1,NTYP*ISCF*mxchwd:,0)#                   DM20  30
NSPEC=0#                                                                DM20  31
FRAME1=1;FRAME2=16000000#              Preset range                     DM20  32
MDFMT=FMT#                             Initialize the file format       DM20  33
#                                                                       DM20  34
IARC=0;   ITEM=11;    ISEL=0#          Reset archive parameters         DM20  35
#                                                                       DM20  36
REPEAT#                                Loop over control lines          DM20  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM20  38
readline:(DM21,NDM21)#                 Process control line             DM20  39
#                                                                       DM20  40
IF(LINID==1)#                          ****** scale *******             DM20  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM20  42
ifvo:(BUFIN(1)) NEXT#                  Skip if void scale               DM20  43
ifvo:(BUFIN(2)) I=1#                   Default scale group              DM20  44
ELSE             I=NINT(BUFIN(2))#     Enter scale group                DM20  45
QX(MARK4+I)=BUFIN(1)#                  Store scale value                DM20  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM20  47
#                                                                       DM20  48
ELSE IF(LINID==2)#                     ****** maxhkl *******            DM20  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DM20  50
ifnv:(BUFIN(1)) MAXH=BUFIN(1)#         Set active max /h/               DM20  51
ifnv:(BUFIN(2)) MAXK=BUFIN(2)#         Set active max /k/               DM20  52
ifnv:(BUFIN(3)) MAXL=BUFIN(3)#         Set active max /l/               DM20  53
ifnv:(BUFIN(4)) SMIN=BUFIN(4)#         Set active min st/l              DM20  54
ifnv:(BUFIN(5)) SMAX=BUFIN(5)#         Set active max st/l              DM20  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DM20  56
#                                                                       DM20  57
ELSE IF(LINID==3\LINID==4)#            ****** select/omit *******       DM20  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DM20  59
IF(ISEL==1&LINID==4) iquit:(DM2001)#   Select and omit lines mixed      DM20  60
IF(ISEL==2&LINID==3) iquit:(DM2001)#   Select and omit lines mixed      DM20  61
ISEL=LINID-2#                          Select=1; omit=2                 DM20  62
DO I=1,30#                             Loop over select fields          DM20  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DM20  64
ifvo:(BUFIN(I)) BREAK#                 Exit first inactive field        DM20  65
M=MARK6+1#                             Point to next name               DM20  66
incrqx:(MARK6,MARK6+NAME,DM2002)#      Expand qx......fc202             DM20  67
stringlim:(I,J,K)#                     Extract string limits            DM20  68
K=MIN0(K-J,24)#                        Limit to 24 characters           DM20  69
movector:(DM22,1,QX(M),1,24,1)#        Blank out qx region              DM20  70
movector:(CHRIP,J,QX(M),1,K,0)#        Store name in qx                 DM20  71
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DM20  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DM20  73
#                                                                       DM20  74
ELSE IF(LINID==5)#                     ***** transf ******              DM20  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DM20  76
DO I=1,9#                              Loop over fields                 DM20  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DM20  78
ifnm:(BUFIN(I)) TM(I)=BUFIN(I)#        Numeric field                    DM20  79
ELSE iquit:(DM2003)#                   Bad field                        DM20  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DM20  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DM20  82
ELSE IF(LINID==6)#                     ***** typinf ******              DM20  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DM20  84
FOR(H=1;H<30;H=H+2)#                   Loop over preset fields          DM20  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DM20  86
ifvo:(BUFIN(H)) BREAK#                 Exit on first void               DM20  87
stringlim:(H,J,K)#                     Extract string limits            DM20  88
label:(CHRIP(J^K+1),I,J,SFTYP,L)#      Get atom type                    DM20  89
IF(L==0)iquit:(DM2004)#                Unrecognized scat type           DM20  90
ifnm:(BUFIN(H+1))#                                                      DM20  91
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DM20  92
ifne:(FLOAT(NINT(BUFIN(H+1))),BUFIN(H+1))iquit:(DM2006)# Non integral   DM20  93
IF(BUFIN(H+1)<=0.)iquit:(DM2006)#      Negative unsupported             DM20  94
NSPEC=NSPEC+1#                         Number of species incremented    DM20  95
ASP(NSPEC)=L#                          Save type pointer                DM20  96
NASP(NSPEC)=NASP(NSPEC)+NINT(BUFIN(H+1))# Save cumulative species num   DM20  97
NASP(NSPEC+1)=NASP(NSPEC)#             Init for next species            DM20  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DM20  99
ELSE iquit:(DM2006)#                   Nonnumeric is bad                DM20 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DM20 101
#                                      Just ignore blank entries        DM20 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DM20 103
ELSE IF(LINID==7)#                     ***** frames ******              DM20 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DM20 105
ifnm:(BUFIN(1))FRAME1=MAX(1,NINT(BUFIN(1)))# First frame to use         DM20 106
ifnm:(BUFIN(2))FRAME2=FRAME1+NINT(BUFIN(2))-1# Last frame to use        DM20 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DM20 108
ELSE IF(LINID==7)#                     ***** format ******              DM20 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DM20 110
MDFMT=CHRIP(8^)#                       Copy the format                  DM20 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DM20 112
#                                                                       DM20 113
ELSE BREAK#                            ****** end *******               DM20 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM20 115
IF(NSPEC==0)iquit:(DM2007)#                                             DM20 116
#                                                                       DM20 117
#                                                                       DM20 118
RETURN#                                                                 DM20 119
END#                                                                    DM20 120
systemheader:(DM30)#                   Get atom parameters from lra     DM30   1
# ####################################################################  DM30   2
#                                                                       DM30   3
#                               DM30                                    DM30   4
#                                                                       DM30   5
# ####################################################################  DM30   6
SUBROUTINE DM30#                                                        DM30   7
include:(AACOMN)#                                                       DM30   8
include:(DMCOMN)#                                                       DM30   9
#                                                                       DM30  10
INTEGER I,J,K,L,M,N#                   Working indices                  DM30  11
INTEGER IPO#                           O/p buffer pointer               DM30  12
INTEGER LIST#                          Number of list items             DM30  13
INTEGER NAT#                           Atom name point                  DM30  14
INTEGER NSTEP#                         Step size per atom in mark6      DM30  15
REAL SMUL#                             Site muliplicity                 DM30  16
REAL POPP#                             Population parameter             DM30  17
REAL X,Y,Z#                            Coordinate storage               DM30  18
#                                                                       DM30  19
string:(NAME1,24)#                     Atom name from bdf               DM30  20
string:(NAME2,24)#                     Selected part atom name          DM30  21
string:(NAME3,24)#                     Atom name left part              DM30  22
chardata:(DM31," x/a    y/b    z/c   $#                                 DM30  23
pp*ml    U11     U22     U33     U12     U13     U23")#                 DM30  24
realdata:(FMT,[742.,742.,742.,622.,842.,842.,842.,842.,842.,842.])#     DM30  25
realdata:(B11,0.); realdata:(B22,0.); realdata:(B33,0.)#                DM30  26
realdata:(B12,0.); realdata:(B13,0.); realdata:(B23,0.)#                DM30  27
datastuff:#                                                             DM30  28
#                                                                       DM30  29
copyfile:(1,2,incr:(lrdset:),decr:(lratom:))# Copy to atom rec.         DM30  30
#                                                                       DM30  31
#--------------------------------------------------------------------   DM30  32
##### LAYOUT OF ATOM PARAMETER STORAGE                                  DM30  33
# RELATIVE ADDRESS                                                      DM30  34
# IN QX ARRAY                                                           DM30  35
#      1                SCAT. FACTOR POINTER                            DM30  36
#      2                X                                               DM30  37
#      3                Y                                               DM30  38
#      4                Z                                               DM30  39
#      5                ATOM MULTIPLICITY * POPULATION                  DM30  40
#      6                BETA11 (OR B)                                   DM30  41
#      7                BETA22 (OR SIGNAL TO B IN 6)                    DM30  42
#      8                BETA 33                                         DM30  43
#      9                BETA 12                                         DM30  44
#     10                BETA 13                                         DM30  45
#     11                BETA 23                                         DM30  46
#---------------------------------------------------------------------- DM30  47
#                                                                       DM30  48
#   LOCATE REQUIRED PARAMETERS IN LR LRATOM:                            DM30  49
#   ----------------------------------                                  DM30  50
#                                                                       DM30  51
MARK7=MARK6#                           End of atom list                 DM30  52
IWNT(1)=22; IWNT(14)=21#               Set nscf, mult, tf idnums        DM30  53
IWNT(2)=14; IWNT(13)=11#               Set atom name, neut-flag idnum   DM30  54
DO I=1,3;   IWNT(I+2)=I#               Set x to z idnums                DM30  55
DO I=4,10;  IWNT(I+2)=I#               Set displ. params u uij          DM30  56
IWNT(15)=26#                                                            DM30  57
KEY(1)=5;  KEY(2)=15;  KEY(3)=0#       Set search delimiters            DM30  58
KEY(4)=0#                              Copy mode for indexpkt:          DM30  59
indexpkt:(1,lratom:,LPAK,IP,2,KEY,IWNT,IREL)# Get relative pointers     DM30  60
IF(KEY(4)<0) RETURN#                                                    DM30  61
#                                                                       DM30  62
IF((TYPE==4)&(IREL(7)<=0)) TYPE=3#     Type 4 needs aniso               DM30  63
IF((TYPE==3)&(IREL(6)<=0)) TYPE=2#     Type 3 calc needs iso b          DM30  64
IF((TYPE==2)&(BOVL<0.)) iquit:(DM3001)# Type 2 needs overall tf         DM30  65
#                                                                       DM30  66
#    RESERVE QX ARRAY FOR ATOM PARAMETERS                               DM30  67
#    ------------------------------------                               DM30  68
#                                                                       DM30  69
IF     (TYPE==1) IATM=5#               Allow for ff,x,y,z,m             DM30  70
ELSE IF(TYPE==2) IATM=5#               Allow for ff,x,y,z,pp            DM30  71
ELSE IF(TYPE==3) IATM=6#               Allow for ff,x,y,z,pp,b          DM30  72
ELSE             IATM=11#              Allow for ff,x,y,z,pp,bij        DM30  73
NSTEP=NROT*IATM#                       Figure step size for each at     DM30  74
HEADOT=' '; HEADOT(14^)=DM31#          Set atom list header             DM30  75
#                                                                       DM30  76
#   EXTRACT ATOM PARAMETERS FROM LR LRATOM:                             DM30  77
#   ---------------------------------                                   DM30  78
#                                                                       DM30  79
writeline:(0,0,0,1,3);  LINRM=4#       Prepare for list header          DM30  80
NATM=0#                                Zero count of selected atoms     DM30  81
DO I=1,mxat:; ATP(I)=0.#               Zero count of atom number        DM30  82
K=MARK6#                               Start atom list pointer          DM30  83
REPEAT#                                Loop over atom packets           DM30  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM30  85
readwpkt:(1,lratom:,LPAK,IP,0)#        Get packet pointer               DM30  86
IF(IP<=0) BREAK#                       Exit after last packet           DM30  87
writepkt:(2,lratom:,LPAK,IPO)#         Get o/p buffer pointer           DM30  88
movereal:(QX,IP+1,QX,IPO+1,LPAK,1)#    Copy the packet                  DM30  89
LIST=IATM-1#                           Set number list items            DM30  90
#                                                                       DM30  91
N=IP+IREL(2)#                          Make pointer to atom name        DM30  92
movertoc:(QX(N),1,NAME1,1,24,0)#       Move name to character array     DM30  93
label:(NAME1,I,J)#                     Get max label length             DM30  94
NAME2=NAME1(1^J)#                      Extract scatt fact symbol        DM30  95
FOR(I=MARK5;I<MARK6;I=I+NAME)#         Loop over selected atoms         DM30  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM30  97
movertoc:(QX(I+1),1,NAME3,1,24,0)#     Move name of selected atom       DM30  98
IF(NAME1==NAME3\NAME2==NAME3) BREAK#   Test atom label or type symbol   DM30  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM30 100
IF(I>=MARK6&ISEL==1) NEXT#             Skip unselected atoms            DM30 101
IF(I<MARK6&ISEL==2)  NEXT#             Skip omitted atoms               DM30 102
NATM=NATM+1#                           Increment count of found ato     DM30 103
incrqx:(MARK7,K+NSTEP,DM3002)#         Expand qx......fc302             DM30 104
#                                                                       DM30 105
I=IP+IREL(1); scat:(K)=QX(I); NAT=NINT(QX(I))# Get sf number pointer    DM30 106
I=IP+IREL(3); X=QX(I)#                 Store x coordinate               DM30 107
I=IP+IREL(4); Y=QX(I)#                 Store y coordinate               DM30 108
I=IP+IREL(5); Z=QX(I)#                 Store z coordinate               DM30 109
I=IP+IREL(13); IF(I>IP) POPP=QX(I)#    Store pop parameter              DM30 110
ELSE POPP=1.#                          Else set to one                  DM30 111
I=IP+IREL(14); IF(I>IP) SMUL=QX(I)#    Store site mult.                 DM30 112
ELSE SMUL=1.#                          Else set to one                  DM30 113
POPP=POPP*SMUL#                        Store combined m*pp              DM30 114
B11=0.#                                Initialize b11                   DM30 115
IF(TYPE>2)#                            Test if more data needed         DM30 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DM30 117
I=IP+IREL(6); IF(I>IP) bis:(K)=QX(I)*UTOB# Store isotropic b            DM30 118
ELSE                   bis:(K)=BOVL#   Else store overall b             DM30 119
IF(TYPE==4)#                           Test if more data needed         DM30 120
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DM30 121
I=IP+IREL(7); IF(I>IP) B11=QX(I)*UTOBET(1)# Extract beta11              DM30 122
IF(B11>0.)#                            Test if aniso or iso tf          DM30 123
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DM30 124
I=IP+IREL(8); B22=QX(I)*UTOBET(2)#     Extract beta22                   DM30 125
I=IP+IREL(9); B33=QX(I)*UTOBET(3)#     Extract beta33                   DM30 126
I=IP+IREL(10); B12=QX(I)*UTOBET(4)#    Extract beta12                   DM30 127
I=IP+IREL(11); B13=QX(I)*UTOBET(5)#    Extract beta13                   DM30 128
I=IP+IREL(12); B23=QX(I)*UTOBET(6)#    Extract beta23                   DM30 129
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DM30 130
ELSE LIST=5#                           Reset list to isotropic          DM30 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DM30 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DM30 133
#                                                                       DM30 134
#                                                                       DM30 135
#   GENERATE EQUIVALENT POSITIONS                                       DM30 136
#   -----------------------------                                       DM30 137
#                                                                       DM30 138
M=K-5#                                 Set init betaij test pt to fai   DM30 139
FOR(N=MARK1;N<MARK2;N=N+12)#           Loop over rot matrices           DM30 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DM30 141
DO I=1,3#                              Rowxcolumn marix multiply        DM30 142
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DM30 143
J=N+I;   L=K+I+1#                      Increment pointers               DM30 144
xif:(K,I)=X*QX(J)+Y*QX(J+3)+Z*QX(J+6)+QX(J+9)# Matrix multiply          DM30 145
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DM30 146
pmul:(K)=POPP#                         Store site population            DM30 147
#                                                                       DM30 148
IF(B11>0.)#                            Test if aniso needed             DM30 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DM30 150
#                                        Calculate beta11               DM30 151
bij:(K,1)= QX(N+1)*QX(N+1)*B11 $#                                       DM30 152
+          QX(N+4)*QX(N+4)*B22 $#                                       DM30 153
+          QX(N+7)*QX(N+7)*B33 $#                                       DM30 154
+    2.0 *(QX(N+1)*QX(N+4)*B12 $#                                       DM30 155
+          QX(N+1)*QX(N+7)*B13 $#                                       DM30 156
+          QX(N+4)*QX(N+7)*B23)#                                        DM30 157
#                                        Calculate beta22               DM30 158
bij:(K,2)= QX(N+2)*QX(N+2)*B11 $#                                       DM30 159
+          QX(N+5)*QX(N+5)*B22 $#                                       DM30 160
+          QX(N+8)*QX(N+8)*B33 $#                                       DM30 161
+    2.0 *(QX(N+2)*QX(N+5)*B12 $#                                       DM30 162
+          QX(N+2)*QX(N+8)*B13 $#                                       DM30 163
+          QX(N+5)*QX(N+8)*B23)#                                        DM30 164
#                                        Calculate beta33               DM30 165
bij:(K,3)= QX(N+3)*QX(N+3)*B11 $#                                       DM30 166
+          QX(N+6)*QX(N+6)*B22 $#                                       DM30 167
+          QX(N+9)*QX(N+9)*B33 $#                                       DM30 168
+    2.0 *(QX(N+3)*QX(N+6)*B12 $#                                       DM30 169
+          QX(N+3)*QX(N+9)*B13 $#                                       DM30 170
+          QX(N+6)*QX(N+9)*B23)#                                        DM30 171
#                                        Calculate beta12               DM30 172
bij:(K,4)=  QX(N+1)*QX(N+2)*B11 $#                                      DM30 173
+           QX(N+4)*QX(N+5)*B22 $#                                      DM30 174
+           QX(N+7)*QX(N+8)*B33 $#                                      DM30 175
+          (QX(N+2)*QX(N+4)     $#                                      DM30 176
+           QX(N+1)*QX(N+5))*B12$#                                      DM30 177
+          (QX(N+2)*QX(N+7)     $#                                      DM30 178
+           QX(N+1)*QX(N+8))*B13$#                                      DM30 179
+          (QX(N+5)*QX(N+7)     $#                                      DM30 180
+           QX(N+4)*QX(N+8))*B23#                                       DM30 181
#                                        Calculate beta13               DM30 182
bij:(K,5)=  QX(N+1)*QX(N+3)*B11 $#                                      DM30 183
+           QX(N+4)*QX(N+6)*B22 $#                                      DM30 184
+           QX(N+7)*QX(N+9)*B33 $#                                      DM30 185
+          (QX(N+3)*QX(N+4)     $#                                      DM30 186
+           QX(N+1)*QX(N+6))*B12$#                                      DM30 187
+          (QX(N+3)*QX(N+7)     $#                                      DM30 188
+           QX(N+1)*QX(N+9))*B13$#                                      DM30 189
+          (QX(N+6)*QX(N+7)     $#                                      DM30 190
+           QX(N+4)*QX(N+9))*B23#                                       DM30 191
#                                        Calculate beta23               DM30 192
bij:(K,6)=  QX(N+2)*QX(N+3)*B11 $#                                      DM30 193
+           QX(N+5)*QX(N+6)*B22 $#                                      DM30 194
+           QX(N+8)*QX(N+9)*B33 $#                                      DM30 195
+          (QX(N+3)*QX(N+5)     $#                                      DM30 196
+           QX(N+2)*QX(N+6))*B12$#                                      DM30 197
+          (QX(N+3)*QX(N+8)     $#                                      DM30 198
+           QX(N+2)*QX(N+9))*B13$#                                      DM30 199
+          (QX(N+6)*QX(N+8)     $#                                      DM30 200
+           QX(N+5)*QX(N+9))*B23#                                       DM30 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DM30 202
#                                                                       DM30 203
#    LIST INPUT ATOMS                                                   DM30 204
#    ----------------                                                   DM30 205
#                                                                       DM30 206
IF(PPRIOR>=4\(DLIS<99999.&N==MARK1))#  Dump atom list at pr=5           DM30 207
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DM30 208
IF(N==MARK1)#                          Test if input atom site          DM30 209
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DM30 210
movechar:(NAME1,1,CHROT,2,24,0)#       Get current atom name            DM30 211
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DM30 212
ELSE IF(B11<.00001) LIST=3#            Reset for equiv. site            DM30 213
movereal:(xif:(K,1),1,BUFOT,1,LIST,0)# Copy to bufot for editing        DM30 214
IF(LIST==5) BUFOT(5)=BUFOT(5)/UTOB#    Print u for isotropic dp         DM30 215
ELSE IF(LIST==10)#                     Anisotropic dp                   DM30 216
DO I=1,6; BUFOT(I+4)=BUFOT(I+4)/UTOBET(I)# Uij                          DM30 217
LCHROT=11#                             Start op formats                 DM30 218
ncodefld:(BUFOT,1,CHROT,FMT,LIST)#     Format stored items              DM30 219
writeline:(0,HEADOT,100,1,3)#          Print equivalent sites           DM30 220
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DM30 221
#                                                                       DM30 222
#   ACCOUNT FOR REPETITIVE DATA                                         DM30 223
#   ---------------------------                                         DM30 224
#                                                                       DM30 225
IF(B11>0.)#                            Test if betaij calculated        DM30 226
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DM30 227
I=0#                                   Set identical betaij frag        DM30 228
FOR(L=1;L<7;L=L+1)#                    Loop over betaij elements        DM30 229
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DM30 230
IF(L>3) bij:(K,L)=2.*bij:(K,L)#        Apply 2*beta(i!=j) now           DM30 231
ifne:(bij:(K,L),bij:(M,L)) I=1#        Flag if betaij different         DM30 232
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DM30 233
IF(I==1) M=K#                          Diff so reset betaij test poin   DM30 234
ELSE     bij:(K,2)=0.#                 Use u22 as flag for identical    DM30 235
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DM30 236
pmul:(K)=pmul:(K)*FMUL#                Apply sym multipicity now        DM30 237
K=K+IATM#                              Incr atom list pointer           DM30 238
ATP(NAT)=ATP(NAT)+FMUL*SMUL#           Atom number of partial structu   DM30 239
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DM30 240
#                                                                       DM30 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM30 242
#                                                                       DM30 243
RETURN#                                                                 DM30 244
END#                                                                    DM30 245
systemheader:(DM40)#                   Prepare lr lrrefl: & copy fi     DM40   1
# ####################################################################  DM40   2
#                                                                       DM40   3
#                                DM40                                   DM40   4
#                                                                       DM40   5
# ####################################################################  DM40   6
SUBROUTINE DM40#                                                        DM40   7
include:(AACOMN)#                                                       DM40   8
include:(DMCOMN)#                                                       DM40   9
#                                                                       DM40  10
INTEGER I,J#                           Working indices                  DM40  11
REAL H(3)#                                                              DM40  12
REAL HNEG(3)#                                                           DM40  13
REAL HPOS(3)#                                                           DM40  14
#                                                                       DM40  15
chardata:(DM41,-NO YESXRAYNEUTSCATREFLOVERALL  $#                       DM40  16
ISOTROPICMIXED    ALL)#                                                 DM40  17
chardata:(DM42, DYNAMO CALCULATION PARAMETERS)#                         DM40  18
chardata:(DM43, DATA SET NUMBER USED     )#                             DM40  19
chardata:(DM4A, STRUCTURE FACTOR UNITS            )#                    DM40  20
chardata:(DM44, DISPL. PARAM. U X100                      )#            DM40  21
chardata:(DM45, EXTINCTION CORRECTION                )#                 DM40  22
chardata:(DM46, ANOMALOUS DISPERSION       )#                           DM40  23
chardata:(DM47, SIN/COS LOOKUP TABLE       )#                           DM40  24
chardata:(DM48, REFLN CODES REJECTED          )#                        DM40  25
chardata:(DM49, LIST REFLNS ABOVE DF              )#                    DM40  26
chardata:(DM410, RADIATION TYPE USED              )#                    DM40  27
chardata:(DM411, SOURCE OF SCAT.FACTOR LR           )#                  DM40  28
chardata:(DM412, MAXIMUM H K L USED              )#                     DM40  29
chardata:(DM413, MIN/MAX ST/L USED               )#                     DM40  30
chardata:(DM414, NUMBER OF ATOM SITES          )#                       DM40  31
chardata:(DM415, FREL SCALE FOR GROUP   1         )#                    DM40  32
chardata:(DM416,[ EXTINCTION NOT APPLIED (FACTOR NOT ON BDF)])#         DM40  33
chardata:(DM417, SIM WEIGHT IS ADDED TO BDF)#                           DM40  34
chardata:(DM418,NEUTRON ELECTRONXRAYS   )#                              DM40  35
chardata:(DM419,PICO-CMS VOLTS    ELECTRONS)#                           DM40  36
chardata:(DM420, SOURCE OF M.D. DATA       )#                           DM40  37
chardata:(DM421,FRELFCAL)#                                              DM40  38
chardata:(DM422, STORING M.D.S.F. AS        )#                          DM40  39
chardata:(DM423, CALCULATING STANDARD   FCAL)#                          DM40  40
chardata:(AR03F,"[ Reflection data to be generated  -&+h -&+k -&+l]")#  DM40  41
chardata:(NC102," ARCHIVE TO MOL. DYNAM. TRANSFORMATION matrix: ")#     DM40  42
chardata:(NC103,"[ M.D. a = (        ,         ,         ) a ]")#       DM40  43
chardata:(NC104,"abc")#                                                 DM40  44
chardata:(NC105,"[ DETERMINANT =           ]")#                         DM40  45
realdata:(FMT,[190842.,290842.,390842.])#                               DM40  46
datastuff:#                                                             DM40  47
#                                                                       DM40  48
#    LIST CALCULATION PARAMETERS                                        DM40  49
#    ---------------------------                                        DM40  50
#                                                                       DM40  51
LINRM=10#                              Force parameter header           DM40  52
movechar:(DM41,1,CHROT,2,NDM42-1,2)#   Underline header                 DM40  53
writeline:(1,DM42,NDM42,1,3)#          Print calculation header         DM40  54
#                                                                       DM40  55
CHROT=DM420; CHROT(25^)=MDFILE#        Print filename                   DM40  56
writeline:(0,0,0,1,3)#                 Print scales only                DM40  57
#                                                                       DM40  58
I=MIN(IRAD,3)#                         Modification for mo,cu,ag,sync   DM40  59
movechar:(DM419,I*9-8,DM4A,25,9,0)#    Insert sf units                  DM40  60
writeline:(0,DM4A,NDM4A,3,3)#          Print sf units                   DM40  61
#                                                                       DM40  62
movechar:(DM418,I*8-7,DM410,25,8,0)#   Insert radiation type            DM40  63
writeline:(0,DM410,NDM410,3,3)#        Print radiation type             DM40  64
#                                                                       DM40  65
ncodefld:(DSNM,1,DM43,250513.,1)#      Format dataset number            DM40  66
writeline:(0,DM43,NDM43,3,3)#          Print dataset number             DM40  67
#                                                                       DM40  68
IF(MARK7>MARK6)#                                                        DM40  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM40  70
movechar:(DM41,(TYPE-2)*9+24,DM44,25,9,0)# Insert dp type               DM40  71
IF(TYPE==2)#                                                            DM40  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM40  73
BUFOT(1)=100.*BOVL/UTOB#               Output 100* uoverall             DM40  74
ncodefld:(BUFOT(1),1,DM44,420532.,1)#  Insert value in buffer           DM40  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM40  76
writeline:(0,DM44,NDM44,3,3)#          Print tf type                    DM40  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM40  78
#                                                                       DM40  79
movechar:(DM41,DISP*3+2,DM46,25,3,0)#  Insert no/yes for a.d.           DM40  80
writeline:(0,DM46,NDM46,3,3)#          Print dispersion                 DM40  81
#                                                                       DM40  82
movechar:(DM41,ISIN*3+2,DM47,25,3,0)#  Insert no/yes s/c table          DM40  83
writeline:(0,DM47,NDM47,3,3)#          Print s/c table status           DM40  84
#                                                                       DM40  85
ifeq:(REJF,6.)I=no:; ELSE I=yes:#      Test for rejections              DM40  86
movechar:(DM41,I*3+2,DM48,25,3,0)#     Insert no/yes rejects            DM40  87
IF(I==yes:)#                           Test if reject active            DM40  88
ncodefld:(REJF+.5,1,DM48,300113.,1)#   Format reject flag               DM40  89
writeline:(0,DM48,NDM48,3,3)#          Print reject conditions          DM40  90
#                                                                       DM40  91
IF(DLIS<9998.)I=yes:; ELSE I=no:#      Test if list expected            DM40  92
movechar:(DM41,I*3+2,DM49,25,3,0)#     Insert no/yes list               DM40  93
IF(DLIS<0.)movechar:(DM41,NDM41-2,DM49,30,3,0)# Insert 'all'            DM40  94
ELSE IF(I==yes:)#                      Test if partial list             DM40  95
ncodefld:(DLIS,1,DM49,350822.,1)#      Format list limit                DM40  96
writeline:(0,DM49,NDM49,3,3)#          Print list parameters            DM40  97
#                                                                       DM40  98
DSTL=.02#                              Set default ff incr              DM40  99
IF(IFFF==0)#                           Test if ff in lrrefl             DM40 100
ncodefld:(DSTL,1,DM411,350522.,1)#     Add stol interval to o/p         DM40 101
movechar:(DM41,IFFF*4+16,DM411,26,4,0)# Insert lr number                DM40 102
writeline:(0,DM411,NDM411,3,3)#        Print scat.fac. source           DM40 103
#                                                                       DM40 104
ncodefld:(MAXH,1,DM412,250413.,1)#     Format max/h/                    DM40 105
ncodefld:(MAXK,1,DM412,290413.,1)#     Format max/k/                    DM40 106
ncodefld:(MAXL,1,DM412,330413.,1)#     Format max/l/                    DM40 107
writeline:(0,DM412,NDM412,3,3)#        Print max hkl                    DM40 108
#                                                                       DM40 109
ncodefld:(SMIN,1,DM413,270532.,1)#     Format min st/l                  DM40 110
ncodefld:(SMAX,1,DM413,330532.,1)#     Format max st/l                  DM40 111
writeline:(0,DM413,NDM413,3,3)#        Print st/l min/max               DM40 112
#                                                                       DM40 113
ncodefld:(FLOAT(NATM),1,DM414,260413.,1)# Format atom count             DM40 114
writeline:(0,DM414,NDM414,3,3)#        Print atom count                 DM40 115
#                                                                       DM40 116
ncodefld:(QX,MARK4+1,DM415,340732.,1)# Format scale 1                   DM40 117
writeline:(0,DM415,NDM415,3,3)#        Print scale 1                    DM40 118
FOR(I=2;I<=NSCL;I=I+1)#                Loop over scale groups           DM40 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DM40 120
ncodefld:(FLOAT(I),1,CHROT,250213.,1)## Format scale group              DM40 121
ncodefld:(QX,MARK4+I,CHROT,340732.,1)## Format scale value              DM40 122
writeline:(0,0,0,1,3)#                 Print scales only                DM40 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DM40 124
#                                                                       DM40 125
#   SETUP SIN/COS TABLE IF NEEDED                                       DM40 126
#   -----------------------------                                       DM40 127
#                                                                       DM40 128
MARK8=MARK7#                                                            DM40 129
IF(ISIN==yes:)#                        Test if table requested          DM40 130
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DM40 131
IF(MARK7+452<=QXMAX)#                  Check if enough memory           DM40 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DM40 133
incrqx:(MARK8,MARK7+452,-DM4002)#      Expand qx......fc402             DM40 134
FOR(I=MARK7;I<MARK8;I=I+1)#            Loop over degree intervals       DM40 135
QX(I+1)=SIN(FLOAT(I-MARK7)*.0174532925)# Sine 0/s/449                   DM40 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DM40 137
ELSE ISIN=no:#                         Shutoff table lookup             DM40 138
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DM40 139
#                                                                       DM40 140
#                                                                       DM40 141
#                                                                       DM40 142
DO I=1,NTYP; ATP(I)=MAX(0.0,ATA(I)-ATP(I))# Get unknown atom number     DM40 143
#                                                                       DM40 144
#   SEARCH LR LRREFL: GET POINTERS FOR INPUT                            DM40 145
#   ----------------------------------------                            DM40 146
#                                                                       DM40 147
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))# Copy to refl rec.         DM40 148
IWNT(1)=1#                                                              DM40 149
DO I=1,NTYP; IWNT(I+1)=500+I#          Set scat.fac. idnums             DM40 150
IWNT(NTYP+2)=2#                        Set stol idnums                  DM40 151
IWNT(NTYP+3)=NMDS+304#                 Set frel idnum                   DM40 152
IWNT(NTYP+4)=NMDS+308#                 Set jcode idnum                  DM40 153
IWNT(NTYP+5)=NMDS+309#                 Set nscl idnum                   DM40 154
IWNT(NTYP+6)=NMDS+202#                 Set extf idnum                   DM40 155
IWNT(NTYP+7)=NMDS+701#                 Set fcal idnum                   DM40 156
#                                                                       DM40 157
KEY(1)=1;     KEY(2)=NTYP+6#           Set search delimiters            DM40 158
KEY(4)=0;     KEY(3)=KEY(2)#           Set search delimiters            DM40 159
indexpkt:(1,lrrefl:,LPAK,IP,0,KEY,IWNT,IREL)# Search rel pointers       DM40 160
#                                                                       DM40 161
# SECOND PARSE ARCHIVE LOGIC                                            DM40 162
# --------------------------                                            DM40 163
#                                                                       DM40 164
IF(MOLDFR==no: &MOLDFC==no:)#          No user specifications           DM40 165
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DM40 166
IF(IREL(NTYP+3)>0)MOLDFC=yes:#         Dont overwrite measurements      DM40 167
ELSE              MOLDFR=yes:#         Create measurement from md dat   DM40 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DM40 169
IF(MOLDFR==yes:&MARK7>MARK6) NORMFC=yes:# Do normal fcal and diffs a    DM40 170
#                                                                       DM40 171
movechar:(DM421,1+MOLDFC*4,DM422,25,4,0)# Insert sf units               DM40 172
writeline:(0,DM422,NDM422,3,3)#        Print storage type               DM40 173
IF(NORMFC==yes:)writeline:(0,DM423,NDM423,3,3)#                         DM40 174
#                                                                       DM40 175
movechar:(DM41,IEXT*3+2,DM45,25,3,0)#  Insert no/yes for ext.           DM40 176
writeline:(0,DM45,NDM45,3,3)#          Print ext. parameters            DM40 177
IF(IREL(NTYP+6)<=0&IEXT==yes:)#        Ext. consts not on bdf           DM40 178
$(IEXT=no:;writeline:(1,DM416,NDM416,3,3)$)# Tell user ext. turned of   DM40 179
#                                                                       DM40 180
#  DEAL WITH THE TRANSFORMATION MATRIX                                  DM40 181
#  ===================================                                  DM40 182
#                                                                       DM40 183
writeline:(1,NC102,NNC102,3,3)#                                         DM40 184
DO I=1,3#                                                               DM40 185
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DM40 186
movechar:(NC104,I,NC103,7,1,0)#        Insert abc                       DM40 187
movechar:(NC104,I,NC103,42,1,0)#       Insert abc                       DM40 188
ncodefld:(TM(3*I-2),1,NC103,FMT,3)#    Transformation terms             DM40 189
writeline:(0,NC103,NNC103,3,3)#                                         DM40 190
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DM40 191
TMI(1) = +TM(5)*TM(9) - TM(8)*TM(6)#   Get tm**-1                       DM40 192
TMI(4) = -TM(4)*TM(9) + TM(7)*TM(6)#                                    DM40 193
TMI(7) = +TM(4)*TM(8) - TM(7)*TM(5)#                                    DM40 194
DET=TM(1)*TMI(1)+TM(2)*TMI(4)+TM(3)*TMI(7)#                             DM40 195
ncodefld:(DET,1,NC105,250742.,1)#      Format the determinant           DM40 196
writeline:(0,NC105,NNC105,3,3)#                                         DM40 197
ifeq:(DET,0.0) iquit:(DM4003)#         Die if singular                  DM40 198
IF(DET<0.0)#                           Make determinant positive        DM40 199
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DM40 200
DET=ABS(DET)#                                                           DM40 201
DO I=1,9; TM(I)=-TM(I)#                                                 DM40 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DM40 203
TMI(1) = TMI(1)/DET#                                                    DM40 204
TMI(4) = TMI(4)/DET#                                                    DM40 205
TMI(7) = TMI(7)/DET#                                                    DM40 206
TMI(2) = (-TM(2)*TM(9) + TM(8)*TM(3))/DET#                              DM40 207
TMI(5) = (+TM(1)*TM(9) - TM(7)*TM(3))/DET#                              DM40 208
TMI(8) = (-TM(1)*TM(8) + TM(7)*TM(2))/DET#                              DM40 209
TMI(3) = (+TM(2)*TM(6) - TM(5)*TM(3))/DET#                              DM40 210
TMI(6) = (-TM(1)*TM(6) + TM(4)*TM(3))/DET#                              DM40 211
TMI(9) = (+TM(1)*TM(5) - TM(4)*TM(2))/DET#                              DM40 212
VOLFAC=DET#                                                             DM40 213
#                                                                       DM40 214
#                                                                       DM40 215
# IF LRREFL: EXISTS THEN READ AND STORE                                 DM40 216
# -------------------------------------                                 DM40 217
#                                                                       DM40 218
MARK9=MARK8#                                                            DM40 219
HKL=MARK8#                             Start of refln record            DM40 220
IF(KEY(4)>0)#                                                           DM40 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DM40 222
STEP8=step8:#                          Base record size:                DM40 223
DO I=2,NTYP+1;IF(IREL(I)>0)STEP8=STEP8+1# Loop over atom types          DM40 224
IF(NSCF==0)#                           Test if scatfac table exist      DM40 225
DO I=1,NTYP#                           Loop over atom types             DM40 226
IF(IREL(1+I)==0) iquit:(DM4004)#       No ff......fc401                 DM40 227
#                                                                       DM40 228
#  LOOP OVER REFLECTION PACKETS (LRREFL:)                               DM40 229
#  ===================================                                  DM40 230
#                                                                       DM40 231
REPEAT#                                Loop over refln packets          DM40 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DM40 233
readwpkt:(1,lrrefl:,LPAK,IP,0)#        Point to input packet            DM40 234
IF(IP<=0) BREAK#                       Ifexit after last packet         DM40 235
#                                                                       DM40 236
#    EXTRACT REQUIRED REFLN DATA                                        DM40 237
#    ---------------------------                                        DM40 238
#                                                                       DM40 239
I=IP+IREL(NTYP+4); IF(I>IP) CODE=QX(I)# Extract st/l                    DM40 240
ELSE CODE=1.#                          Assume ok                        DM40 241
IF(CODE>REJF) NEXT#                    Skip rejected reflections        DM40 242
ifvo:(CODE) NEXT#                      Skip if rcode is void            DM40 243
#                                                                       DM40 244
gethkl:(IP+IREL(1),H)#                 Extract signed h,k,l             DM40 245
X=H(1); Y=H(2); Z=H(3)#                Make hkl local variables         DM40 246
IF(X>MAXH) NEXT#                       Skip if /h/ too big              DM40 247
IF(Y>MAXK) NEXT#                       Skip if /k/ too big              DM40 248
IF(Z>MAXL) NEXT#                       Skip if /l/ too big              DM40 249
#                                                                       DM40 250
I=IP+IREL(NTYP+2); IF(I>IP) STOL=QX(I)# Extract st/l                    DM40 251
ELSE STOL=.5*SQRT($#                                                    DM40 252
 X*(X*RM(1)+Y*RM(2)+Z*RM(3))$#         Apply metric tensor              DM40 253
+Y*(X*RM(4)+Y*RM(5)+Z*RM(6))$#         Apply metric tensor              DM40 254
+Z*(X*RM(7)+Y*RM(8)+Z*RM(9)))#         Apply metric tensor              DM40 255
IF((STOL<SMIN)\(STOL>SMAX)) NEXT#      Skip if outside s limits         DM40 256
#                                                                       DM40 257
incrqx:(MARK9,HKL+STEP8,DM4010)#       Get space for record             DM40 258
#                                      Transform hkl to moldynam cell   DM40 259
refh:=X*TM(1)+Y*TM(2)+Z*TM(3)#         Transformed h'                   DM40 260
refk:=X*TM(4)+Y*TM(5)+Z*TM(6)#         Transformed k'                   DM40 261
refl:=X*TM(7)+Y*TM(8)+Z*TM(9)#         Transformed l'                   DM40 262
stol:=STOL#                            Save sin theta                   DM40 263
anodl:=0.0#                                                             DM40 264
bnodl:=0.0#                                                             DM40 265
adisl:=0.0#                                                             DM40 266
bdisl:=0.0#                                                             DM40 267
anod:=0.0#                                                              DM40 268
bnod:=0.0#                                                              DM40 269
adis:=0.0#                                                              DM40 270
bdis:=0.0#                                                              DM40 271
#                                                                       DM40 272
DO I=1,NTYP#                           Loop for interp form factors     DM40 273
IF(IREL(1+I)>0) QX(HKL+step8:+I)=QX(IP+IREL(1+I))# Save factor          DM40 274
#                                                                       DM40 275
HKL=MARK9#                                                              DM40 276
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DM40 277
#                                                                       DM40 278
rewindbdf:(1)#                                                          DM40 279
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DM40 280
#                                                                       DM40 281
#  AUTOMATICALLY GENERATE REFLECTIONS                                   DM40 282
#  ----------------------------------                                   DM40 283
#                                                                       DM40 284
ELSE#                                  Create fresh reflections         DM40 285
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DM40 286
STEP8=step8:#                          Bare bones                       DM40 287
#                                                                       DM40 288
DO I=1,3; HNEG(I)=1.#                  Allow all negatives              DM40 289
FOR(II=MARK1+12;II<MARK2;II=II+12)#    Loop over unique matrices        DM40 290
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DM40 291
J=-3#                                  Start diag element pointer       DM40 292
DO I=1,3#                              Loop over hkl signs              DM40 293
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DM40 294
J=J+4#                                 Incr diag element pointer        DM40 295
ifeq:(QX(II+J),1.) NEXT#               Skip positive elements           DM40 296
ifeq:(HNEG(I),0.) NEXT#                Skip if already shut off         DM40 297
HNEG(I)=0.;    BREAK#                  Shut off negative and exit       DM40 298
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DM40 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DM40 300
IF(ICNT==1\IFRIED==1)#                 If friedel not required          DM40 301
DO I=1,3#                              Loop over hkl signs              DM40 302
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DM40 303
ifeq:(HNEG(I),0.) NEXT#                Skip if already shut off         DM40 304
HNEG(I)=0.;    BREAK#                  Shut off negative and exit       DM40 305
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DM40 306
#                                                                       DM40 307
DO I=1,3#                              Loop over hkl signs              DM40 308
ifeq:(HNEG(I),0.)movechar:(BLANK,1,AR03F,30+I*5,2,0)# Blank out '-&'    DM40 309
writeline:(0,AR03F,NAR03F,3,3)#        Print generator message          DM40 310
#                                                                       DM40 311
#   SET UP LIMITS FOR GENERATED HKL                                     DM40 312
#   -------------------------------                                     DM40 313
#                                                                       DM40 314
DO I=7,9; RC(I)=ABS(SIN(RC(I)*6.2831853))# Get sine of angles           DM40 315
ifne:(HX,999.) HPOS(1)=HX#             Set max h                        DM40 316
ELSE           HPOS(1)=2.*SMAX/(RC(1)*RC(8)*RC(9))# Calc h max          DM40 317
ifne:(KX,999.) HPOS(2)=KX#             Set max k                        DM40 318
ELSE           HPOS(2)=2.*SMAX/(RC(2)*RC(7)*RC(9))# Calc k max          DM40 319
ifne:(LX,999.) HPOS(3)=LX#             Set max l                        DM40 320
ELSE           HPOS(3)=2.*SMAX/(RC(3)*RC(8)*RC(7))# Calc l max          DM40 321
DO I=1,3; HPOS(I)=FLOAT(NINT(HPOS(I)))# Intergerize maxima              DM40 322
DO I=1,3; ifne:(HNEG(I),0.) HNEG(I)=-HPOS(I)# Set hkl minimum           DM40 323
#                                                                       DM40 324
FOR(X=HNEG(1);X<HPOS(1);X=X+1.)#       Loop for possible h values       DM40 325
FOR(Y=HNEG(2);Y<HPOS(2);Y=Y+1.)#       Loop for possible k values       DM40 326
FOR(Z=HNEG(3);Z<HPOS(3);Z=Z+1.)#       Loop for possible l values       DM40 327
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DM40 328
#                                                                       DM40 329
IF(X>MAXH) NEXT#                       Skip if /h/ too big              DM40 330
IF(Y>MAXK) NEXT#                       Skip if /k/ too big              DM40 331
IF(Z>MAXL) NEXT#                       Skip if /l/ too big              DM40 332
#                                                                       DM40 333
STOL=.5*SQRT($#                                                         DM40 334
 X*(X*RM(1)+Y*RM(2)+Z*RM(3))$#         Apply metric tensor              DM40 335
+Y*(X*RM(4)+Y*RM(5)+Z*RM(6))$#         Apply metric tensor              DM40 336
+Z*(X*RM(7)+Y*RM(8)+Z*RM(9)))#         Apply metric tensor              DM40 337
IF((STOL<SMIN)\(STOL>SMAX)) NEXT#      Skip if outside s limits         DM40 338
#                                                                       DM40 339
incrqx:(MARK9,HKL+STEP8,DM4010)#       Get space for record             DM40 340
#                                      Transform hkl to moldynam cell   DM40 341
refh:=X*TM(1)+Y*TM(2)+Z*TM(3)#         Transformed h'                   DM40 342
refk:=X*TM(4)+Y*TM(5)+Z*TM(6)#         Transformed k'                   DM40 343
refl:=X*TM(7)+Y*TM(8)+Z*TM(9)#         Transformed l'                   DM40 344
stol:=STOL#                            Save sin theta                   DM40 345
#ANODL:=0.0; BNODL:=0.0; ADISL:=0.0; BDISL:=0.0                         DM40 346
#ANOD:=0.0; BNOD:=0.0 ADIS:=0.0; BDIS:=0.0                              DM40 347
#                                                                       DM40 348
#                                                                       DM40 349
HKL=MARK9#                                                              DM40 350
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DM40 351
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DM40 352
#                                                                       DM40 353
#  SETUP SCAT FACTOR OFFSETS                                            DM40 354
#  -------------------------                                            DM40 355
#                                                                       DM40 356
DO I=1,NTYP;OFF(I)=MARK3+(I-1)*NSCF+1# Setup ff table offsets           DM40 357
#                                                                       DM40 358
RETURN#                                                                 DM40 359
END#                                                                    DM40 360
systemheader:(DM45)#                   Calc  mol dyn structure factor   DM45   1
# ####################################################################  DM45   2
#                                                                       DM45   3
#                                DM45                                   DM45   4
#                                                                       DM45   5
# ####################################################################  DM45   6
SUBROUTINE DM45#                                                        DM45   7
include:(AACOMN)#                                                       DM45   8
include:(DMCOMN)#                                                       DM45   9
INTEGER MDSTEP#                                                         DM45  10
INTEGER HKL#                                                            DM45  11
INTEGER IAT#                                                            DM45  12
INTEGER NTHTYP# ## Nth Species type                                     DM45  13
#                                                                       DM45  14
chardata:(DM451, FIRST FRAME USED             )#                        DM45  15
chardata:(DM452, LAST  FRAME USED             )#                        DM45  16
chardata:(DM453, EXPECTED MD ATOMS            )#                        DM45  17
chardata:(DM454, ACTUAL   MD ATOMS            )#                        DM45  18
realdata:(PI2,6.2831853)#                                               DM45  19
datastuff:#                                                             DM45  20
#                                                                       DM45  21
#                                                                       DM45  22
RUNAVE=yes:#                                                            DM45  23
openfmt:(iofm1:,MDFILE)#                                                DM45  24
#                                                                       DM45  25
FOR(MDSTEP=1;;MDSTEP=MDSTEP+1)#        Loop for each molecular dynam    DM45  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM45  27
NTHTYP=1#                                                               DM45  28
FOR(IAT=1;IAT<=NASP(NSPEC);IAT=IAT+1)# Loop for each atom               DM45  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM45  30
readfmt:(iofm1:,MDFMT,99,[X1,Y1,Z1,NA])#                                DM45  31
IF(NA>NASP(NTHTYP)) NTHTYP=NTHTYP+1#                                    DM45  32
IF(NTHTYP>NSPEC) iquit:(DM4501)#       Too many atoms                   DM45  33
L=ASP(NTHTYP)#                                                          DM45  34
#                                                                       DM45  35
IF(MDSTEP>=FRAME1)#                    In requested range               DM45  36
FOR(HKL=MARK8;HKL<MARK9;HKL=HKL+STEP8)# Loop for each reflection        DM45  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DM45  38
#                                                                       DM45  39
#   ACCUMULATE A & B FOR EACH REFLECTION                                DM45  40
#   ------------------------------------                                DM45  41
#                                                                       DM45  42
ANG=refh:*X1+refk:*Y1+refl:*Z1#        Calc phase component             DM45  43
STOL=stol:#                                                             DM45  44
IF(ISIN==yes:)#                        Test for sin/cos table           DM45  45
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  DM45  46
IF(ANG<0.)#                            Test if angle negative           DM45  47
I=INT((1.+AMOD(ANG,1.))*360.+.5)+MARK7## Point to sin/cos table         DM45  48
ELSE#                                  If angle is positive             DM45  49
I=INT(AMOD(ANG,1.)*360.+.5)+MARK7#     Point to sin/cos table           DM45  50
ACAL=QX(I+91)#                         Calc real s.f. component         DM45  51
IF(CENT==1)#                           Test if centrosymmetric          DM45  52
BCAL=QX(I+1)#                          Calc imag s.f. component         DM45  53
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  DM45  54
ELSE#                                  Else use fortran lib sin/cos     DM45  55
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DM45  56
ACAL=COS(ANG*PI2)#                     Calc real s.f. component         DM45  57
IF(CENT==1)#                           Test if centrosymmetric          DM45  58
BCAL=SIN(ANG*PI2)#                     Calc imag s.f. component         DM45  59
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DM45  60
IF(IRAD==1) J=OFF(L)#                  Point to neutron ff              DM45  61
ELSE IF(IREL(1+L)>0) J=HKL+step8:+L#   Get ff pointers to buffer        DM45  62
ELSE          J=NINT(STOL/DSTL)+OFF(L)# Point to ff curves              DM45  63
ANOD=ACAL*QX(J)#                                                        DM45  64
IF(CENT==1)#                           Test if centrosymmetric          DM45  65
BNOD=BCAL*QX(J)#                       Total imag s.f.              d   DM45  66
IF(DISP==yes:)#                        Is dispersion applied            DM45  67
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DM45  68
ADIS=ACAL*ADR(L)-BCAL*ADI(L)#          Apply anom.disp. factors         DM45  69
BDIS=BCAL*ADR(L)+ACAL*ADI(L)#          Apply anom.disp. factors         DM45  70
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DM45  71
#                                                                       DM45  72
#                                                                       DM45  73
IF(RUNAVE==yes:)#                      Numerical precision issues       DM45  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DM45  75
anodl:=anodl:+ANOD#                                                     DM45  76
bnodl:=bnodl:+BNOD#                                                     DM45  77
adisl:=adisl:+ADIS#                                                     DM45  78
bdisl:=bdisl:+BDIS#                                                     DM45  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DM45  80
ELSE#                                                                   DM45  81
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DM45  82
anod:=anod:+ANOD#                                                       DM45  83
bnod:=bnod:+BNOD#                                                       DM45  84
adis:=adis:+ADIS#                                                       DM45  85
bdis:=bdis:+BDIS#                                                       DM45  86
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DM45  87
#                                                                       DM45  88
# END OF HKL AND READING ITERATIONS                                     DM45  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DM45  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM45  91
IF(MDSTEP<FRAME1) NEXT#                Not in requested range           DM45  92
FN=1.0/FLOAT(MDSTEP-FRAME1+1)#                                          DM45  93
FM=1.0-FN#                                                              DM45  94
IF(RUNAVE==yes:)#                      Numerical precision issues       DM45  95
FOR(HKL=MARK8;HKL<MARK9;HKL=HKL+STEP8)# Loop for each reflection        DM45  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DM45  97
anod:=anod:*FM+anodl:*FN#                                               DM45  98
bnod:=bnod:*FM+bnodl:*FN#                                               DM45  99
adis:=adis:*FM+adisl:*FN#                                               DM45 100
bdis:=bdis:*FM+bdisl:*FN#                                               DM45 101
anodl:=0.0#                                                             DM45 102
bnodl:=0.0#                                                             DM45 103
adisl:=0.0#                                                             DM45 104
bdisl:=0.0#                                                             DM45 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DM45 106
IF(MDSTEP==FRAME2)BREAK#               Beyond requested range           DM45 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM45 108
#                                                                       DM45 109
99CONTINUE#                                                             DM45 110
closefmt:(iofm1:)#                                                      DM45 111
#                                                                       DM45 112
# DO AVERAGES FOR EACH REFLECTION IF REQUIRED                           DM45 113
# -------------------------------------------                           DM45 114
#                                                                       DM45 115
N=MDSTEP-FRAME1+1#                     How many frames                  DM45 116
ncodefld:(FLOAT(FRAME1),1,DM451,300913.,1)#                             DM45 117
writeline:(0,DM451,NDM451,3,3)#        Print starting point             DM45 118
ncodefld:(FLOAT(MDSTEP),1,DM452,300913.,1)#                             DM45 119
writeline:(0,DM452,NDM452,3,3)#        Print final point                DM45 120
ncodefld:(FLOAT(NASP(NSPEC)),1,DM453,300913.,1)#                        DM45 121
writeline:(0,DM453,NDM453,3,3)#        Print expected atoms             DM45 122
ncodefld:(FLOAT(NA),1,DM454,300913.,1)#                                 DM45 123
writeline:(0,DM454,NDM454,3,3)#        Print encountered atoms          DM45 124
#                                                                       DM45 125
IF(RUNAVE==no:)#                                                        DM45 126
FOR(HKL=MARK8;HKL<MARK9;HKL=HKL+STEP8)# Loop for each reflection        DM45 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DM45 128
anod:=anod:/FLOAT(N)#                                                   DM45 129
bnod:=bnod:/FLOAT(N)#                                                   DM45 130
adis:=adis:/FLOAT(N)#                                                   DM45 131
bdis:=bdis:/FLOAT(N)#                                                   DM45 132
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DM45 133
#                                                                       DM45 134
# REVERT HKL TO ORIGINAL CELL                                           DM45 135
# ---------------------------                                           DM45 136
#                                                                       DM45 137
FOR(HKL=MARK8;HKL<MARK9;HKL=HKL+STEP8)# Loop for each reflection        DM45 138
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DM45 139
X=refh:; Y=refk:; Z=refl:#                                              DM45 140
refh:=X*TMI(1)+Y*TMI(2)+Z*TMI(3)#      Transformed h'                   DM45 141
refk:=X*TMI(4)+Y*TMI(5)+Z*TMI(6)#      Transformed k'                   DM45 142
refl:=X*TMI(7)+Y*TMI(8)+Z*TMI(9)#      Transformed l'                   DM45 143
anod:=anod:/VOLFAC#                    Scale electron number back       DM45 144
bnod:=bnod:/VOLFAC#                    Scale electron number back       DM45 145
adis:=adis:/VOLFAC#                    Scale electron number back       DM45 146
bdis:=bdis:/VOLFAC#                    Scale electron number back       DM45 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DM45 148
#                                                                       DM45 149
RETURN#                                                                 DM45 150
END#                                                                    DM45 151
#                                                                       DM45 152
systemheader:(DM50)#                   Build lrrefl:                    DM50   1
# ####################################################################  DM50   2
#                                                                       DM50   3
#                                DM50                                   DM50   4
#                                                                       DM50   5
# ####################################################################  DM50   6
SUBROUTINE DM50#                                                        DM50   7
include:(AACOMN)#                                                       DM50   8
include:(DMCOMN)#                                                       DM50   9
INTEGER I,N#                                                            DM50  10
#                                                                       DM50  11
# BUILD SEARCH/UPDATE KEYS FOR SECOND LRREFL: PASS                      DM50  12
# ------------------------------------------------                      DM50  13
#                                                                       DM50  14
DO I=1,32;ARCH(I)=I#                   Initialize archiving             DM50  15
# USEFUL IF THERE BUT NOT ADDED                                         DM50  16
DO I=1,NTYP; IWNT(I)=500+I#            Set scat.fac. idnums             DM50  17
IWNT(irj:)  =NMDS+308#                 Set jcode idnum                  DM50  18
IWNT(irs:)  =NMDS+309#                 Set nscl idnum                   DM50  19
IWNT(irx:)  =NMDS+202#                 Set extf idnum                   DM50  20
# USEFULLY ADDED. NOT REQUIRED                                          DM50  21
IWNT(ifcnd:)=NMDS+800#                 Archive fcal no disp             DM50  22
IWNT(ifa:)  =NMDS+801#                 Archive real fc (no disp)        DM50  23
IWNT(ifb:)  =NMDS+802#                 Archive imag fc (no disp)        DM50  24
IWNT(ifad:) =NMDS+803#                 Archive real disp only           DM50  25
IWNT(ifbd:) =NMDS+804#                 Archive imag disp only           DM50  26
IWNT(ifanx:)=NMDS+805#                 Archive real fc (no ext.)        DM50  27
IWNT(ifbnx:)=NMDS+806#                 Archive imag fc (no ext.)        DM50  28
# REQUIRED                                                              DM50  29
IWNT(irh:)=1#                          Hkl                              DM50  30
IWNT(irl:)=2#                          Stol                             DM50  31
IWNT(iph:)=NMDS+700#                   Archive phase in cycles          DM50  32
IWNT(iph2:)=NMDS+631#                  Archive phase in cycles          DM50  32
N=NTYP+14#                                                              DM50  33
KEY(1)=0;KEY(2)=4;KEY(3)=13;KEY(4)=0#  Deleting nothing                 DM50  34
#                                                                       DM50  35
IFR=0;IFRC=0;IFR=0#                    Initialize                       DM50  36
IF(MOLDFR==yes:)#                      Save md as frel instead          DM50  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM50  38
IFR =N+1;IWNT(IFR) =NMDS+304#          Set frel idnum                   DM50  39
IFRC=N+2;IWNT(IFRC)=NMDS+701#          Scaled corrected frel            DM50  40
N=N+2#                                                                  DM50  41
KEY(2)=NTYP+13;KEY(3)=N#                                                DM50  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM50  43
#                                                                       DM50  44
IF(NORMFC==yes:\MOLDFC==yes:)#         Iether either                    DM50  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM50  46
IFC=N+1;IWNT(IFC)=NMDS+820#            Scaled corrected fcal            DM50  47
N=N+1#                                                                  DM50  48
KEY(2)=NTYP+3;KEY(3)=N#                Add all others                   DM50  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM50  50
#                                                                       DM50  51
indexpkt:(1,lrrefl:,LPAK,IP,2,KEY,IWNT,IREL)# Search rel pointers       DM50  52
NPAK=KEY(4)#                           Set output paksize               DM50  53
DO I=1,KEY(3);ARCH(I)=IREL(I)#         Set archive availability         DM50  54
IF(IFC!=0) IFC=IREL(IFC)#              Fcalculated                      DM50  55
IF(IFR!=0) IFR=IREL(IFR)#              Frelative - raw                  DM50  56
IF(IFRC!=0)IFRC=IREL(IFRC)#            Frelative disp+ext corrected     DM50  57
#                                                                       DM50  58
writeline:(0,0,0,1,3);  LINRM=4#       Prepare for fc listing           DM50  59
#                                                                       DM50  60
RETURN#                                                                 DM50  61
END#                                                                    DM50  62
systemheader:(DM55)#                   Calc normal structure factors    DM55   1
# ####################################################################  DM55   2
#                                                                       DM55   3
#                                DM55                                   DM55   4
#                                                                       DM55   5
# ####################################################################  DM55   6
SUBROUTINE DM55#                                                        DM55   7
include:(AACOMN)#                                                       DM55   8
include:(DMCOMN)#                                                       DM55   9
#                                                                       DM55  10
REAL A,ATOT,ADIS,ANOD,ACAL(mxat:)#     Real s.f. components             DM55  11
REAL B,BTOT,BDIS,BNOD,BCAL(mxat:)#     Imag s.f. components             DM55  12
REAL FCAL,FREL,FDIF,FRND,FCND#         Structure factors                DM55  13
REAL H(3)#                             Miller indices & products        DM55  14
REAL SCPA,WSIM,XAP#                    For calc sim weight              DM55  15
INTEGER I,J,K,L,M#                     Working indices                  DM55  16
INTEGER JCOD#                          Current refln code               DM55  17
REAL PHI,ANG#                          Phase components                 DM55  18
REAL STOL,S2L2#                        St/l & s2t/l2 values             DM55  19
INTEGER MATCH#                                                          DM55  20
INTEGER FIN#                                                            DM55  21
#                                                                       DM55  22
chardata:(DM51,    H   K   L   ST/L RC SG    FREL    FCAL   $#          DM55  23
ADSP   BDSP    EXTF   FRNDNE   FCNDNE   PHI   DELTA  MDPHI)#
realdata:(FMT,[$#                                                       DM55  25
50413.,90413.,130413.,200642.,230203.,260203.,340822.,420822.,#         DM55  26
490612.,560612.,640822.,730922.,820922.,880613.,960822.,1020613.])# 
realdata:(PI2,6.2831853)#                                               DM55  28
realdata:(AH,0.); realdata:(AK,0.); realdata:(AL,0.)#                   DM55  29
realdata:(HH,0.); realdata:(KK,0.); realdata:(LL,0.)#                   DM55  30
realdata:(HK,0.); realdata:(HL,0.); realdata:(KL,0.)#                   DM55  31
realdata:(FACT,0.); realdata:(ANOX,0.); realdata:(BNOX,0.)#             DM55  32
realdata:(TEMP,0.); realdata:(CODE,0.); intdata:(ISCG,1)#               DM55  33
realdata:(EXTFAC,1.)#                  Ext. factor for fcals            DM55  34
datastuff:#                                                             DM55  35
#                                                                       DM55  36
#  LOOP OVER REFLECTION PACKETS (LRREFL:)                               DM55  37
#  ===================================                                  DM55  38
#                                                                       DM55  39
IF(LPAK<=0) FIN=yes:#                                                   DM55  40
ELSE        FIN=no:#                                                    DM55  41
FOR(HKL=MARK8;HKL<MARK9;HKL=HKL+STEP8)# Loop for each reflection        DM55  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM55  43
STOL=stol:#                                                             DM55  44
S2L2=STOL*STOL#                                                         DM55  45
AH=refh:; AK=refk:; AL=refl:#                                           DM55  46
#                                                                       DM55  47
#  MERGE MOLECULAR DYNAMICS CALC BACK WITH LRREFL:                      DM55  48
#  -----------------------------------------------                      DM55  49
#                                                                       DM55  50
MATCH=no:#                             Assume no matching refln found   DM55  51
writepkt:(2,lrrefl:,NPAK,JP)#          Create new output packet         DM55  52
WHILE(FIN==no:)#                                                        DM55  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM55  54
readwpkt:(1,lrrefl:,LPAK,IP,0)#        Point to input packet            DM55  55
IF(IP<=0) $(FIN=yes:;BREAK$)#          If exit after last packet        DM55  56
gethkl:(IP+irh:,H)#                    Extract signed h,k,l             DM55  57
X=H(1); Y=H(2); Z=H(3)#                Make hkl local variables         DM55  58
ifeq:(X,AH)ifeq:(Y,AK)ifeq:(Z,AL)$(MATCH=yes:;BREAK$)#                  DM55  59
#                                                                       DM55  60
movereal:(QX,IP+1,QX,JP+1,LPAK,1)#     Move i/p to o/p                  DM55  61
movereal:(voidflg:,1,QX,JP+LPAK+1,NPAK-LPAK,2)# Void add-on area        DM55  62
writepkt:(2,lrrefl:,NPAK,JP)#          Create new output packet         DM55  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM55  64
#                                                                       DM55  65
#    SETUP OUTPUT PACKET                                                DM55  66
#    -------------------                                                DM55  67
#                                                                       DM55  68
movereal:(voidflg:,1,QX,JP+1,NPAK,2)#  Void fill                        DM55  69
EXTFAC=1.0#                            Store extin. factor              DM55  70
CODE=0.#                               Reflection rcode                 DM55  71
ISCG=MARK4+1#                          Scale group                      DM55  72
FREL=0.0#                              Measured frel                    DM55  73
IF(MATCH==yes:)#                                                        DM55  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  DM55  75
movereal:(QX,IP+1,QX,JP+1,LPAK,1)#     Move i/p to o/p                  DM55  76
IF(irx:>0) EXTFAC=QX(IP+irx:)#         Store extin. factor              DM55  77
IF(irj:>0)   CODE=QX(IP+irj:)#         Store refln code                 DM55  78
IF(irs:>0)ISCG=MARK4+NINT(QX(IP+irs:))# Store refln code                DM55  79
IF(IFR>0)    FREL=QX(IP+IFR)#          Store refln code                 DM55  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  DM55  81
ELSE#                                                                   DM55  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  DM55  83
H(1)=AH; H(2)=AK; H(3)=AL#                                              DM55  84
BADCNT=BADCNT+1#                                                        DM55  85
#THE REFLECTIONS IN MEMORY SHOULD BE A SUBSET OF THE ARCHIVE            DM55  86
IF(BADCNT==10)WRITE(6,*)"Aargle. I think somethings is wrong!"#         DM55  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  DM55  88
#                                                                       DM55  89
#                                                                       DM55  90
#                                                                       DM55  91
#                                                                       DM55  92
IF(NORMFC==yes:)#                                                       DM55  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  DM55  94
IF(TYPE==4)#                           Test if aniso tf possible        DM55  95
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  DM55  96
HH=AH**2;  KK=AK**2;  LL=AL**2#        Calc index products              DM55  97
HK=AH*AK;  HL=AH*AL;  KL=AK*AL#        Calc index products              DM55  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  DM55  99
ELSE IF(TYPE<3) TEMP=EXP(-BOVL*S2L2)#  Calc overall temp factor         DM55 100
DO I=1,NTYP#                           Loop over atom types             DM55 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  DM55 102
ACAL(I)=0.;   BCAL(I)=0.#              Zeroize s.f. components          DM55 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  DM55 104
#                                                                       DM55 105
#    LOOP OVER ATOMS LIST                                               DM55 106
#    --------------------                                               DM55 107
#                                                                       DM55 108
FOR(M=MARK6;M<MARK7;M=M+IATM)#         Loop over atoms list             DM55 109
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 DM55 110
#                                                                       DM55 111
IF(scat:(M)>0.5)#                      Test if equivalent site          DM55 112
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 DM55 113
L=NINT(scat:(M))#                      Extract sf sequence              DM55 114
IF(TYPE<3) FACT=pmul:(M)*TEMP#         Calc factor for overall b        DM55 115
ELSE FACT=pmul:(M)*EXP(-bis:(M)*S2L2)# Get s.f.product                  DM55 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 DM55 117
IF((TYPE==4)&(bij:(M,2)>0.))#          Test for aniso tf                DM55 118
FACT=pmul:(M)*EXP(-HH*bij:(M,1)-KK*bij:(M,2)$# Calc s.f. product        DM55 119
-LL*bij:(M,3)-HK*bij:(M,4)-HL*bij:(M,5)-KL*bij:(M,6))# Calc s.f. prod   DM55 120
#                                                                       DM55 121
#   CALC A & B FOR EACH ATOM TYPE                                       DM55 122
#   -----------------------------                                       DM55 123
#                                                                       DM55 124
ANG=AH*xif:(M,1)+AK*xif:(M,2)+AL*xif:(M,3)# Calc phase component        DM55 125
IF(ISIN==yes:)#                        Test for sin/cos table           DM55 126
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 DM55 127
IF(ANG<0.)#                            Test if angle negative           DM55 128
I=INT((1.+AMOD(ANG,1.))*360.+.5)+MARK7## Point to sin/cos table         DM55 129
ELSE#                                  If angle is positive             DM55 130
I=INT(AMOD(ANG,1.)*360.+.5)+MARK7#     Point to sin/cos table           DM55 131
ACAL(L)=ACAL(L)+FACT*QX(I+91)#         Calc real s.f. component         DM55 132
IF(CENT==1)#                           Test if centrosymmetric          DM55 133
BCAL(L)=BCAL(L)+FACT*QX(I+1)#          Calc imag s.f. component         DM55 134
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 DM55 135
ELSE#                                  Else use fortran lib sin/cos     DM55 136
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 DM55 137
ACAL(L)=ACAL(L)+FACT*COS(ANG*PI2)#     Calc real s.f. component         DM55 138
IF(CENT==1)#                           Test if centrosymmetric          DM55 139
BCAL(L)=BCAL(L)+FACT*SIN(ANG*PI2)#     Calc imag s.f. component         DM55 140
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 DM55 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 DM55 142
#                                                                       DM55 143
#   CALC TOTAL COMPONENTS A & B                                         DM55 144
#   ---------------------------                                         DM55 145
#                                                                       DM55 146
ANOD=0.;  BNOD=0.;  ADIS=0.;  BDIS=0.# Reset a & b sums                 DM55 147
DO L=1,NTYP#                           Loop over scat. factors          DM55 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 DM55 149
IF(IRAD==1)      J=OFF(L)#             Point to neutron ff              DM55 150
ELSEIF(isf:(L)>0)J=JP+isf:(L)#         Get ff pointers to buffer        DM55 151
ELSE             J=NINT(STOL/DSTL)+OFF(L)# Point to ff curves           DM55 152
ANOD=ANOD+ACAL(L)*QX(J)#               Sum total real s.f.              DM55 153
IF(CENT==1)#                           Test if centrosymmetric          DM55 154
BNOD=BNOD+BCAL(L)*QX(J)#               Sum total imag s.f.              DM55 155
IF(DISP==yes:)#                        Is dispersion applied            DM55 156
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 DM55 157
A=ACAL(L)*ADR(L)-BCAL(L)*ADI(L)#       Apply anom.disp. factors         DM55 158
B=BCAL(L)*ADR(L)+ACAL(L)*ADI(L)#       Apply anom.disp. factors         DM55 159
ADIS=ADIS+A#                           Sum real contributions           DM55 160
BDIS=BDIS+B#                           Sum imag contributions           DM55 161
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 DM55 162
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 DM55 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  DM55 164
#                                                                       DM55 165
#  OTHERWISE USE MOLECULAR DYNAMICS VALUES                              DM55 166
#  ---------------------------------------                              DM55 167
#                                                                       DM55 168
ELSEIF(MOLDFC==yes:)#                                                   DM55 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 DM55 170
ANOD=anod:#                            Retrieve from md calcn           DM55 171
BNOD=bnod:#                            Retrieve from md calcn           DM55 172
ADIS=adis:#                            Retrieve from md calcn           DM55 173
BDIS=bdis:#                            Retrieve from md calcn           DM55 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 DM55 175
ELSE ;#                                No fc calculation - no diffs     DM55 176
#                                                                       DM55 177
#                                                                       DM55 178
#                                                                       DM55 179
IF(MOLDFR==yes:)#                      Save md as frel instead          DM55 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 DM55 181
FRND=SQRT(anod:*anod:+bnod:*bnod:)#    Theoretical frel (without disp   DM55 182
A=(anod:+adis:)#                       Calc disp correction a           DM55 183
B=(bnod:+bdis:)#                       Calc disp correction b           DM55 184
IF(DISP==yes:)FRD =SQRT(A*A+B*B)#      Frel with dispersion             DM55 185
ELSE          FRD =FRND#               Frel disp = frel no dispersion   DM55 186
FREL=FRD*EXTFAC#                       Raw frel with dispers+extinct    DM55 187
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 DM55 188
#                                                                       DM55 189
IF(NORMFC==yes:\MOLDFC==yes:)#         Iether either                    DM55 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 DM55 191
ATOT=ANOD+ADIS;  BTOT=BNOD+BDIS#       Include dispersion terms         DM55 192
#                                                                       DM55 193
#   APPLY EXTINCTION IF REQUESTED                                       DM55 194
#   -----------------------------                                       DM55 195
#                                                                       DM55 196
IF(IEXT==yes:)#                        Test for extinction              DM55 197
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 DM55 198
ANOX=ATOT;  BNOX=BTOT#                 Set extinction free a,b          DM55 199
J=IP+irx:#                             Point to extinction term         DM55 200
EXTFAC=SQRT(QX(J))#                    Get extinction factor            DM55 201
ATOT=ATOT*EXTFAC;  BTOT=BTOT*EXTFAC#   Apply extinct. to a,b            DM55 202
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 DM55 203
#                                                                       DM55 204
#   CALCULATE TOTAL STRUCTURE FACTOR                                    DM55 205
#   --------------------------------                                    DM55 206
#                                                                       DM55 207
IF((ABS(ANOD)<.01)&(ABS(BNOD)<.01))ANOD=.01# Test indeterminency        DM55 208
PHI=AMOD(ATAN2(BNOD,ANOD)/PI2+1.000001,1.)# Get phase in cycles         DM55 209
PHI2=PHI                               duplicate
FCAL=SQRT(ATOT*ATOT+BTOT*BTOT)#        Calculate s.f.                   DM55 210
FRND=FREL/EXTFAC;  FCND=FCAL/EXTFAC#   Correct for extinc.              DM55 211
IF(DISP==yes:)#                        Test for dispersion              DM55 212
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 DM55 213
FCND=SQRT(ANOD*ANOD+BNOD*BNOD)#        Calculate fc (without disp)      DM55 214
A=(ADIS*BNOD-BDIS*ANOD)/FCND#          Calc disp correction a           DM55 215
B=(ADIS*ANOD+BDIS*BNOD)/FCND#          Calc disp correction b           DM55 216
A=AMAX1(0.,FRND*FRND-A*A)#             Get +ve diff f2-a2               DM55 217
FRND=AMAX1(0.,SQRT(A)-B)#              Calc corrected frel              DM55 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 DM55 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 DM55 220
#
A=anod:;B=bnod:#                       calculate molec dynam phase
IF((ABS(A)<.01)&(ABS(B)<.01)) A=.01#   Test indeterminency   
PHI2=AMOD(ATAN2(B,A)/PI2+1.000001,1.)# Get MD phase in cycles    
#Molecular dynamics phase is archived where it wont be overwrit
#by subsequent CRYLSQ  - access by FOURR pset option
#
#                                                                       DM55 221
#    SETUP OUTPUT ARCHIVE LIST                                          DM55 222
#    -------------------------                                          DM55 223
#                                                                       DM55 224
IF(ifcnd:>0)QX(JP+ifcnd:)=FCND#        Archive calculated s.f.          DM55 225
IF(ifa:>0)  QX(JP+ifa:)=ANOD#          Archive real fc (no disp)        DM55 226
IF(ifb:>0)  QX(JP+ifb:)=BNOD#          Archive imag fc (no disp)        DM55 227
IF(ifad:>0) QX(JP+ifad:)=ADIS#         Archive real disp only           DM55 228
IF(ifbd:>0) QX(JP+ifbd:)=BDIS#         Archive imag disp only           DM55 229
IF(ifanx:>0)QX(JP+ifanx:)=ANOX#        Archive real fc (no ext.)        DM55 230
IF(ifbnx:>0)QX(JP+ifbnx:)=BNOX#        Archive imag fc (no ext.)        DM55 231
IF(iph:>0)  QX(JP+iph:)=PHI#           Archive phase in cycles          DM55 232
IF(iph2:>0) QX(JP+iph2:)=PHI2#         Archive phase in cycles          DM55 232
IF(IFC>0)   QX(JP+IFC)=FCAL#           Archive full fcalc               DM55 233
IF(IFR>0)   QX(JP+IFR)=FREL#           Archive raw frel                 DM55 234
IF(IFRC>0)  QX(JP+IFRC)=FRND/QX(ISCG)# Archive corrected frel           DM55 235
#                                                                       DM55 236
#    ACCUMULATE STATISTICS                                              DM55 237
#    ---------------------                                              DM55 238
#                                                                       DM55 239
FDIF=FRND-FCND#                        Calculate s.f. difference        DM55 240
JCOD=INT(CODE+1.5)#                    Convert refln code               DM55 241
SUMN(1,JCOD)=SUMN(1,JCOD)+1.#          Sum number of reflns             DM55 242
SUMR(1,JCOD)=SUMR(1,JCOD)+FRND#        Sum measured s.f.                DM55 243
SUMC(1,JCOD)=SUMC(1,JCOD)+FCND#        Sum calculated s.f.              DM55 244
SUMD(1,JCOD)=SUMD(1,JCOD)+ABS(FDIF)#   Sum f difference                 DM55 245
SUMN(2,JCOD)=SUMN(2,JCOD)+1.#          Sum number of reflns             DM55 246
SUMR(2,JCOD)=SUMR(2,JCOD)+FREL#        Sum measured s.f.                DM55 247
SUMC(2,JCOD)=SUMC(2,JCOD)+FCAL#        Sum calculated s.f.              DM55 248
SUMD(2,JCOD)=SUMD(2,JCOD)+ABS(FREL-FCAL)# Sum f difference              DM55 249
#                                                                       DM55 250
#    LIST REFLECTIONS IF REQUESTED                                      DM55 251
#    -----------------------------                                      DM55 252
#                                                                       DM55 253
IF(ABS(FDIF)<DLIS) NEXT#               List if abs(fdiff) > dlist       DM55 254
BUFOT(1)=STOL#                         Store sin theta/lambda           DM55 255
BUFOT(2)=CODE#                         Store refln code                 DM55 256
BUFOT(3)=FLOAT(ISCG-MARK4)#            Float scale group                DM55 257
BUFOT(4)=FREL#                         Store measured s.f.              DM55 258
BUFOT(5)=FCAL#                         Store total fc                   DM55 259
BUFOT(6)=ADIS#                         Store real dispersion term       DM55 260
BUFOT(7)=BDIS#                         Store imag dispersion term       DM55 261
BUFOT(8)=EXTFAC#                       Store extin. factor              DM55 262
BUFOT(9)=FRND#                         Store disp-free frel             DM55 263
BUFOT(10)=FCND#                        Store disp-free fcal             DM55 264
BUFOT(11)=PHI*360.#                    print disp-free MD phase       
BUFOT(12)=FDIF#                        Store disp-free fdiff            DM55 266
BUFOT(13)=PHI2*360.#                   print disp-free fcal phase
ncodefld:(H,     1,CHROT,FMT,3)#       Format h,k,l                     DM55 267
ncodefld:(BUFOT,1,CHROT,FMT(4),13)#    Format s,jc,is,frel              DM55 268
writeline:(0,DM51,NDM51,1,1)#          Print all data                   DM55 269
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM55 270
#                                                                       DM55 271
RETURN#                                                                 DM55 272
END#                                                                    DM55 273
systemheader:(DM60)#                   Print structure factor stats     DM60   1
# ####################################################################  DM60   2
#                                                                       DM60   3
#                                DM60                                   DM60   4
#                                                                       DM60   5
# ####################################################################  DM60   6
SUBROUTINE DM60#                                                        DM60   7
include:(AACOMN)#                                                       DM60   8
include:(DMCOMN)#                                                       DM60   9
#                                                                       DM60  10
INTEGER I,K#                           Working indices                  DM60  11
chardata:(DM61,[ REFLECTION STATISTICS   (DISPERSION/EXTINCTION $#      DM60  12
UNCORRECTED)])#                                                         DM60  13
chardata:(DM62,CODE0CODE1CODE2CODE3CODE4TOTAL)#                         DM60  14
chardata:(DM63,           NREF   AV FREL   AV FCAL   AV DIFF   $#       DM60  15
RFACTOR   SCALE)#                                                       DM60  16
chardata:(DM64,UN  )#                                                   DM60  17
realdata:(FMT,[150513.,250622.,350622.,450622.,550632.,630842.])#       DM60  18
datastuff:#                                                             DM60  19
#                                                                       DM60  20
#   CALCULATE STATISTICS                                                DM60  21
#   -------------------                                                 DM60  22
#                                                                       DM60  23
DO K=2,1,-1#                           Loop over disp., extn.           DM60  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  DM60  25
DO I=1,5#                              Loop over refln codes            DM60  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  DM60  27
SUMN(K,6)=SUMN(K,6)+SUMN(K,I)#         Sum total refln count            DM60  28
SUMR(K,6)=SUMR(K,6)+SUMR(K,I)#         Sum total frel                   DM60  29
SUMC(K,6)=SUMC(K,6)+SUMC(K,I)#         Sum total fcal                   DM60  30
SUMD(K,6)=SUMD(K,6)+SUMD(K,I)#         Sum total /diff/                 DM60  31
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  DM60  32
#                                                                       DM60  33
writeline:(1,DM61,NDM61,3,3); LINRM=3# Print stats header               DM60  34
DO I=1,6#                              Loop over refln codes            DM60  35
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  DM60  36
ifeq:(SUMN(K,I),0.) NEXT#              Skip null sums                   DM60  37
movechar:(DM62,I*5-4,CHROT,3,5,0)#     Put in side header               DM60  38
BUFOT(1)=SUMN(K,I)#                    Store number of reflns           DM60  39
BUFOT(2)=SUMR(K,I)/SUMN(K,I)#          Store mean frel                  DM60  40
BUFOT(3)=SUMC(K,I)/SUMN(K,I)#          Store mean fcal                  DM60  41
BUFOT(4)=SUMD(K,I)/SUMN(K,I)#          Store mean diff                  DM60  42
BUFOT(5)=SUMD(K,I)/AMAX1(1.,SUMR(K,I))# Store r-factor                  DM60  43
BUFOT(6)=SUMC(K,I)/AMAX1(1.,SUMR(K,I))# Store scale                     DM60  44
ncodefld:(BUFOT,1,CHROT,FMT,6)#        Format statistics                DM60  45
writeline:(0,DM63,NDM63,1,3)#          Print statistics                 DM60  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  DM60  47
movechar:(DM64,K*2-1,DM61,49,2,0)#     Reset heading                    DM60  48
IF(DISP==no: & IEXT==no:)  BREAK#      Exit if no disp., extinc.        DM60  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  DM60  50
#                                                                       DM60  51
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off file               DM60  52
#                                                                       DM60  53
RETURN#                                                                 DM60  54
END#                                                                    DM60  55
pmacro:([no:])#                        Purge xtal system macros         DM60  56
