#include <stdlib.h>
#include <stdio.h>

#if defined(__cplusplus)
#else
#define __stdcall 
#endif


#if NeedFunctionProtoTypes
static int CompareFloat(const void *a, const void *b);
static  void qiksrt_(float *list, int *sequ, int *entries); 
#endif

int CompareFloat(const void *a, const void *b)
{    
	if (* (float *) a < *(float *) b ) return (-1);
	if (* (float *) a > *(float *) b ) return (1);
	return  (0);
}


void qiksrt_(float *list, int *sequ, int *entries)
{
    register int i;
/*    float  *arra;   */
    float  arra[10000*2] ;
 
    if (*entries>9999){
          printf("qiksort: --- Insufficient statically allocated memory.\n");
          printf("             Recompile qsort.c.\n");
          exit(1);
         }
/*
    if ((arra=(float *)malloc((unsigned)(*entries *2* sizeof(float))))==NULL){
          printf("qiksort: --- error allocating memory for sort array .\n");
          return;
          }
*/

    for(i=0; i< *entries;++i){
        arra[i*2    ] = list[i] ;
        arra[i*2 + 1] = (float) i+1 ;
        }

    qsort((void *) arra, (size_t) *entries, sizeof(float)*2, CompareFloat); 
    for(i=0; i< *entries;++i) sequ[i]=(int) arra[i*2 + 1];
 /*   free(arra);  */
}

void __stdcall QIKSRT(float *list,int *sequ,int *entries) 
 {qiksrt_(list,sequ,entries);}
#ifndef VMS
void  qiksrt(float *list,int *sequ,int *entries) {qiksrt_(list,sequ,entries);}
#endif

