systemheader:(RFP   )#                 Start of rfpp macros             RFP    1
##*****************************************************************##   RFP    2
##                                                                 ##   RFP    3
##          RFPP ---- RATMAC-TO-FORTRAN77 PREPROCESSOR             ##   RFP    4
##                                                                 ##   RFP    5
##*****************************************************************##   RFP    6
#                                                                       RFP    7
select:(mic)#     ## <<<<<<<< Select correct compiler code here!        RFP    8
#                                                                       RFP    9
##                           UNX   Unix f77                             RFP   10
##                           UNX64 Unix f77 for Cray Unicos             RFP   11
##                           VMS   Vax VMS F77 compiler                 RFP   12
##                           CRA   Cray           non-unix F77          RFP   13
##                           IBM   IBM     ebcdic non-unix F77          RFP   14
##                           SIE   Siemens ebcdic non-unix F77          RFP   15
##                           MIC   MicroSoft F77 for PC                 RFP   16
#                                                                       RFP   17
macro:(head:,' RFPP --- Ratmac-Ftn77 PreProcessor  (3.2/Oct92)')#       RFP   18
#                                                                       RFP   19
#                                                                       RFP   20
#   CATEGORY 1: MACHINE-DEPENDENT MACROS                                RFP   21
#   ------------------------------------                                RFP   22
#                                                                       RFP   23
ifsel:(IBM,SIE)#                       Ebcdic characters                RFP   24
macro:(base:,192)#                     Base index start-1               RFP   25
macro:(upc:,192)#                      Upper-case start-1               RFP   26
macro:(loc:,128)#                      Lower-case start-1               RFP   27
macro:(wid:,41)#                       Width of coll-seq.               RFP   28
ifsel:#                                Ascii 7-bit characters           RFP   29
macro:(base:,47)#                      Base index start-1               RFP   30
macro:(upc:,64)#                       Upper-case start-1               RFP   31
macro:(loc:,96)#                       Lower-case start-1               RFP   32
macro:(wid:,26)#                       Width of coll-seq.               RFP   33
endsel:#                                                                RFP   34
#                                                                       RFP   35
ifsel:(CRA,IBM,SIE)#                                                    RFP   36
macro:(macdefn:,[CHARACTER*1 MACTAB(maxtab:)])#                         RFP   37
macro:(mactest:,MACTAB($1))#                                            RFP   38
macro:(pushover:,[IJK=$2;DO LJK=$4,$5#                                  RFP   39
$($3(LJK^LJK)=$1(IJK);IJK=IJK+1$)])#                                    RFP   40
macro:(pushback:,[IJK=$2;DO LJK=$4,$5#                                  RFP   41
$($3(LJK)=$1(IJK^IJK);IJK=IJK+1$)])#                                    RFP   42
ifsel:#                                                                 RFP   43
macro:(macdefn:,[CHARACTER*maxtab: MACTAB])#                            RFP   44
macro:(mactest:,MACTAB($1^$1))#                                         RFP   45
macro:(pushover:,[$3($4^$5)=$1($2^)])#                                  RFP   46
macro:(pushback:,[$3($4^$5)=$1($2^)])#                                  RFP   47
endsel:#                                                                RFP   48
#                                                                       RFP   49
ifsel:(VMS)#                                                            RFP   50
macro:(idev:,31)#                      Input file1 device               RFP   51
macro:(iftn:,37)#                      Output ftn file                  RFP   52
macro:(ilst:,38)#                      Output list file                 RFP   53
macro:(iext:,40)#                      Extruded file device             RFP   54
macro:(file1:,'RFPRAT')#               Name of dev1 file                RFP   55
macro:(openi:,OPEN($1,FILE=$2//'.',#   Open input file                  RFP   56
STATUS='OLD',READONLY);REWIND($1))#                                     RFP   57
macro:(openo:,OPEN(iftn:,#             Open fortran file                RFP   58
STATUS='NEW',FILE='RFPFTN.');REWIND(iftn:))#                            RFP   59
macro:(openl:,OPEN(ilst:,#             Open list file                   RFP   60
STATUS='NEW',FILE='RFPLST.');REWIND(ilst:))#                            RFP   61
macro:(opene:,$(OPEN(iext:,#           Open extrude file                RFP   62
STATUS='NEW',FILE=$1//'.');REWIND(iext:)$))#                            RFP   63
macro:(close:,CLOSE(UNIT=$1))#         Close input file                 RFP   64
#                                                                       RFP   65
ifsel:(IBM,MIC)#                                                        RFP   66
macro:(idev:,1)#                       Input file1 device               RFP   67
macro:(iftn:,7)#                       Output ftn file                  RFP   68
macro:(ilst:,8)#                       Output list file                 RFP   69
macro:(iext:,10)#                      Extruded file device             RFP   70
macro:(file1:,'RFPRAT')#               Name of dev1 file                RFP   71
macro:(openi:,OPEN($1,FILE=$2,#        Open input file                  RFP   72
STATUS='OLD');REWIND($1))#                                              RFP   73
macro:(openo:,OPEN(iftn:,#             Open fortran file                RFP   74
FILE='RFPFTN',STATUS='UNKNOWN');REWIND(iftn:))#                         RFP   75
macro:(openl:,OPEN(ilst:,#             Open list file                   RFP   76
FILE='RFPLST',STATUS='UNKNOWN');REWIND(ilst:))#                         RFP   77
macro:(opene:,$(OPEN(iext:,#           Open extrude file                RFP   78
FILE=$1,STATUS='UNKNOWN');REWIND(iext:)$))#                             RFP   79
macro:(close:,CLOSE(UNIT=$1))#         Close input file                 RFP   80
#                                                                       RFP   81
ifsel:(SIE)#                                                            RFP   82
macro:(idev:,31)#                      Input file1 device               RFP   83
macro:(iftn:,37)#                      Output ftn file                  RFP   84
macro:(ilst:,38)#                      Output list file                 RFP   85
macro:(iext:,40)#                      Extruded file device             RFP   86
macro:(file1:,'RFPRAT')#               Name of dev1 file                RFP   87
macro:(openi:,OPEN($1,FILE=$2,#        Open input file                  RFP   88
STATUS='OLD');REWIND($1))#                                              RFP   89
macro:(openo:,OPEN(iftn:,#             Open fortran file                RFP   90
FILE='RFPFTN',STATUS='UNKNOWN');REWIND(iftn:))#                         RFP   91
macro:(openl:,OPEN(ilst:,#             Open list file                   RFP   92
FILE='RFPLST',STATUS='UNKNOWN');REWIND(ilst:))#                         RFP   93
macro:(opene:,$(OPEN(iext:,#           Open extrude file                RFP   94
FILE=$1,STATUS='UNKNOWN');REWIND(iext:)$))#                             RFP   95
macro:(close:,CLOSE(UNIT=$1))#         Close input file                 RFP   96
#                                                                       RFP   97
ifsel:#                                                                 RFP   98
macro:(idev:,1)#                       Input file1 device               RFP   99
macro:(iftn:,7)#                       Output ftn file                  RFP  100
macro:(ilst:,8)#                       Output list file                 RFP  101
macro:(iext:,10)#                      Extruded file device             RFP  102
macro:(file1:,'RFPRAT')#               Name of dev1 file                RFP  103
macro:(openi:,OPEN($1,FILE=$2,#        Open input file                  RFP  104
STATUS='OLD');REWIND($1))#                                              RFP  105
macro:(openo:,OPEN(iftn:,#             Open fortran file                RFP  106
FILE='RFPFTN',STATUS='UNKNOWN');REWIND(iftn:))#                         RFP  107
macro:(openl:,OPEN(ilst:,#             Open list file                   RFP  108
FILE='RFPLST',STATUS='UNKNOWN');REWIND(ilst:))#                         RFP  109
macro:(opene:,$(OPEN(iext:,#           Open extrude file                RFP  110
FILE=$1,STATUS='UNKNOWN');REWIND(iext:)$))#                             RFP  111
macro:(close:,CLOSE(UNIT=$1))#         Close input file                 RFP  112
endsel:#                                                                RFP  113
#                                                                       RFP  114
ifsel:(VMS,MIC)#                                                        RFP  115
macro:(imes:,6)#                       Message /terminal device         RFP  116
macro:(openm:,)#                       Open message file                RFP  117
macro:(closem:,)#                      Close message device             RFP  118
ifsel:(IBM)#                                                            RFP  119
macro:(imes:,9)#                       Message /terminal device         RFP  120
macro:(openm:,OPEN(imes:,#             Open message device              RFP  121
FILE='RFPMES',STATUS='UNKNOWN');REWIND(imes:))# Open message device     RFP  122
macro:(closem:,CLOSE(imes:))#          Close message device             RFP  123
ifsel:(SIE)#                                                            RFP  124
macro:(imes:,39)#                      Message /terminal device         RFP  125
macro:(openm:,OPEN(imes:,#             Open message device              RFP  126
FILE='RFPMES',STATUS='UNKNOWN');REWIND(imes:))# Open message device     RFP  127
macro:(closem:,CLOSE(imes:))#          Close message device             RFP  128
ifsel:(UNX)#                                                            RFP  129
macro:(imes:,6)#                       Message /terminal device         RFP  130
macro:(openm:,)#                       Open message device              RFP  131
macro:(closem:,)#                      Close message device             RFP  132
ifsel:#                                                                 RFP  133
macro:(imes:,6)#                       Message /terminal device         RFP  134
macro:(openm:,OPEN(imes:,#             Open message device              RFP  135
FILE='RFPMES',STATUS='UNKNOWN');REWIND(imes:))# Open message device     RFP  136
macro:(closem:,CLOSE(imes:))#          Close message device             RFP  137
endsel:#                                                                RFP  138
#                                                                       RFP  139
#                                                                       RFP  140
#    CATEGORY 2: POSSIBLE MACHINE-DEPENDENT MACROS                      RFP  141
#    ---------------------------------------------                      RFP  142
#                                                                       RFP  143
macro:(sys:,'SYSTEMHEADER:IFELSE:($2,,$PC-------$1,)    ')# Def=43cha   RFP  144
#                                                                       RFP  145
macro:(read:,$(READ($1,'(A)',END=112)$2(1^80)# Read input source        RFP  146
$3=80;GOTO113;112 $3=-1;113 CONTINUE$))#                                RFP  147
macro:(write:,WRITE($1,'(A)')$2(1^$3))# Write output line               RFP  148
macro:(page:,$(WRITE(ilst:,'(1H1)');LLIN=3$))# Skip to new page         RFP  149
#                                                                       RFP  150
macro:(maxfil:,5)#                     Max level of file include's      RFP  151
macro:(maxind:,64)#                    Size of macro index table        RFP  152
macro:(maxmac:,500)#                   Max number of macro names        RFP  153
macro:(maxout:,72)#                    Output buffer length             RFP  154
macro:(maxtab:,20000)#                 Macro table size (chars)         RFP  155
macro:(maxstk:,100)#                   General stack size (words)       RFP  156
macro:(maxbuf:,4000)#                  Expansion buffer size (chars     RFP  157
macro:(maxstr:,100)#                   General string buffer (chars     RFP  158
macro:(maxlpp:,80)#                    Max lines/page list device       RFP  159
#                                                                       RFP  160
#                                                                       RFP  161
#   CATEGORY 3: MACHINE-INDEPENDENT MACROS                              RFP  162
#   --------------------------------------                              RFP  163
#                                                                       RFP  164
macro:(push:,[$(IF($4>0)$(KJK=$3+$4-1;IF(KJK>=maxbuf:)#                 RFP  165
error:(18,$1,$4);$2($3^KJK)=$1;$3=KJK+1$)$)])#                          RFP  166
macro:(move:,[$($2(1^$4)=$1; $3=$4$)])#                                 RFP  167
macro:(back:,[$(IF($4>0)$(JKJ=$3;$3=$3-($4);IF($3<=0)#                  RFP  168
error:(18,$1,$4);$2(($3+1)^JKJ)=$1$)$)])#                               RFP  169
macro:(error:,CALL ERROR($1,$2,$3))#   Output error message             RFP  170
macro:(eatu:,CALL EATUP($1,$2))#       Process rest of line             RFP  171
macro:(outs:,CALL OUTSTR($1,$2,$3,$4))# Put string in op buffer         RFP  172
macro:(onlynum:,[DO KJ=$2,$3#          Test if arith arguments digits   RFP  173
IF(INDEX('0123456789 -+',$1(KJ^KJ))==0) error:(21,$1($2^),$3-$2+1)])#   RFP  174
macro:(ctoi:,[CALL CHRINT($4,$1,$2,$3,LX,0)])# Digits to integer        RFP  175
macro:(itoc:,[CALL CHRINT($1,$2,$3,$4,$5,1)])# Integer to digits        RFP  176
macro:(inc:,'INCLUDE:INCLUDE $1            ')# Macro def=30char.        RFP  177
macro:(numb:,[$2=ICHAR($1)])#          Char to col. seq. no.            RFP  178
macro:(char:,[$2=CHAR($1)])#           Col. seq. no. to char            RFP  179
#                                                                       RFP  180
#                                                                       RFP  181
macro:(eol:,'#')#                      End-of-line flag                 RFP  182
macro:(alnm:,1)#                       Code for alphanumeric tokens     RFP  183
macro:(macr:,2)#                       Code for macro name tokens       RFP  184
macro:(endl:,3)#                       Code for end of line             RFP  185
macro:(endf:,4)#                       Code for end of file             RFP  186
macro:(othr:,5)#                       Code for 'other' tokens          RFP  187
macro:(numr:,6)#                       Code for all digits              RFP  188
macro:(code:,7)#                       Code for diagraph                RFP  189
macro:(blnk:,8)#                       Code for blank token             RFP  190
macro:(ndo:,1)#                        <do> function code               RFP  191
macro:(nif:,2)#                        <if> function code               RFP  192
macro:(nfo:,3)#                        <for> function code              RFP  193
macro:(nwh:,4)#                        <while> function code            RFP  194
macro:(nre:,5)#                        <repeat> function code           RFP  195
macro:(nel:,6)#                        <else> function code             RFP  196
macro:(nlb:,7)#                        Left brace function code         RFP  197
macro:(con:,0)#                        Concatenate signal               RFP  198
macro:(tab:,-1)#                       Tab to col7 signal               RFP  199
macro:(new:,-2)#                       Start in col1 signal             RFP  200
macro:(sav:,-3)#                       Save <for-reint> code            RFP  201
macro:(dig:,-4)#                       Process digit string             RFP  202
macro:(cnt:,-5)#                       Continue line flag               RFP  203
#                                                                       RFP  204
macro:(icommon:,[#                     Int1 common variables            RFP  205
INTEGER ARGSTK(maxstk:)#               Macro argument stack             RFP  206
INTEGER MACADR(maxmac:)#               Macro table pointer list         RFP  207
INTEGER MACDEF(maxmac:)#               Macro definition length          RFP  208
INTEGER MACIND(maxind:)#               Macro index table of <char>:     RFP  209
INTEGER MACNAM(maxmac:)#               Macro name length                RFP  210
INTEGER MACNEX(maxmac:)#               Macro next list pointer          RFP  211
INTEGER ITAB#                          Macro table pointer              RFP  212
INTEGER MACM#                          Max number of macros             RFP  213
INTEGER MTAB#                          Max macro table pointer          RFP  214
INTEGER NARG#                          Macro argument counter           RFP  215
INTEGER NBUF#                          Input buffer pointer             RFP  216
INTEGER NDEV#                          Input file device number         RFP  217
INTEGER NOUT#                          Output buffer pointer            RFP  218
INTEGER NMAC#                          Current number of macros         RFP  219
INTEGER NDAT#                          Number of datastuff macros       RFP  220
COMMON/INT1/ARGSTK,MACADR,MACDEF,MACIND,MACNAM,#                        RFP  221
MACNEX,MACM,NARG,NMAC,ITAB,MTAB,NBUF,NDAT,NDEV,NOUT])#                  RFP  222
#                                                                       RFP  223
macro:(jcommon:,[#                     Int2 common variables            RFP  224
INTEGER ACCF#                          Accept flag for ifsel:           RFP  225
INTEGER CODF#                          Coded  flag for ifsel:           RFP  226
INTEGER EXTF#                          Extrude file flag                RFP  227
INTEGER FLAGS,FLAGR,FLAGD#             Flagon/flagoff signals           RFP  228
INTEGER FORSTK(maxstr:)#               <for-reinit.> string pointer     RFP  229
INTEGER NERR#                          Error count for routine          RFP  230
INTEGER NLAB#                          Current label number             RFP  231
INTEGER NERT#                          Total error count for routine    RFP  232
INTEGER NBRC#                          Left brace count                 RFP  233
INTEGER NSQB#                          Left square bracket count        RFP  234
INTEGER NFIL#                          File level counter               RFP  235
INTEGER NFOR#                          Levels of <for> loops            RFP  236
INTEGER IFOR#                          <for-reinit.> string pointer     RFP  237
INTEGER ILIN#                          Input line count                 RFP  238
INTEGER LLIN#                          List line count                  RFP  239
INTEGER OLIN#                          Output line count                RFP  240
INTEGER XFLG#                          Quote string flag                RFP  241
COMMON/INT2/ACCF,CODF,EXTF,FLAGS,FLAGR,FLAGD,FORSTK,#                   RFP  242
NERR,NLAB,NERT,NBRC,NSQB,NFIL,NFOR,IFOR,ILIN,LLIN,OLIN,XFLG])#          RFP  243
#                                                                       RFP  244
macro:(ccommon:,[#                     Char common variables            RFP  245
CHARACTER*maxbuf: IBUF#                Input & expansion buffer         RFP  246
CHARACTER*maxout: OBUF#                Output ftn77 buffer              RFP  247
CHARACTER*120 LBUF#                    List source buffer               RFP  248
CHARACTER*12 PROG#                     Store program name               RFP  249
macdefn:#                              Macro name/defn table            RFP  250
CHARACTER*maxbuf: MACSTR#              Macro expansion string           RFP  251
CHARACTER*maxbuf: FORSTR#              <for-reinit.> string list        RFP  252
CHARACTER*1   BSL#                     For backslash character          RFP  253
COMMON/CHRX/IBUF,OBUF,LBUF,PROG,MACTAB,MACSTR,FORSTR,BSL])#             RFP  254
#                                                                       RFP  255
systemheader:(RFPP)#                   Ratmac-ftn77 preprocessor        RFPP   1
#********************************************************************   RFPP   2
#                                                                   *   RFPP   3
#                           RFPP                                    *   RFPP   4
#                                                                   *   RFPP   5
#********************************************************************   RFPP   6
PROGRAM RFPP#                          S.r.hall june 85                 RFPP   7
#                                                                       RFPP   8
icommon:#                              Int1 common variables            RFPP   9
jcommon:#                              Int2 common variables            RFPP  10
ccommon:#                              Char common variables            RFPP  11
#                                                                       RFPP  12
CHARACTER*1 C#                         Single local character           RFPP  13
CHARACTER*maxstr: STRING#              Char string passed to rfpp       RFPP  14
CHARACTER*20 LINE#                     Error line                       RFPP  15
INTEGER FLAG#                          Output control flag              RFPP  16
INTEGER FILSTK(maxfil:)#               Stack of file device numbers     RFPP  17
INTEGER FUNSTK(maxstk:)#               Stack of ratfor functions        RFPP  18
INTEGER LABSTK(maxstk:)#               Stack of function labels         RFPP  19
INTEGER ILAB#                          Label number increment           RFPP  20
INTEGER INCL#                          <include> flag                   RFPP  21
INTEGER NFUN#                          Ratfor function level            RFPP  22
INTEGER NSTR#                          Number of chars in string        RFPP  23
INTEGER NTOK#                          Number of chars in token         RFPP  24
INTEGER TYPE#                          Lexical type of string           RFPP  25
DATA FLAG/tab:/#                                                        RFPP  26
DATA LINE/' Total Errors:      '/#                                      RFPP  27
#                                                                       RFPP  28
#    SET INITIAL PARAMETERS                                             RFPP  29
#    -----------------------                                            RFPP  30
#                                                                       RFPP  31
CALL INITL#                            Initialize parameters            RFPP  32
FOR(I=0;I<maxfil:;I=I+1)#              Loop over possible ip files      RFPP  33
FILSTK(I+1)=I+idev:#                   Set device first file            RFPP  34
STRING(1^)=' '#                        Blank out character string       RFPP  35
#                                                                       RFPP  36
#   PROCESS ALL INPUT RATMAC SOURCE FILES                               RFPP  37
#   -------------------------------------                               RFPP  38
#                                                                       RFPP  39
FOR(NFIL=1;NFIL>0;NFIL=NFIL-1)#        Loop input source files          RFPP  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RFPP  41
NDEV=FILSTK(NFIL);      NFUN=0#        Get input device number          RFPP  42
REPEAT#                                Loop over all strings to eof     RFPP  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RFPP  44
INCL=no:;       NSTR=1#                Reset <include> flag             RFPP  45
REPEAT#                                Loop until 'include' found       RFPP  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RFPP  47
#    *******************************                                    RFPP  48
CALL MACEXP(STRING(NSTR^),TYPE,NTOK)#  Get a character string           RFPP  49
#    *******************************                                    RFPP  50
NSTR=NSTR+NTOK#                        Incr string pointer              RFPP  51
#                                                                       RFPP  52
#   SEARCH CHAR STRING FOR <INCLUDE>                                    RFPP  53
#   --------------------------------                                    RFPP  54
#                                                                       RFPP  55
IF(TYPE==endf:) BREAK#                 Exit include search if eof       RFPP  56
IF(INCL==no:)#                         If include not in prior str      RFPP  57
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RFPP  58
IF(STRING(1^7)!='INCLUDE') BREAK#      Exit if not include              RFPP  59
INCL=yes:#                             Flag is string is <include>      RFPP  60
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RFPP  61
IF(TYPE==blnk:) NSTR=NSTR-NTOK#        Ignore blanks in filename        RFPP  62
IF(TYPE!=endl:) NEXT#                  Test for end of <include>        RFPP  63
NFIL=NFIL+1#                           Incr input file counter          RFPP  64
IF(NFIL>maxfil:) error:(01,' ',0)#     Test if max files exceeded       RFPP  65
NDEV=FILSTK(NFIL)#                     Get input device number          RFPP  66
openi:(NDEV,STRING(8^NSTR-2))#         Open include file                RFPP  67
BREAK#                                 Skip to new read file            RFPP  68
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RFPP  69
#                                                                       RFPP  70
#   PROCESS LOOP CONTROL STRINGS                                        RFPP  71
#   ----------------------------                                        RFPP  72
#                                                                       RFPP  73
IF(TYPE==endl: \ TYPE==blnk:) NEXT#    Skip if eol or blank             RFPP  74
IF(TYPE==endf: \ INCL==yes:)  BREAK#   Test for termination             RFPP  75
NSTR=NSTR-1;  C=STRING(1^1)#           Set length of string             RFPP  76
#                                                                       RFPP  77
IF(C=='{'\(TYPE==code: & C=='('))#     Test for left brace              RFPP  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RFPP  79
NBRC=NBRC+1#                           Incr left brace counter          RFPP  80
IFUN=nlb:;     ILAB=0#                 Store function type              RFPP  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RFPP  82
#                                                                       RFPP  83
ELSE IF(C=='}'\(TYPE==code: & C==')'))# Test for right brace            RFPP  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RFPP  85
NBRC=NBRC-1;       IFUN=0#             Decr left brace counter          RFPP  86
IF(FUNSTK(NFUN)==nlb:) NFUN=NFUN-1#    Decr fun stack if match          RFPP  87
ELSE                  error:(04,' ',0)# Brace mismatch detected         RFPP  88
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RFPP  89
#                                                                       RFPP  90
ELSE IF(TYPE==code: & C=='P')#         Test for col1 position code      RFPP  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RFPP  92
FLAG=new:;    IFUN=0#                  Force start in col1              RFPP  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RFPP  94
#                                                                       RFPP  95
ELSE IF(NSTR==2&STRING(1^2)=='IF')#    Test for **** if ****            RFPP  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RFPP  97
IF(IFUN==nel:) ILAB=con:#              Output 'if' after 'else'         RFPP  98
ELSE           ILAB=tab:#              Output first 'if'                RFPP  99
outs:(ILAB,'IF',2,0)#                  Output 'if' on new line          RFPP 100
eatu:(nif:,con:)#                      Output <if-condition>            RFPP 101
outs:(con:,'THEN',4,0)#                Output 'then'                    RFPP 102
IFUN=nif:#                             Store function type              RFPP 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RFPP 104
#                                                                       RFPP 105
ELSE IF(NSTR==4&STRING(1^4)=='ELSE')#  Test for **** else ****          RFPP 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RFPP 107
N=FUNSTK(NFUN)#                        Get function and label           RFPP 108
IF(N!=nif:) error:(17,' ',0)#          Else must follow 'if'            RFPP 109
outs:(tab:,'ELSE ',5,0)#               Output 'else'                    RFPP 110
IFUN=nel:;     ILAB=0#                 Store function type              RFPP 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RFPP 112
#                                                                       RFPP 113
ELSE IF(NSTR==6&STRING(1^6)=='ELSEIF')# Test for **** elseif ****       RFPP 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RFPP 115
N=FUNSTK(NFUN)#                        Get function and label           RFPP 116
IF(N!=nif:) error:(17,' ',0)#          Else must follow 'if'            RFPP 117
NFUN=NFUN+1#                           Incr function count              RFPP 118
IF(NFUN>maxstk:) error:(05,' ',0)#     Test for stack overflow          RFPP 119
FUNSTK(NFUN)=nel:#                     Store the else function          RFPP 120
LABSTK(NFUN)=NLAB#                     Store current label              RFPP 121
outs:(tab:,'ELSE IF',7,0)#             Output 'else if' on a new line   RFPP 122
eatu:(nif:,con:)#                      Output <if-condition>            RFPP 123
outs:(con:,'THEN',4,0)#                Output 'then'                    RFPP 124
IFUN=nif:;    ILAB=con:#               Store function type              RFPP 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RFPP 126
#                                                                       RFPP 127
ELSE IF(NSTR==2&STRING(1^2)=='DO')#    Test for **** do ****            RFPP 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RFPP 129
outs:(tab:,'DO',2,NLAB)#               Output 'do nlab'                 RFPP 130
eatu:(ndo:,con:)#                      Output <do-condition>            RFPP 131
IFUN=ndo:;     ILAB=2#                 Store function type              RFPP 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RFPP 133
#                                                                       RFPP 134
ELSE IF(NSTR==5&STRING(1^5)=='WHILE' )# Test for **** while ****        RFPP 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RFPP 136
outs:(NLAB,'IF',2,0)#                  Output 'nlab if'                 RFPP 137
eatu:(nwh:,con:)#                      Output <while-condition>         RFPP 138
outs:(con:,'THEN',4,0)#                Output 'then'                    RFPP 139
IFUN=nwh:;      ILAB=2#                Store function type              RFPP 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RFPP 141
#                                                                       RFPP 142
ELSE IF(NSTR==6&STRING(1^6)=='REPEAT')# Test for **** repeat ****       RFPP 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RFPP 144
outs:(NLAB,'CONTINUE',8,0)#            Output 'nlab continue'           RFPP 145
IFUN=nre:;     ILAB=2#                 Store function type              RFPP 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RFPP 147
#                                                                       RFPP 148
ELSE IF(NSTR==3&STRING(1^3)=='FOR')#   Test for **** for ****           RFPP 149
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RFPP 150
eatu:(nfo:,tab:)#                      Output <for-initialization>      RFPP 151
NBUF=NBUF+1#                           Point to next ip char            RFPP 152
IF(IBUF(NBUF^NBUF)!=';')#              Test for void <for-condit.>      RFPP 153
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RFPP 154
NBUF=NBUF-1#                           Reset ip buffer pointer          RFPP 155
outs:(NLAB,'IF(',3,0)#                 Output 'nlab if'                 RFPP 156
eatu:(nfo:,con:)#                      Output <for-condition>           RFPP 157
outs:(con:,')THEN',5,0)#               Output 'then'                    RFPP 158
IFUN=nfo:#                             Set function flag                RFPP 159
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RFPP 160
ELSE#                                  No <for condition>               RFPP 161
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RFPP 162
outs:(NLAB,'CONTINUE',8,0)#            Output dummy <for-condition>     RFPP 163
IFUN=-nfo:#                            Flag for no 'end if'             RFPP 164
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RFPP 165
eatu:(nfo:,sav:)#                      Save <for-reinit> in forstr      RFPP 166
ILAB=2;    NLAB=NLAB+1#                Store function type              RFPP 167
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RFPP 168
#                                                                       RFPP 169
ELSE IF((NSTR==4&STRING(1^4)=='NEXT' )$# Test for **** next ****        RFPP 170
       \(NSTR==5&STRING(1^5)=='BREAK'))# Or   for **** break ****       RFPP 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RFPP 172
FOR(I=NFUN;I>0;I=I-1)#                 Loop over nested loops           RFPP 173
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RFPP 174
N=IABS(FUNSTK(I));  L=IABS(LABSTK(I))# Get function & label             RFPP 175
IF(N!=nwh:& N!=ndo:& N!=nfo:& N!=nre:)NEXT# Skip nonloop functions      RFPP 176
IF(NSTR==4)#                           Test for <next>                  RFPP 177
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RFPP 178
outs:(tab:,'GOTO',4,L)#                Output if <next>                 RFPP 179
IF(N==nfo:) FORSTK(NFOR)=-IABS(FORSTK(NFOR))# Flag <for> if next        RFPP 180
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RFPP 181
ELSE#                                  This is a break                  RFPP 182
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RFPP 183
outs:(tab:,'GOTO',4,L+1)#              Output if <break>                RFPP 184
LABSTK(I)=-L#                          Flag label for break             RFPP 185
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RFPP 186
IFUN=0;       BREAK#                   Exit function loop               RFPP 187
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RFPP 188
IF(I==0) error:(03,' ',0)#             Illegal break/next               RFPP 189
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RFPP 190
#                                                                       RFPP 191
ELSE IF(C==';') IFUN=0#                Test for end of expression       RFPP 192
#                                                                       RFPP 193
ELSE IF(TYPE==numr:)#                  Test for **** alldigit ****      RFPP 194
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RFPP 195
outs:(dig:,STRING(1^),NSTR,0)#         Output digit string              RFPP 196
eatu:(0,con:)#                         Output to end of line            RFPP 197
IFUN=0#                                No function code                 RFPP 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RFPP 199
#                                                                       RFPP 200
ELSE#                                  Process all other strings        RFPP 201
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RFPP 202
outs:(FLAG,STRING(1^),NSTR,0)#         Output other string              RFPP 203
eatu:(0,con:)#                         Output to end of line            RFPP 204
FLAG=tab:;      IFUN=0#                Set for new line                 RFPP 205
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RFPP 206
#                                                                       RFPP 207
IF(IFUN!=0)#                           When functions are stacked       RFPP 208
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RFPP 209
NFUN=NFUN+1#                           Incr function count              RFPP 210
IF(NFUN>maxstk:) error:(05,' ',0)#     Test for stack overflow          RFPP 211
FUNSTK(NFUN)=IFUN#                     Store actual function            RFPP 212
IF(ILAB<0) LABSTK(NFUN)=0#             Flag first if statement          RFPP 213
ELSE#                                  For all other functions          RFPP 214
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RFPP 215
LABSTK(NFUN)=NLAB#                     Store current label              RFPP 216
NLAB=NLAB+ILAB#                        Incr statement label             RFPP 217
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RFPP 218
NEXT#                                  Skip to next string              RFPP 219
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RFPP 220
#                                                                       RFPP 221
#   IF <STATEMENT> CLOSED UNSTACK FUNCTIONS                             RFPP 222
#   ---------------------------------------                             RFPP 223
#                                                                       RFPP 224
FOR(;NFUN>0;NFUN=NFUN-1)#              Unstack function list            RFPP 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RFPP 226
N=FUNSTK(NFUN); M=LABSTK(NFUN); L=IABS(M)# Get function & label         RFPP 227
IF(N==nlb:) BREAK#                     Exit on left brace               RFPP 228
#                                                                       RFPP 229
IF(N==nif:)#                           Test if <if> in stack            RFPP 230
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RFPP 231
FOR(TYPE=endl:;TYPE==endl:\TYPE==blnk:\STRING(1^1)==';';)# Next token   RFPP 232
CALL MACEXP(STRING(1^),TYPE,NTOK)#     Look at next token               RFPP 233
IF(TYPE!=code:) NBUF=NBUF-NTOK#        Reset ip buffer pointer          RFPP 234
ELSE            NBUF=NBUF-2#           Allow for digraph                RFPP 235
IF(STRING(1^4)=='ELSE') BREAK#         Skip continue if else next       RFPP 236
IF(L==0) outs:(tab:,'END IF',6,0)#     Output 'endif'                   RFPP 237
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RFPP 238
#                                                                       RFPP 239
ELSE IF(N==nel:)#                      Test if <else> in stack          RFPP 240
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RFPP 241
IF(NFUN>1) NFUN=NFUN-1#                Decr function counter            RFPP 242
IF(LABSTK(NFUN)==0) outs:(tab:,'END IF',6,0)# Output 'endif'            RFPP 243
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RFPP 244
#                                                                       RFPP 245
ELSE IF(N==ndo:)#                      Test if <do> in stack            RFPP 246
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RFPP 247
outs:(L,'CONTINUE',8,0)#               Output 'n continue'              RFPP 248
IF(M<0) outs:(L+1,'CONTINUE',8,0)#     Output cont for break            RFPP 249
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RFPP 250
#                                                                       RFPP 251
ELSE IF(N==nwh:\N==nre:)#              Test if <while> or <repeat>      RFPP 252
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RFPP 253
outs:(tab:,'GOTO',4,L)#                Output 'goto nlab'               RFPP 254
IF(M<0) outs:(L+1,'CONTINUE',8,0)#     Output cont for break            RFPP 255
IF(N==nwh:) outs:(tab:,'END IF',6,0)#  Output 'endif'                   RFPP 256
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RFPP 257
#                                                                       RFPP 258
ELSE IF(IABS(N)==nfo:)#                Test if <for> in stack           RFPP 259
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RFPP 260
I=FORSTK(NFOR); J=IABS(I);  NFOR=NFOR-1# Extract for stack pointer      RFPP 261
K=IFOR-J;    IFOR=J#                   Calc length of <reinit> stri     RFPP 262
IF(I<0) outs:(L,'CONTINUE',8,0)#       Output 'nlab continue'           RFPP 263
IF(K>0) outs:(tab:,FORSTR(J^),K,0)#    Output '<reinit>'                RFPP 264
outs:(tab:,'GOTO',4,L-1)#              Output '     goto nlab-1'        RFPP 265
IF(M<0) outs:(L+1,'CONTINUE',8,0)#     Output cont for break            RFPP 266
IF(N>0) outs:(tab:,'END IF',6,0)#      Output 'endif'                   RFPP 267
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RFPP 268
#                                                                       RFPP 269
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RFPP 270
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RFPP 271
close:(NDEV)#                          Close off input file             RFPP 272
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RFPP 273
#                                                                       RFPP 274
IF(NERT!=0)#                           Test if errors detected          RFPP 275
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RFPP 276
itoc:(NERT,LINE,16,20,II)#             Insert total error number        RFPP 277
write:(ilst:,LINE,20)#                 Print error message              RFPP 278
write:(imes:,LINE,20)#                 Print error message              RFPP 279
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RFPP 280
closem:#                               Close message device             RFPP 281
close:(iftn:)#                         Close fortran output device      RFPP 282
close:(ilst:)#                         Close ratmac listing device      RFPP 283
IF(NERT!=0)  STOP 8#                   Exit with error count            RFPP 284
STOP#                                                                   RFPP 285
END#                                                                    RFPP 286
systemheader:(INITL)#                  Initialize processing            INIT   1
#********************************************************************   INIT   2
#                                                                   *   INIT   3
#                          INITL      CALLED BY: RFPP               *   INIT   4
#                                                                   *   INIT   5
#********************************************************************   INIT   6
SUBROUTINE INITL#                      S.r.hall june 85                 INIT   7
#                                                                       INIT   8
icommon:#                              Int1 common variables            INIT   9
jcommon:#                              Int2 common variables            INIT  10
ccommon:#                              Char common variables            INIT  11
#                                                                       INIT  12
CHARACTER HEAD1*50,HEAD2*20#           Listing headers                  INIT  13
DATA HEAD1/head:/#                                                      INIT  14
DATA HEAD2/' R:     F:          '/#                                     INIT  15
#                                                                       INIT  16
#   SET INITIAL PARAMETERS                                              INIT  17
#   ----------------------                                              INIT  18
#                                                                       INIT  19
openi:(idev:,file1:)#                  Open first input file            INIT  20
openo:#                                Open output file                 INIT  21
openl:#                                Open list file                   INIT  22
openm:#                                Open message device              INIT  23
page:#                                 Force pagination for signon      INIT  24
write:(ilst:,HEAD1,50)#                Print signon message             INIT  25
write:(imes:,HEAD1,50)#                Print signon message             INIT  26
write:(ilst:,HEAD1,1)#                 Insert blank line                INIT  27
write:(imes:,HEAD1,1)#                 Insert blank line                INIT  28
LBUF(1^20)=HEAD2#                      Insert header                    INIT  29
PROG='            '#                   Blank program name               INIT  30
#                                                                       INIT  31
IBUF(maxbuf:^maxbuf:)=eol:#            Set eol char in ip buffer        INIT  32
NBUF=maxbuf:#                          Force first source input         INIT  33
NOUT=1#                                Output buffer pointer            INIT  34
ILIN=0#                                Set input line count             INIT  35
OLIN=1#                                Set output line count            INIT  36
NERR=0#                                Set error count                  INIT  37
NERT=0#                                Set error count                  INIT  38
NMAC=0#                                Set number of macros             INIT  39
MACM=0#                                Set max number of macros         INIT  40
NDAT=1000#                             Set datastuff: limit             INIT  41
NARG=0#                                Set number of arguments          INIT  42
ITAB=1#                                Macro table pointer              INIT  43
MTAB=1#                                Max macro table pointer:         INIT  44
NLAB=27000#                            Start label number               INIT  45
NBRC=0#                                Zero left brace count            INIT  46
NSQB=0#                                Zero left square bracket         INIT  47
NFOR=0#                                For-reinit stack count           INIT  48
IFOR=1#                                For-reinit string point          INIT  49
XFLG=-1#                               Set quote string flag            INIT  50
FLAGS=no:#                             Default source listing off       INIT  51
FLAGR=no:#                             Default reject source off        INIT  52
FLAGD=no:#                             Default dump macros off          INIT  53
ACCF=yes:#                             Accept flag for ifsel:           INIT  54
CODF=no:#                              Coded  flag for ifsel:           INIT  55
EXTF=no:#                              Flag to extrude file             INIT  56
BSL='\\\\'#                            Install backslash                INIT  57
DO I=1,maxind:; MACIND(I)=0#           Zero macro index table           INIT  58
DO I=1,maxmac:; MACNEX(I)=0#           Zero maxro next list             INIT  59
#                                                                       INIT  60
#   INSTAL SYSTEM MACROS                                                INIT  61
#   --------------------                                                INIT  62
#                                                                       INIT  63
CALL PUTMAC('ARITH:]A',6,2,I)#         Instal system macro              INIT  64
CALL PUTMAC('MACRO:]M',6,2,I)#         Instal system macro              INIT  65
CALL PUTMAC('XMACRO:]X',7,2,I)#        Instal system macro              INIT  66
CALL PUTMAC('IFELSE:]I',7,2,I)#        Instal system macro              INIT  67
CALL PUTMAC('INCR:]+',5,2,I)#          Instal system macro              INIT  68
CALL PUTMAC('DECR:]-',5,2,I)#          Instal system macro              INIT  69
CALL PUTMAC('CHR:]C',4,2,I)#           Instal system macro              INIT  70
CALL PUTMAC('ORD:]O',4,2,I)#           Instal system macro              INIT  71
CALL PUTMAC('LENSTR:]L',7,2,I)#        Instal system macro              INIT  72
CALL PUTMAC('SUBSTR:]S',7,2,I)#        Instal system macro              INIT  73
CALL PUTMAC('FLAGON:]Y',7,2,I)#        Instal system macro              INIT  74
CALL PUTMAC('FLAGOFF:]N',8,2,I)#       Instal system macro              INIT  75
CALL PUTMAC('PMACRO:]P',7,2,I)#        Instal system macro              INIT  76
CALL PUTMAC('DMACRO:]D',7,2,I)#        Instal system macro              INIT  77
CALL PUTMAC('CHARDATA:]E',9,2,I)#      Instal system macro              INIT  78
CALL PUTMAC('REALDATA:]G',9,2,I)#      Instal system macro              INIT  79
CALL PUTMAC('DBLEDATA:]J',9,2,I)#      Instal system macro              INIT  80
CALL PUTMAC('INTDATA:]H',8,2,I)#       Instal system macro              INIT  81
CALL PUTMAC('DATASTUFF:]F',10,2,I)#    Instal system macro              INIT  82
CALL PUTMAC('STRING:]R',7,2,I)#        Instal system macro              INIT  83
CALL PUTMAC('SELECT:]Q',7,2,I)#        Instal system macro              INIT  84
CALL PUTMAC('IFSEL:]Z',6,2,I)#         Instal system macro              INIT  85
CALL PUTMAC('ENDSEL:]W',7,2,I)#        Instal system macro              INIT  86
CALL PUTMAC('EXTRUDE:]U',8,2,I)#       Instal system macro              INIT  87
CALL PUTMAC('ENDEXT:]V',7,2,I)#        Instal system macro              INIT  88
CALL PUTMAC(inc:,8,22,I)#              Instal std macro                 INIT  89
CALL PUTMAC(sys:,13,30,I)#             Instal std macro                 INIT  90
CALL PUTMAC('YES:1',4,1,I)#            Instal std macro                 INIT  91
CALL PUTMAC('NO:0',3,1,I)#             Instal std macro                 INIT  92
#                                                                       INIT  93
RETURN#                                                                 INIT  94
END#                                                                    INIT  95
ifsel:(PER)#                           Select chrint for non-per        INIT  96
ifsel:#                                                                 INIT  97
systemheader:(CHRINT)#                 Char-to-int and reverse          CHRI   1
#********************************************************************   CHRI   2
#                                                                   *   CHRI   3
#                            CHRINT                                 *   CHRI   4
#                                                                   *   CHRI   5
#********************************************************************   CHRI   6
SUBROUTINE CHRINT(INT,STRING,TOP,BOT,LEN,KEY)#                          CHRI   7
#                                                                       CHRI   8
CHARACTER*1 C#                         Single local character           CHRI   9
CHARACTER*(*)     STRING#              Working character string         CHRI  10
CHARACTER*13 DIGIT#                    Digit string                     CHRI  11
CHARACTER*10 BLANK#                    Blank string                     CHRI  12
INTEGER POWER(9)#                      Arithmetic powers of ten         CHRI  13
INTEGER INT#                           Input/output integer             CHRI  14
INTEGER TOP,BOT#                       Start/end of string              CHRI  15
INTEGER LEN#                           Length of string                 CHRI  16
INTEGER KEY#                           Key=0 ctoi; key=1 itoc           CHRI  17
INTEGER I,J,K,L,M,N#                   Working indices                  CHRI  18
DATA BLANK/'          '/,DIGIT/'0123456789+-*'/#                        CHRI  19
DATA POWER/1,10,100,1000,10000,100000,1000000,10000000,100000000/#      CHRI  20
#                                                                       CHRI  21
IF(KEY==0)#                            Test for c-to-i function         CHRI  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CHRI  23
LEN=0;    INT=0#                       Zero length and integer          CHRI  24
DO I=BOT,TOP,-1#                       Loop over char string            CHRI  25
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CHRI  26
C=STRING(I^I)#                         Extract current character        CHRI  27
FOR(J=1; J<=12; J=J+1)#                Loop over digit string           CHRI  28
IF(C==DIGIT(J^J)) BREAK#               Exit on match                    CHRI  29
IF(J==12) INT=-INT#                    Negative integer                 CHRI  30
IF(J>10) NEXT#                         Ignore no digits                 CHRI  31
LEN=LEN+1#                             Incr length counter              CHRI  32
INT=INT+POWER(LEN)*(J-1)#              Incr integer                     CHRI  33
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CHRI  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CHRI  35
#                                                                       CHRI  36
ELSE#                                  This is i-to-c function          CHRI  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CHRI  38
STRING(TOP^BOT)=BLANK#                 Blank out string                 CHRI  39
IF(INT==0)#                            Test for zero integer            CHRI  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CHRI  41
STRING(TOP^TOP)=DIGIT(1^)#             Insert zero character            CHRI  42
LEN=1#                                 Set string length                CHRI  43
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CHRI  44
ELSE#                                  Integer is non-zero              CHRI  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CHRI  46
LEN=TOP;    N=IABS(INT)#               Zero length & local integer      CHRI  47
M=N;        L=MIN0(BOT-TOP+1,9)#       Integer magnitude & length       CHRI  48
IF(INT<0)#                             Test if negative                 CHRI  49
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CHRI  50
STRING(TOP^TOP)=DIGIT(12^)#            Insert negative                  CHRI  51
LEN=LEN+1#                             Incr string length               CHRI  52
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CHRI  53
DO I=L,1,-1#                           Loop over integer powers         CHRI  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CHRI  55
IF(M<POWER(I)) NEXT#                   Skip until in range              CHRI  56
K=N/POWER(I);   N=N-K*POWER(I)#        Calc modulo & remainder          CHRI  57
IF(K>9) K=12#                          * if too little space            CHRI  58
STRING(LEN^LEN)=DIGIT(K+1^)#           Store single digit               CHRI  59
LEN=LEN+1#                             Incr length counter              CHRI  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CHRI  61
LEN=LEN-TOP#                           Get length of string             CHRI  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CHRI  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CHRI  64
RETURN#                                                                 CHRI  65
END#                                                                    CHRI  66
endsel:#                               Return to normal input           CHRI  67
systemheader:(MACEXP)#                 Process any macros in token      MACE   1
#********************************************************************   MACE   2
#                                                                   *   MACE   3
#                           MACEXP     CALLED BY: RFPP              *   MACE   4
#                                                                   *   MACE   5
#********************************************************************   MACE   6
SUBROUTINE MACEXP(TOKEN,TYPE,NTOK)#    S.r.hall june 85                 MACE   7
#                                                                       MACE   8
icommon:#                              Int1 common variables            MACE   9
jcommon:#                              Int2 common variables            MACE  10
ccommon:#                              Char common variables            MACE  11
#                                                                       MACE  12
CHARACTER*1 C#                         Single character                 MACE  13
CHARACTER*132 TEMP#                    Temporary dump buffer            MACE  14
CHARACTER*(*)     TOKEN#               Token character string           MACE  15
CHARACTER*14 HEAD#                     Macro dump header                MACE  16
INTEGER I,J,K,L,M,N#                   Working indices                  MACE  17
INTEGER IMAC#                          Macro macstr string pointer      MACE  18
INTEGER MMAC#                          Macro stack pointer              MACE  19
INTEGER MACSTK(maxstk:)#               Local macro stack                MACE  20
INTEGER NTOK#                          Number of characters in toke     MACE  21
INTEGER PARLEV(maxstk:)#               Parenth. level count             MACE  22
INTEGER QFLG#                          Quote signal                     MACE  23
INTEGER TYPE#                          Nature of token string           MACE  24
INTEGER NPNT#                          Pointer to macro lists           MACE  25
DATA PARLEV/maxstk:*0/#                                                 MACE  26
DATA IMAC,MMAC/2,0/#                                                    MACE  27
DATA HEAD/' >>>>>>>>>>>> '/#                                            MACE  28
#                                                                       MACE  29
#   PROCESS ANY MACRO DEFINITION OR CALLS                               MACE  30
#   --------------------------------------                              MACE  31
#                                                                       MACE  32
NPNT=0#                                Initialize macro pointer         MACE  33
REPEAT#                                Loop tokens until eol            MACE  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MACE  35
#    ***********************                                            MACE  36
CALL GETTOK(TOKEN,TYPE,NTOK)#          Get next token string            MACE  37
#    ***********************                                            MACE  38
IF(TYPE==endf:) BREAK#                 Exit if eof detected             MACE  39
C=TOKEN(1^1)#                          Extract first character          MACE  40
IF(NSQB>0)#                            If inside square brackets        MACE  41
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MACE  42
IF     (C=='[') NSQB=NSQB+1#           Incr sqr bracket counter         MACE  43
ELSE IF(C==']') NSQB=NSQB-1#           Decr sqr bracket counter         MACE  44
IF(NSQB==0) NEXT#                      Skip level 1 sqr brackets        MACE  45
IF(MMAC==0) BREAK#                     Macro not being processed        MACE  46
push:(TOKEN,MACSTR,IMAC,NTOK)#         Add token to macro string        MACE  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MACE  48
#                                                                       MACE  49
#   MACRO NAME<:> ENCOUNTERED                                           MACE  50
#   -------------------------                                           MACE  51
#                                                                       MACE  52
ELSE IF(TYPE==macr:)#                  Test for macro name              MACE  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MACE  54
CALL PUTMAC(TOKEN(1^),NTOK,-1,NPNT)#   Look up macro name               MACE  55
IF(NPNT==0)#                           Macro name not defined yet       MACE  56
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MACE  57
IF(MMAC==0)#                           Test if invoked macro            MACE  58
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  MACE  59
error:(11,TOKEN(1^),NTOK);   BREAK#    Invoked macro not defined        MACE  60
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  MACE  61
ELSE   push:(TOKEN,MACSTR,IMAC,NTOK)#  Add token to macro string        MACE  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MACE  63
ELSE#                                  Existing macro name & defini     MACE  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  MACE  65
MMAC=MMAC+1;   NARG=NARG+1#            Incr macro & argument counte     MACE  66
IF(MMAC>maxstk: \ NARG>maxstk:)#       Test for stack overflow          MACE  67
error:(05,' ',0)#                      Signal stack overlow             MACE  68
MACSTK(MMAC)=NARG#                     Store arg stack index            MACE  69
ARGSTK(NARG)=IMAC#                     Store mac string pointer         MACE  70
PARLEV(MMAC)=0#                        Reset paren. level counter       MACE  71
N=MACNAM(NPNT);   L=MACDEF(NPNT)#      Get name/defn lengths            MACE  72
I=MACADR(NPNT)+N#                      Point to macro defn string       MACE  73
IF(L>0)#                               Make sure there are chars        MACE  74
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  MACE  75
IF(IMAC+L-1>=maxbuf:) error:(18,' ',0)# Signal buffer overflow          MACE  76
pushover:(MACTAB,I,MACSTR,IMAC,IMAC+L-1)# Insert macro definition       MACE  77
IMAC=IMAC+L#                           Update table pointer             MACE  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  MACE  79
ELSE MACSTR(IMAC^IMAC)=' '#                                             MACE  80
IF(IBUF(NBUF+1^NBUF+1)!='(')#          Test for <(> to follow           MACE  81
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  MACE  82
NBUF=NBUF-2#                           Reset ip buffer pointer          MACE  83
IBUF(NBUF+1^NBUF+2)='()'#              Insert dummy delimitors          MACE  84
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  MACE  85
IF(FLAGD==yes:)#                       If macro dump in force           MACE  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  MACE  87
TEMP(1^14)=HEAD#                       Store dump header                MACE  88
itoc:(MMAC,TEMP,15,17,II)#             Format macro stack number        MACE  89
TEMP(18^35)=TOKEN(1^NTOK)#             Insert macro name                MACE  90
L=MIN0(L,95)#                          Avoid buffer overflow            MACE  91
IF(L>0)pushover:(MACTAB,I,TEMP,36,L+35)# Insert macro definition        MACE  92
IF(MMAC==1) write:(ilst:,HEAD,14)#     Insert extra spacer              MACE  93
write:(ilst:,TEMP,L+35)#               Optput mstk and macro na         MACE  94
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  MACE  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  MACE  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MACE  97
#                                                                       MACE  98
ELSE IF(C=='[')#                       Test first left sqr bracket      MACE  99
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 MACE 100
NSQB=1;     NEXT#                      Skip level 1 sqr bracket         MACE 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 MACE 102
#                                                                       MACE 103
ELSE IF(MMAC==0)#                      For non-macro tokens             MACE 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 MACE 105
IF(NTOK==2 & C=='$')#                  Test for a digraph               MACE 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 MACE 107
TOKEN(1^1)=TOKEN(2^2)#                 Keep code character              MACE 108
TYPE=code:;      NTOK=1#               Reset type and length            MACE 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 MACE 110
ELSE IF(C=='^') TOKEN(1^1)=':'#        Change <^> to <:>                MACE 111
BREAK#                                 Exit from token loop             MACE 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 MACE 113
#                                                                       MACE 114
ELSE IF(TYPE!=othr:)#                  For alphanumeric tokens          MACE 115
push:(TOKEN,MACSTR,IMAC,NTOK)#         Add to macro string              MACE 116
#                                                                       MACE 117
#   MACRO PROCESSING BEYOND HERE                                        MACE 118
#   ----------------------------                                        MACE 119
#                                                                       MACE 120
ELSE IF(C=='(')#                       Test for <(> char                MACE 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 MACE 122
IF(PARLEV(MMAC)>0) push:(TOKEN,MACSTR,IMAC,NTOK)# Add token to string   MACE 123
ELSE#                                  This the first macro argumen     MACE 124
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 MACE 125
NARG=NARG+1;     ARGSTK(NARG)=IMAC#    Store arg start pointer          MACE 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 MACE 127
PARLEV(MMAC)=PARLEV(MMAC)+1#           Incr paren. level count          MACE 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 MACE 129
#                                                                       MACE 130
ELSE IF(C==')')#                       Test for <)> char                MACE 131
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 MACE 132
PARLEV(MMAC)=PARLEV(MMAC)-1#           Decr paren, level count          MACE 133
IF(PARLEV(MMAC)>0) push:(TOKEN,MACSTR,IMAC,NTOK)# Add token to str      MACE 134
ELSE#                                  End of macro -- evaluate         MACE 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 MACE 136
NARG=NARG+1;   ARGSTK(NARG)=IMAC#      Store end of last arg            MACE 137
I=MACSTK(MMAC);   J=ARGSTK(I)#         Extract arg & str pointers       MACE 138
IF(FLAGD==yes:)#                       If macro dump flag is on         MACE 139
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 MACE 140
itoc:(MMAC,TEMP,15,35,II)#             Store macro stack number         MACE 141
II=36#                                 Set initial pointer              MACE 142
FOR(K=I+1;K<NARG;K=K+1)#               Loop over macro args             MACE 143
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 MACE 144
N=ARGSTK(K);  L=II+ARGSTK(K+1)-N#      Get arg start & buff end         MACE 145
L=MIN0(L,130)#                         Avoid buffer overflow            MACE 146
TEMP(II^II)='<'#                       Arg string delimiter             MACE 147
IF(L>II) TEMP(II+1^L)=MACSTR(N^)#      Store arg string                 MACE 148
TEMP(L+1^L+1)='>'#                     Arg string delimiter             MACE 149
II=L+2#                                Incr buffer pointer              MACE 150
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 MACE 151
write:(ilst:,TEMP,II-1)#               Output macro args                MACE 152
IF(MMAC==1) write:(ilst:,HEAD,14)#     Insert spacer                    MACE 153
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 MACE 154
IF(MACSTR(J^J)==']') CALL SYSMAC(I,J+1)# Test if system macro           MACE 155
ELSE#                                  Else this is user macro          MACE 156
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 MACE 157
QFLG=-1#                               Reset quote signal               MACE 158
FOR(N=ARGSTK(I+1)-1;N>=J;N=N-1)#       Scan string for $n arg.s         MACE 159
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 MACE 160
C=MACSTR(N^N)#                         Extract adjacent chars           MACE 161
IF(C=='''') QFLG=-QFLG#                Toggle '...' string flag         MACE 162
IF(N>J & MACSTR(N-1^N-1)=='$' & $#     Test for next dollar             MACE 163
QFLG!=yes: & C>='1' & C<='9')#         Test for exposed <$n>            MACE 164
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 MACE 165
ctoi:(C,1,1,M)#                        Convert to integer               MACE 166
M=M+I;          N=N-1#                 Point to arg & skip arg          MACE 167
IF(M>=NARG) NEXT#                      Arg not stored so skip           MACE 168
K=ARGSTK(M)#                           Start of arg string              MACE 169
L=ARGSTK(M+1)-K#                       Length of arg string             MACE 170
back:(MACSTR(K^),IBUF,NBUF,L)#         Push back onto input buff        MACE 171
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 MACE 172
ELSE back:(C,IBUF,NBUF,1)#             Push char back onto input        MACE 173
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 MACE 174
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 MACE 175
NARG=I-1;   IMAC=J;    MMAC=MMAC-1#    Reset macro pointers             MACE 176
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 MACE 177
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 MACE 178
#                                                                       MACE 179
ELSE IF(C==',' & PARLEV(MMAC)==1)#     Test for <,> delimitor           MACE 180
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 MACE 181
NARG=NARG+1;      ARGSTK(NARG)=IMAC#   Add new macro argument           MACE 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 MACE 183
#                                                                       MACE 184
ELSE  push:(TOKEN,MACSTR,IMAC,NTOK)#   Add to macro string              MACE 185
#                                                                       MACE 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MACE 187
IF(MMAC!=0 & TYPE==endf:) error:(12,' ',0)# Macro incomplete            MACE 188
#                                                                       MACE 189
RETURN#                                                                 MACE 190
END#                                                                    MACE 191
systemheader:(GETTOK)#                 Get char token from input        GETT   1
#********************************************************************   GETT   2
#                                                                   *   GETT   3
#                           GETTOK     CALLED BY: MACEXP            *   GETT   4
#                                                 Rfpp              *   GETT   5
#                                                                   *   GETT   6
#********************************************************************   GETT   7
SUBROUTINE GETTOK(TOKEN,TYPE,NTOK)#    S.r.hall june 85                 GETT   8
#                                                                       GETT   9
icommon:#                              Int1 common variables            GETT  10
jcommon:#                              Int2 common variables            GETT  11
ccommon:#                              Char common variables            GETT  12
#                                                                       GETT  13
CHARACTER*1 C,D#                       Single characters                GETT  14
CHARACTER HEAD1*50#                    Listing header                   GETT  15
CHARACTER*(*)     TOKEN#               Char string for discrete tok     GETT  16
INTEGER AFLG#                          Signal if <'> being processe     GETT  17
INTEGER NINP#                          Number of input characters       GETT  18
INTEGER NTOK#                          Number of token characters       GETT  19
INTEGER TYPE#                          Nature of token (eg. alnm:)      GETT  20
INTEGER QFLG#                          Quote flag switch                GETT  21
SAVE NINP#                             Ninp required next time          GETT  22
DATA HEAD1/head:/#                                                      GETT  23
#                                                                       GETT  24
#   GET NEW TOKEN STRING FROM INPUT                                     GETT  25
#   -------------------------------                                     GETT  26
#                                                                       GETT  27
TYPE=numr:;       AFLG=no:#            Set initial values               GETT  28
FOR(NTOK=1;NTOK<maxstr:;NTOK=NTOK+1)#  Loop over chars in token         GETT  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  GETT  30
#                                                                       GETT  31
#   IF BUFFER EMPTY READ NEW LINE                                       GETT  32
#   -----------------------------                                       GETT  33
#                                                                       GETT  34
NBUF=NBUF+1#                           Incr buffer pointer              GETT  35
IF(NBUF>maxbuf: \ ACCF==no:)#          Is input buffer empty            GETT  36
REPEAT#                                Loop until active line           GETT  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  GETT  38
#                                                                       GETT  39
#*******************                                                    GETT  40
read:(NDEV,IBUF,NINP)#                 Read next input line             GETT  41
#*******************                                                    GETT  42
#                                                                       GETT  43
IF(NINP<0) BREAK#                      Exit if eof detected             GETT  44
IF(NINP==0) NEXT#                      Skip void lines                  GETT  45
IF(NFIL==1) ILIN=ILIN+1#               Count input lines                GETT  46
#                                                                       GETT  47
#   LIST INPUT SOURCE IF REQUESTED                                      GETT  48
#   ------------------------------                                      GETT  49
#                                                                       GETT  50
IF(FLAGS==yes:)#                       Test if source to be listed      GETT  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  GETT  52
LLIN=LLIN+1#                           Count lines listed               GETT  53
IF(LLIN>maxlpp:)#                      Test for end of page             GETT  54
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  GETT  55
page:#                                 Force new page                   GETT  56
write:(ilst:,HEAD1,50)#                List/console header              GETT  57
write:(ilst:,HEAD1,1)#                 Insert a spacer line             GETT  58
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  GETT  59
I=NINP+17#                             Point to end of output           GETT  60
itoc:(ILIN,LBUF,4,7,II)#               Insert rat line number           GETT  61
IF(NOUT>1) itoc:(OLIN+1,LBUF,11,14,II)# Ftn line is in buffer           GETT  62
ELSE       itoc:(OLIN  ,LBUF,11,14,II)# No ftn line in buffer           GETT  63
LBUF(18^I)=IBUF(1^NINP)#               Store source line                GETT  64
write:(ilst:,LBUF,I)#                  Print lbuf as line               GETT  65
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  GETT  66
#                                                                       GETT  67
#    EXTRUDE INTERNAL FILE                                              GETT  68
#    ---------------------                                              GETT  69
#                                                                       GETT  70
IF(EXTF==yes:)#                                                         GETT  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  GETT  72
IF(IBUF(1^7)!='ENDEXT:'&$#             Test for end extrude signal      GETT  73
   IBUF(1^7)!='endext:'&$#             Test for end extrude signal      GETT  74
   IBUF(4^10)!='ENDEXT:')#             Test for end extrude signal      GETT  75
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  GETT  76
write:(iext:,IBUF,80)#                 Write output record              GETT  77
NEXT#                                  Skip further processing          GETT  78
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  GETT  79
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  GETT  80
#                                                                       GETT  81
#   BY-PASS NON-RATMAC CODE IF REQUESTED                                GETT  82
#   ------------------------------------                                GETT  83
#                                                                       GETT  84
IF(FLAGR==yes:)#                       Is input to be processed         GETT  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  GETT  86
IF(IBUF(8^11)==':(R)') FLAGR=no:#      Test to switch off               GETT  87
ELSE#                                  If ftn77 line                    GETT  88
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  GETT  89
OLIN=OLIN+1#                           Count ftn77 line                 GETT  90
write:(iftn:,IBUF,80)#                 Write ftn77 line                 GETT  91
NEXT#                                  Skip to new input line           GETT  92
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  GETT  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  GETT  94
IF(IBUF(1^1)=='#') NEXT#               Skip comment lines               GETT  95
#                                                                       GETT  96
#    EXTRACT ACTIVE LINE                                                GETT  97
#    -------------------                                                GETT  98
#                                                                       GETT  99
QFLG=-1;     D=' '#                    Reset '...' string flag          GETT 100
FOR(I=1;I<=NINP;I=I+1)#                Scan input line for sharp        GETT 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  GETT 102
C=IBUF(I^)#                            Get current & last char          GETT 103
IF(C==''''&(D!='$'\QFLG==yes:)) QFLG=-QFLG# Toggle '...' flag           GETT 104
ELSE IF(QFLG==yes:) NEXT#              Skip if in '...' string          GETT 105
ELSE IF(C=='#') BREAK#                 Exit if end of line              GETT 106
IF(C=='"') XFLG=-XFLG#                 Toggle "..." flag                GETT 107
ELSE IF(XFLG==yes:) NEXT#              Skip if in "..." string          GETT 108
D=C#                                   Store last character             GETT 109
numb:(C,N)#                            Convert character to number      GETT 110
N=N-loc:#                              Convert l/c <a> to 1             GETT 111
IF(N>=1&N<=wid:)#                      Convert to u/c character         GETT 112
char:(N+upc:,IBUF(I^I))#               Convert to u/c character         GETT 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  GETT 114
NBUF=maxbuf:-I+1#                      Reset buffer pointer             GETT 115
IBUF(NBUF^decr:(maxbuf:))=IBUF(1^I-1)# Transfer input to top buffer     GETT 116
IF(ACCF==yes:) BREAK#                  Exit from input loop             GETT 117
IF(NBUF>arith:(maxbuf:,-,6)) NEXT#     Avoid index conflict             GETT 118
IF(IBUF(NBUF^NBUF+5)=='IFSEL:') BREAK# Exit if ifsel: macro             GETT 119
IF(IBUF(NBUF^NBUF+6)=='ENDSEL:') BREAK# Exit if endsel: macro           GETT 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  GETT 121
IF(NINP<0) BREAK#                      Exit on end of file              GETT 122
#                                                                       GETT 123
#   MAKE '....' STRING ONE TOKEN                                        GETT 124
#   ----------------------------                                        GETT 125
#                                                                       GETT 126
C=IBUF(NBUF^);      ACCF=yes:#         Store single character           GETT 127
TOKEN(NTOK^NTOK)=C#                    Place into token string          GETT 128
IF(NBUF==decr:(maxbuf:))#              Test for continue flag           GETT 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 GETT 130
IF(C=='$')#                            Test for <$#> signal             GETT 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 GETT 132
NTOK=NTOK-1;  NBUF=maxbuf:;    NEXT#   Force next read buffer           GETT 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 GETT 134
IF(C==',' & NTOK==1) NBUF=maxbuf:#     Skip end of line signal          GETT 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 GETT 136
IF(C=='''')#                           Test for apostrophe              GETT 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 GETT 138
IF(AFLG==no: & NTOK>1) BREAK#          Apostrophe is delimitor          GETT 139
IF(AFLG==no:) AFLG=yes:#               Set apostrophe flag              GETT 140
ELSE          AFLG=no:#                Reset apostrophe flag            GETT 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 GETT 142
IF(AFLG==yes: & NBUF<maxbuf:) NEXT#    Skip if inside '...'             GETT 143
ifsel:(IBM,SIE)#                                                        GETT 144
IF((C>='A' & C<='I')\$#                Ibm test of alphabetic           GETT 145
   (C>='J' & C<='R')\$#                Ibm test of alphabetic           GETT 146
   (C>='S' & C<='Z'))#                 Ibm test of alphabetic           GETT 147
ifsel:#                                                                 GETT 148
IF(C>='A' & C<='Z')#                   Test if alphabetic               GETT 149
endsel:#                                                                GETT 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 GETT 151
IF(TYPE==alnm:) NEXT#                  Skip if already typed            GETT 152
IF(NTOK>1) BREAK#                      Exit if preceeding stuff         GETT 153
TYPE=alnm:;  NEXT#                     Type and continue                GETT 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 GETT 155
ELSE IF(C>='0' & C<='9') NEXT#         Continue if digit                GETT 156
BREAK#                                 Exit if non-alphanumeric cha     GETT 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  GETT 158
IF(NTOK==maxstr:) error:(10,' ',0)#    Token string too long            GETT 159
IF(AFLG==yes:)    error:(15,' ',0)#    Incomplete quote string          GETT 160
#                                                                       GETT 161
#   PROCESS SINGLE CHARACTER TOKEN                                      GETT 162
#   -----------------------------                                       GETT 163
#                                                                       GETT 164
IF(NINP<0) TYPE=endf:#                 End of file detected             GETT 165
ELSE IF(NTOK==1)#                      If token string is 1 char        GETT 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 GETT 167
TYPE=othr:#                            Get the next character           GETT 168
#                                                                       GETT 169
IF(C==eol:) TYPE=endl:#                Signal end of line               GETT 170
#                                                                       GETT 171
ELSE IF(C==',');#                      Inhibit comma processing         GETT 172
#                                                                       GETT 173
#   PRESERVE DIGRAPHS <$X>                                              GETT 174
#   ------------------------                                            GETT 175
#                                                                       GETT 176
ELSE IF(C=='$')#                       Test for digraph flag <$>        GETT 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 GETT 178
TOKEN(2^2)=IBUF(NBUF+1^)#              Add next digraph char            GETT 179
NBUF=NBUF+1;    NTOK=2#                Incr ip buffer pointer           GETT 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 GETT 181
#                                                                       GETT 182
#    CONCATENATE BLANKS AS STRING                                       GETT 183
#    ----------------------------                                       GETT 184
#                                                                       GETT 185
ELSE IF(C==' ')#                       Test for blank char              GETT 186
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 GETT 187
FOR(NBUF=NBUF+1;NBUF<maxbuf:;NBUF=NBUF+1)# Scan buffer for non-blank    GETT 188
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 GETT 189
IF(IBUF(NBUF^NBUF)!=' ') BREAK#        Exit on first non-blank          GETT 190
NTOK=NTOK+1#                           Incr token string pointer        GETT 191
TOKEN(NTOK^NTOK)=' '#                  Insert blank into token          GETT 192
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 GETT 193
NBUF=NBUF-1;    TYPE=blnk:#            Reset ip buffer pointer          GETT 194
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 GETT 195
#                                                                       GETT 196
ELSE IF(NSQB>0);#                      Protect contents of macro        GETT 197
#                                                                       GETT 198
#  CONVERT RELATIONAL SYMBOLS TO FTN77                                  GETT 199
#  -----------------------------------                                  GETT 200
#                                                                       GETT 201
ELSE IF(IBUF(NBUF+1^NBUF+1)=='=')#     Test for an equal char           GETT 202
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 GETT 203
NBUF=NBUF+1#                           Incr ip buffer pointer           GETT 204
IF     (C=='=') move:('.EQ.',TOKEN,NTOK,4)# Replace with ftn77          GETT 205
ELSE IF(C=='!') move:('.NE.',TOKEN,NTOK,4)# Replace with ftn77          GETT 206
ELSE IF(C=='<') move:('.LE.',TOKEN,NTOK,4)# Replace with ftn77          GETT 207
ELSE IF(C=='>') move:('.GE.',TOKEN,NTOK,4)# Replace with ftn77          GETT 208
ELSE NBUF=NBUF-1#                      Reset ip buffer pointer          GETT 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 GETT 210
ELSE IF(C=='<') move:('.LT.' ,TOKEN,NTOK,4)# Replace with ftn77         GETT 211
ELSE IF(C=='>') move:('.GT.' ,TOKEN,NTOK,4)# Replace with ftn77         GETT 212
ELSE IF(C=='&') move:('.AND.',TOKEN,NTOK,5)# Replace with ftn77         GETT 213
ELSE IF(C==BSL) move:('.OR.' ,TOKEN,NTOK,4)# Replace with ftn77         GETT 214
ELSE IF(C=='!') move:('.NOT.',TOKEN,NTOK,5)# Replace with ftn77         GETT 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 GETT 216
#                                                                       GETT 217
#   TOKEN MORE THAN ONE CHARACTER                                       GETT 218
#   -----------------------------                                       GETT 219
#                                                                       GETT 220
ELSE#                                  For tokens >1 character          GETT 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 GETT 222
IF(C==':')#                            Test for macro character         GETT 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 GETT 224
TYPE=macr:#                            Signal as macro name             GETT 225
IF(TOKEN(1^NTOK)=='SYSTEMHEADER:')#    Test for start of routine        GETT 226
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 GETT 227
DO I=NBUF,maxbuf:#                     Loop over input buffer           GETT 228
IF(IBUF(I^I)==','\IBUF(I^I)==')') BREAK# Exit on comma or parenth       GETT 229
IF(IBUF(I^I)==')')#                    If no second argument            GETT 230
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 GETT 231
PROG=IBUF(NBUF+2^I-1)#                 Insert new program name          GETT 232
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 GETT 233
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 GETT 234
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 GETT 235
ELSE IF(TOKEN(1^1)!='''')#             '...' strg is not a token        GETT 236
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 GETT 237
NBUF=NBUF-1;     NTOK=NTOK-1#          Remove <othr> character          GETT 238
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 GETT 239
ELSE TYPE=alnm:#                       Type '....' strings as alpha     GETT 240
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 GETT 241
#                                                                       GETT 242
RETURN#                                                                 GETT 243
END#                                                                    GETT 244
systemheader:(OUTSTR)#                 Output character string          OUTS   1
#********************************************************************   OUTS   2
#                                                                   *   OUTS   3
#                           OUTSTR     CALLED BY: RFPP              *   OUTS   4
#                                                                   *   OUTS   5
#********************************************************************   OUTS   6
SUBROUTINE OUTSTR(L1,STRING,NSTR,L2)#  S.r.hall june 85                 OUTS   7
#                                                                       OUTS   8
icommon:#                              Int1 common variables            OUTS   9
jcommon:#                              Int2 common variables            OUTS  10
ccommon:#                              Char common variables            OUTS  11
CHARACTER*56 LINE#                     Last line header string          OUTS  12
CHARACTER*(*)     STRING#              Output character string          OUTS  13
INTEGER ICNT#                          Input line marker                OUTS  14
INTEGER L1,LAB1#                       Start of line label number       OUTS  15
INTEGER L2,LAB2#                       End   of line label number       OUTS  16
INTEGER NSTR#                          Number of char in string         OUTS  17
INTEGER OCNT#                          Output line marker               OUTS  18
INTEGER OUTF#                          Output flag                      OUTS  19
DATA LINE/'NERR:      NRAT:      NFTN:      NMAC:      MACT:    %  '/#  OUTS  20
DATA ICNT,OCNT/0,1/#                                                    OUTS  21
#                                                                       OUTS  22
#   LOOP OVER LINES PER STRING                                          OUTS  23
#   --------------------------                                          OUTS  24
#                                                                       OUTS  25
LAB1=L1;   LAB2=L2;   N=1#             Set starting labels/limits       OUTS  26
#                                                                       OUTS  27
IF(STRING(1^4)!='GOTO'\OBUF(7^10)!='GOTO')# Skip goto/goto sequence     OUTS  28
REPEAT#                                Loop over output lines           OUTS  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OUTS  30
OUTF=no:#                              Cancel output flag               OUTS  31
IF(NOUT==7 & LAB1!=0) NOUT=1#          Cancel continue if new line      OUTS  32
#                                                                       OUTS  33
#   PROCESS FIRST STATEMENT LABEL                                       OUTS  34
#   -----------------------------                                       OUTS  35
#                                                                       OUTS  36
IF(LAB1!=0 & NOUT==1)#                 Test if label 1 active           OUTS  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OUTS  38
NOUT=7;     OBUF(1^6)='      '#        Reset pointer & blank            OUTS  39
IF(LAB1>0) itoc:(LAB1,OBUF,1,6,II)#    Convert label to string          OUTS  40
ELSE IF(LAB1==cnt:) OBUF(6^6)='&'#     Test for continue flag           OUTS  41
ELSE IF(LAB1==new: \ LAB1==dig:)#      Test for start col1              OUTS  42
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OUTS  43
OBUF(1^NSTR)=STRING(1^NSTR)#           Insert string from col1          OUTS  44
N=NSTR+1#                              Reset output pointer             OUTS  45
IF(LAB1==new:) NOUT=N#                 For non-digit string             OUTS  46
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OUTS  47
LAB1=0#                                Reset label signal               OUTS  48
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OUTS  49
ELSE IF(LAB1!=0) OUTF=yes:#            Set output flag                  OUTS  50
#                                                                       OUTS  51
#    PROCESS CHARACTER STRING                                           OUTS  52
#    ------------------------                                           OUTS  53
#                                                                       OUTS  54
IF(OUTF==no: & NSTR>=N)#               If buffer is ready               OUTS  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OUTS  56
L=MIN0(NSTR-N,maxout:-NOUT)#           Get max op string                OUTS  57
OBUF(NOUT^NOUT+L)=STRING(N^)#          Store in op buffer               OUTS  58
N=N+L+1;   NOUT=NOUT+L+1#              Reset string & output counts     OUTS  59
IF(NOUT>maxout:)#                      Test if buffer full              OUTS  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OUTS  61
OUTF=yes:;   LAB1=cnt:#                Force output line                OUTS  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OUTS  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OUTS  64
#                                                                       OUTS  65
#    PROCESS SECOND STATEMENT LABEL                                     OUTS  66
#    ------------------------------                                     OUTS  67
#                                                                       OUTS  68
IF(OUTF==no: & LAB2!=0)#               Test for label 2 or endl         OUTS  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  OUTS  70
IF(LAB2>0 & (NOUT+4<=maxout:))#        Test for active label            OUTS  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  OUTS  72
itoc:(LAB2,OBUF,NOUT,NOUT+4,II)#       Convert label to chars           OUTS  73
NOUT=NOUT+5#                           Incr output counter              OUTS  74
LAB2=0;      NEXT#                     Reset label flag                 OUTS  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  OUTS  76
ELSE IF(LAB2>0) LAB1=cnt:#             Force output & continue          OUTS  77
ELSE IF(LAB2<0) LAB2=0#                Test for end-line flag           OUTS  78
OUTF=yes:#                             Switch on output flag            OUTS  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  OUTS  80
#                                                                       OUTS  81
#    OUTPUT FTN77 LINE                                                  OUTS  82
#    -----------------                                                  OUTS  83
#                                                                       OUTS  84
IF(NOUT==10 & OBUF(7^9)=='END') OUTF=yes:# Force end if processed       OUTS  85
IF(OUTF==no: \ NOUT==1) BREAK#         Test for line output             OUTS  86
OLIN=OLIN+1;     NOUT=NOUT-1#          Count output line                OUTS  87
#***************                                                        OUTS  88
write:(iftn:,OBUF,NOUT)#               Write output line                OUTS  89
#***************                                                        OUTS  90
IF(NOUT==9 & OBUF(7^9)=='END')#        Test for end of routine          OUTS  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  OUTS  92
IF(NBRC!=0) error:(16,' ',0)#          Brace imbalance on exit          OUTS  93
IF(NDAT!=1000) error:(19,' ',0)#       Datastuff: missing               OUTS  94
OBUF(1^70)=' '#                        Blank line buffer                OUTS  95
OBUF(2^13)=PROG#                       Insert program name              OUTS  96
OBUF(15^70)=LINE#                      Insert line header               OUTS  97
itoc:(NERR,OBUF,21,24,II)#             Insert error count               OUTS  98
itoc:(ILIN-ICNT,OBUF,32,35,II)#        Insert source line count         OUTS  99
itoc:(OLIN-OCNT,OBUF,43,46,II)#        Insert ftn77  line count         OUTS 100
itoc:(MACM,OBUF,54,56,II)#             Insert max number of macros      OUTS 101
I=MTAB*100/maxtab:#                    Calculate table usage            OUTS 102
itoc:(I,OBUF,65,66,II)#                Insert macro table usage         OUTS 103
LLIN=LLIN+1#                           Incr lines per page              OUTS 104
NERT=NERT+NERR#                        Count all errors                 OUTS 105
write:(ilst:,OBUF,70)#                 Print final summary              OUTS 106
write:(imes:,OBUF,70)#                 Print final summary              OUTS 107
ICNT=ILIN;   OCNT=OLIN;   NERR=0#      Reset line/err counts            OUTS 108
MTAB=ITAB;   NDAT=1000;   NBRC=0#      Reset table & brace count        OUTS 109
MACM=NMAC#                             Reset max number of macros       OUTS 110
NLAB=27000#                            Reset base for label generator   OUTS 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  OUTS 112
NOUT=1#                                Reset output counter             OUTS 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OUTS 114
#                                                                       OUTS 115
RETURN#                                                                 OUTS 116
END#                                                                    OUTS 117
systemheader:(EATUP)#                  Output string to <;>,<)>,eol     EATU   1
#********************************************************************   EATU   2
#                                                                   *   EATU   3
#                           EATUP      CALLED BY: RFPP              *   EATU   4
#                                                                   *   EATU   5
#********************************************************************   EATU   6
SUBROUTINE EATUP(N,IFLG)#              S.r.hall june 85                 EATU   7
#                                                                       EATU   8
icommon:#                              Int1 common variables            EATU   9
jcommon:#                              Int2 common variables            EATU  10
ccommon:#                              Char common variables            EATU  11
CHARACTER*1 C#                         Characters 1 & 2                 EATU  12
CHARACTER*arith:(maxbuf:,+,50) STRING# Token character string           EATU  13
INTEGER IFLG#                          Local value of 'flag'            EATU  14
INTEGER N#                             Incoming function code           EATU  15
INTEGER LPAR#                          Left paren flag in <for>         EATU  16
INTEGER NPAR#                          Count of parentheses             EATU  17
INTEGER NSTR#                          Current string pointer           EATU  18
INTEGER NTOK#                          Length of token string           EATU  19
INTEGER TYPE#                          Lexical type of token            EATU  20
INTEGER QFLG#                          Quote <"> signal                 EATU  21
#                                                                       EATU  22
#    SAVE FORSTK POINTER IF FOR<REINIT>                                 EATU  23
#    ----------------------------------                                 EATU  24
#                                                                       EATU  25
IF(IFLG==sav:)#                        Test if <for-reinit.>            EATU  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  EATU  27
NFOR=NFOR+1#                           Incr for level counter           EATU  28
FORSTK(NFOR)=IFOR#                     Store for string pointer         EATU  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  EATU  30
#                                                                       EATU  31
#   SCAN INPUT UNTIL DELIMITER FOUND                                    EATU  32
#   --------------------------------                                    EATU  33
#                                                                       EATU  34
NPAR=0;         LPAR=no:#              Reset parenthesis counter        EATU  35
NSTR=1;    QFLG=no:#                   Reset counter & " iflg           EATU  36
REPEAT#                                Loop until string complete       EATU  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  EATU  38
#    *******************************                                    EATU  39
CALL MACEXP(STRING(NSTR^),TYPE,NTOK)#  Get a character string           EATU  40
#    *******************************                                    EATU  41
IF(TYPE==endf:)               BREAK#   Exit " search if eof found       EATU  42
IF(TYPE==endl: & QFLG==yes:)  NEXT#    Skip imbedded end iflg           EATU  43
IF(TYPE==blnk: & QFLG==no:)   NEXT#    Skip blank tokens                EATU  44
IF(TYPE==endl:&(N==ndo:\N==0))BREAK#   Exit on eol for <do>             EATU  45
IF(TYPE==endl:)               NEXT#    Jump to next line                EATU  46
C=STRING(NSTR^)#                       First character of token         EATU  47
IF(C=='{' \ C=='}')#                   Brace is end of line             EATU  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  EATU  49
NBUF=NBUF-1;                 BREAK#    Force brace to be reprocesse     EATU  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  EATU  51
IF(TYPE==code:&(C=='(' \ C==')'))#     Brace is end of line             EATU  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  EATU  53
NBUF=NBUF-2;                 BREAK#    Force brace to be reprocesse     EATU  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  EATU  55
IF(N==nfo:& LPAR==no: &IFLG==tab:)#    Test char1 in <for-init>         EATU  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  EATU  57
IF(C!='(') error:(02,' ',0)#           <for> paren. is missing          EATU  58
LPAR=yes:;                    NEXT#    Iflg and skip parenthesis        EATU  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  EATU  60
#                                                                       EATU  61
IF(C=='"')#                            Test for quote <">               EATU  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  EATU  63
IF(QFLG==no:) QFLG=yes:#               Switch on quote iflg             EATU  64
ELSE          QFLG=no:#                String "...." complete           EATU  65
STRING(NSTR^NSTR)=''''#                Convert to apostrophe            EATU  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  EATU  67
ELSE IF(TYPE==code:)#                  Test for digraph code            EATU  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  EATU  69
IF     (C=='B') STRING(NSTR^NSTR)=' '# Insert blank character           EATU  70
ELSE IF(C=='L') STRING(NSTR^NSTR)='('# Insert left bracket              EATU  71
ELSE IF(C=='R') STRING(NSTR^NSTR)=')'# Insert right bracket             EATU  72
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  EATU  73
IF     (C==';') BREAK#                 Exit on first <;>                EATU  74
ELSE IF(C=='(') NPAR=NPAR+1#           Count left paren.s               EATU  75
ELSE IF(C==')') NPAR=NPAR-1#           Count right paren.s              EATU  76
NSTR=NSTR+NTOK#                        Incr "..." string count          EATU  77
IF(NSTR>maxbuf:) error:(18,' ',0)#     Tell user buffer overflow        EATU  78
IF(NPAR<0) BREAK#                      Exit if paren. imbalance         EATU  79
IF(NPAR==0&(N==nif:\N==nwh:)) BREAK#   Exit if <if> or <while>          EATU  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  EATU  81
IF(NPAR>0)         error:(06,' ',0)#   Too many left paren.             EATU  82
IF(NPAR<0&N!=nfo:) error:(07,' ',0)#   Too many right paren.            EATU  83
IF(QFLG==yes:)     error:(15,' ',0)#   Quote string incomplete          EATU  84
#                                                                       EATU  85
IF(IFLG==sav:)#                        Test if <for-reinit.>            EATU  86
push:(STRING,FORSTR,IFOR,NSTR-2)#      Store <for-reinit.>              EATU  87
ELSE IF(NSTR>1)#                       Else output string               EATU  88
outs:(IFLG,STRING,NSTR-1,0)#           Output string string             EATU  89
#                                                                       EATU  90
RETURN#                                                                 EATU  91
END#                                                                    EATU  92
systemheader:(PUTMAC)#                 Point/put macro in table         PUTM   1
#********************************************************************   PUTM   2
#                                                                   *   PUTM   3
#                           PUTMAC     CALLED BY: MACEXP            *   PUTM   4
#                                                 Sysmac            *   PUTM   5
#                                                                   *   PUTM   6
#********************************************************************   PUTM   7
SUBROUTINE PUTMAC(MACS,LNAM,LDEF,NPNT)# S.r.hall june 85                PUTM   8
#                                                                       PUTM   9
icommon:#                              Int1 common variables            PUTM  10
jcommon:#                              Int2 common variables            PUTM  11
ccommon:#                              Char common variables            PUTM  12
#                                                                       PUTM  13
CHARACTER*1 C#                                                          PUTM  14
CHARACTER*(*)     MACS#                Macro name string                PUTM  15
CHARACTER*maxstr: MACTEM#              Temp macro name for compare      PUTM  16
INTEGER I,J,K,L,M,N#                   Working indices                  PUTM  17
INTEGER LNAM#                          Length of macro name             PUTM  18
INTEGER LDEF#                          Length of macro defn             PUTM  19
INTEGER NPNT#                          Pointer to macro lists           PUTM  20
#                                                                       PUTM  21
#   POINT TO MACRO NAME IN MACRO LISTS                                  PUTM  22
#   ----------------------------------                                  PUTM  23
#                                                                       PUTM  24
IF(LNAM>0)#                            Is macro name active             PUTM  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PUTM  26
WHILE(MACS(LNAM^LNAM)==' ')#           Test for blank after <:>         PUTM  27
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PUTM  28
I=LNAM;   LNAM=LNAM-1#                 Reduce length of name            PUTM  29
DO J=1,LDEF#                           Loop over definition string      PUTM  30
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PUTM  31
C=MACS(I+1^);  MACS(I^)=C#             Pushback definition              PUTM  32
I=I+1#                                 Incr definition pointer          PUTM  33
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PUTM  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PUTM  35
IF(NPNT>=0 & MACS(LNAM^LNAM)!=':')#    Perm names end in <:>            PUTM  36
error:(08,' ',0)#                      Macro name without <:>           PUTM  37
I=LNAM-1#                              Point to char next to <:>        PUTM  38
numb:(MACS(I^I),M)#                    Convert <char>: to integer       PUTM  39
M=M-base:#                             Reduce to index 0<m<65           PUTM  40
NPNT=MACIND(M)#                        Extract macro list pointer       PUTM  41
IF(LDEF>=0 \ NPNT>0)#                  If defn to be attempted          PUTM  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PUTM  43
FOR(N=0;NPNT!=0;NPNT=MACNEX(NPNT))#    Scan macro list for name:        PUTM  44
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PUTM  45
N=NPNT#                                Save last active pointer         PUTM  46
IF(LNAM!=MACNAM(NPNT)) NEXT#           Skip if diff lengths             PUTM  47
J=MACADR(NPNT);   K=I+J#               Point to name in macro table     PUTM  48
pushover:(MACTAB,J,MACTEM,1,LNAM)#     Move chars for test              PUTM  49
IF(MACS(1^LNAM)==MACTEM(1^LNAM)) BREAK# Exit if name matches            PUTM  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PUTM  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PUTM  52
#   INSTAL MACRO DEFINTION                                              PUTM  53
#   ----------------------                                              PUTM  54
#                                                                       PUTM  55
IF(LDEF>=0)#                           Test for definition              PUTM  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PUTM  57
IF(NPNT>0)#                            Test existing macro name         PUTM  58
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PUTM  59
IF(LDEF<=MACDEF(NPNT))#                Test if new defn <= old          PUTM  60
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PUTM  61
MACDEF(NPNT)=LDEF#                     Store new defn length            PUTM  62
pushback:(MACS,1,MACTAB,J,K+LDEF)#     Store name & defn in table       PUTM  63
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PUTM  64
ELSE#                                  Cannot overwrite old macro       PUTM  65
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PUTM  66
MACNAM(NPNT)=0#                        Cancel old definition            PUTM  67
FOR(N=0;NPNT!=0;NPNT=MACNEX(NPNT)) N=NPNT# Find last next pointer       PUTM  68
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PUTM  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PUTM  70
IF(NPNT==0)#                           Test for new definition          PUTM  71
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PUTM  72
NMAC=NMAC+1#                           Incr macro counter               PUTM  73
IF(NMAC>maxmac:) error:(20,' ',0)#     Test for macro overflow          PUTM  74
IF(N>0) MACNEX(N)=NMAC#                Set 'next' pointer               PUTM  75
IF(MACIND(M)==0) MACIND(M)=NMAC#       Point to new macro               PUTM  76
L=ITAB+LNAM+LDEF#                      Get end macro table              PUTM  77
IF(L>maxtab:) error:(09,' ',0)#        Macro table exceeded             PUTM  78
MACADR(NMAC)=ITAB#                     Store table pointer              PUTM  79
MACNAM(NMAC)=LNAM#                     Store name length                PUTM  80
MACDEF(NMAC)=LDEF#                     Store defn length                PUTM  81
pushback:(MACS,1,MACTAB,ITAB,L-1)#     Store macro name+defn            PUTM  82
ITAB=L#                                Reset macro table pointer        PUTM  83
IF(ITAB>MTAB) MTAB=ITAB#               Store max macro pointer          PUTM  84
IF(NMAC>MACM) MACM=NMAC#               Store max number of macros       PUTM  85
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PUTM  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PUTM  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PUTM  88
ELSE NPNT=0#                           When name is inactive            PUTM  89
#                                                                       PUTM  90
RETURN#                                                                 PUTM  91
END#                                                                    PUTM  92
systemheader:(SYSMAC)#                 Process system macro expansi     SYSM   1
#********************************************************************   SYSM   2
#                                                                   *   SYSM   3
#                           SYSMAC     CALLED BY: MACEXP            *   SYSM   4
#                                                                   *   SYSM   5
#********************************************************************   SYSM   6
SUBROUTINE SYSMAC(IARG,ISTR)#          S.r.hall june 85                 SYSM   7
#                                                                       SYSM   8
icommon:#                              Int1 common variables            SYSM   9
jcommon:#                              Int2 common variables            SYSM  10
ccommon:#                              Char common variables            SYSM  11
#                                                                       SYSM  12
CHARACTER*1 C,D#                       Single characters                SYSM  13
CHARACTER*10 CODE#                     Ifdef code string                SYSM  14
CHARACTER*40 HEAD#                     Dmacro header                    SYSM  15
CHARACTER*maxbuf: TEMP#                Temporary working string         SYSM  16
INTEGER I,J,K,L,M,N#                   Working integers                 SYSM  17
INTEGER IARG#                          Pointer to first argument        SYSM  18
INTEGER ISTR#                          Pointer to macro string          SYSM  19
INTEGER N1,N2,N3,N4,N5,N6#             Macro string pointers            SYSM  20
INTEGER NA,NN(10)#                     Arg count & pointers             SYSM  21
EQUIVALENCE (N1,NN(1)),(N2,NN(2)),(N3,NN(3))#                           SYSM  22
EQUIVALENCE (N4,NN(4)),(N5,NN(5)),(N6,NN(6))#                           SYSM  23
DATA HEAD/' NMAC  IMAC          NAME  DEFINITION   '/#                  SYSM  24
DATA CODE/'    '/#                                                      SYSM  25
#                                                                       SYSM  26
DO I=1,10; NN(I)=0#                    Reset arg pointers               SYSM  27
NA=0#                                  Reset arg counter                SYSM  28
FOR(I=IARG+1;I<=NARG;I=I+1)#           Loop over possible arguments     SYSM  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SYSM  30
NA=NA+1#                               Incr arg counter                 SYSM  31
NN(NA)=ARGSTK(I)#                      Store arg pointer                SYSM  32
IF(NA==10) BREAK#                      Exit at max of 10 args           SYSM  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SYSM  34
C=MACSTR(ISTR^ISTR)#                   Extract macro type signal        SYSM  35
#                                                                       SYSM  36
#   PROCESS BUILT-IN SYSTEM MACROS                                      SYSM  37
#   ------------------------------                                      SYSM  38
#                                                                       SYSM  39
IF(C=='A')#                            Test for <arith:> signal         SYSM  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SYSM  41
onlynum:(MACSTR,N1,N2-1)#              Test for numerics only           SYSM  42
onlynum:(MACSTR,N3,N4-1)#              Test for numerics only           SYSM  43
ctoi:(MACSTR,N1,N2-1,I)#               Convert arg1 to integer          SYSM  44
ctoi:(MACSTR,N3,N4-1,J)#               Convert arg3 to integer          SYSM  45
D=MACSTR(N2^N2);  K=N2+1#              Extract operator & next          SYSM  46
#                                                                       SYSM  47
IF     (D=='+') N=I+J#                 Apply addition                   SYSM  48
ELSE IF(D=='-') N=I-J#                 Apply subtraction                SYSM  49
ELSE IF(D=='/'&J!=0) N=I/J#            Apply division                   SYSM  50
ELSE IF(D=='*')#                       Test mult/exponentiation         SYSM  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SYSM  52
IF(MACSTR(K^K)!='*') N=I*J#            Apply multiplication             SYSM  53
ELSE                 N=I**J#           Apply exponentiation             SYSM  54
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SYSM  55
ELSE error:(13,' ',0)#                 Illegal arith arguments          SYSM  56
itoc:(N,TEMP,1,10,L)#                  Convert to string length l       SYSM  57
back:(TEMP(1^),IBUF,NBUF,L)#           Push string onto input           SYSM  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SYSM  59
#                                                                       SYSM  60
ELSE IF(C=='M')#                       Test for <macro:> signal         SYSM  61
CALL PUTMAC(MACSTR(N1^),N2-N1,N3-N2,N)# Store macro name & defn         SYSM  62
#                                                                       SYSM  63
ELSE IF(C=='X')#                       Test for <xmacro:> signal        SYSM  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SYSM  65
CALL PUTMAC(MACSTR(N1^),N2-N1,-1,N)#   Remove from macro lists          SYSM  66
IF(N>0) MACNAM(N)=0#                   Reset macro name                 SYSM  67
ELSE    error:(11,MACSTR(N1^),N2-N1)#  Macro not defined                SYSM  68
IF(N==NMAC)#                           Is this the last macro           SYSM  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SYSM  70
FOR(I=N;I>0;I=I-1) IF(MACNAM(I)>0) BREAK# Exit on first active macro    SYSM  71
DO J=1,NMAC#                           Loop over surviving macros       SYSM  72
IF(MACNEX(J)>I) MACNEX(J)=0#           Delete pnt to purged macros      SYSM  73
DO J=1,maxind:#                        Loop over macro index            SYSM  74
IF(MACIND(J)>I) MACIND(J)=0#           Delete pnt to purged macros      SYSM  75
NMAC=I;    ITAB=MACADR(I+1)#           Reset macro count                SYSM  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SYSM  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SYSM  78
#                                                                       SYSM  79
ELSE IF(C=='I')#                       Test for <ifelse:> signal        SYSM  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SYSM  81
M=0#                                   Set compare flag off             SYSM  82
IF(N2-N1==N3-N2)#                      If both strings equal length     SYSM  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SYSM  84
IF(N1==N3) M=1#                        Test if both strings null        SYSM  85
ELSE IF(MACSTR(N1^N2-1)==MACSTR(N2^N3-1))M=1# Test if strings equiv.    SYSM  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SYSM  87
IF(M>0) back:(MACSTR(N3^),IBUF,NBUF,N4-N3)# Push arg3 back on input     SYSM  88
ELSE    back:(MACSTR(N4^),IBUF,NBUF,N5-N4)# Push arg4 back on input     SYSM  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SYSM  90
#                                                                       SYSM  91
ELSE IF(C=='+')#                       Test for <incr:> signal          SYSM  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SYSM  93
onlynum:(MACSTR,N1,N2-1)#              Test for numerics only           SYSM  94
ctoi:(MACSTR,N1,N2-1,I)#               Convert int string to intege     SYSM  95
itoc:(I+1,TEMP,1,10,N)#                Convert integer+1 to char st     SYSM  96
back:(TEMP(1^),IBUF,NBUF,N)#           Push int string onto input       SYSM  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SYSM  98
#                                                                       SYSM  99
ELSE IF(C=='-')#                       Test for <decr:> signal          SYSM 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SYSM 101
onlynum:(MACSTR,N1,N2-1)#              Test for numerics only           SYSM 102
ctoi:(MACSTR,N1,N2-1,I)#               Convert int string to intege     SYSM 103
itoc:(I-1,TEMP,1,10,N)#                Convert integer+1 to char st     SYSM 104
back:(TEMP(1^),IBUF,NBUF,N)#           Push int string onto input       SYSM 105
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SYSM 106
#                                                                       SYSM 107
ELSE IF(C=='C')#                       Test for <chr:> signal           SYSM 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SYSM 109
onlynum:(MACSTR,N1,N2-1)#              Test for numerics only           SYSM 110
ctoi:(MACSTR,N1,N2-1,I)#               Convert int string to intege     SYSM 111
char:(I,TEMP(1^1))#                    Convert integer to character     SYSM 112
back:(TEMP(1^),IBUF,NBUF,1)#           Push char back onto input        SYSM 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SYSM 114
#                                                                       SYSM 115
ELSE IF(C=='O')#                       Test for <ord:> signal           SYSM 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SYSM 117
numb:(MACSTR(N1^N1),I)#                Convert character to integer     SYSM 118
itoc:(I,TEMP,1,10,N)#                  Convert integer to int strin     SYSM 119
back:(TEMP(1^),IBUF,NBUF,N)#           Push int string onto input       SYSM 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SYSM 121
#                                                                       SYSM 122
ELSE IF(C=='L')#                       Test for <lenstr:> signal        SYSM 123
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SYSM 124
itoc:(N2-N1,TEMP,1,10,N)#              Convert length into string       SYSM 125
back:(TEMP(1^),IBUF,NBUF,N)#           Push back onto input             SYSM 126
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SYSM 127
#                                                                       SYSM 128
ELSE IF(C=='S')#                       Test for <substr:> signal        SYSM 129
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SYSM 130
N=N2-N1#                               Total length of string           SYSM 131
onlynum:(MACSTR,N2,N3-1)#              Test for numerics only           SYSM 132
ctoi:(MACSTR,N2,N3-1,I)#               Get substring start              SYSM 133
IF(I<1\I>N) J=0#                       Null if start outside            SYSM 134
ELSE IF(N4>0)#                         Argument 3 is given              SYSM 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SYSM 136
onlynum:(MACSTR,N3,N4-1)#              Test for numerics only           SYSM 137
ctoi:(MACSTR,N3,N4-1,J)#               Get substring length             SYSM 138
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SYSM 139
ELSE J=N-I+1#                          Set to remainder                 SYSM 140
I=N1+I-1#                              Set substring start pointer      SYSM 141
back:(MACSTR(I^),IBUF,NBUF,J)#         Push substr onto input           SYSM 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SYSM 143
#                                                                       SYSM 144
ELSE IF(C=='Y' \ C=='N')#              Test for <flagon:/off:> sign     SYSM 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SYSM 146
IF(C=='Y') N=yes:#                     For <flagon:>  switch on         SYSM 147
ELSE       N=no:#                      For <flagoff:> switch off        SYSM 148
D=MACSTR(N1^N1)#                       Extract flag signal              SYSM 149
IF     (D=='S') FLAGS=N#               Switch on/off source list        SYSM 150
ELSE IF(D=='R') FLAGR=N#               Switch on/off ratmac rejecti     SYSM 151
ELSE IF(D=='D') FLAGD=N#               Switch on/off dump macros        SYSM 152
ELSE            error:(14,' ',0)#      Unrecognized flag signal         SYSM 153
outs:(0,' ',0,-1)#                     Flush output buffer              SYSM 154
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SYSM 155
#                                                                       SYSM 156
ELSE IF(C=='P')#                       Test for <pmacro:> signal        SYSM 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SYSM 158
CALL PUTMAC(MACSTR(N1^),N2-N1,-1,N)#   Point to macro lists             SYSM 159
IF(N==0) error:(11,MACSTR(N1^),N2-N1)# Macro not in table               SYSM 160
DO J=1,NMAC#                           Loop over surviving macros       SYSM 161
IF(MACNEX(J)>N) MACNEX(J)=0#           Delete pnt to purged macros      SYSM 162
DO J=1,maxind:#                        Loop over macro index            SYSM 163
IF(MACIND(J)>N) MACIND(J)=0#           Delete pnt to purged macros      SYSM 164
NMAC=N;     ITAB=MACADR(N+1)#          Reset macro count                SYSM 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SYSM 166
#                                                                       SYSM 167
ELSE IF(C=='D')#                       Test for <dmacro:> signal        SYSM 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SYSM 169
CALL PUTMAC(MACSTR(N1^),N2-N1,-1,N)#   Look for start name              SYSM 170
IF(N==0) N=1#                          If not found start at 1          SYSM 171
CALL PUTMAC(MACSTR(N2^),N3-N2,-1,L)#   Look for end   name              SYSM 172
IF(L==0) L=NMAC#                       If not found end at nmac         SYSM 173
write:(ilst:,HEAD,40)#                 Output first header              SYSM 174
FOR(;N<=L;N=N+1)#                      Loop over macro range            SYSM 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SYSM 176
I=MACNAM(N);    J=MACADR(N)#           Set name string limits           SYSM 177
TEMP(1^27)='                           '# Blank out prev name           SYSM 178
itoc:(N,TEMP,2,5,K)#                   Insert macro counter             SYSM 179
itoc:(J,TEMP,8,11,K)#                  Insert macro table pointer       SYSM 180
pushover:(MACTAB,J,TEMP,27-I,26)#      Store name string in output      SYSM 181
J=J+I#                                 Point to macro definition        SYSM 182
FOR(I=MACDEF(N);I>=0;I=I-70)#          Divide defn in 60-char parts     SYSM 183
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SYSM 184
K=MIN0(I,70)+27#                       Point end of defn part           SYSM 185
pushover:(MACTAB,J,TEMP,28,K)#         Store defn part in output        SYSM 186
LLIN=LLIN+1#                           Count list lines                 SYSM 187
IF(LLIN>maxlpp:)#                      Test for pagination              SYSM 188
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SYSM 189
page:;    write:(ilst:,HEAD,40)#       Paginate and op header           SYSM 190
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SYSM 191
write:(ilst:,TEMP,K)#                  Print macro information          SYSM 192
TEMP(1^27)=' '#                        Blank out buffer region          SYSM 193
J=J+70#                                Incr defn pointer                SYSM 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SYSM 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SYSM 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SYSM 197
#                                                                       SYSM 198
ELSE IF(C=='E')#                       Test for <chardata:> macro       SYSM 199
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SYSM 200
I=N2-N1;   J=N3-N2;   N=-1#            Get name & string lengths        SYSM 201
IF(MACSTR(N2^N2)==''''\MACSTR(N2^N2)=='"')# Test for leading quote      SYSM 202
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SYSM 203
TEMP(1^J)=MACSTR(N2+1^)#               Transfer string without quote    SYSM 204
MACSTR(N2^N3)=TEMP(1^)#                Restore in macstr buffer         SYSM 205
J=J-2#                                 Reduce string by quotes          SYSM 206
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SYSM 207
CALL PUTMAC(MACSTR(N1^),I,J,N)#        Store string as macro            SYSM 208
NDAT=MIN0(NDAT,NMAC)#                  Store start for datastuff:       SYSM 209
TEMP(1^8)='INTEGERN'#                  Insert 'integer n' string        SYSM 210
TEMP(9^I+8)=MACSTR(N1^)#               Insert name of string            SYSM 211
outs:(tab:,TEMP(1^),I+8,0)#            Output integer definition        SYSM 212
TEMP(1^10)='CHARACTER*'#               Insert character type            SYSM 213
itoc:(J,TEMP,11,16,K)#                 Insert string length             SYSM 214
TEMP(17^I+16)=MACSTR(N1^)#             Insert name of string            SYSM 215
outs:(tab:,TEMP(1^),I+16,0)#           Output line                      SYSM 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SYSM 217
#                                                                       SYSM 218
ELSE IF(C=='G'\C=='H'\C=='J')#         Test <real/int/dbledata:>        SYSM 219
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SYSM 220
I=N2-N1+1;   J=N3-N2;    N=-1#         Get name & string lengths        SYSM 221
TEMP(1^I)=MACSTR(N1^)#                 Store array name                 SYSM 222
TEMP(I^I)='/'#                         Store signal for datastore       SYSM 223
TEMP(I+1^I+J)=MACSTR(N2^)#             Store array definition           SYSM 224
CALL PUTMAC(TEMP(1^),I,J,N)#           Store string as macro            SYSM 225
NDAT=MIN0(NDAT,NMAC);   N=1#           Store start for datastuff:       SYSM 226
FOR(J=J+N2;N2<J;N2=N2+1)#              Loop over int/real string        SYSM 227
IF(MACSTR(N2^N2)==',') N=N+1#          Count imbedded commas            SYSM 228
IF(C=='G')      TEMP(1^16)='REAL'#     Insert real line                 SYSM 229
ELSE IF(C=='H') TEMP(1^16)='INTEGER'#  Insert integer line              SYSM 230
ifsel:(UNX64,CRA)#                     If wordsize for 64 bits          SYSM 231
ELSE            TEMP(1^16)='REAL'#     Insert real line                 SYSM 232
ifsel:#                                If wordsize for 32 bits          SYSM 233
ELSE            TEMP(1^16)='DOUBLE PRECISION'# Insert dble prec line    SYSM 234
endsel:#                                                                SYSM 235
TEMP(17^I+16)=MACSTR(N1^)#             Insert name of string            SYSM 236
IF(N>1)#                               If more than one variable        SYSM 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SYSM 238
TEMP(I+16^I+20)='(   )'#               Insert punctuation               SYSM 239
itoc:(N,TEMP,I+17,I+19,K)#             Insert array dimension           SYSM 240
outs:(tab:,TEMP(1^),I+20,0)#           Output integer definition        SYSM 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SYSM 242
ELSE outs:(tab:,TEMP(1^),I+15,0)#      Output integer definition        SYSM 243
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SYSM 244
#                                                                       SYSM 245
ELSE IF(C=='F' & NDAT<1000)#           Test for <datastuff:> line       SYSM 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SYSM 247
DO N=NDAT,NMAC#                        Loop over all datastore:s        SYSM 248
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SYSM 249
I=MACNAM(N); J=MACADR(N); L=MACDEF(N)# Extract macro pointers           SYSM 250
K=I+J-1#                               Point to realdata signal         SYSM 251
IF(mactest:(K)=='/')#                  Test if real/int data array      SYSM 252
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SYSM 253
TEMP(1^4)='DATA'#                      Store start of data statemen     SYSM 254
K=I+L+4#                               Set temp pointer                 SYSM 255
pushover:(MACTAB,J,TEMP,5,K)#          Store name and definition        SYSM 256
TEMP(K+1^K+1)='/'#                     Store punctuation                SYSM 257
outs:(tab:,TEMP(1^),K+1,0)#            Output line                      SYSM 258
NEXT#                                  Skip to next macro               SYSM 259
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SYSM 260
TEMP(1^5)='DATAN'#                     Start data construction          SYSM 261
pushover:(MACTAB,J,TEMP,6,I+5)#        Store name without <:>           SYSM 262
TEMP(I+6^I+12)='/   /, '#              Store punctuation                SYSM 263
itoc:(L,TEMP,I+7,I+9,K)#               Insert string length             SYSM 264
K=I+I+12#                              Set temp pointer                 SYSM 265
pushover:(MACTAB,J,TEMP,I+13,K)#       Insert name of string            SYSM 266
TEMP(K+1^K+2)='/'''#                   Insert punctuation               SYSM 267
L=K+L+2#                               Set temp pointer                 SYSM 268
pushover:(MACTAB,I+J,TEMP,K+3,L)#      Insert string                    SYSM 269
TEMP(L+1^L+2)='''/'#                   Insert punctuation               SYSM 270
outs:(tab:,TEMP(1^),L+2,0)#            Output data line                 SYSM 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SYSM 272
DO J=1,NMAC#                           Loop over surviving macros       SYSM 273
IF(MACNEX(J)>=NDAT) MACNEX(J)=0#       Delete pnt to purged macros      SYSM 274
DO J=1,maxind:#                        Loop over macro index            SYSM 275
IF(MACIND(J)>=NDAT) MACIND(J)=0#       Delete pnt to purged macros      SYSM 276
NMAC=NDAT-1;   ITAB=MACADR(NDAT)#      Reset macro count                SYSM 277
NDAT=1000#                             Reset datastore start            SYSM 278
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SYSM 279
#                                                                       SYSM 280
ELSE IF(C=='R')#                       Test for <string:> macro         SYSM 281
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SYSM 282
I=N2-N1#                               Get name & string lengths        SYSM 283
TEMP(1^11)='CHARACTER*('#              Insert 'character* '             SYSM 284
TEMP(12^17)=MACSTR(N2^N3-1)#           Insert string length             SYSM 285
TEMP(18^18)=')'#                       Insert close string length       SYSM 286
TEMP(19^I+18)=MACSTR(N1^)#             Insert name of string            SYSM 287
outs:(tab:,TEMP(1^),I+18,0)#           Output line                      SYSM 288
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SYSM 289
#                                                                       SYSM 290
ELSE IF(C=='U')#                       Test for <extrude> macro         SYSM 291
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SYSM 292
IF(MACSTR(N1^N1)=='''')opene:(MACSTR(N1+1^N2-2))# Open extruded file    SYSM 293
ELSE                   opene:(MACSTR(N1^N2-1))# Open extruded file      SYSM 294
EXTF=yes:#                             Set extrude file switch          SYSM 295
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SYSM 296
#                                                                       SYSM 297
ELSE IF(C=='V')#                       Test for <endext> macro          SYSM 298
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SYSM 299
close:(iext:)#                         Close extruded file              SYSM 300
EXTF=no:#                              Set extrude file switch          SYSM 301
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SYSM 302
#                                                                       SYSM 303
ELSE IF(C=='Q')#                       Test for <select:> signal        SYSM 304
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 SYSM 305
I=N2-N1;    CODE(1^10)='          '#   Get code length                  SYSM 306
CODE(1^I)=MACSTR(N1^)#                 Extract define code              SYSM 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 SYSM 308
#                                                                       SYSM 309
ELSE IF(C=='Z')#                       Test for <ifsel:> signal         SYSM 310
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 SYSM 311
IF(CODF==no:)#                         Test if ifdef is active          SYSM 312
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 SYSM 313
FOR(I=1;I<NA;I=I+1)#                   Loop over arguments              SYSM 314
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 SYSM 315
N=NN(I);    M=NN(I+1);     J=M-N#      Get arg pointers & length        SYSM 316
IF(J<=0) BREAK#                        Exit if null string              SYSM 317
IF(CODE(1^J)==MACSTR(N^M-1)) BREAK#    Exit if strings match            SYSM 318
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 SYSM 319
IF(I<NA) CODF=yes:#                    If match or all accepted         SYSM 320
ELSE ACCF=no:#                         Switch off accept flag           SYSM 321
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 SYSM 322
ELSE ACCF=no:#                         Switch off accept flag           SYSM 323
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 SYSM 324
#                                                                       SYSM 325
ELSE IF(C=='W') CODF=no:#              Test for <endsel:> signal        SYSM 326
#                                                                       SYSM 327
RETURN#                                                                 SYSM 328
END#                                                                    SYSM 329
systemheader:(ERROR)#                  Process error signals            ERRO   1
#********************************************************************   ERRO   2
#                                                                   *   ERRO   3
#                           ERROR    CALLED BY: ALL ROUTINES        *   ERRO   4
#                                                                   *   ERRO   5
#********************************************************************   ERRO   6
SUBROUTINE ERROR(IERR,NAME,M)#         S.r.hall june 85                 ERRO   7
#                                                                       ERRO   8
icommon:#                              Int1 common variables            ERRO   9
jcommon:#                              Int2 common variables            ERRO  10
ccommon:#                              Char common variables            ERRO  11
#                                                                       ERRO  12
CHARACTER*(*) NAME#                    Token causing error              ERRO  13
CHARACTER*30 MESS(21)#                 Error message strings            ERRO  14
CHARACTER*70 EBUF#                     Error message buffer             ERRO  15
INTEGER N,M#                           Length of name passed            ERRO  16
INTEGER IERR#                          Error number passed              ERRO  17
#                                                                       ERRO  18
DATA EBUF(1^19)/' ERROR in line     '/#                                 ERRO  19
DATA MESS(1)/'max <INCLUDE> files exceeded  '/#                         ERRO  20
DATA MESS(2)/'<FOR> MUST be followed by <(> '/#                         ERRO  21
DATA MESS(3)/'<NEXT>,<BREAK> not in a loop  '/#                         ERRO  22
DATA MESS(4)/'BRACES are not balanced       '/#                         ERRO  23
DATA MESS(5)/'stack overflow - incr. maxstk:'/#                         ERRO  24
DATA MESS(6)/'too many LEFT parentheses     '/#                         ERRO  25
DATA MESS(7)/'too many RIGHT parentheses    '/#                         ERRO  26
DATA MESS(8)/'macro NAME is now redefined   '/#                         ERRO  27
DATA MESS(9)/'macro TABLE has been exceeded '/#                         ERRO  28
DATA MESS(10)/'max size of TOKEN exceeded    '/#                        ERRO  29
DATA MESS(11)/'invoked macro not defined     '/#                        ERRO  30
DATA MESS(12)/'macro definition incomplete   '/#                        ERRO  31
DATA MESS(13)/'illegal arith: operator       '/#                        ERRO  32
DATA MESS(14)/'unrecognized flagon/off: code '/#                        ERRO  33
DATA MESS(15)/'quoted string is incomplete   '/#                        ERRO  34
DATA MESS(16)/'braces imbalanced at END line '/#                        ERRO  35
DATA MESS(17)/'illegal <ELSE-IF> construction'/#                        ERRO  36
DATA MESS(18)/'line expansion exceeds maxbuf:'/#                        ERRO  37
DATA MESS(19)/'datastuff: missing in program '/#                        ERRO  38
DATA MESS(20)/'macro overflow - incr. maxmac:'/#                        ERRO  39
DATA MESS(21)/'macro arg. must be numeric    '/#                        ERRO  40
#                                                                       ERRO  41
N=MIN0(M,14)#                          Limit length of name             ERRO  42
itoc:(ILIN,EBUF,16,21,II)#             Convert line num to chars        ERRO  43
EBUF(22^51)=MESS(IERR)#                Insert error message             ERRO  44
N=N+51#                                Set length of message            ERRO  45
IF(N>51) EBUF(52^N)=NAME(1^)#          Insert erroneous name            ERRO  46
LLIN=LLIN+1#                           Count list lines                 ERRO  47
write:(ilst:,EBUF,N)#                  Print error message              ERRO  48
write:(imes:,EBUF,N)#                  Print error message              ERRO  49
NERR=NERR+1#                           Count program errors             ERRO  50
IF(IERR==1\IERR==5\IERR==9\IERR==10$#  Test for fatal errors            ERRO  51
\IERR==18\IERR==20\IERR==12\IERR==21)# Test for fatal errors            ERRO  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  ERRO  53
outs:(0,' ',0,-1);   STOP 15#          Flush output buffer & exit       ERRO  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  ERRO  55
#                                                                       ERRO  56
RETURN#                                                                 ERRO  57
END#                                                                    ERRO  58
